#!/usr/bin/python3

import csv
import json
#import datetime
from datetime import datetime
import glob
import shutil
import subprocess
import os
import time
import sqlite3
import cgi,cgitb
cgitb.enable()

from globalSettings import *
from global_func import get_ccm_command_id, send_ccm_msg, get_ccm_response #*


form = cgi.FieldStorage()

request_Type=form.getvalue('request_Type')

cmd_Id = get_ccm_command_id()

DATE_FORMAT_LOGROUTINE = '%d/%m/%Y-%H:%M:%S'
DATE_FORMAT_FOR_GUI = '%b %d, %Y, %H:%M:%S'


startDate=form.getvalue('startDate')
endDate=form.getvalue('endDate')
maxLogLevel=form.getvalue('maxLogLevel')
logType=form.getvalue('logType')

csvlimit = 50
limitcsv = False
SANUYI_LOGS_FOLDER = "Logs"
EMAIL_LOG_ZIP_PASSWORD = "hello123"

def createFolderIfnotExists(path):
    if not os.path.exists(path):
        os.makedirs(path, 0o777)

def sanuyiLogsZipName():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    try:
        dbquery = "SELECT serial_number from system "
        query = c.execute(dbquery)
        dbdata = []
        serial_number = ""
        for col in c:
            serial_number = col[0]
        c.close()
        conn.close()
        downloadFileName = "Logs_"+str(serial_number)+".zip"
        SANUYI_LOGS_ZIP1 = webServerRoot+"/Quantum/"+downloadFileName
        return SANUYI_LOGS_ZIP1
    except Exception as err:
        c.close()
        conn.close()
        downloadFileName = "Logs_123.zip"
        sanuyi_logs_zip = "/var/www/gui@Q/Quantum"+"Quantum/"+downloadFileName
        return sanuyi_logs_zip
        #print "sanuyiLogsZipName except condition",err # This should return something if there's an exception
        
def create_zip_file_with_logs():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    try:
        temp_folder_name = SANUYI_LOGS_FOLDER #"/mnt/xdata/zip"                  
        zip_file_name = sanuyiLogsZipName()#SANUYI_LOGS_ZIP
        #zip_file_name = SANUYI_LOGS_ZIP
        if os.path.isfile(zip_file_name):
            os.remove(zip_file_name)
        if os.path.isdir(temp_folder_name):
            try:
                shutil.rmtree(temp_folder_name)
            except OSError as e:
                print ("Error: %s - %s." % (e.filename, e.strerror))
                
        createFolderIfnotExists(temp_folder_name)
        dbquery = "SELECT serial_number from system"
        query = c.execute(dbquery)
        dbdata = []
        serial_number = ""
        for col in c:
            serial_number = col[0]
        
        multi_device_data = []                
        query = c.execute("select * from multi_device")
        conn.commit()
        columnNames = list(map(lambda x: x[0], query.description))
        for col in c:
            rowDict = dict(zip(columnNames, col))
            multi_device_data.append(rowDict)
            
        volume_data = []
        query = c.execute("select * from volume")
        conn.commit()
        columnNames = list(map(lambda x: x[0], query.description))
        for col in c:
            rowDict = dict(zip(columnNames, col))
            volume_data.append(rowDict)
            
        host_server_data = []
        query = c.execute("select * from host")
        conn.commit()
        columnNames = list(map(lambda x: x[0], query.description))
        for col in c:
            rowDict = dict(zip(columnNames, col))
            host_server_data.append(rowDict)
        
        #CURRENT HW VALUES

        current_Hw_Values = {}
        fan_data = []
        query = c.execute("select name,system_name,low_threshold,hi_threshold,speed from fan")
        conn.commit()
        columnNames = list(map(lambda x: x[0], query.description))
        for col in c:
            rowDict = dict(zip(columnNames, col))
            fan_data.append(rowDict)

        current_Hw_Values["Fan"]=fan_data

        Temperature = []

        query = c.execute("select t.name,t.system_name,t.low_threshold,t.hi_threshold,t.temp  from temp_probes t")
        conn.commit()
        columnNames = list(map(lambda x: x[0], query.description))
        for col in c:
            rowDict = dict(zip(columnNames, col))
            Temperature.append(rowDict)
        
        disks_temperature = []

        query = c.execute("select d.name,d.system_name,d.low_threshold,d.hi_threshold from disks d")
        conn.commit()
        columnNames = list(map(lambda x: x[0], query.description))
        for col in c:
            rowDict = dict(zip(columnNames, col))
            disks_temperature.append(rowDict)

        current_Hw_Values["Disks_Temperature"] = disks_temperature
        c.close()
        conn.close()
        
        license_info = "NA"
        cmd="test_response"
        name="License"
        action="check"
        message="set,element=test_response,element_name={0},args=2,action={1},uuid={2}".format(name,action,cmd_Id)
        send_ccm_msg(message) 
        response = json.loads(get_ccm_response(cmd_Id))
        if response["status"] == 'success':
            is_license = response["description"].split(",")[-1].split(':')[-1].strip()
            if "NOT OK" in is_license:
                license_info = 'NOT PRESENT'
            else:
                license_info = 'PRESENT'
        else:
            license_info = 'NOT PRESENT'
        additional_data = {
            "multi_device_data" : multi_device_data,
            "volume_data" : volume_data,
            "host_server_data" : host_server_data,
            "serial_number" : {"serial_number": serial_number},
            "license_info" : {"license_info": license_info},
            "Current_Hw_Values": current_Hw_Values
        }
        for key, data in additional_data.items():
            json_filename = os.path.join(temp_folder_name, key+'.json')
            with open(json_filename,'w') as f:
                json.dump(data, f, indent=2)
        #copying files
        #change permision to /var/log
        process2 = subprocess.check_output(['sudo','chmod','-R', '777', '/var/log/']).decode("utf-8")        
        file_names = [LogsFilePath, AlertsFilePath, network_yaml_path,ConsoleAlertLogPath,ConsoleLogPath,LicenseCertPath,KmipKeyIdPath,LicenseFeaturePath]
        for file in file_names:
            if not os.path.exists(file):
                continue
            else:
                process1 = subprocess.check_output(['sudo','chmod',"-R",'777', file]).decode("utf-8")
                shutil.copy(file, temp_folder_name)
        
        logSeq = ["ccmloggerFile.log*","console.log*","consoleAlert*","storcli.log*"]

        for seq in logSeq:
            filesLst = []
            if seq=="storcli.log*":
                filesLst = glob.iglob(os.path.join("/home/sanuyi/san/", seq))
            else:
                filesLst = glob.iglob(os.path.join("/mnt/data/", seq))
            
            for file in filesLst:
                if os.path.isfile(file):
                    shutil.copy(file, temp_folder_name)
        
        #copy /var/log/
        destination = shutil.copytree("/var/log/", os.path.join(temp_folder_name, "LogFiles"))
        # copy rrd folder
        destination = shutil.copytree(rrdPath, os.path.join(temp_folder_name, "rrdFiles"))
        # dmseg
        dmseg_file = os.path.join(temp_folder_name, "dmesg.txt")
        process1 = subprocess.check_output(["dmesg", '-T']).decode("utf-8")
        with open(dmseg_file, 'w') as f:
            f.write(process1)
        # sudo apt install zip
        #  zip -r --password password file2.zip hardware-testing/
        arg1 = "/usr/bin/zip"
        arg2 = "-r"
        arg3 = "--password"
        arg4 = EMAIL_LOG_ZIP_PASSWORD
        arg5 = zip_file_name
        arg6 = temp_folder_name
        arg7 = '-j'
        # process1 = subprocess.check_output(["cd",arg6])
        try:
            process1 = subprocess.check_output([arg1, arg2, arg3, arg4, arg5, arg6]).decode("utf-8")
        except:
            process1 = subprocess.check_output([arg1, arg2, arg3, arg4, arg5, arg6], shell=True).decode("utf-8")
        try:
            shutil.rmtree(temp_folder_name)
        except OSError as e:
            print ("Error: %s - %s." % (e.filename, e.strerror))
        return zip_file_name
        
    except Exception as err:
        #print "create_zip_file_with_logs",err
        return -1


def read_CCMLogs():	
    displayTextList = ['Date Time','Element','Element Name','Log Level','State','Action','Message']
    colWidth = [{ "width": "10%" },{ "width": "10%" },{ "width": "10%" },{ "width": "5%" },{ "width": "5%" },{ "width": "15%" },{ "width": "25%" }]
    propertyNameList = ['datetime','element','elementname','loglevel','sate','action','message']
    try:
        with open(LogsFilePath, 'r') as csvfile:
            filereader = reversed(list(csv.reader(csvfile, delimiter='@')))
            i = 0
            header = []
            out_data = []
            header = propertyNameList
            for row in filereader:
                i+=1
                if i > csvlimit and limitcsv:
                    break
                row = [elem for elem in row if elem]
                #print row
                #row[0:2] = [row[0]]
                _dict = {}
                for elem, header_elem in zip(row, header):
                    try:
                        if header_elem.strip() == "datetime":
                            elem = datetime.strptime(elem.strip(),DATE_FORMAT_LOGROUTINE).strftime(DATE_FORMAT_FOR_GUI)
                        _dict[header_elem.strip()] = elem.strip()
                    except:
                        pass
                out_data.append(_dict)	
        
            # shutil.copyfile(LogsFilePath,"/var/www/gui@Q/Quantum/SystemLogs.log")
            print (json.JSONEncoder().encode({
                'logsData':ApplyFilter(out_data),'headers':displayTextList,'propetyName':propertyNameList,
                'colWidth':colWidth
            }))
    except Exception as e:
        print(json.JSONEncoder().encode({
                'logsData':[],'headers':displayTextList,'propetyName':propertyNameList,
                'colWidth':colWidth
            }))

def read_CCMAlerts():	
    displayTextList = ['Date Time','Element','Element Name','Log Level','State','Action','Message']
    colWidth = [{ "width": "10%" },{ "width": "10%" },{ "width": "10%" },{ "width": "5%" },{ "width": "5%" },{ "width": "10%" },{ "width": "30%" }]
    propertyNameList = ['datetime','element','elementname','loglevel','sate','action','message']
    try:
        with open(AlertsFilePath, 'r') as csvfile:
            filereader = reversed(list(csv.reader(csvfile, delimiter='@')))
            i = 0
            header = []
            out_data = []
            header = propertyNameList
            for row in filereader:
                i+=1
                if i > csvlimit and limitcsv :
                    break
                row = [elem for elem in row if elem]
                #print row
                #row[0:2] = [row[0]]
                _dict = {}
                for elem, header_elem in zip(row, header):
                    try:
                        if header_elem.strip() == "datetime":
                            elem = datetime.strptime(elem.strip(),DATE_FORMAT_LOGROUTINE).strftime(DATE_FORMAT_FOR_GUI)
                        _dict[header_elem.strip()] = elem.strip()
                    except:
                        pass
                out_data.append(_dict)	
        #print datetime.strptime('15/03/2019-19:34:46', '%d/%m/%Y-%H:%M:%S')
        print (json.JSONEncoder().encode({'logsData':ApplyFilter(out_data),'headers':displayTextList,'propetyName':propertyNameList, 'colWidth':colWidth}))
    except Exception as e:
        print(json.JSONEncoder().encode({
                'logsData':[],'headers':displayTextList,'propetyName':propertyNameList,
                'colWidth':colWidth
            }))
def read_CCMConsole():	
    displayTextList = ['Date Time','Message']
    colWidth = [{ "width": "10%" },{ "width": "10%" }]
    propertyNameList = ['datetime','message']
    try:
        with open(ConsoleLogPath, 'r') as csvfile:
            filereader = reversed(list(csv.reader(csvfile, delimiter='@')))
            i = 0
            header = []
            out_data = []
            header = propertyNameList
            for row in filereader:
                i+=1
                if i > csvlimit and limitcsv :
                    break
                row = [elem for elem in row if elem]
                #print row
                #row[0:2] = [row[0]]
                _dict = {}
                for elem, header_elem in zip(row, header):
                    try:
                        if header_elem.strip() == "datetime":
                            elem = datetime.strptime(elem.strip(),DATE_FORMAT_LOGROUTINE).strftime(DATE_FORMAT_FOR_GUI)
                        _dict[header_elem.strip()] = elem.strip()
                    except:
                        pass
                out_data.append(_dict)	
        #print datetime.strptime('15/03/2019-19:34:46', '%d/%m/%Y-%H:%M:%S')
        print (json.JSONEncoder().encode({'logsData':ApplyFilterConsole(out_data),'headers':displayTextList,'propetyName':propertyNameList, 'colWidth':colWidth}))
    except Exception as e:
        print(json.JSONEncoder().encode({
                'logsData':[],'headers':displayTextList,'propetyName':propertyNameList,
                'colWidth':colWidth
            })  )
def ApplyFilterConsole(logs):
    if str(logType) != '':
        logTypeFilters = logType.split(",")
        
    # if str(logType) != '' and str(logType) != 'All':
    #     logs = [x for x in logs if x['sate'] in logTypeFilters]
    
    # if str(maxLogLevel) != '' and str(maxLogLevel) != 'None':
    #     logs = [x for x in logs if int(x['loglevel']) <= int(maxLogLevel)]
    
    if str(startDate) != '' and str(startDate) != 'None':		
        #print datetime.strptime(str(startDate), '%m/%d/%Y')        
        logs = [x for x in logs if datetime.strptime(x['datetime'], DATE_FORMAT_FOR_GUI) >= datetime.strptime(str(startDate)+" 00:00:00", '%m/%d/%Y %H:%M:%S')]       
        
    if str(endDate) != '' and str(endDate) != 'None':
        #print "endDate",endDate
        logs = [x for x in logs if datetime.strptime(x['datetime'], DATE_FORMAT_FOR_GUI) <= datetime.strptime(str(endDate)+" 23:59:59", '%m/%d/%Y %H:%M:%S')]
        
    return logs
    
def ApplyFilter(logs):
    if str(logType) != '':
        logTypeFilters = logType.split(",")
        
    if str(logType) != '' and str(logType) != 'All':
        logs = [x for x in logs if x['sate'] in logTypeFilters]
    
    if str(maxLogLevel) != '' and str(maxLogLevel) != 'None':
        logs = [x for x in logs if int(x['loglevel']) <= int(maxLogLevel)]
    
    if str(startDate) != '' and str(startDate) != 'None':		
        #print datetime.strptime(str(startDate), '%m/%d/%Y')        
        logs = [x for x in logs if datetime.strptime(x['datetime'], DATE_FORMAT_FOR_GUI) >= datetime.strptime(str(startDate)+" 00:00:00", '%m/%d/%Y %H:%M:%S')]       
        
    if str(endDate) != '' and str(endDate) != 'None':
        #print "endDate",endDate
        logs = [x for x in logs if datetime.strptime(x['datetime'], DATE_FORMAT_FOR_GUI) <= datetime.strptime(str(endDate)+" 23:59:59", '%m/%d/%Y %H:%M:%S')]
        
    return logs
    
def download_logs():
    zipFileName = create_zip_file_with_logs()
    
    time.sleep(2)
    web_zip_path = zipFileName.replace(webServerRoot,'')
    
    time.sleep(2)
    print (json.JSONEncoder().encode({
        'download_file':web_zip_path, 'filename':os.path.basename(zipFileName)
    }))
    time.sleep(2)

print ("Content-type:text/html\r\n\r\n")
# if request_Type == 'download_logs':
    # download_logs()
try:
    if request_Type == 'read_CCMLogs':
        read_CCMLogs()
    elif request_Type == 'read_CCMAlerts':
        read_CCMAlerts()
    elif request_Type == 'read_CCMConsole':
        read_CCMConsole()
    elif request_Type == 'download_logs':
        download_logs()
except BaseException as e:
    #print json.JSONEncoder().encode({'status':'fail','description':'Eror occured, Please refer log file more info'})
    print (json.JSONEncoder().encode({'status':'fail','description':str(e)}))
    timeNow =  datetime.now()
    f= open("./log.txt","a+")
    f.write(str(timeNow)+" "+ str(e)+ "\r\n")
