#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
from cgi_Global_myserver_totResources import *
import cgi,cgitb
cgitb.enable()
import sqlite3
import json
import datetime
from globalSettings import *
from globalSettings import LocalTempPath
import xml.etree.ElementTree as ET
import logging
import sys
import socket
import subprocess
from subprocess import call
import os
import shutil

#filename='elemenTree.xml'
elementTreeXML= ElementTreeXML   #replace the path with the current directory path where the file resides
#print elementTreeXML
tree = ET.parse(elementTreeXML)
root = tree.getroot()
xml_write=elemenTree_write

date=datetime.date.today().strftime("%Y-%m-%d")
res_group=[]
res_image=[]
veth_id_list=[]
vm_id_list=[]
vm_network_name_list=[]

available_storage=sys_storage()
available_vcpu=sys_vcpu()
available_memory=sys_memory()


form = cgi.FieldStorage()

#Logic for getting App info for createing Snapshot -- start
if GUI:
	server_name=form.getvalue('server_name')
	app_type=form.getvalue('type')
	server_name=form.getvalue('snapshot_name')
else:
	server_name=input('Enter server_name => ')
	app_type=input('Enter type => ')
	server_name=input('Enter snapshot_name =>')

conn=sqlite3.connect(DBPath)
conn.text_factory=str
c=conn.cursor()
try:
	query_fetch_vmid=c.execute("select vm_image_id,num_cores,memory_GB,vm_disk_size,id from virtualmachine where name=?",[server_name])
	for col in c:		
		image_id = col[0]
		vcpu=col[1]
		memory = col[2]
		disk_size = col[3]
		parent_VM_id=col[4]
	conn.commit()



	queryNetwork="select network.name from vm_network inner join veth_port on vm_network.id=veth_port.id inner join network on network.id=veth_port.network_id where vm_network.vm_id="+ str(parent_VM_id) +"" 
	#print queryNetwork
	query_fetch_ntwNames=c.execute("select network.name from vm_network inner join veth_port on vm_network.id=veth_port.id inner join network on network.id=veth_port.network_id where vm_network.vm_id=?",[parent_VM_id])
	for nwnames in c:
		nw_name=nwnames[0]
		vm_network_name_list.append(nw_name)		
	conn.commit()

except:
	c.close()
	conn.close()
#Logic for getting App info for createing Snapshot -- End

def virtual_machine_setup():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		if int(disk_size) > int(available_storage) or int(available_storage)==0:
			print (json.JSONEncoder().encode({"status":"fail","message":"InSufficient Storage"}))
		elif int(vcpu) > int(available_vcpu):
			print (json.JSONEncoder().encode({"status":"fail","message":"InSufficient VCPU's"}))
		elif float(memory) > int(available_memory):
			print (json.JSONEncoder().encode({"status":"fail","message":"Insufficient Memory"}))
		else:

			query_vmName=c.execute("select name from virtualmachine where name=?",[server_name])
			vmName=c.fetchall()
			
			#Search database if virtual machine exists with the entered name
			
			if not vmName:
				query_virtualmachine_set=c.execute("insert into virtualmachine (name,num_cores,memory_GB,vm_disk_size,vm_image_id,cr_date,edit_date,saved_path,state,type,parent_VM_id) values(?,?,?,?,?,?,?,'/vm/?',4,?,?)",[server_name,vcpu,memory,disk_size,image_id,date,date,server_name,app_type,parent_VM_id])
				conn.commit()

				#Get the 'id' of the entered virtual server/virtual machine
				query_fetch_vmid=c.execute("select id from virtualmachine where name=?",[server_name])
				conn.commit()
				
				for vmId in c:
					vnet_vmId=vmId[0]
					vm_id_list.append(vnet_vmId) #Get vm_id to create vm_network for the created Virtual machine

				#Insert Values to 'veth_port' table by using network names(ref:Network Table)

				for i in vm_network_name_list:
					query=c.execute("select id from network where name='"+i+"'")      #network(id) list to use as foreign key constraint in veth_port table
					conn.commit()
					for ntw in c:
						network_id=ntw[0]
						query_vethPort=c.execute("insert into veth_port(name,state,cr_date,edit_date,ip,netmask,network_id) values(?,?,?,?,?,?,?)",(i,0,date,date,"0.0.0.0","255.255.255.0",network_id))
						conn.commit()
						fetch_veth_id=c.lastrowid
						veth_id_list.append(fetch_veth_id)
						

				for i in vm_id_list:
					for j in veth_id_list:
						query_vm_ntw=c.execute("insert into vm_network (vm_id,veth_id) values(?,?)",(i,j))
						conn.commit()				

				snapVmId=vm_id_list[0]
				print(json.JSONEncoder().encode({'status':'success','message':'successfully inserted','name':server_name,'vmId':snapVmId}))
				#resource_save_VM()
				resources_vm_running()
				copyImageToNativeLocalFolder(parent_VM_id,snapVmId)

			else:		
				print(json.JSONEncoder().encode({'status':'Fail','message':'Server Name already exists','name':server_name}))

								
			c.close()
			conn.close()
	except Exception as e:
		c.close()
		conn.close()
		



def copyImageToNativeLocalFolder(parent_VM_id,snapVmId):
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		query_lan=c.execute("Select path_app_saved,file_name,app_download_server,image_type,vm_group.group_name,image_name,virtualmachine.saved_path,virtualmachine.name,virtualmachine.type from vm_image inner join vm_group on vm_image.vm_group_id=vm_group.id inner join virtualmachine on virtualmachine.vm_image_id=vm_image.id  where virtualmachine.id=?",[parent_VM_id])
		for col in c:		
			sourcepath=col[0]	
			srcfile =  col[6]+'/'+ (col[7].replace(" ", "_"))+'.'+col[3]
			if col[8] == 'native':
				localRoot = '/local'
			else:
				localRoot=''
			dstroot = col[6]+localRoot									#+(server_name).replace(" ", "_")
			#print(dstroot)
			oldFileName=(col[7].replace(" ", "_"))+'.'+col[3]
			newFileName=(server_name + '.'+col[3]).replace(" ", "_")
			
			
		conn.commit()
		if not os.path.exists(dstroot) and srcfile !='' and srcfile !='None':
			os.makedirs(dstroot)
		
		if not os.path.exists(LocalTempPath):
			os.makedirs(LocalTempPath)
		shutil.copy(srcfile, LocalTempPath)
		#shutil.copy(srcfile, dstroot)
		for filename in os.listdir(LocalTempPath):
			if filename == oldFileName:
				os.rename(LocalTempPath+'/'+oldFileName, LocalTempPath+'/'+ newFileName)
		shutil.copy(LocalTempPath + '/'+ newFileName, dstroot)
		shutil.rmtree(LocalTempPath + '/')
		query = "update virtualmachine set saved_path='"+ dstroot +"' where virtualmachine.id="+str(snapVmId)
		query_lan=c.execute(query)
		query = "update virtualmachine set last_local_backup=Date() where id="+str(parent_VM_id)
		query_lan1=c.execute(query)
		conn.commit()
		c.close()
		conn.close()
	except Exception as e:
		c.close()
		conn.close()

	
	
	
	
	
def update_element(tag_name,new_value):
	for element in root.iter(tag_name):
		element.text=str(new_value)
		#tree.write('/var/www/vm_xml1.xml')
		tree.write(xml_write)
		

def set_element_attribute(tag_name,attribute_name,new_value):
	print ("Length is 3")
	for element in root.iter(tag_name):
		#root.iter(element_name)
		element.set(attribute_name,new_value)
		#tree.write('/var/www/vm_xml1.xml')
		tree.write(xml_write)


#socket_cmd = "</msg>64get,element=virtualmachine,element_name="+server_name+",args=2,id,name</msg>"
# xml_path="/var/www/vm_xml1.xml"
xml_path="/var/www/vm_xml1.xml"
args=1
element_action='start'
#message="set,element=virtualmachine,element_name={0},args={1},element_action={2},element_path={3}".format(server_name,args,element_action,xml_path)
length="0000"
length_message=99#len(message)
if length_message<=9:
	k=length.rfind("0")
elif length_message<=99:
	k=length.rfind("00")
elif length_message<=999:
	k=length.rfind("000")
msg_length=length[:k]+str(length_message)
#socket_cmd="</msg>{:0>4}{1}</msg>".format(len(message),message)
#socket_cmd="</msg>{0}{1}</msg>".format(msg_length,message)

#def send_ccm_msg():
	#process1 = subprocess.call(['/var/www/vm_ccm/cgi_client.sh',socket_cmd])
#	process1 = subprocess.call(['/var/www/cgi_client.sh',socket_cmd])
	#print process1
	#print socket_cmd





print ("Content-type:text/html\r\n\r\n")
virtual_machine_setup()
update_element('name',server_name)
update_element('memory',float(memory)*1024)
update_element('vcpu',vcpu)
#send_ccm_msg()


