#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
import cgi
import cgitb
from global_func import *
from globalSettings import *
cgitb.enable()
import sqlite3
import json
from db import *
from logRoutine import *

initLogging()

form = cgi.FieldStorage()

if GUI == True:
    request_Type = form.getvalue('RequestType')
else:
    print("1. read_SubComponent()")
    print("2. read_AllSubComponents()")

    choice = int(input("Select cgi funcation => "))

    if choice == 1:
        request_Type = "read_SubComponent"
    elif choice == 2:
        request_Type = "read_AllSubComponents"
    else:
        print("Invalid Choice")

component = form.getvalue('component')
subComponent = form.getvalue('subComponent')
if subComponent == "IPMI Port" or subComponent=="IPMI":
    subComponent = "IPMI"#"Management"


def read_SubComponent():
    # Call corresponding method based on component and sub component
    if component == 'Temperature':
        typeOfTemp = form.getvalue('type')
        result = {}
        if typeOfTemp == "CPU":
            cpu_query = c.execute(
                "Select id,name,ifnull(location,'System'),ifnull(temperature,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(min,0),ifnull(max,0),ifnull([default],0) from cpu where name = '"+subComponent + "'")
        # elif "Disk" in subComponent or "HDD" in subComponent or "SSD" in subComponent:
        elif typeOfTemp == 'Disks':
            cpu_query = c.execute(
                "Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull(temp_default,'c') from disks where name = '"+subComponent + "'")
        # elif typeOfTemp=='Temp_Probes':
        else:
            cpu_query = c.execute(
                "Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull([default],0) from temp_probes where name =? ",[subComponent])
        
        for col in c:
            result['id'] = col[0]
            result['name'] = col[1]
            result['location'] = col[2]
            #default value is the temp
            result['temperature'] = col[3]
            result['low_threshold'] = col[4]
            result['hi_threshold'] = col[5]
            result['min'] = col[6]
            result['max'] = col[7]
            result['default_val'] = 0
            result['TemperatureType'] = NameConversions('Temperature',col[8])#TemperatureType #read default type from globalSettings

        print((json.JSONEncoder().encode(result)))

    elif component == 'Fans':
        result = {}
        cpu_query = c.execute(
            "Select id,name,location,ifnull([default],0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull(speed,0) from fan where name = '"+subComponent + "'")
        for col in c:
            result['id'] = col[0]
            result['name'] = col[1]
            result['location'] = col[2]
            result['default_val'] = col[3]
            result['low_threshold'] = col[4]
            result['hi_threshold'] = col[5]
            result['t_min'] = col[6]
            result['t_max'] = col[7]
            result['speed'] = col[8]
        print((json.JSONEncoder().encode(result)))
    elif component == 'Network':
        result = {}
        cpu_query = c.execute(
            "Select id,name,location,ifnull(tx_rx_monitor,0),ifnull(err_threshold,50),ifnull(err_max,0),ifnull(tx_rx_default,10) from eth_ports where name = '"+subComponent + "'")
        for col in c:
            name = col[1]
            if name == "IPMI":
                name = "IPMI Port"
            result['id'] = col[0]
            result['name'] = name
            result['location'] = col[2]
            result['tx_rx_monitor'] = col[3]
            result['err_threshold'] = col[4]
            result['err_max'] = col[5]
            result['tx_rx_default'] = col[6]
        print((json.JSONEncoder().encode(result)))
    elif component == 'Storage':
        typeOfStorage = form.getvalue('type')
        result = {}
        if typeOfStorage == "Pools":
            cpu_query = c.execute(
                "Select id,system_name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,50),ifnull(err_max,0),ifnull(tx_rx_default,10) from multi_device where system_name = '"+subComponent + "'")
        # elif typeOfStorage=="Disks":
        else:
            cpu_query = c.execute(
                "Select id,name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,50),ifnull(err_max,0),ifnull([tx_rx_default],10) from disks where name = '"+subComponent + "'")
        for col in c:
            result['id'] = col[0]
            result['name'] = col[1]
            result['location'] = col[2]
            result['tx_rx_monitor'] = col[3]
            result['err_threshold'] = col[4]
            result['err_max'] = col[5]
            result['tx_rx_default'] = col[6]
        print((json.JSONEncoder().encode(result)))
    elif component == 'Sensor':
            result = {}
            cpu_query = c.execute(
                "Select id,name,value,min,max,units,position,type  from sensor where name = '"+subComponent + "'")
            for col in c:
                result['id'] = col[0]
                result['name'] = col[1]
                result['value'] = col[2]
                result['min'] = col[3]
                result['max'] = col[4]
                result['units'] = col[5]
                result['position'] = col[6]
                result['type'] = col[7]
            print((json.JSONEncoder().encode(result)))

    conn.commit()
    c.close()
    conn.close()


def update_SubComponent():
    if component == 'Temperature':
        low_threshold = form.getvalue('low_threshold')
        hi_threshold = form.getvalue('hi_threshold')
        temperature = form.getvalue('temperature')
        typeOfTemp = form.getvalue('type')
        if typeOfTemp == "CPU":
            cpu_query = c.execute("update cpu set low_threshold=?,hi_threshold=?,[default]=?  where name =?", [
                                  low_threshold, hi_threshold, temperature, subComponent])
        # elif "Disk" in subComponent or "HDD" in subComponent or "SSD" in subComponent:
        elif typeOfTemp == 'Disks':
            cpu_query = c.execute("update disks set low_threshold=?,hi_threshold=?,temp_default=?  where name =?", [
                                  low_threshold, hi_threshold, temperature, subComponent])
        # elif typeOfTemp=='Temp_Probes':
        else:
            cpu_query = c.execute("update temp_probes set low_threshold=?,hi_threshold=?,[default]=?  where name =?", [
                                  low_threshold, hi_threshold, temperature, subComponent])

        dArgs=loggerArgs(typeOfTemp + "/" + "hardware",component,infoLevel,"update")
        ccmLogger(info,"updated temperature of " + typeOfTemp +" of " + subComponent,dArgs)
        print((json.JSONEncoder().encode(
            {"status": "success", "description": "updated successfully"})))

    if component == 'Network':
        #err_threshold = form.getvalue('err_threshold')
        tx_rx_default = form.getvalue('tx_rx_default')
        tx_rx_monitor = form.getvalue('tx_rx_monitor')
        cpu_query = c.execute("update eth_ports set tx_rx_default=?,tx_rx_monitor=?  where name =?", [
                              tx_rx_default, tx_rx_monitor, subComponent])

        dArgs=loggerArgs("eth_ports/" + "hardware",component,infoLevel,"update")
        ccmLogger(info,"updated network of " + "eth_ports of " + subComponent,dArgs)

        print((json.JSONEncoder().encode(
            {"status": "success", "description": "updated successfully"})))

    if component == 'Storage':
        #err_threshold = form.getvalue('err_threshold')
        tx_rx_default = form.getvalue('tx_rx_default')
        tx_rx_monitor = form.getvalue('tx_rx_monitor')
        typeOfStorage = form.getvalue('type')
        tableName = str()
        if typeOfStorage == "Pools":
            cpu_query = c.execute("update multi_device set tx_rx_default=?,tx_rx_monitor=?  where system_name =?", [
                                  tx_rx_default, tx_rx_monitor, subComponent])
            tableName = "multi_device"
        # elif typeOfStorage=="Disks":
        else:
            cpu_query = c.execute("update disks set tx_rx_default=?,tx_rx_monitor=?  where name =?", [
                                  tx_rx_default, tx_rx_monitor, subComponent])
            tableName = "disks"

        dArgs=loggerArgs(tableName+"/" + "hardware",component,infoLevel,"update")
        ccmLogger(info,"updated storage of " + tableName +" of " + subComponent,dArgs)
        print((json.JSONEncoder().encode(
            {"status": "success", "description": "updated successfully"})))

    elif component == 'Fans':
        low_threshold = form.getvalue('low_threshold')
        hi_threshold = form.getvalue('hi_threshold')
        cpu_query = c.execute("update fan set low_threshold=?,hi_threshold=?  where name =?", [
                              low_threshold, hi_threshold, subComponent])

        dArgs=loggerArgs("fan/" + "hardware",component,infoLevel,"update")
        ccmLogger(info,"updated fans of fan of " + subComponent,dArgs)

        print((json.JSONEncoder().encode(
            {"status": "success", "description": "updated successfully"})))
    elif component == 'Sensor':
        min = form.getvalue('min')
        max = form.getvalue('max')
        cpu_query = c.execute("update sensor set min=?,max=?  where name =?", [
                              min, max, subComponent])

        dArgs=loggerArgs("sensor/" + "",component,infoLevel,"update")
        ccmLogger(info,"updated sensor of sensor of " + subComponent,dArgs)

        print((json.JSONEncoder().encode(
            {"status": "success", "description": "updated successfully"})))
    conn.commit()
    c.close()
    conn.close()


def read_AllSubComponents():
    NodeType = Get_MachineID()
    temperature = []  # ['CPU','Motherboard','Storage']
    fans = []  # 'CPU','REAR FAN1','REAR FAN2','PSU1 FAN','PSU2 FAN'
    network = []
    # storage = {'Pools':[],'Disks':[]} #['HDD Pool','SSD Pool','HDD 0','HDD 1','HDD 2','HDD 3','HDD 4','HDD 5','HDD 6','HDD 7','SSD 0','SSD 1','SSD 2','SSD 3']
    storage = []
    sensor = []

    temperature_query = c.execute(
        "Select name,'CPU' from cpu where name='CPU' union select name,'Temp_Probes' from temp_probes union select name,'Disks' from disks where name not like 'sd%'")
    for col in c:
        temperature.append({'name': col[0], 'type': col[1]})

    fan_query = c.execute("Select name from fan order by name")
    for col in c:
        fans.append(col[0])

    #network_query = c.execute("Select name from eth_ports where name!='IPMI'  order by name")
    if NodeType == "Prowler2":
        network_query = c.execute("Select name from eth_ports where name not in ('IPMI','LAN3','LAN4')  order by name")
    else:
        network_query = c.execute("Select name from eth_ports where name not in ('IPMI')  order by name")
    for col in c:
        name = col[0]
        if name == "Management":
            name = "IPMI"
        network.append(name)

    storage_query = c.execute(
        "Select system_name,name from multi_device union select name,'Disks' from disks where name not like 'sd%'")
    for col in c:
        storage.append({"name": col[0], "type": col[1]})
    
    sensor_query = c.execute("Select name from sensor")
    for col in c:
        sensor.append(col[0])

    conn.commit()
    c.close()
    conn.close()
    print((json.JSONEncoder().encode(
        {"temperature": temperature, "fans": fans, "network": network, "storage": storage,"sensor" : sensor})))

def NameConversions(Title,type):
    if Title == 'Temperature':
        #if type == 'F':
        if type == 'f':
            return 'Fahrenheit'
        #elif type == 'Celcius':
        elif type == 'c':
            return 'Celcius'
        else:
            return TemperatureType  #read default type from globalSettings
    elif Title == 'Monitor':
        if type == 0:
            return 'OFF'
        elif type == 1:
            return 'ON'
        else:
            return ''

print("Content-type:text/html\r\n\r\n")

# Entry point for CRUD operations
if request_Type == 'read_SubComponent':
    read_SubComponent()
elif request_Type == 'update_SubComponent':
    update_SubComponent()
elif request_Type == 'create_Component':
    create_Component()
elif request_Type == 'read_AllSubComponents':
    read_AllSubComponents()