#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
import os
from globalSettings import DBPath
from logRoutine import *
initLogging()
try:
    from kmip.pie import objects
    from kmip.pie.client import ProxyKmipClient, enums
except Exception as e:
    pass
import binascii
import ssl

form = cgi.FieldStorage()

cmd_Id = get_ccm_command_id()


if GUI == True:
    request_Type = form.getvalue('RequestType')
else:
    print("1. Read KMIP")
    print("2. Create KMIP")
    choice = int(input("Select cgi funcation => "))
    if choice == 1:
        request_Type = "read_KMIPServices"
    elif choice == 2:
        request_Type = "create_KMIPServices"
def create_KMIPServices():
    if GUI == True:
        userName = form.getvalue('userName')
        password = form.getvalue('password')
        host = form.getvalue('host')
        portNumber = form.getvalue('portNumber')
        auth = form.getvalue('auth')
    else:
        userName = input('Enter userName =>')
        password = input('Enter password => ')
        host = input('Enter host => ')
        portNumber = input('Enter portNumber => ')
        auth = input('Enter auth (yes/no) => ')
    
    if host !="" and portNumber!="" and userName!="" and password!="":
        config_path = "/etc/pykmip/pykmip.conf"
        if os.path.exists(config_path):
            config_path = config_path
        else:
            config_path = "/mnt/data/kmip_files/pykmip.conf"
        try:
            cKmip = ProxyKmipClient(
                hostname=host,
                port=int(portNumber),
                username=userName,
                password=password,
                config_file= config_path
            )
        except Exception as e:
            print (json.JSONEncoder().encode({"status": "fail", "description": "pykmip module not installed!!"}))
            return
        try:
            if(auth == "yes"):
                cKmip.open()
                kmipConnection = "Success - KMIP Connection Open"
            else:
                cKmip.close()
                kmipConnection = "Success - KMIP Connection Closed"
        except Exception as e:
            print (json.JSONEncoder().encode({"status": "fail", "description": "Connection Error / Invalid Credentials"}))
            return
        
        if CCM:
            cmd = "SaveKMIP"
            message = "set,element=services,element_name={0},args=7,Action={1},userName={2}," \
                    "pwd={3},host={4},port={5},auth={6},uuid={7}" \
                .format(sender, cmd, userName, password, host, portNumber,auth ,cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            dArgs=loggerArgs("kmipServer/" + "KMIP_serviceManager",userName,infoLevel,"create")
            ccmLogger(info,response["description"],dArgs)
            print (response)
            delete_ccm_response(cmd_Id)
        else:
            conn = sqlite3.connect(DBPath)
            conn.text_factory = str
            c = conn.cursor()
            Db_open=True
            try:
                query_lan = c.execute("delete from kmipServer")
                conn.commit()
                query_lan = c.execute(
                    "insert into kmipServer (userName,pwd,host,port,auth) values(?,?,?,?,?)",
                    [userName, password, host, portNumber,auth])
                conn.commit()
                c.close()
                conn.close()
                print (json.JSONEncoder().encode({"status": "success", "description": kmipConnection}))
                Db_open = False
            except Exception as e:
                if Db_open:
                    c.close()
                    conn.close()
                print (json.JSONEncoder().encode({"status": "fail", "description": "Exception while saving KMIP service Details"}))
    else:
        print (json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"}))

def read_KMIPServices():
    id, userName, password, host, port = '', '', '', '', ''
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open=True
    dbdata = []
    try:
        dbquery = "SELECT id,userName,pwd,host,port,auth from kmipServer"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            id, userName, password, host, port, auth = col[0], col[1], col[2], col[3], col[4],col[5]
        jsonschema = {"id": id, "userName": userName, "password": password, "host": host,
                        "port": port,"auth" : auth}
        dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
    print (json.JSONEncoder().encode(dbdata))


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_KMIPServices':
    create_KMIPServices()
elif request_Type == 'read_KMIPServices':
    read_KMIPServices()
else:
    print (json.JSONEncoder().encode({"test":"test"}))
