#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=True
import cgi, cgitb
import sqlite3
import json,os
import subprocess
from clearTextPwd import *
from logRoutine import *
from globalSettings import DBPath
from global_func import get_ccm_command_id,send_ccm_msg,get_ccm_response
cgitb.enable()
initLogging()
import base64
form = cgi.FieldStorage()


if GUI == True:
    request_Type = form.getvalue('RequestType')
else:
    print("1. read_MachineSetupServices()")
    print("2. create_MachineSetupServices()")
    print("3. updateCanister()")

    choice = int(input("Select cgi funcation => "))
    if choice == 1:
        request_Type = "read_MachineSetupServices"
    elif choice == 2:
        request_Type = "create_MachineSetupServices"
    elif choice == 3:
        request_Type = "updateCanister"
def updateSystemName(system_name):
    FileName = "/etc/hosts"
    old_system_name = getSystemName()

    process = subprocess.check_output(['sudo','chmod','777',FileName]).decode("utf-8")

    process = subprocess.check_output(['sudo','hostnamectl','set-hostname',system_name]).decode("utf-8")

    with open(FileName) as f:
        newText=f.read().replace(old_system_name, system_name)

    with open(FileName, "w") as f:
        f.write(newText)



def CheckCanDisks():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    canisterState="No Disks"
    try:    
        query2 = c.execute("select count(*) from multi_device where name!='system'")
        poolCount = c.fetchone()[0]
        #query = c.execute("select name from disks where name like'mr%'")
        query = c.execute("select count(*) from disks where name like'mr%'")
        disksCount = c.fetchone()[0]
        if poolCount==0 and disksCount==0:
            canisterState = "No Disks"
        elif poolCount == 0 and disksCount!=0:
            canisterState = "Native"
            #canisterState = CheckSerial()
        elif disksCount == 0:
            canisterState = "No Disks"
        else:
            pass
    except Exception as e:
        c.close()
        conn.close()

    return canisterState     

def getCanisterSerialNumber(CanDBFileName):
    canisterState = CheckCanDisks()

    if canisterState == "Native":
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        try:
            query = c.execute("select serial_number from system")
            canisterSerial = c.fetchone()[0]
            c.close()
            conn.close()
        except Exception as e:
            c.close()
            conn.close()
    else:

        canisterSerial=""
        CheckFile = CanDBFileName
        isfile=os.path.isfile(CheckFile)
        if isfile==True:
            f_size=os.path.getsize(CheckFile)
            if f_size==0:
                process = subprocess.check_output(["rm",CheckFile]).decode("utf-8")
                isfile=os.path.isfile(CheckFile)
                canisterSerial = None
                #return "NoDB"
            else:
                Fconn = sqlite3.connect(CanDBFileName)
                Fconn.text_factory = str
                Fconn.execute('pragma foreign_keys=ON')
                Fc = Fconn.cursor()
                try:
                    query = Fc.execute("select serial_number from system")
                    canisterSerial = Fc.fetchone()[0]
                    Fc.close()
                    Fconn.close()
                except Exception as e:
                    Fc.close()
                    Fconn.close()
        else:
            canisterSerial = None
    
    
    return canisterSerial


def getSystemName():
    system_name = "n/a"
    try:
        process1 = subprocess.check_output(["hostnamectl"]).decode("utf-8")
        output = process1.splitlines()
        for line in output:
            if "Static hostname" in line.split(':')[0].strip():
                system_name = line.split(':')[-1].strip()
    except Exception as e:
        system_name = system_name
    return system_name


def create_MachineSetupServices():
    if GUI == True:
        system_name = form.getvalue('system_name')
        controller_name = form.getvalue('controller_name')
        reset_can_extn = form.getvalue('reset_can_extn')
        reset_db= form.getvalue('reset_db')
    else:
        system_name = input('Enter system_name => ')
        controller_name = input('Enter controller_name => ')
        reset_can_extn = input('Enter reset canister extenstion (yes/no) => ')
        reset_db = input('Enter reset DB Data on Start (yes/no) => ')
    #canister_serial = form.getvalue("canister_sl")

    if system_name != "" and controller_name!='' and system_name and controller_name:
        try:
            updateSystemName(system_name)
        except Exception as e:
            print (json.JSONEncoder().encode({"status": "fail", "description": "Error while updating the system name: {}".format(str(e))}))
            return
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        try:
            query_lan = c.execute("update system set name='" + str(system_name) + "', reset_on_extraction='"+reset_can_extn+"', reset_on_db='" + reset_db+"'")
            conn.commit()
            query_lan = c.execute("update controller set name='" + str(controller_name) + "'")
            conn.commit()
            c.close()
            conn.close()
            print (json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"}))
        except Exception as e:
            c.close()
            conn.close()
            print (json.JSONEncoder().encode({"status": "fail", "description": "Error While updating system name/contorller name {)".format(str(e))}))
    else:
        print (json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"}))


def read_MachineSetupServices():
    canDbFilename = "/mnt/system/quantumDB.db"    
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    dbdata = []
    jsonschema = {}
    try:
        dbquery = "SELECT c.name, s.serial_number,s.reset_on_extraction,s.reset_on_db from system s, controller c"
        query = c.execute(dbquery)
        conn.commit()
        
        for col in c:
            jsonschema["controller_name"] = col[0]
            jsonschema["serial_number"] = col[1]
            jsonschema["reset_on_extraction"] = col[2]
            jsonschema["reset_on_db"] = col[3]
            #dbdata.append(jsonschema)
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
    jsonschema["system_name"] = getSystemName()
    jsonschema["canister_serial"] = getCanisterSerialNumber(canDbFilename)
    dbdata.append(jsonschema)
        
        # for col in c:
        #     system_name = getSystemName()
        #     canisterSerial= getCanisterSerialNumber(canDbFilename)
        #     jsonschema = {"system_name": system_name, "controller_name": col[0], "serial_number":col[1],"canister_serial":canisterSerial}
        #     dbdata.append(jsonschema)
        # conn.close()
    print (json.JSONEncoder().encode(dbdata))

def btoa(name):
    name_bytes = name.encode('utf-8')
    encoded_name_bytes = base64.b64encode(name_bytes)
    encoded_password = encoded_name_bytes.decode('utf-8')

    return encoded_password

def updateCanister():
    conn = sqlite3.connect(DBPath,check_same_thread= False)
    conn.text_factory = str
    c = conn.cursor()
    if GUI:
        userId = form.getvalue('userId')
        password = form.getvalue('password')
    else:
        c.execute("select id,userName from person")
        resp = c.fetchall()
        print(resp)
        userId = input('Enter userId => ')
        password = btoa(input('Enter password => '))
    #print"Password",password
    decoded_password = (base64.b64decode(password)).decode("utf-8")
    password = decoded_password

    try:
        query_pwd = c.execute("select password from person where id=?",[userId])
        db_Pwd = c.fetchone()[0]
        conn.commit()
        isEnPwd = is_EncodedString_base64(db_Pwd)
        
        if isEnPwd :
            EncryptGUIpwd = pwd_encoding(password)
            password = EncryptGUIpwd

        query=c.execute("SELECT * from person where id=? and password=?",[userId,password])
        isValidCredentials=c.fetchall()
        sys_serial = c.execute("select serial_number from system")
        for col in c:
            serial_number=col[0]
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
        print (json.JSONEncoder().encode({"status": "fail", "description": "Error while fetching serial_number.{0}".format(str(e))}))

    if isValidCredentials:
        #canDbFilename = "/mnt/data/quantumDB.db"
        # check if file exists
        # if yes update it
        # if no file
        # return Canister DB does not exist
        canDbFilename = "/mnt/system/quantumDB.db"
        if(os.path.exists(canDbFilename)):
            os.chmod(canDbFilename,0o777)
            Fconn = sqlite3.connect(canDbFilename,check_same_thread= False)
            Fconn.text_factory = str
            Fconn.execute('pragma foreign_keys=ON')
            Fc = Fconn.cursor()
            try:
                dbquery=Fc.execute("update system set serial_number='"+serial_number+"'")
                Fconn.commit()
                Fc.close()
                Fconn.close()
                print (json.JSONEncoder().encode({"status": "success", "description": "Saved successfully","serial_number":serial_number}))
            except Exception as e:
                Fc.close()
                Fconn.close()
                print (json.JSONEncoder().encode({"status": "fail", "description": "DB Update failed"}))
        else:
            print(json.JSONEncoder().encode({"status" : "fail", "description" : "Canister DB does not exist"}))
    else:
        print (json.JSONEncoder().encode({"status": "fail", "description": "Invalid Credentials"}))
    conn.close()

def factoryReset():
    cmd_Id = get_ccm_command_id()
    cmd="test_response"
    name="Factory"
    action="factory reset Canister"
    if CCM:
        message="set,element=test_response,element_name={0},args=2,action={1},uuid={2}".format(name,action,cmd_Id)
        #print(message)
        send_ccm_msg(message)
        response = get_ccm_response(cmd_Id)
        print (response)
    else:
        print (json.JSONEncoder().encode({"status": "success", "description": "Factory reset"}))

print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_MachineSetupServices':
    create_MachineSetupServices()
elif request_Type == 'read_MachineSetupServices':
    read_MachineSetupServices()
elif request_Type=="updateCanister":
    updateCanister()
elif request_Type=="factoryReset":
    factoryReset()
else:
    print (json.JSONEncoder().encode({"status": "fail", "description": "test"}))
