#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=True
import cgi,cgitb
cgitb.enable()
import sqlite3
import json
import datetime
from globalSettings import DBPath
import subprocess
from subprocess import call
from global_func import *
from logRoutine import *
initLogging()


date=datetime.date.today().strftime("%Y-%m-%d")

form=cgi.FieldStorage
if GUI:
    request_Type=form.getvalue('requestType')
else:
    print("1. read_Networks")
    choice = int(input("Select choice => "))
    if choice == 1:
        request_Type = "read_Networks"

cmd_Id = get_ccm_command_id()
cmd_Id2="2578"
#Step 1 get values we need from the GUI environment
print("Content-type:text/html\r\n\r\n")

def create_Network():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        cmd="create_Network"

        ntw_Name=form.getvalue("ntw_Name")
        cidr_Addr=form.getvalue("cidr_Addr")
        if form.getvalue("dhcp"):
            dhcp=form.getvalue("dhcp")
        else:
            dhcp="no"

        #result_addNtw=[]

        #Step2 : PRECHECKS

        if ('/') not in cidr_Addr:
            dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"create")
            ccmLogger(error,"CIDR '/' is missing in "+ cidr_Addr,dArgs)
            print(json.JSONEncoder().encode({"status":"Failed","Description":"CIDR '/' is missing"}))
            #result_addNtw.append(json_res)
        else:

            (addrString,cidrString)=cidr_Addr.split('/')
            addr=addrString
            cidr=int(cidrString)
            val_format=[]
            ipv4_Addr=add_validate(addr)

            if ipv4_Addr==True and cidr in range(33):

                query_validate_name=c.execute("select name from network where name='"+ntw_Name+
                                            "' or name='"+ntw_Name.upper()+"' or name='"+
                                            ntw_Name.lower()+"' or name='"+ntw_Name.title()+"' ")
                conn.commit()
                networkName=c.fetchall()

                if not networkName:
                    query_validate_cidr=c.execute("select cidr from network where cidr='"+cidr_Addr+"'")
                    conn.commit()
                    cidr_ip=c.fetchall()
                    if not cidr_ip:
                        # Step 3 Send CCM message
                        if CCM == True:
                            message="set,element=network,element_name={0},args=4,action={1},cidr={2},enable_dhcp={3},uuid={4}".\
                                                format(ntw_Name,cmd,cidr_Addr,dhcp,cmd_Id)
                            send_ccm_msg(message)
                            response = get_ccm_response(cmd_Id)
                            print(response)
                            delete_ccm_response(cmd_Id)
                        else:
                            query_setup_network=c.execute(" insert into network (name,cidr,enable_dhcp,state,cr_date,edit_date) values(?,?,?,?,?,?)",(ntw_Name,cidr_Addr,dhcp,0,date,date))
                            conn.commit()
                            c.close()
                            conn.close()
                            print(json.JSONEncoder().encode({"status":"success","description":"Successfully added Network with CCM False"}))
                        dArgs=loggerArgs("network/" + "network",ntw_Name,infoLevel,"create")
                        ccmLogger(info,"Successfully added Network " + ntw_Name,dArgs)
                    else:
                        dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"create")
                        ccmLogger(error,"CIDR Already Exists",dArgs)
                        print(json.JSONEncoder().encode({"status":"fail","description":"Cidr already Exists"}))
                else:
                    dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"create")
                    ccmLogger(error,"Network Name already exists",dArgs)
                    print(json.JSONEncoder().encode({"status":"fail","description":"network name already exists"}))
            else:
                dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"create")
                ccmLogger(error,"Address should be in the format x.y.z.a and all the values should be in the range 0-255 "
                    "and cidr should be of /24",dArgs)
                print(json.JSONEncoder().encode({"status":"fail","description":
                    "Address should be in the format x.y.z.a and all the values should be in the range 0-255 "
                    "and cidr should be of /24"}))
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()

def update_Network():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        #step1:get values we need from the GUI environment

        cmd="edit_Network"

        ntw_Id=form.getvalue('ntw_Id')
        ntw_Name=form.getvalue('ntw_Name')
        cidr_Addr=form.getvalue("cidr_Addr")
        if form.getvalue('dhcp'):
            dhcp=form.getvalue('dhcp')
        else:
            dhcp='no'


        #Step2 : PRECHECKS

        query=c.execute("select count(*) from veth_port where network_id={}".format(ntw_Id))
        conn.commit()
        counter=c.fetchone()[0]

        if counter == 0:
            result_editNtw=[]

            if('/') not in cidr_Addr:
                dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"update")
                ccmLogger(error,"CIDR '/' is missing in "+ cidr_Addr,dArgs)
                print(json.JSONEncoder().encode({"status":"fail","Description":"CIDR '/' is missing"}))

            else:
                (addrString,cidrString)=cidr_Addr.split('/')
                addr=addrString
                cidr=int(cidrString)
                #val_format=[]
                ipv4_Addr=add_validate(addr)

                if ipv4_Addr==True and cidr in range(33):

                    query_validate_name1=c.execute("select name from network where name in ('"+ntw_Name+"','"+
                                                ntw_Name.lower()+"','"+ntw_Name.upper()+"','"+ntw_Name.title()+
                                                "')and id not like '{}'".format(ntw_Id))
                    networkName=c.fetchall()

                    if not networkName:
                        query_validate_cidr=c.execute("select cidr from network where cidr='"+
                                                    cidr_Addr+"' and id not like '{}'".format(ntw_Id))
                        conn.commit()
                        cidr_ip=c.fetchall()

                        if not cidr_ip:
                            # Step 3 Send CCM message
                            if CCM == True:

                                message="set,element=network,element_name={0},args=5,action={1}," \
                                        "cidr={2},enable_dhcp={3},network_id={4},uuid={5}".format(ntw_Name,cmd,cidr_Addr,dhcp,ntw_Id,cmd_Id)
                                send_ccm_msg(message)
                                response = get_ccm_response(cmd_Id)
                                print(response)
                                delete_ccm_response(cmd_Id)
                            else:
                                query_update_network=c.execute("update network set name=?,cidr=?,enable_dhcp=?,edit_date=? where id=?",(ntw_Name,cidr_Addr,dhcp,date,ntw_Id))
                                conn.commit()
                                c.close()
                                conn.close()
                                print(json.JSONEncoder().encode({"status":"success","Description":"Successfully Updated Network"}))
                            dArgs=loggerArgs("network/" + "network",ntw_Name,infoLevel,"update")
                            ccmLogger(info,"Successfully Updated Network " + ntw_Name,dArgs)
                        else:
                            dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"update")
                            ccmLogger(error,"CIDR Already Exists",dArgs)
                            print(json.JSONEncoder().encode({"status":"fail","Description":"CIDR Already Exists"}))

                    else:
                        dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"update")
                        ccmLogger(error,"Network Name already exists",dArgs)
                        print(json.JSONEncoder().encode({"status":"fail","Description":"Network Name already exists"}))

                else:
                    dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"update")
                    ccmLogger(error,"Address should be in the format x.y.z.a and cidr in range 3",dArgs)
                    print(json.JSONEncoder().encode({"status":"fail","Description":"Address should be in the format x.y.z.a and cidr in range 3"}))
        



        else:
            dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"update")
            ccmLogger(error,"Cannot Edit a network " + ntw_Name + " as it is used by {} Virtual Machine(s).".format(counter),dArgs)
            print(json.JSONEncoder().encode({"status":"fail","Description":"Cannot Edit a Network as it is used by {} Virtual Machine(s)".format(counter)}))
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()

def delete_Network():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        cmd="delete_Network"
        ntw_Id=form.getvalue('ntw_Id')
        ntw_Name=form.getvalue('ntw_name')

        query=c.execute("select count(*) from veth_port where network_id={}".format(ntw_Id))
        counter=c.fetchone()[0]

        if counter==0:
            if CCM == True:
                message="set,element=network,element_name={0},args=3,action={1},network_id={2},uuid={3}".format(ntw_Name,cmd,ntw_Id,cmd_Id)
                send_ccm_msg(message)
                response = get_ccm_response(cmd_Id)
                print(response)
                delete_ccm_response(cmd_Id)
            else:
                dlt_ntw=c.execute("delete from network where id={}".format(ntw_Id))
                conn.commit()
                print(json.JSONEncoder().encode({"status":"success","description":"Successfully Deleted Network when CCM False"}))	
            dArgs=loggerArgs("network/" + "network",ntw_Name,infoLevel,"delete")
            ccmLogger(info,"deleted network",dArgs)
        else:
            dArgs=loggerArgs("network/" + "network",ntw_Name,errorLevel,"delete")
            ccmLogger(error,"Cannot Delete a network " + ntw_Name + " as it is used by {} Virtual Machine(s).".format(counter),dArgs)
            print(json.JSONEncoder().encode({"status":"fail","Description":"Cannot Delete a network as it is used by {} Virtual Machine(s).".format(counter)}))
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()


def read_NetworkAll():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        ntw_Names=[]
        q_Ntw_Names=c.execute("select id,name from network")
        conn.commit()

        for col in c:
            temp={}
            temp['id']= col[0]
            temp['name'] = col[1]
            ntw_Names.append(temp)
        print(json.JSONEncoder().encode(ntw_Names))
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()


def read_NetworkById():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        ntw_Id=form.getvalue('ntw_Id')
        q_Ntw_CIDR=c.execute("select cidr,enable_dhcp from network where id={}".format(ntw_Id))
        conn.commit()
        temp = {}
        for col in c:
            temp['cidr']=col[0]
            temp['enable_dhcp']=col[1]
        print(json.JSONEncoder().encode(temp))
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
if request_Type=='delete_Network':
    delete_Network()
elif request_Type== 'update_Network':
    update_Network()
elif request_Type=='create_Network':
    create_Network()
elif request_Type == 'read_Networks':
    read_NetworkAll()
elif request_Type == 'read_NetworkById':
    read_NetworkById()
