#!/usr/bin/python3
import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=False
else:
	GUI=True
	CCM=False
import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from logRoutine import *
from uuid import getnode as get_mac
import subprocess
from globalSettings import DBPath
from clearTextPwd import * 
initLogging()
import base64

form = cgi.FieldStorage()
if GUI == True:
    request_Type=form.getvalue('RequestType') 
    # pass
else:
    print("1. read_Group()")
    print("2. read_User()")
    print("3. read_Role()")
    print("4. create_AdminUser()")
    print("5. delete_User()")

    choice = int(input("Select cgi funcation => "))
    if(choice == 1):
        request_Type = "read_Group"
    if(choice == 2):
        request_Type = "read_User"
    if(choice == 3):
        request_Type = "read_Role"
    if(choice == 4):
        request_Type = "create_AdminUser"
    if(choice == 5):
        request_Type = "delete_User"

def get_mac_hash():
    mac = get_mac()
    return hash(mac)

def Uploadfile(filePath):
	#logic for save image in folder
	#logic for insert image details in fileinfo table
	#return file id
	return 1

def getBaseBoardSerialNumber():
    try:
        process1 = subprocess.check_output(["sudo",'dmidecode','-s','baseboard-serial-number']).decode("utf-8")
        return process1.strip()
    except:
        return "DUMMY: error dmidecode"

def create_Group():
    groupId=form.getvalue('groupId')
    groupName=form.getvalue('groupName') 
    groupDescription=form.getvalue('groupDescription')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    try:
        if groupId == '0':
            query_lan=c.execute("select count(*) from OrgGroup where Name='"+ str(groupName)+"'")
            nameCount = c.fetchone()[0]
            conn.commit()
        
            if nameCount == 0:
                query_SP=c.execute("insert into OrgGroup(Name,Description,cr_date,edit_date) values(?,?,datetime(),datetime())",[groupName,groupDescription])
                conn.commit()       
                print (json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
            else:

                print (json.JSONEncoder().encode({"status":"fail","description":"Group Name already exists"}))
        else:
            query_SP=c.execute("update OrgGroup set Name=?,Description=?,edit_date=datetime() where id=?",[groupName,groupDescription,groupId])
            conn.commit()
            print (json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
        print (json.JSONEncoder().encode({"status":"fail","description":"Exception while updating the group"}))
    
def delete_Group():
    groupId=form.getvalue('groupId')
    
    try:
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        Db_open = True
        query_lan=c.execute("select count(*) from UserLink where group_id='"+ str(groupId)+"'")
        recordCount = c.fetchone()[0]
        conn.commit()   
    
        query_lan=c.execute("select count(*) from GroupLink where link_group_id='"+ str(groupId)+"'")
        recordCountGroups = c.fetchone()[0]
        conn.commit()    
    
        if recordCount > 0:
            print (json.JSONEncoder().encode({'status':'fail','description':'You cant delete group, since users are mapped to this group.'}))
            c.close()
            conn.close()
            Db_open = False
            return
        elif recordCountGroups >0:
            print (json.JSONEncoder().encode({'status':'fail','description':'You cant delete group, since groups are mapped to this group.'}))
            c.close()
            conn.close()
            Db_open = False
            return
        else:
            query_FT=c.execute("delete from  OrgGroup where id=?",[groupId])
            conn.commit()
            query_FT=c.execute("delete from  GroupLink where group_id=?",[groupId])
            conn.commit()
            c.close()
            conn.close()
            Db_open = False
            print (json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
        print (json.JSONEncoder().encode({'status':'fail','description':'Exception while deleting the group'}))


def delete_Role():
    roleId=form.getvalue('roleId')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    try:
        query_lan=c.execute("select count(*) from UserLink where role_id='"+ str(roleId)+"'")
        recordCount = c.fetchone()[0]
        conn.commit()   
        if recordCount > 0:
            print (json.JSONEncoder().encode({'status':'fail','description':'You cant delete role, since users are mapped to this role.'}))
            c.close()
            conn.close()
            Db_open = False
            return
        else:
            query_FT=c.execute("delete from  OrgRole where id=?",[roleId])  
            conn.commit()   
            query_FT=c.execute("delete from  RoleLink where role_id=?",[roleId])    
            conn.commit()
            c.close()
            conn.close()
            Db_open = False
            print (json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
        print (json.JSONEncoder().encode({'status':'fail','description':'Exception while deleting the role'}))
    
def read_Group():
    if GUI:
        groupId=form.getvalue('groupId')
    else:
        groupId="0"
    if groupId == '0':
        dbquery="SELECT id,name,description from OrgGroup"
    else:
        dbquery="SELECT id,name,description from OrgGroup where id="+str(groupId)
    
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            jsonschema = {"id":col[0],"name" : col[1],"description" :col[2]}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    print (json.JSONEncoder().encode(dbdata))

def getDBGroups():
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        dbquery="SELECT id,Name,Description,level from OrgGroup"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"id":col[0],"Name" : col[1],"Description" :col[2],"level":col[3]}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    #conn.close()
    return dbdata
    
def create_User():
    userId=form.getvalue('userId')
    
    firstName=form.getvalue('firstName')
    middleName=form.getvalue('middleName')
    lastName=form.getvalue('lastName') 
    
    userName=form.getvalue('userName') 
    userName = userName.lower().strip()

    password=(base64.b64decode(form.getvalue('password'))).decode("utf-8")
    
    selectedRoles =form.getvalue('selectedRoles')
    selectedGroups =form.getvalue('selectedGroups')
    
    managerId=form.getvalue('managerId')
    employmentStatus=form.getvalue('employmentStatus')
    imgPath = form.getvalue('imgPath')
    
    contactEmail=form.getvalue('contactEmail')
    contactPhone=form.getvalue('contactPhone')
    companyEmail=form.getvalue('companyEmail')
    companyPhone=form.getvalue('companyPhone')
    
    address1=form.getvalue('address1')
    address2=form.getvalue('address2')
    city=form.getvalue('city')
    state=form.getvalue('state')
    country=form.getvalue('country')
    postalCode=form.getvalue('postalCode')
    
    if userId == '0':
        if imgPath == "None":
            imgPath=None
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        Db_open = True
        try:
            query_lan=c.execute("select count(*) from person where userName='"+ str(userName)+"'")
            nameCount = c.fetchone()[0]
            conn.commit()
            
            if nameCount == 0:
                Encryptpassword=dbSavePwd(password)
                password = Encryptpassword
                query_SP=c.execute("insert into person(userName,FirstName,MiddleName,LastName,password,contactEmail,contactPhone,companyEmail,companyPhone,manager_id,employmentStatus,address1,address2,city,state_providence,country,postalcode,profilePic_id,cr_date,edit_date) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,datetime(),datetime())",[userName,firstName,middleName,lastName,password,contactEmail,contactPhone,companyEmail,companyPhone,managerId,employmentStatus,address1,address2,city,state,country,postalCode,imgPath])
                conn.commit()
                userId = c.lastrowid
                c.close()
                conn.close()
                Db_open = False           
                
                mapUserRoleGroups(userId,selectedRoles,selectedGroups)
                dArgs=loggerArgs("person/" + "organization",userId,infoLevel,"create")
                ccmLogger(info,"successfully created" + userId,dArgs)
                print (json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
            else:
                dArgs=loggerArgs("person/" + "organization",userId,errorLevel,"create")
                ccmLogger(error,"User Name already exists " + userName,dArgs)   
                print (json.JSONEncoder().encode({"status":"fail","description":"User Name already exists"}))
        except Exception as e:
            if Db_open:
                c.close()
                conn.close()
                Db_open = False
            print (json.JSONEncoder().encode({"status":"fail","description":"Exception while saving User"}))
            
    else:
        if imgPath == "None":
            query_lan=c.execute("select profilePic_id from person where userName='"+ str(userName)+"'")
            imgPath = c.fetchone()[0]
            #print "imgPath ", imgPath
        
        Encryptpassword=dbSavePwd(password)
        password = Encryptpassword
        query_SP=c.execute("update person set userName = ?,FirstName = ?,MiddleName = ?,LastName = ?,password = ?,contactEmail = ?,contactPhone = ?,companyEmail = ?,companyPhone = ?,manager_id = ?,employmentStatus = ?,address1 = ?,address2 = ?,city = ?,state_providence = ?,country = ?,postalcode = ?,edit_date=datetime(),profilePic_id=? where id=?",[userName,firstName,middleName,lastName,password,contactEmail,contactPhone,companyEmail,companyPhone,managerId,employmentStatus,address1,address2,city,state,country,postalCode,imgPath,str(userId)])
        conn.commit()
        query_SP=c.execute("delete from UserLink where person_id=?",[userId])
        conn.commit()
        
        mapUserRoleGroups(userId,selectedRoles,selectedGroups)
        dArgs=loggerArgs("person/" + "organization",userId,infoLevel,"update")
        ccmLogger(info,"successfully updated" + userId,dArgs)
        print (json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
    
    c.close()
    conn.close()
    
def createAdminUser():
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    if GUI:
        userId=form.getvalue('userId')
        
        firstName=form.getvalue('firstName')
        middleName=form.getvalue('lastName')
        lastName=form.getvalue('lastName') 
        
        userName=form.getvalue('userName') 
        userName = userName.lower().strip()

        password=(base64.b64decode(form.getvalue('password'))).decode("utf-8")
        
        selectedRoles ="User"
        selectedGroups ="User"
        
        managerId="Admin"
        employmentStatus="OK"
        imgPath = "None"
        
        companyEmail=form.getvalue('companyEmail')
        contactEmail=form.getvalue('companyEmail') 
        companyPhone=form.getvalue('companyPhone')
        contactPhone=form.getvalue('companyPhone')

        create_by = form.getvalue('createdBy')
    else:
        print("1. Insert ")
        print("2. update ")
        choice = int(input("Eneter type => "))
        if choice == 1:
            userId = "0"
        else:
            c.execute("Select id,userName from person")
            print(c.fetchall())
            userId=input('Enter userId =>')
        
        firstName=input('Enter firstName =>')
        middleName=""#input('Enter middleName =>')
        lastName=input('Enter lastName =>')

        userName=input('Enter userName => ') 
        userName = userName.lower().strip()

        # password=input('Enter password').decode('base64 =>')
        password=input('Enter password =>')
        
        selectedRoles ="User"
        selectedGroups ="User"
        
        managerId="Admin"
        employmentStatus="OK"
        imgPath = "None"
        
        companyEmail=input('Enter email =>')
        contactEmail=""#input('Enter companyEmail =>') 
        companyPhone=input('Enter Phone => ')
        contactPhone=""#input('Enter companyPhone =>')
        
        create_by =input('Enter createdBy (admin)=> ')

    address1="None"
    address2="None"
    city="None"
    state="None"
    country="None"
    postalCode="None"
    Db_open = True
    if userId == '0':
        if imgPath == "None":
            imgPath=None
        try:
            query_lan=c.execute("select count(*) from person where userName='"+ str(userName)+"'")
            nameCount = c.fetchone()[0]
            conn.commit()
            if nameCount == 0:
                Encryptpassword=dbSavePwd(password)
                password = Encryptpassword
                query_SP=c.execute("insert into person(userName,FirstName,MiddleName,LastName,password,contactEmail,contactPhone,companyEmail,companyPhone,manager_id,employmentStatus,address1,address2,city,state_providence,country,postalcode,profilePic_id,cr_date,edit_date) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,datetime(),datetime())",[userName,firstName,middleName,lastName,password,contactEmail,contactPhone,companyEmail,companyPhone,managerId,employmentStatus,address1,address2,city,state,country,postalCode,imgPath])
                conn.commit()
                userId = c.lastrowid
                c.close()
                conn.close()
                Db_open = False
                mapUserRoleGroups(userId,selectedRoles,selectedGroups)
                print (json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
            else:
                dArgs=loggerArgs("person/" + "organization",userId,errorLevel,"create")
                ccmLogger(error,"User Name already exists " + userName,dArgs)   
                print (json.JSONEncoder().encode({"status":"fail","description":"User Name already exists"}))
        except Exception as e:
            if Db_open:
                c.close()
                conn.close()
                Db_open = False
            print(json.JSONEncoder().encode({"status":"fail","description":"Exception while saving User"}))
            
    else:
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        Db_open = True
        try:
            if imgPath == "None":
                query_lan=c.execute("select profilePic_id from person where userName='"+ str(userName)+"'")
                imgPath = c.fetchone()[0]
            Encryptpassword=dbSavePwd(password)
            password = Encryptpassword
            query_SP=c.execute("update person set userName = ?,FirstName = ?,MiddleName = ?,LastName = ?,password = ?,contactEmail = ?,contactPhone = ?,companyEmail = ?,companyPhone = ?,manager_id = ?,employmentStatus = ?,address1 = ?,address2 = ?,city = ?,state_providence = ?,country = ?,postalcode = ?,edit_date=datetime(),profilePic_id=? where id=?",[userName,firstName,middleName,lastName,password,contactEmail,contactPhone,companyEmail,companyPhone,managerId,employmentStatus,address1,address2,city,state,country,postalCode,imgPath,str(userId)])
            conn.commit()
            query_SP=c.execute("delete from UserLink where person_id=?",[userId])
            conn.commit()
            c.close()
            conn.close()
            Db_open = False
        except Exception as e:
            print(e)
            if Db_open:
                c.close()
                conn.close()
                Db_open = False
                print (json.JSONEncoder().encode({'status':'faile','description':'Exception while updating user'}))
                return
        
        mapUserRoleGroups(userId,selectedRoles,selectedGroups)
        dArgs=loggerArgs("person/" + "organization",userId,infoLevel,"update")
        ccmLogger(info,"Username: '" + str(userName) + "' successfully updated by '" + str(create_by) + "'",dArgs)

        print (json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
    
def mapUserRoleGroups(userId,selectedRoles,selectedGroups):
    if str(selectedRoles) != "None":
        selectedRolesList = selectedRoles.split(",")
        selectedGroupsList = selectedGroups.split(",")
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        try:
            for index, roleId in enumerate(selectedRolesList):
                groupId = selectedGroupsList[index]
                query_SP=c.execute("insert into UserLink(state,cr_date,person_id,role_id,group_id) values(?,datetime(),?,?,?)",[1,userId,roleId,groupId])
                conn.commit()
            c.close()
            conn.close()
        except Exception as e:
            c.close()
            conn.close()

def delete_User():
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    if GUI:
        userId=form.getvalue('userId')
    else:
        c.execute("select id,userName from person")
        print(c.fetchall())
        userId = input("Enter userId => ")
    try:
        query_lan=c.execute("select count(*) from person where manager_id='"+ str(userId)+"'")
        recordCount = c.fetchone()[0]
        conn.commit()   
        if recordCount > 0:
            print (json.JSONEncoder().encode({'status':'fail','description':'You cant delete user, since other users are mapped to this user.'}))
            dArgs=loggerArgs("person/" + "organization",userId,errorLevel,"delete")
            ccmLogger(error,"You cant delete user, since other users are mapped to this user. " + userId,dArgs)
            return
        else:
            query_FT=c.execute("delete from  person where id=?",[str(userId)])  
            conn.commit()
            query_FT=c.execute("delete from  UserLink where person_id=?",[str(userId)]) 
            conn.commit()
        c.close()
        conn.close()
        print (json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
    except Exception as e:
        c.close()
        conn.close()
        print (json.JSONEncoder().encode({'status':'fail','description':'Exception while deleting {0}'.format(str(e))}))
    
    
def validate_User():
    userName=form.getvalue('userName')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    try:
        query_lan=c.execute("select count(*) from person where userName='"+ str(userName)+"'")
        nameCount = c.fetchone()[0]
        conn.commit()
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
        print (json.JSONEncoder().encode({'status':'fail','description':'Exception while validating user name {0}'.format(str(e))}))
        return
    if nameCount == 0:
        dArgs=loggerArgs("person/" + "organization",userName,infoLevel,"validate")
        ccmLogger(info,"User Name Available " + userName,dArgs)
        print (json.JSONEncoder().encode({'status':'success','description':'User Name Available'}))
    else:
        dArgs=loggerArgs("person/" + "organization",userName,errorLevel,"validate")
        ccmLogger(error,"User Name Already Exists, please choose another " + userName,dArgs)
        print (json.JSONEncoder().encode({'status':'fail','description':'User Name Already Exists, please choose another'}))

def read_User(bReturn):
    if GUI == True:
        userId=form.getvalue('userId')
    else:
        userId = "0"
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    
    if str(userId) == "None":
        userId= '0'
    try:   
        if userId == '0':
            dbquery="SELECT person.id,userName,FirstName,MiddleName,LastName,password,contactEmail,contactPhone,companyEmail,companyPhone,manager_id,employmentStatus,address1,address2,city,state_providence,country,postalcode,fileInfo.path from person left join fileInfo on person.profilePic_id = fileInfo.id"
        else:
            dbquery="SELECT person.id,userName,FirstName,MiddleName,LastName,password,contactEmail,contactPhone,companyEmail,companyPhone,manager_id,employmentStatus,address1,address2,city,state_providence,country,postalcode,fileInfo.path from person  left join fileInfo on person.profilePic_id = fileInfo.id where person.id="+str(userId)
        
        query = c.execute(dbquery)
        
        conn.commit()
        for col in c:
            profilePicPath=str(col[18]).replace(webServerRoot,'') #webServerRoot in globalSettings eg. /var/www
            jsonschema = {"id":col[0],"userName" : col[1],"FirstName" :col[2],"MiddleName":col[3],"LastName" : col[4],"password" :pwd_decoding(col[5]),"userEmail":col[6],"Phone" : col[7],"companyEmail":col[8],"companyPhone" : col[9],"manager_id" :col[10],"employmentStatus":col[11],"address1" : col[12],"address2" :col[13],"city":col[14],"state_providence" : col[15],"country":col[16],"postalcode" : col[17],"profilePicPath":profilePicPath,"userSelectedGroupsRoles" :read_AllUserLinksByUser(col[0]), "system_id":getBaseBoardSerialNumber()}
            dbdata.append(jsonschema)
        #conn.close()
        c.close()
        conn.close()
        Db_open = False
        if bReturn == True:
            return dbdata
        else:
            print(json.JSONEncoder().encode(dbdata))
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open  = False
        print (json.JSONEncoder().encode(dbdata))
        


def read_AllUserLinksByUser(userId):
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    
    #newCon=conn.cursor()
    selectedRoles = []
    try:
        dbquery="SELECT group_id,role_id from UserLink where person_id="+str(userId)
        query = c.execute(dbquery)
        #selectedRoles = []
        conn.commit()
        for userLink in c:
            selectedRoles.append({"groupId":userLink[0],"roleId":userLink[1]})
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    return  selectedRoles

def read_AllGroupsByUser(userId):
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    selectedGroups = []
    try:
        dbquery="SELECT group_id from UserLink where type='group' and user_id="+str(userId)
        query = c.execute(dbquery)
        conn.commit()
        for lst in c:
            selectedGroups.append(lst[0])
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    return  selectedGroups

def read_AllGroupsByRole(roleId):
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    selectedGroups = []
    try:
        dbquery="SELECT group_id from RoleLink where role_id="+str(roleId)
        query = c.execute(dbquery)
        selectedGroups = []
        conn.commit()
        for lst in c:
            selectedGroups.append(lst[0])
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    return  selectedGroups
    
def read_UsersByRole():
    roleId=form.getvalue('roleId')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        dbquery="SELECT distinct person.id,userName,FirstName,LastName,contactEmail from person inner join UserLink rul on  person.id = rul.person_id where rul.role_id="+str(roleId)
        
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            jsonschema = {"id":col[0],"userName" : col[1],"FirstName" :col[2],"LastName":col[3],"userEmail" : col[4]}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
            
    print (json.JSONEncoder().encode(dbdata))

def read_RolesByGroup():
    groupId=form.getvalue('groupId')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        dbquery="SELECT role.id,role.name,role.description from orgRole role inner join RoleLink rgl on  role.id = rgl.role_id where rgl.group_id="+str(groupId)
        
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            jsonschema = {"id":col[0],"name" : col[1],"description" :col[2]}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    print (json.JSONEncoder().encode(dbdata))
    
def read_GroupsByRoles():
    roleIds=form.getvalue('roleIds')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        dbquery="SELECT role.id,role.name,role.description,rgl.group_id,orgGroup.name from orgRole role inner join RoleLink rgl on  role.id = rgl.role_id inner join OrgGroup on orgGroup.id=rgl.group_id where rgl.role_id in("+str(roleIds)+")"
        
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            jsonschema = {"roleId":col[0],"roleName" : col[1],"description" :col[2],"id":col[3],"name":col[4]}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    print (json.JSONEncoder().encode(dbdata))

    
def create_Role():
    roleId=form.getvalue('roleId')
    roleName=form.getvalue('roleName') 
    roleDescription=form.getvalue('roleDescription')    
    selectedGroups=form.getvalue('selectedGroups')
    
    
    if roleId == '0':
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        Db_open = True
        try:
            query_lan=c.execute("select count(*) from OrgRole where Name='"+ str(roleName)+"'")
            nameCount = c.fetchone()[0]
            conn.commit()
        
            if nameCount == 0:
                query_SP=c.execute("insert into OrgRole(Name,Description,cr_date,edit_date) values(?,?,datetime(),datetime())",[roleName,roleDescription])
                conn.commit()
                roleId = c.lastrowid
                c.close()
                conn.close()
                Db_open = False
                mapRoleGroups(roleId,selectedGroups)
                print (json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
            else:
                print (json.JSONEncoder().encode({"status":"fail","description":"Role Name already exists"}))
        except Exception as e:
            if Db_open:
                c.close()
                conn.close()
                Db_open = False
            print (json.JSONEncoder().encode({'status':'fail','description':'Exception while updating OrgRole {0}'.format(str(e))}))
            return  
    else:
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        Db_open = True
        try:
            query_SP=c.execute("update OrgRole set Name=?,Description=?,edit_date=datetime() where id=?",[roleName,roleDescription,roleId])
            conn.commit()
            
            query_SP=c.execute("delete from RoleLink where role_id=?",[roleId])
            conn.commit()
            c.close()
            conn.close()
            Db_open = False
        except Exception as e:
            if Db_open:
                c.close()
                conn.close()
                Db_open = False
            print (json.JSONEncoder().encode({'status':'fail','description':'Exception while updating OrgRole {0}'.format(str(e))}))
            return  
        
        mapRoleGroups(roleId,selectedGroups)
        print (json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))

def mapRoleGroups(roleId,selectedGroups):
    if str(selectedGroups) != "None":
        selectedGroupsList = selectedGroups.split(",")
        conn = sqlite3.connect(DBPath)
        conn.text_factory = str
        c = conn.cursor()
        Db_open = True
        try:
            for groupId in selectedGroupsList:
                query_SP=c.execute("insert into RoleLink(group_id,role_id,cr_date,edit_date) values(?,?,datetime(),datetime())",[groupId,roleId])
                conn.commit()
            c.close()
            conn.close()
            Db_open = False
        except Exception as e:
            if Db_open:
                c.close()
                conn.close()
                Db_open = False
            
def read_Role(bReturn):
    roleId=form.getvalue('roleId') 
    if str(roleId) == "None":
        roleId ='0'
    if roleId == '0':
        dbquery="SELECT id,Name,Description from OrgRole"
    else:
        dbquery="SELECT id,Name,Description from OrgRole where id="+str(roleId)
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            jsonschema = {"id":col[0],"name" : col[1],"description" :col[2],"selectedGroups":read_AllGroupsByRole(col[0])}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
    #conn.close()
    if bReturn == True:
        return dbdata
    else:
        print (json.JSONEncoder().encode(dbdata))

def create_GroupOrganize():
    groupsIds=form.getvalue('groupsIds')
    linkGroupIds=form.getvalue('linkGroupIds')
    groupLevels=form.getvalue('groupLevels')
    
    selectedGroups = groupsIds.split(",")
    selectedLinkedGroups = linkGroupIds.split(",")
    selectedGroupLevels = groupLevels.split(",")
    
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    try:
        query_SP=c.execute("delete from  GroupLink")
        conn.commit()
        
        for index, groupId in enumerate(selectedGroups):
                linkGroupId = selectedLinkedGroups[index]
                level = selectedGroupLevels[index]
                query_SP=c.execute("insert into GroupLink(group_id,link_group_id,cr_date,edit_date) values(?,?,datetime(),datetime())",[groupId,linkGroupId])
                query_SP=c.execute("update orgGroup set level=? where id=?",[level,groupId])
                conn.commit()   
        c.close()
        conn.close()
        Db_open = False
        print (json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False
        print (json.JSONEncoder().encode({'status':'fail','description':'Exception while saving'}))

def read_GroupOrganize():
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        dbquery="SELECT group_id,link_group_id,level from GroupLink inner join orgGroup on GroupLink.group_id=orgGroup.id"  
        query = c.execute(dbquery)
         
        for col in c:
            jsonschema = {"groupId":col[0],"linkGroupId" : col[1],"level":col[2],"type":"GroupLinks"}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
            Db_open = False  
    print (json.JSONEncoder().encode({'savedLinkGroups':dbdata,'DBGroups':getDBGroups(),'DBRoles':read_Role(True),'savedRoleLinks':read_AllRoleLinks(),'DBUsers':read_User(True),'savedUserLinks':read_AllUserLinks()}))
    conn.close()

def read_AllRoleLinks():
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        dbquery="SELECT group_id,role_id from RoleLink" 
        query = c.execute(dbquery)
        for col in c:
            jsonschema = {"groupId":col[0],"roleId" : col[1],"type":"RoleLinks"}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
    except Exception as e:
        if Db_open:
            c.close()
            conn.close() 
    return dbdata
    

def read_AllUserLinks():
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    Db_open = True
    dbdata = []
    try:
        dbquery="SELECT group_id,role_id,person_id from UserLink"   
        query = c.execute(dbquery)
        for col in c:
            jsonschema = {"groupId":col[0],"roleId" : col[1],"userId":col[2],"type":"UserLinks"}
            dbdata.append(jsonschema)
        c.close()
        conn.close()
        Db_open = False
    except Exception as e:
        if Db_open:
            c.close()
            conn.close()
         
    return dbdata
    
print ("Content-type:text/html\r\n\r\n")

try:
    if request_Type=='create_Group':
        create_Group()
    elif request_Type == 'read_Group':
        read_Group()
    elif request_Type == 'delete_Group':
        delete_Group()
    elif request_Type == 'create_User':
        create_User()
    elif request_Type == 'create_AdminUser':
        createAdminUser()
    elif request_Type == 'delete_User':
        delete_User()
    elif request_Type == 'read_User':
        read_User(False)
    elif request_Type == 'validate_User':
        validate_User()
    elif request_Type == 'read_UsersByRole':
        read_UsersByRole()
    elif request_Type == 'read_RolesByGroup':
        read_RolesByGroup()
    elif request_Type=='create_Role':
        create_Role()
    elif request_Type=='read_Role':
        read_Role(False)
    elif request_Type == 'delete_Role':
        delete_Role()
    elif request_Type == 'create_GroupOrganize':
        create_GroupOrganize()
    elif request_Type == 'read_GroupOrganize':
        read_GroupOrganize()
    elif request_Type == 'read_GroupsByRoles':
        read_GroupsByRoles()
except BaseException as e:
    dArgs=loggerArgs("request/organization","request_Type",criticalLevel,"request")
    ccmLogger(critical, str(e), dArgs)
    #print e.message
    # assert False, ccmLogger(critical, str(e), dArgs)
# finally:
#     conn.close() #TODO: need to remove connection close from all other places