#!/usr/bin/python3

import sys
if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
	GUI=False
	CCM=True
else:
	GUI=True
	CCM=True
if GUI==True:
    import cgi,cgitb
    cgitb.enable()
    
from global_func import *
from globalSettings import *
import sqlite3
import json
from logRoutine import *
initLogging()

MIN_FreeSpace=350
if GUI==True:
    form = cgi.FieldStorage()
    requestType=form.getvalue('RequestType')
    #print requestType
    volOff=4
    volStarting=5
    volOn=6
    VolSuspended=7
    cifs=1
    nfs=2
    iSCSI_Chap=3
    iSCSI_NoChap=4
    ftp=5
    fc=6
else:
    volOff=4
    volStarting=5
    volOn=6
    VolSuspended=7
    cifs=1
    nfs=2
    iSCSI_Chap=3
    iSCSI_NoChap=4
    ftp=5
    fc=6
    print( '1. delete_Pool')
    print( '2. create_Pool')
    print( '3. update_Pool')
    print( '4. info ')

    choice=int(input("select cgi function==>"))
    if (choice==1):
        requestType='delete_pool'
    if (choice==2):
        requestType='create_pool'
    if (choice==3):
        requestType='update_pool'
    if (choice==4):
        requestType='read_pool'

    #print( "requestType="+str(requestType))

def form_getvalue(val):
    if (val=='systemName'):
        pool=str(input("input Pool System  Name==>"))
        return pool
    elif (val=='PoolName'):
        query_lan=c.execute("select system_name from multi_device ")
        resp = c.fetchall()
        print (resp)
        pool=str(input("input Pool Type Name==>"))
        return pool
    elif (val=='PoolSize'):
        return 10
    elif (val=='PoolLevel'):
        level=str(input("input Pool Level (0,1,2) ==>"))
        return level
    elif (val=='Acceleration'):
        AccStr=str(input("Acceleration string ==>"))
        return AccStr
    elif (val=='Deduplication'):
        DedupStr=str(input('Deduplication yes or no==>'))
        return DedupStr
    elif (val=='Compression'):
        CompStr=str(input('Compression yes or no==>'))
        return CompStr        
    elif (val=='Percentage'):
        CompStr=str(input('Input Pool %===>'))
        return CompStr
    elif (val=='AccelerationPercent'):
        CompStr=str(input('Input AccelerationPercent %===>'))
        return CompStr
    elif (val=='PoolType'):
        query_lan=c.execute("select id,name from multi_device ")
        resp = c.fetchall()
        print (resp)
        PoolType=str(input('Input PoolType ===>'))
        return PoolType
    else: 
        print( "Unknown Value")
        
cmd_Id = get_ccm_command_id()

totalHDDStorage = TotalHDDStorage #read from global settings
totalSSDStorage = TotalSSDStorage #read from global settings
#92.168.30.11/cgi/cgi_Setup_Pool_Manager.py?PoolName=HDD+POOL&Percentage=10&PoolLevel=0&
#Compression=No&AccelerationPercent=0&Deduplication=No&systemName=pxxx&AvailableStorage=8000&
#availableSSD=4000&RequestType=create_pool&uuid=7U4crC8k

def CheckName(name):
    if len(name)>20:
        return -1
    if len(name)<1:
        return -2
    return 0
    
def create_pool():
    if GUI==True:
        PoolName=form.getvalue('PoolName') 
        PoolLevel=form.getvalue('PoolLevel')
        Compression=form.getvalue('Compression') 
        Deduplication=form.getvalue('Deduplication')
        systemName = form.getvalue('systemName')
        Percentage = form.getvalue('Percentage')
        AccelerationPercent = form.getvalue('AccelerationPercent')
        availableStorage  = form.getvalue('AvailableStorage')
        availableSSD  = form.getvalue('availableSSD')
        raid_controller_id = None

    else:
        PoolName=form_getvalue('PoolName') 
        PoolLevel=form_getvalue('PoolLevel')
        Compression=form_getvalue('Compression') 
        Deduplication=form_getvalue('Deduplication')
        systemName = form_getvalue('systemName')
        Percentage = form_getvalue('Percentage')
        AccelerationPercent = form_getvalue('AccelerationPercent')
        availableStorage  = form_getvalue('AvailableStorage')
        availableSSD  = form_getvalue('availableSSD')
        raid_controller_id = None
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    try:
        redundancy=1
        if int(PoolLevel)==1:
            redundancy=1	#.9
        if int(PoolLevel)==2:
            redundancy=1	#.8
        if int(PoolLevel)==3:
            redundancy=1	#.7

        if ((availableSSD =='0') and (AccelerationPercent !='0')):
            dArgs=loggerArgs("multi_device/" + "setupPool",PoolName,errorLevel,"create")
            ccmLogger(error,"No available SSD for acceleration",dArgs)        
            print( json.JSONEncoder().encode({"status":"fail","description":"No available SSD for acceleration"}) )
            return

        pc1=float(Percentage)
        pc2=float(AccelerationPercent)
        per_cent=float(pc1/100)
        per_centAcc=float(pc2/100)
        Psize=float(per_cent*float(availableStorage)*float(redundancy))
        PoolSize=int(Psize)
        CalculatedRaw= int(float(per_cent)*float(availableStorage))
        acceleration_storage=int(per_centAcc*int(availableSSD))

        query_lan=c.execute("select count(*) from multi_device where system_name='"+ str(systemName)+"'")
        nameCount = c.fetchone()[0]
        conn.commit() 
        
        sysName=systemName.lower()
        
        if sysName == 'system':
            print( json.JSONEncoder().encode({'status':'fail','description':'Pool name cannot be system'}))
            c.close()
            conn.close()
            return
        
        if CheckName(systemName)!=0:
            print( json.JSONEncoder().encode({'status':'fail','description':'Name must be > 1 and less than 20 characters'}))
            c.close()
            conn.close()
            return
        try:
            
            if PoolName == "MegaRAID POOL":
                res = systemName.split("_",2)
                raid_controller_name = "_".join(res[:2])
                query = c.execute("select  id from raid_controller where name='"+raid_controller_name+"'")
                raid_controller_id = c.fetchone()[0]    
        except Exception as e:
            pass
            
        if (nameCount==0):
            if (CCM==True):
                cmd="PoolCreate"
                message="set,element=multi_device,element_name={0},args=8,action={1},PoolLevel={2},Dedup={3},Compression={4},Acceleration={5},AccelerationStorage={6},SystemName={7},Percentage={8},CalculatedRaw={9},Controller_id={10},uuid={11}".\
                format(PoolName,cmd,PoolLevel,Deduplication,Compression,AccelerationPercent,acceleration_storage,systemName,Percentage, CalculatedRaw, raid_controller_id, cmd_Id)            
                send_ccm_msg(message) 
                response = get_ccm_response(cmd_Id)
                print( parse_ccm_response_and_send_verbose("pool", response))
            else:
                acceleration_storage=0
                query_SP=c.execute("insert into multi_device(name,pool_storage,level,state,cr_date,edit_date,compression,acceleration,acceleration_storage,deduplication,system_name,percentage,calculatedraw,controller_id)\
                values(?,?,?,0,datetime(),datetime(),?,?,?,?,?,?,?,?)",[PoolName,PoolSize,PoolLevel,Compression,AccelerationPercent,acceleration_storage,Deduplication,systemName,Percentage,CalculatedRaw,raid_controller_id])
                conn.commit()           
                print( json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
            dArgs=loggerArgs("multi_device/" + "setupPool",PoolName,infoLevel,"create")
            ccmLogger(info,"Pool created successfully",dArgs)
        else:
            dArgs=loggerArgs("multi_device/" + "setupPool",PoolName,errorLevel,"create")
            ccmLogger(error,"Pool Name already exists",dArgs)
            print( json.JSONEncoder().encode({"status":"fail","description":"Pool Name already exists"})  )
            
        c.close()
        conn.close()
    except Exception as e:
        #print(e)
        print( json.JSONEncoder().encode({"status":"fail","description":"Something went wrong"})  )
        c.close()
        conn.close()
    
#def delete_pool():
#    poolType=form.getvalue('PoolType') 
#    query_FT=c.execute("delete from  multi_device where name=?",[poolType])
#    print( json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
#    conn.commit()
#    c.close()
#    conn.close()

def delete_pool():
    if GUI==True:
        PoolType=form.getvalue('PoolType')
        PoolName=form.getvalue('PoolName')
    else:
        PoolType=form_getvalue('PoolType')
        PoolName=form_getvalue('PoolName')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    try:
        query=c.execute("select count(*) from multi_device m, volume v where v.multi_device_id = m.id and m.system_name='"+str(PoolName)+"'")
        count=c.fetchone()[0]
        if count > 0:
            dArgs=loggerArgs("multi_device/" + "setupPool",PoolType,errorLevel,"delete")
            ccmLogger(error,"Volume assosiated with pool. Can't delete!",dArgs)
            print( json.JSONEncoder().encode({"status":"fail","description":"Volume assosiated with pool. Can't delete!"}))
            return  

        query=c.execute("select system_name from multi_device where system_name='"+str(PoolName)+"'")
        systemName=c.fetchone()[0]
        query_lan=c.execute("select count(*) from multi_device where system_name='"+ str(PoolName)+"'")
        nameCount = c.fetchone()[0]
        conn.commit()
        if nameCount != 0:
            if (CCM==True):
                cmd="PoolDelete"
                message="set,element=multi_device,element_name={0},args=3,action={1},SystemName={2},uuid={3}".\
                format(PoolType,cmd,systemName,cmd_Id)
                send_ccm_msg(message)
                response = get_ccm_response(cmd_Id)
                print( parse_ccm_response_and_send_verbose("pool", response))
                        
            else: 
                query=c.execute("delete from  multi_device where system_name=?",[PoolName])
                conn.commit()
                print( json.JSONEncoder().encode({'status':'success','description':'Deleted successfully'}))
            dArgs=loggerArgs("multi_device/" + "setupPool",PoolType,infoLevel,"delete")
            ccmLogger(info,"Deleted successfully",dArgs)           
        else:
            dArgs=loggerArgs("multi_device/" + "setupPool",PoolType,errorLevel,"delete")
            ccmLogger(error,"Pool Name already exists",dArgs)
            print( json.JSONEncoder().encode({"status":"fail","description":"Pool Name does not exist"}))
        c.close()
        conn.close()
    except Exception as e:
        print( json.JSONEncoder().encode({"status":"fail","description":"Pool not deleted!"}))
        c.close()
        conn.close()
    
    
def update_pool():
    PoolName=form.getvalue('PoolName')
    Compression=form.getvalue('Compression')  
    Deduplication=form.getvalue('Deduplication')
    systemName = form.getvalue('systemName')
    AccelerationPercent = form.getvalue('AccelerationPercent')
    #acceleration_storage = form.getvalue('acceleration_storage')
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    sysName=systemName.lower()
    if sysName == 'system':
        print( json.JSONEncoder().encode({'status':'fail','description':'Pool name cannot be system'}))
        c.close()
        conn.close()
        return
    if CheckName(systemName)!=0:
        print( json.JSONEncoder().encode({'status':'fail','description':'Name must be > 1 and less than 20 characters'}))
        c.close()
        conn.close()
        return
    try:
        query_FT=c.execute("update multi_device set compression=?,deduplication=?,system_name=?,acceleration=? where system_name=?",[Compression,Deduplication,systemName,AccelerationPercent,PoolName])
        dArgs=loggerArgs("multi_device/" + "setupPool",PoolName,infoLevel,"update")
        ccmLogger(info,"updated successfully " + PoolName ,dArgs)
        print( json.JSONEncoder().encode({'status':'success','description':'Updated successfully'}))
        
        conn.commit()
        c.close()
        conn.close()
    except Exception as e:
        print( json.JSONEncoder().encode({'status':'fail','description':'Not Updated!'}))
        c.close()
        conn.close()


def getAvailableNVMeOF():
    return 20*1000

def getAvailableiSTOR():
    return 20*1000

def getAvailableMegaRAID(cx):

    MRpoolSize=0
    if cx!='/cx':
        ctrl= cx
        dbquery=c.execute("select sum(size) from disks where controller_id ='{}".format(ctrl)+"'")
        #select sum(size) from disks where name='mra' or name='mrb' or name='mrc' or name='mrd'
        #dbquery=c.execute("select sum(size) from disks where (name='mra' or name='mrb' or name='mrc' or name='mrd')")
        #dbquery=c.execute("select sum(size) from disks where controller_id='/c0'")
    else:
        dbquery=c.execute("select sum(size) from disks where (name='mra' or name='mrb' or name='mrc' or name='mrd')")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        MRpoolSize=int(resp)
    return MRpoolSize
def getAvailableMegaRAID1():

    MRpoolSize=0
    #select sum(size) from disks where name='mra' or name='mrb' or name='mrc' or name='mrd'
    dbquery=c.execute("select sum(size) from disks where (name='mra' or name='mrb' or name='mrc' or name='mrd')")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        MRpoolSize=int(resp)
    return MRpoolSize

    
def getAvailableDisks(cx):

    nbDisks=0
    AllocatedDisks=0
    ctrl=cx
    
    if GUI == True:
        PoolType=form.getvalue('PoolType')
    else:
        query_lan=c.execute("select distinct(name) from multi_device ")
        resp = c.fetchall()
        print (resp)
        PoolType = input("Enter Pool type => ")

    if PoolType=="HDD POOL":
        dbquery=c.execute("select count(*) from disks where rotation =1")
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            nbDisks=int(resp)
        dbquery=c.execute("select id from multi_device where name='HDD POOL'")
        IdList=c.fetchall()
        for md_id in IdList:
            #print( ("id=",md_id[0]))
            PoolId=md_id[0]
            dbquery=c.execute("select count(*) from disks where multi_device_id=?",[PoolId])
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatedDisks=AllocatedDisks+int(resp)
        return (nbDisks-AllocatedDisks)

    elif (PoolType=="MegaRAID POOL" or PoolType=="MegaRAID_c0" or PoolType=="MegaRAID_c1" or PoolType=="MegaRAID_c2"):
        dbquery=c.execute("select count(*) from disks where controller_id ='{}".format(ctrl)+"'")
        #dbquery=c.execute("select count(*) from disks where name='mra' or name='mrb' or name='mrc' or name='mrd'")
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            MRnbDisks=int(resp)
            return MRnbDisks
    else:
        return 10
        
def getRAIDlevel(PoolType):
    level=0
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    try:
        dbquery=c.execute("select level from multi_device where name=?",[PoolType])
        resp=c.fetchone()
        if resp !="None":
            level=resp[0]
        else:
            level=0
        return level
    except Exception as err:
        c.close()
        conn.close()
        return level
       #print( ("getRAIDlevel except",err))
 
def read_pool():
    systemName = form.getvalue('PoolType')
    if systemName!=None:
        #systemName='MegaRAID_c1_p4'
        if 'MegaRAID_c0' in systemName:
            cx='/c0'
        elif 'MegaRAID_c1' in systemName:
            cx='/c1'
        elif 'MegaRAID_c2' in systemName:
            cx='/c2'
        else:
            cx='/cx'
    else:
        cx='/cx'
    
   
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    try:
        dbquery="SELECT id,name,level,pool_storage,state,compression,acceleration,deduplication,acceleration_storage,system_name,percentage,calculatedRaw from multi_device"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"id":col[0],"name" : col[1],"level" :col[2],"pool_storage" : col[3],"state":col[4],"compression" :col[5],"acceleration" : col[6],"deduplication":col[7],"acceleration_storage":col[8],"systemName":col[9],"percentage":col[10],"calculatedRaw":col[11]}
            dbdata.append(jsonschema)


        if True:
            AllocatedHDD = 0
            #dbquery=c.execute("select sum(calculatedRaw+pool_storage) from multi_device where name='HDD POOL'")
            dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='HDD POOL'")
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatedHDD=int(resp)

            AllocatedAcceleration = 0.0
            dbquery=c.execute("select sum(acceleration_storage) from multi_device where name='HDD POOL'")
            AllocatedAcceleration = c.fetchone()[0]
            
            AllocatedSSD = 0
            dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='SSD POOL'")
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatedSSD=int(resp)

            AllocatediSTOR = 0
            dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='iSCSI POOL'")
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatediSTOR=int(resp)

            AllocatedNVMeOF = 0
            dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='NVMeOF POOL'")
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatedNVMeOF=int(resp)

            AllocatedMegaRAID = 0
            dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='MegaRAID POOL'")
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatedMegaRAID=int(resp)   

            AllocatedHDD = 0
            dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='HDD POOL'")
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatedHDD=int(resp)

                #get HDD space
            TotalHDDStorage=0
            rotation=1
            query=c.execute("select state,size from disks where rotation=?",[rotation])
            state=0
            size=1
            online=0
            DiskList = c.fetchall()
            for disk in DiskList:
                if disk[state]==online:
                    TotalHDDStorage=TotalHDDStorage+disk[size]
                    #print( ("TotalHDDStorage=",TotalHDDStorage))
                    
            #get SSD space
            TotalSSDStorage=0
            rotation=0
            query=c.execute("select state,size,vid,name from disks where rotation=?",[rotation])
            DiskList = c.fetchall()
            for disk in DiskList:
                if not (disk[3].startswith("mr")): 
                    if (disk[0]==0 and disk[2]!="BROADCOM"):
                        TotalSSDStorage=TotalSSDStorage+disk[1]
                    #print( ("TotalSSDStorage=",TotalSSDStorage))
            availableHDD=int(TotalHDDStorage)-int(AllocatedHDD)    #This is in GB
            availableSSD=int(TotalSSDStorage)-int(AllocatedSSD)    #This is in GB
            #availableSSD=int(1000*TotalSSDStorage)-int(AllocatedSSD)-int(AllocatedAcceleration)    
            
            availableiSTOR=getAvailableiSTOR()
            availableiSTOR=availableiSTOR-AllocatediSTOR
            
            availableNVMeOF=getAvailableNVMeOF()
            availableNVMeOF=availableNVMeOF-AllocatedNVMeOF

            availableMegaRAID=getAvailableMegaRAID(cx)
            PoolType="MegaRAID POOL"
            RAIDlevel=getRAIDlevel(PoolType)
            if RAIDlevel==1:
                availableMegaRAID=availableMegaRAID*.745
        
            if AllocatedMegaRAID > availableMegaRAID:
                availableMegaRAID =0
            else:
                availableMegaRAID=availableMegaRAID-AllocatedMegaRAID
            if availableMegaRAID < MIN_FreeSpace:
                availableMegaRAID=0
                

            Disks=getAvailableDisks(cx)
            
        print( json.JSONEncoder().encode({
            "poolData":dbdata,"availableDisks":Disks,"availableHDDStorage":availableHDD,
            "availableSSDStorage":availableSSD,"availableMVMeOFStorage":availableNVMeOF,"availableiSTORStorage":availableiSTOR,"availableMegaRAIDStorage":availableMegaRAID,
            "AllocatedHDD":AllocatedHDD,"AllocatedSSD":AllocatedSSD,"AllocatedAcceleration":AllocatedAcceleration
        }) )   
        c.close()
        conn.close()
    except Exception as e:
        c.close()
        conn.close()
def read_raid_controller():
    conn = sqlite3.connect(DBPath)
    conn.text_factory = str
    c = conn.cursor()
    dbdata = []
    try:
        dbquery="SELECT name from raid_controller"
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            jsonschema = {"name" : col[0]}
            dbdata.append(jsonschema)
        print(json.JSONEncoder().encode(dbdata))
    except Exception as err:
        c.close()
        conn.close()
        print(json.JSONEncoder().encode(dbdata))

print( "Content-type:text/html\r\n\r\n")
if requestType=='delete_pool':
    delete_pool()
    conn.close()
elif requestType== 'update_pool':
    update_pool()
elif requestType == 'create_pool':
    create_pool()
    conn.close()
elif requestType == 'read_pool':
    read_pool()
    conn.close()
elif requestType == 'read_raid_controller':
    read_raid_controller()
    conn.close()
