#!/usr/bin/python3
from global_func import * #send_ccm_msg, get_ccm_command_id, get_ccm_response, Get_MachineID #*
GUI, CCM = get_ccm_status()
import sqlite3
import json
import csv
import subprocess
#from db import *
import os
import psutil
from datetime import datetime
import re
from globalSettings import DBPath, AlertsFilePath

MIN_FreeSpace=350

if GUI==True:
    import cgi,cgitb
    cgitb.enable()

cmd_Id = get_ccm_command_id()
db_filename = DBPath

if GUI==True:
    form = cgi.FieldStorage()
    requestType=form.getvalue('requestType')
else:
    print ('1. read_status()')
    print ('2. read_resources()')
    print ('3. read_apps()')
    print ('4. read_hostServers()')
    print ('5. read_storage()')
    print ('6. read_alerts()')
    print ('7. read_schedules()')
    print ('8 read_appliance_details()')
    print ('9 read_CCM()')

    choice=int(input("select cgi function==>"))
    if (choice==1):
        requestType='getStatus'
    elif (choice==2):
        requestType='getResources'
    elif (choice==3):
        requestType='getApps'
    elif (choice==4):
        requestType='getHostServers'
    elif (choice==5):
        requestType='getStorage'
        PoolType="MegaRAID POOL"
        #PoolType="HDD POOL"
        #PoolType="SSD POOL"
        #PoolType="NVMeOF POOL"
        #PoolType=="iSCSI POOL"
        
    elif (choice==6):
        requestType='getAlerts'
    elif (choice==7):
        requestType='getSchedules'
    elif (choice==8):
        requestType='getApplianceDetails'
    elif (choice==9):
        requestType='getCCMStatus'
    else:
        requestType='invalid'
        
    print ("Request_Type="+str(requestType))

def getPoolType():
        PoolType="MegaRAID POOL"
        #PoolType="HDD POOL"
        #PoolType="SSD POOL"
        #PoolType="NVMeOF POOL"
        #PoolType=="iSCSI POOL"
        return PoolType

def getTotalStorage(PoolType):
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    available = 0
    try:
        if PoolType=="HDD POOL":
            TotalHDDStorage=0
            rotation=1
            query=c.execute("select state,size from disks where rotation=?",[rotation])
            state=0
            size=1
            online=0
            DiskList = c.fetchall()
            for disk in DiskList:
                if disk[state]==online:
                    TotalHDDStorage=TotalHDDStorage+disk[size]
            available = TotalHDDStorage
            
        elif PoolType=="SSD POOL":
            TotalSSDStorage=0
            rotation=0
            query=c.execute("select state,size,vid,name from disks where rotation=?",[rotation])
            DiskList = c.fetchall()
            for disk in DiskList:
                if not (disk[3].startswith("mr")): 
                    if (disk[0]==0 and disk[2]!="BROADCOM"):
                        TotalSSDStorage=TotalSSDStorage+disk[1]

            available = TotalSSDStorage

        elif PoolType=="NVMeOF POOL":
            available = getAvailableNVMeOF()
        elif PoolType=="iSCSI POOL":
            available = getAvailableiSTOR()
        elif PoolType=="MegaRAID POOL":
            size = float(getAvailableMegaRAID())*.99
            available=int(size)
            
        c.close()
        conn.close()
    except Exception as err:
        c.close()
        conn.close()
    

    return available
 
def getRAIDlevel(PoolType):
    #print ("Pool Type",PoolType)
    level = -1
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    try:
        dbquery=c.execute("select level from multi_device where name=?",[PoolType])
        level=c.fetchone()[0]
        c.close()
        conn.close()
    except Exception as err:
        c.close()
        conn.close()
    
    return level
    
def read_storage():
    if GUI==True:
        PoolType=form.getvalue('PoolType')
    else:
        PoolType=getPoolType()
    
    conn= sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()

    AllocatedStorage = 0
    dbquery=c.execute("select sum(calculatedRaw) from multi_device where name=?",[PoolType])
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        AllocatedStorage=int(resp)

    total_pools = 0
    dbquery=c.execute("select count(*) from multi_device where name=?",[PoolType])
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        total_pools=int(resp)

    disks = 0
    dbquery=c.execute("select sum(level) from multi_device where name=?",[PoolType])
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        disks=int(resp)

    volumes = 0
    dbquery=c.execute("select count(*) from volume join multi_device on volume.multi_device_id=multi_device.id where multi_device.name=?",[PoolType])
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        volumes=int(resp)
        
    c.close()
    conn.close()

    RAIDlevel=0
    total_storage = getTotalStorage(PoolType)
    if (total_pools!=0):
        RAIDlevel=getRAIDlevel(PoolType)
    #print "RaidLevel=",RAIDlevel
    
    if RAIDlevel==1:
        total_storage=total_storage*.75

    if AllocatedStorage > total_storage:
        total_available =0
    else:
        total_available = total_storage - AllocatedStorage
        if total_available < MIN_FreeSpace:
            total_available=0
    total_disks=getAvailableDisks(PoolType)

    
    canisterState = CheckCanDisks()#CheckSerial()
    print (json.JSONEncoder().encode({
        "disks":disks,"total_disks":total_disks,"volumes":volumes,'pools':total_pools,'allocated':AllocatedStorage,
        'available':total_available,'total_storage':total_storage,"canister":canisterState
    }))
    
def get_uptime():
    process1 = subprocess.check_output(['uptime','-p']).decode("utf8").replace(',', '')
    return process1 #convert_time_duration(process1)
    #return process1
    
def convert_time_duration(duration_str):
    # Extract the numbers from the input string
    numbers = re.findall(r'\d+', duration_str)

    # Convert the numbers to integers
    numbers = [int(num) for num in numbers]

     # Assign the extracted numbers to variables
    week = 0
    if len(numbers) <= 3:
        days, hours, minutes = numbers[:3]
    else:
        week, days, hours, minutes = numbers

    # Construct the formatted string
    formatted_str = "up {} wk(s) {} day(s) {} hr(s) {} min(s)".format(week, days, hours, minutes)

    return formatted_str
def get_boottime_deepk():
    try:
        process1 = subprocess.check_output(['ls','-la',"/mnt/data/boot.crm"]).decode("utf8").replace(',', '')
    except Exception as err:
        process1="-rwxrwxrwx 1 www-data www-data   1021 Oct  4 14:06 boot.crm"
    file_parts = process1.split()
    date_time_string = ' '.join(file_parts[5:8])
    date_time_string_with_year = date_time_string + ' 2023'
    date_time = datetime.strptime(date_time_string_with_year, '%b %d %H:%M %Y')
    formatted_date_time = date_time.strftime('%b %d %H:%M %Y')
    return format_time_difference(formatted_date_time)
    
def get_boottime():
    #ls -l --full-time /mnt/data
    try:
        process1 = subprocess.check_output(['ls','-l',"--full-time","/mnt/data/boot.crm"]).decode("utf8")
    except Exception as err:
        process1="-rw-r--r-- 1 root root 0 2023-10-17 11:05:19.909098446 +0530 boot.crm"
        
    fmt_vals = process1.split()
    crm_date = fmt_vals[5]
    crm_time = fmt_vals[6].split(".")[0]
    bootcrm_time_str = crm_date+" "+crm_time
    bootcrm_time_format = datetime.strptime(bootcrm_time_str, "%Y-%m-%d %H:%M:%S")
    formated_str = datetime.strftime(bootcrm_time_format,'%b %d %H:%M %Y')
    return(format_time_difference(formated_str))


def format_time_difference(timestamp):
    current_time = datetime.now()
    given_time = datetime.strptime(timestamp, "%b %d %H:%M %Y")
    time_difference = current_time - given_time

    days = time_difference.days
    hours = time_difference.seconds // 3600
    minutes = (time_difference.seconds // 60) % 60

    formatted_time = "{} day(s) {} hr(s) {} min(s) ago".format(days, hours, minutes)
    return formatted_time 

def read_status():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    try:
        NORMAL_STATE = 0
        #Refer from cgi_statusView.py - read_StatusAll()
        states = {}
        query = c.execute("SELECT state from fan")
        fandata = []
        conn.commit()
        for col in c:
            fandata.append(col[0])
        states["fan"] = fandata

        query = c.execute("SELECT state from temp_probes")
        tempdata=[]
        conn.commit()
        for col in c:
            tempdata.append(col[0])
        states["temp"] = tempdata

        query = c.execute("SELECT state,tx_rx_monitor from eth_ports")
        networkdata=[]
        conn.commit()
        for col in c:
            state = col[0]
            if str(col[1]) == "0":
                state = NORMAL_STATE
            networkdata.append(state)
        states["network"] = networkdata

        query = c.execute("SELECT state from psu where name='PSU_1'")
        psudata=[]
        conn.commit()
        for col in c:
            psudata.append(col[0])
        states["psu"] = psudata

        query = c.execute("SELECT state from psu where name='PSU_2'")
        psudata2=[]
        conn.commit()
        for col in c:
            psudata2.append(col[0])
        states["psu2"] = psudata2

        query = c.execute("SELECT name,state,vid,pid,prl,serial,size from disks")
        disksdata=[]
        conn.commit()
        for col in c:
            disksdata.append(col[0])
        states["disks"] = disksdata

        query = c.execute("SELECT state from cpu")
        cpudata=[]
        conn.commit()
        for col in c:
            cpudata.append(col[0])
        states["cpu"] = cpudata
        
        query = c.execute("SELECT state from multi_device")
        pooldata=[]
        conn.commit()
        for col in c:
            pooldata.append(col[0])
        states["pool"] = pooldata
        c.close()
        conn.close()
    
    except Exception as err:
        c.close()
        conn.close()
        
    flag = -1
    for key,value in states.items():
        try:
            indexValue = value.index(2)
        except ValueError:
            indexValue = -1

        if indexValue != -1:
            flag = 2
            break

    if flag==-1:
        for key,value in states.items():
            try:
                indexValue = value.index(1)
            except ValueError:
                indexValue = -1

            if indexValue != -1:
                flag = 1
                break

    if flag==-1:
        for key,value in states.items():
            try:
                indexValue = value.index(0)
            except ValueError:
                indexValue = -1

            if indexValue != -1:
                flag = 0
                break
    system_uptime = get_uptime()
    boot_time = get_boottime()
    
    print (json.JSONEncoder().encode({"state":flag,"version":SoftwareVersion,"build":BuildVersion,"uptime":system_uptime,"boottime":boot_time}))

def read_resources():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    
    usedVcpu = 0
    usedRam = 0
    usedStorage = 0
    try:
        dbquery=c.execute("select used_vcpu,used_memoryGB,used_storageGB from system where name='System1'")
        resp=c.fetchall()[0]
        if (isinstance(resp[0], int))==True:
            usedVcpu=int(resp[0])
        if (isinstance(resp[1], int))==True:
            usedRam=int(resp[1])
        if (isinstance(resp[2], int))==True:
            usedStorage=int(resp[2])
        c.close()
        conn.close()

    except Exception as err:
        c.close()
        conn.close()
        
    print (json.JSONEncoder().encode({"usedVcpu":usedVcpu,"usedRAM":usedRam,"usedStorage":usedStorage}))

def read_apps():
    conn = sqlite3.connect(DBPath, check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    totalApps = 0
    try:
        dbquery=c.execute("select count(*) from virtualmachine")
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            totalApps=int(resp)

        activeapps = 0
        dbquery=c.execute("select count(*) from virtualmachine where state=6")
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            activeapps=int(resp)

        suspendedapps = totalApps - activeapps
        c.close()
        conn.close()
    except Exception as err:
        c.close()
        conn.close()
        
    print (json.JSONEncoder().encode({"active":activeapps,"suspended":suspendedapps}))

def read_hostServers():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    try:
        hostservers = 0
        dbquery=c.execute("select count(*) from host")
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            hostservers=int(resp)
        c.close()
        conn.close()
        print (json.JSONEncoder().encode({"hostservers":hostservers}))
    except Exception as err:
        c.close()
        conn.close()
def read_alerts():
    with open(AlertsFilePath, 'r') as csvfile:
        filereader = csv.reader(csvfile, delimiter='@')
        i = 0
        for row in filereader:
            i+=1
    print (json.JSONEncoder().encode({"alerts":i}))

def read_schedules():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    try:
        schedules = 0
        dbquery=c.execute("select count(*) from schedule  where isDeleted=0")
        #dbquery=c.execute("SELECT count(*) from schedule s INNER JOIN volume v on s.vol_id=v.id INNER JOIN volume v1 on s.vol_dest_id=v1.id")
        resp=c.fetchone()[0]
        c.close()
        conn.close()
    except Exception as err:
        c.close()
        conn.close()
    if (isinstance(resp, int))==True:
        schedules=int(resp)
    print (json.JSONEncoder().encode({"schedules":schedules}))

def getCPUName():
    process1 = subprocess.check_output(["lscpu","-J"]).decode("utf-8")
    output = json.loads(process1)
    lscpu = output["lscpu"]
    for line in lscpu:
        if line["field"] == "Model name:":
            return line["data"]
    return 'n/a'

def getTotalMemoryCapacity():
    try:
        process1 = subprocess.check_output(["sudo","dmidecode","-t","16"]).decode("utf-8")
        output = process1.splitlines()
        for line in output:
            #Total online memory:      16G
            # Maximum Capacity: 128 GB
            if "Maximum Capacity" in line:
                return line.split(':')[-1].strip()
        return 'n/a'
    except Exception as e:
        error = 'n/a' # str(e)
        return error

def GBtoTB(value):
    TB_value = round(float(value) / 1024, 2)
    return str(TB_value)

def getStatusFromState(state):
    state = int(state)
    if state==0:
        return "Good"
    elif state==1:
        return "Degraded"
    elif state==2:
        return "Critical"
    else:
        return "Rebuilding"

def disk_usage(path):
    hdd = psutil.disk_usage(path)
    size=(hdd.free)
    size=size/(1024**3)
    return size

    #s=os.statvfs(path)
    #return (s.f_bavail * s.f_frsize) 
    
 

def read_appliance_details():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory=str
    c=conn.cursor()
    try:
        make_model = Get_MachineID()
        cpu = getCPUName() #'AMD Ryzen 9 3950X 16 <br> &#160;&#160;Core Processor'
        memory_capacity = getTotalMemoryCapacity() #'132 GB'
        drive_models = 'MegaRAID SSD'
        driveData = []
        driveAttributes = ['Model','Slot','Size','Status']
        dbquery=c.execute("select pid,location,size,state from disks")
        for col in c:
            drive = {}
            drive['Model'] = col[0]
            drive['Slot'] = col[1]
            drive['Size'] = GBtoTB(col[2]) + ' TB'
            drive['Status'] = getStatusFromState(col[3])
            driveData.append(drive)
        c.close()
        conn.close()
    except Exception as err:
        c.close()
        conn.close()
    
    try:
        path=('/mnt/data')
        free=disk_usage(path)
        data_freespace=str(format(free, '.2f'))
        path=('/mnt/xdata')
        free=disk_usage(path)
        xdata_freespace=str(format(free, '.2f'))
    except Exception as e:
        print(e)
    else:
        print( json.JSONEncoder().encode({'xdata_freespace':xdata_freespace,'data_freespace':data_freespace,'make_model':make_model,'cpu':cpu,'memory_capacity':memory_capacity,'drive_models':drive_models,"drives":{"attributes":driveAttributes,"data":driveData}}))

def read_CCM():
    cmd="test_response"
    name="CCM"
    action="check"
    message="set,element=test_response,element_name={0},args=2,action={1},uuid={2}".format(name,action,cmd_Id)
    #print(message)
    send_ccm_msg(message)
    response = get_ccm_response(cmd_Id)
    print (response)

def read_LICENSE():
    cmd="test_response"
    name="License"
    action="check"
    message="set,element=test_response,element_name={0},args=2,action={1},uuid={2}".format(name,action,cmd_Id)
    send_ccm_msg(message) 
    response = get_ccm_response(cmd_Id)
    print (response)
    
def CheckCanDisks():
    cmd_Id = get_ccm_command_id()		
    cmd = "canister_status"
    name="CanisterStatus"
    action="check"
    message="set,element=test_response,element_name={0},args=2,action={1},uuid={2}".format(name,action,cmd_Id)
    send_ccm_msg(message) 
    response = get_ccm_response(cmd_Id)  
    response = json.loads(response)
    if response['status'] != "success":
       canisterState = "UnKnown"
    else:
        canisterState = response["description"]
    return canisterState

print ("Content-type:text/html\r\n\r\n")
if requestType=='getStatus':
    read_status()

elif requestType == 'getResources':
    read_resources()
    
elif requestType == 'getApps':
    read_apps()
    
elif requestType == 'getHostServers':
    read_hostServers()    
    
elif requestType == 'getStorage':
    read_storage()
    
elif requestType == 'getAlerts':
    read_alerts()
    
elif requestType == 'getSchedules':
    read_schedules()
    
elif requestType == 'getApplianceDetails':
    read_appliance_details()
    
elif requestType == 'getCCMStatus':
    read_CCM()
    
elif requestType == 'getLicenseStatus':
    read_LICENSE()