#!/usr/bin/python3

from cgi_Global_myserver_totResources import *

import cgi,cgitb
cgitb.enable()
import sqlite3
import json
import datetime
import os
import shutil
from globalSettings import *
import xml.etree.ElementTree as ET
import logging
import sys
import socket
import subprocess
from subprocess import call
import test_DockerSDK

#filename='elemenTree.xml'
elementTreeXML=ElementTreeXML   #replace the path with the current directory path where the file resides
tree = ET.parse(elementTreeXML)
root = tree.getroot()
xml_write=elemenTree_write

date=datetime.date.today().strftime("%Y-%m-%d")
res_group=[]
res_image=[]
veth_id_list=[]
vm_id_list=[]
vm_network_name_list=[]

available_storage=sys_storage()
available_vcpu=sys_vcpu()
available_memory=sys_memory()


form = cgi.FieldStorage()


dd_group = form.getvalue('dd_group')
server_name=form.getvalue('server_name')
image_id=form.getvalue('image_id')
vcpu=form.getvalue('vcpu')
memory=form.getvalue('memory')
disk_size=form.getvalue('disk_size')
network_ids=str(form.getvalue('network_name'))
selectedGroups = form.getvalue('selectedOrgGroups')
portNo = int(form.getvalue('portNo'))

conn=sqlite3.connect(DBPath)
conn.text_factory=str
c=conn.cursor()
try:
	query="select name from network where id in ("+ network_ids + ")"
	query_fetch_vmids=c.execute(query)
	conn.commit()
	for nwnames in c:
		nw_name=nwnames[0]
		vm_network_name_list.append(nw_name) #Get netwrok names as list 
	c.close()
	conn.close()
except Exception as e:
	c.close()
	conn.close()
	
def virtual_machine_setup():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		if int(disk_size) > int(available_storage) or int(available_storage)==0:
			print (json.JSONEncoder().encode({"status":"fail","message":"InSufficient Storage"}))
		elif int(vcpu) > int(available_vcpu):
			print (json.JSONEncoder().encode({"status":"fail","message":"InSufficient VCPU's"}))
		elif float(memory) > int(available_memory):
			print (json.JSONEncoder().encode({"status":"fail","message":"Insufficient Memory"}))
		else:

			query_vmName=c.execute("select name from virtualmachine where name='"+server_name+"'")
			vmName=c.fetchall()
			
			#Search database if virtual machine exists with the entered name

			query_vmName=c.execute("select port from virtualmachine where port='"+str(portNo)+"'")
			vmPort=c.fetchall()

			#Search database if virtual machine exists with the entered port
			
			if not vmName and not vmPort:

				query = c.execute("select image_type from vm_image where id = {}".format(image_id))
				for col in c:
					image_type = col[0]
				if(str(image_type)=='docker'):
					type = "docker"
				else:
					type = "native"
				query_virtualmachine_set=c.execute("insert into virtualmachine (name,num_cores,memory_GB,vm_disk_size,vm_image_id,cr_date,edit_date,saved_path,state,type,port) \
					values(?,?,?,?,?,?,?,'/vm/"+server_name+"',4,?,?)",[server_name,vcpu,memory,disk_size,image_id,date,date,type,portNo])
				conn.commit()
				AppId = c.lastrowid
				
				
				#Get the 'id' of the entered virtual server/virtual machine
				query_fetch_vmid=c.execute("select id from virtualmachine where name='"+server_name+"'")
				conn.commit()
				
				for vmId in c:
					vnet_vmId=vmId[0]
					vm_id_list.append(vnet_vmId) #Get vm_id to create vm_network for the created Virtual machine

				#Insert Values to 'veth_port' table by using network names(ref:Network Table)

				for i in vm_network_name_list:
					query=c.execute("select id from network where name='"+i+"'")      #network(id) list to use as foreign key constraint in veth_port table
					conn.commit()
					for ntw in c:
						network_id=ntw[0]
						query_vethPort=c.execute("insert into veth_port(name,state,cr_date,edit_date,ip,netmask,network_id) values(?,?,?,?,?,?,?)",(i,0,date,date,"0.0.0.0","255.255.255.0",network_id))
						conn.commit()
						fetch_veth_id=c.lastrowid
						veth_id_list.append(fetch_veth_id)
						

				for i in vm_id_list:
					for j in veth_id_list:
						query_vm_ntw=c.execute("insert into vm_network (vm_id,veth_id) values(?,?)",(i,j))
						conn.commit()				

				mapAppGroups(AppId,selectedGroups)
				
				print(json.JSONEncoder().encode({'status':'success','message':'App has been configured','name':server_name}))
				#resource_save_VM()
				copyImageToNativeFolder()
				resources_vm_running()

				#query_vmName=c.execute("select vm_image.image_name,vm_group.group_name,vm_image.vm_group_id FROM vm_image inner join vm_group on vm_image.vm_group_id=vm_group.id where vm_image.id="+str(image_id))
				query_vmName=c.execute("select vm_image.image_name,vm_image.image_type,vm_group.group_name FROM vm_image,vm_group where vm_image.vm_group_id=vm_group.id and vm_image.id="+str(image_id))
				for col in c:
					image_name=col[0]
					group_name=col[2]
					image_type=col[1]

				#if(group_name == 'Docker'):
				if(image_type == 'docker'):
					containerID = test_DockerSDK.save_docker_vm(portNo,image_name,server_name,group_name)
					query ="update virtualmachine set system_id = '" + str(containerID) + "' where name ='"+str(server_name)+"'"
					c.execute(query)
					conn.commit()

			else:		
				print(json.JSONEncoder().encode({'status':'Fail','message':'Server Name already exists or Port already exists','name':server_name}))

								
			c.close()
			conn.close()
	except Exception as e:
		c.close()
		conn.close()

def copyImageToNativeFolder():
	conn=sqlite3.connect(DBPath)
	conn.text_factory=str
	c=conn.cursor()
	try:
		query_lan=c.execute("Select path_app_saved,file_name,app_download_server,image_type,vm_group.group_name,image_name from vm_image inner join vm_group on vm_image.vm_group_id=vm_group.id inner join virtualmachine on virtualmachine.vm_image_id=vm_image.id  where virtualmachine.id="+str(vm_id_list[0]))
		for col in c:		
			sourcepath=col[0]	
			srcfile = col[0] #old logic col[0]+'/'+ col[5]+'.'+col[3]
			dstroot = AppServersPath +col[4]+'/'+(server_name).replace(" ", "_")
			oldFileName=col[5]+'.'+col[3]
			newFileName=(server_name + '.'+col[3]).replace(" ", "_")
		conn.commit()
		if not os.path.exists(dstroot) and srcfile !='' and srcfile !='None' and not os.path.isdir(srcfile):
			os.makedirs(dstroot,0o777)
		
		if(os.path.isdir(srcfile)):     #if the downloaded file from ftp was zip, we extracted the folder and saved the folder name under 'path_app_saved'
			if os.path.exists(dstroot):
				shutil.rmtree(dstroot)
			shutil.copytree(srcfile,dstroot)
		else:		#if the downloaded file was iso,exe or anything that wasnt extracted
			shutil.copy(srcfile, dstroot)  
		for filename in os.listdir(dstroot):
			if filename == oldFileName:
				os.rename(dstroot+'/'+oldFileName, dstroot+'/'+ newFileName)
		query = "update virtualmachine set saved_path='"+ dstroot +"' where virtualmachine.id="+str(vm_id_list[0])
		query_lan=c.execute(query)
		conn.commit()
		c.close()
		conn.close()
	except Exception as e:
		c.close()
		conn.close()
		
		
def update_element(tag_name,new_value):
	for element in root.iter(tag_name):
		element.text=str(new_value)
		#tree.write('/var/www/vm_xml1.xml')
		tree.write(xml_write)
		

def set_element_attribute(tag_name,attribute_name,new_value):
	print ("Length is 3")
	for element in root.iter(tag_name):
		#root.iter(element_name)
		element.set(attribute_name,new_value)
		#tree.write('/var/www/vm_xml1.xml')
		tree.write(xml_write)

def mapAppGroups(appId,selectedGroups):
	if str(selectedGroups) != "None":
		selectedGroupsList = selectedGroups.split(",")
		
		for index, groupId in enumerate(selectedGroupsList):
			query_SP=c.execute("insert into app_link(state,cr_date,group_id,app_id) values(?,datetime(),?,?)",[1,groupId,appId])
			conn.commit()
		
		
#socket_cmd = "</msg>64get,element=virtualmachine,element_name="+server_name+",args=2,id,name</msg>"
# xml_path="/var/www/vm_xml1.xml"
xml_path="/var/www/vm_xml1.xml"
args=1
element_action='start'
#message="set,element=virtualmachine,element_name={0},args={1},element_action={2},element_path={3}".format(server_name,args,element_action,xml_path)
length="0000"
length_message=99#len(message)
if length_message<=9:
	k=length.rfind("0")
elif length_message<=99:
	k=length.rfind("00")
elif length_message<=999:
	k=length.rfind("000")
msg_length=length[:k]+str(length_message)
#socket_cmd="</msg>{:0>4}{1}</msg>".format(len(message),message)
#socket_cmd="</msg>{0}{1}</msg>".format(msg_length,message)

#def send_ccm_msg():
	#process1 = subprocess.call(['/var/www/vm_ccm/cgi_client.sh',socket_cmd])
#	process1 = subprocess.call(['/var/www/cgi_client.sh',socket_cmd])
	#print process1
	#print socket_cmd





print ("Content-type:text/html\r\n\r\n")
virtual_machine_setup()
update_element('name',server_name)
update_element('memory',float(memory)*1024)
update_element('vcpu',vcpu)
#send_ccm_msg()


