#!/usr/bin/python
import socket
import sys
import time
from array import *
import logging
import subprocess
from subprocess import call
import os
import uuid
from db import *
from globalSettings import DBPath #*
import sqlite3
import string
import random
import json
from errorstrings import get_error_code

def getAvailableNVMeOF():
    return 20*1000

def getAvailableiSTOR():
    return 20*1000

def getAvailableMegaRAID():
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    MRpoolSize=0
    #select sum(size) from disks where name='mra' or name='mrb' or name='mrc' or name='mrd'
    dbquery=c.execute("select sum(size) from disks where (name='mra' or name='mrb' or name='mrc' or name='mrd')")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        MRpoolSize=int(resp)
    c.close()
    conn.close()
    return MRpoolSize

    
def getAvailableDisks(PoolType):
    conn = sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    nbDisks=0
    AllocatedDisks=0

    if PoolType=="HDD POOL":
        dbquery=c.execute("select count(*) from disks where rotation =1")
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            nbDisks=int(resp)
        dbquery=c.execute("select id from multi_device where name='HDD POOL'")
        IdList=c.fetchall()
        for md_id in IdList:
            #print ("id=",md_id[0])
            PoolId=md_id[0]
            dbquery=c.execute("select count(*) from disks where multi_device_id=?",[PoolId])
            resp=c.fetchone()[0]
            if (isinstance(resp, int))==True:
                AllocatedDisks=AllocatedDisks+int(resp)
        c.close()
        conn.close()
        return (nbDisks-AllocatedDisks)

    elif PoolType=="MegaRAID POOL":
        dbquery=c.execute("select count(*) from disks where name='mra' or name='mrb' or name='mrc' or name='mrd'")
        resp=c.fetchone()[0]
        if (isinstance(resp, int))==True:
            MRnbDisks=int(resp)
            c.close()
            conn.close()
            return MRnbDisks
    else:
        c.close()
        conn.close()
        return 4
    

# add_validate function is for ethernet ports ipv4 validations
def add_validate(address, is_gateway = False):
    
    if not address and is_gateway: # Null vales are allowed for gateway
        return True
    if not address:
        return True
    address_ipv4=address.split('.')
    val_format=[]
    if len(address_ipv4)==4:
        for x in address_ipv4:
            if ((len(str(address_ipv4[-1]))) > 1):
                if(str(address_ipv4[-1][0]) == '0'):
                    return "IP/Netmask cannot end with '0x'<br/>"
            if x.isdigit():
                y=int(x)
                if y<0 or y>=256:
                    return "All values should be in the range 0-255<br/>"
                    break
                else:
                    val_format.append(y)
            else:
                return "all the values should be of integer format<br/>"
                break

        if len(val_format)==4:
            return True

def ccm_msg_length(message):
    length="0000"
    tail="</msg>"
    length_message=len(message)
    length_message=length_message+len(tail) # add in the tail length </msg>
    if length_message<=9:
        k=length.rfind("0")
    elif length_message<=99:
        k=length.rfind("00")
    elif length_message<=999:
        k=length.rfind("000")
    msg_length=length[:k]+str(length_message)
    return msg_length


#</msg>0099set,element=multi_device,element_name=mrp1,args=3,action=PoolDelete,SystemName=mrp1,uuid=6RM6</msg>
def send_ccm_msg(message):
    msg_length = ccm_msg_length(message)
    socket_cmd = "</msg>{0}{1}</msg>".format(msg_length, message)
    try:
        socket_msg = bytes(socket_cmd,'utf-8')
        process1 = subprocess.call(["sudo",CGIpath,socket_cmd])
        #print(process1)
    except Exception as err:
        print ("send_ccm_msg except ",err)

def get_ccm_response(uuid):
    filename="ccm_response.txt"
    #print(f"uuid {uuid}")
    ccm_response_file= gui_path+'b'+"'"+str(uuid)+"'"+filename

    file=0
    while (file < 100):
        if os.path.isfile(ccm_response_file):
            file=101
        else:
            file=file+1
            time.sleep(.1)
            if file==99:
                return (json.JSONEncoder().encode({'status':'fail','description':'Command Timeout'}))

    fo = open(ccm_response_file, "r")
    CcmResponse=fo.read()
    fo.close()
    os.remove(ccm_response_file)
    return CcmResponse


def id_generator(size=4, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for _ in range(size))

def get_ccm_command_id():
    command_id=id_generator()
    return (command_id)


def delete_ccm_response(uuid):
   filename="ccm_response.txt"
   ccm_response_file= gui_path+'b'+"'"+str(uuid)+"'"+filename
   #cmd_rm= "rm -rf "+ccm_response_file
   #os.remove(ccm_response_file)
   #os.system(cmd_rm)

def computeAvailableStorage(poolType):
    c=conn.cursor()
    dbquery="SELECT name,pool_storage,acceleration_storage,calculatedraw from multi_device"
    query = c.execute(dbquery)
    hdd = {"name":"HDD POOL","protection_storage":0,"acceleration_storage":0,"caculatedHDD":0}
    ssd = {"name":"SSD POOL","protection_storage":0,"acceleration_storage":0,"caculatedHDD":0}
    conn.commit()
    for col in c:
        if col[0] == 'HDD POOL':
            hdd={"name":col[0],"protection_storage":col[1],"acceleration_storage":col[2],"caculatedHDD":col[3]}
        else:
            ssd= {"name":col[0],"protection_storage":col[1],"acceleration_storage":col[2]}
    if poolType == 'HDD POOL':
        if hdd['protection_storage'] == 0:
            return 0 #as per Naveen if storage protection is 0 then protected capacity also 0
        else:
            return hdd['caculatedHDD'] - hdd['protection_storage']
    else:
        if ssd['protection_storage'] == 0:
            return 0
        else:
            return TotalSSDStorage - hdd['acceleration_storage'] - ssd['protection_storage']

def computeProtected(calculatedraw, storageProtection):
    return int(calculatedraw) - int(storageProtection)
            
def computeRawStorage(poolType):
    conn =  sqlite3.connect(DBPath,check_same_thread=False)
    conn.text_factory = str
    c=conn.cursor()
    dbquery="SELECT name,pool_storage,acceleration_storage from multi_device"
    query = c.execute(dbquery)
    hdd = {"name":"HDD POOL","protection_storage":0,"acceleration_storage":0}
    ssd = {"name":"SSD POOL","protection_storage":0,"acceleration_storage":0}
    conn.commit()
    for col in c:
        if col[0] == 'HDD POOL':
            hdd={"name":col[0],"protection_storage":col[1],"acceleration_storage":col[2]}
        else:
            ssd= {"name":col[0],"protection_storage":col[1],"acceleration_storage":col[2]}
    c.close()
    conn.close()
    if poolType == 'HDD POOL':
        return '16TB'
    else:
        return TotalSSDStorage - hdd['acceleration_storage']

def parse_ccm_response_and_send_verbose(element, reponse):
    try:
        return reponse
        json_response = json.loads(reponse)
        status = json_response["status"]
        description = json_response["description"]
        code = description.lower().split("code:")[-1].strip()
        updated_desciption = get_error_code(element,code)
        return json.JSONEncoder().encode({'status':status,'description':updated_desciption})
    except:
        return reponse

# def getNodeType():
#     global NodeType
#     CCM = False
#     if CCM:
#         SystemName="getNodeType"
#         cmd_Id = get_ccm_command_id()
#         message="set,element=getNodeType,element_name={0},args=2,action={1},uuid={2}".format(SystemName,cmd,cmd_Id)
#         send_ccm_msg(message)
#         response = get_ccm_response(cmd_id)
#         NodeType =  response["nodeType"] #set Node Type
#         delete_ccm_response(cmd_id)
#     else:
#         NodeType = 'R6000'

def Get_MachineID():
    #import subprocess

    Prowler2_BB = "X13SAV-LVDS"
    Prowler1_BB = "X570D4I-2T"
    Raptor_BB = "H12SSL-I"

    #sudo dmidecode -s baseboard-product-name
    process1 = subprocess.check_output(["sudo",'dmidecode','-s','baseboard-product-name']).decode("utf-8")
    bbName = str(process1.strip())
    if BBType == "Default":
        if bbName == Prowler2_BB:
            MID = "Prowler2"
        elif bbName == Prowler1_BB:
            MID = "Prowler1"
        elif bbName == Raptor_BB:
            MID = "Raptor"
        else:
            MID = "UnKnown"

        return MID
    else:
        return BBType
def get_ccm_status():
    GUI = True
    CCM = True
    
    if len(sys.argv) > 1 and sys.argv[1] == "--terminal":
        GUI = False
        CCM = False
    
    return GUI, CCM

def Get_MachineID1():
    #import subprocess

    Prowler2_BB = "X13SAV-LVDS"
    Prowler1_BB = "X570D4I-2T"
    MB_TYPES = {"X13SAV-LVDS":"Prowler2","X570D4I-2T":"Prowler1","H12SSL-I":"Raptor","default":"UnKnown"}
    
    

    #sudo dmidecode -s baseboard-product-name
    process1 = subprocess.check_output(["sudo",'dmidecode','-s','baseboard-product-name']).decode("utf-8")
    bbName = str(process1.strip())
    if bbName in MB_TYPES:
        return MB_TYPES[bbName]
    else:
        return MB_TYPES["default"]