#!/usr/bin/python3
# -*- coding: utf-8 -*-
import warnings
import subprocess
import re
import time
import json
# import StringIO

useFake = False

def getProcessOutput(cmd):
    process = subprocess.Popen(
        cmd,
        stdout=subprocess.PIPE)
    process.wait()
    data, err = process.communicate()
    return data

def getMegaRAIDslotList():
    slotList=[]
    attributes = ["EID:Slt","DID","Size",'SeSz',"Intf", "Med", "Model"]
    try:
        storcli="/opt/MegaRAID/storcli/storcli64"
        storCLIlog="R600"
        argLog="logfile="+storCLIlog
        cmd="show"
        arg1='/c0/e252/sall'
        argLast='J'
        #print storcli,cmd,cx,arg1,argLast
        if not useFake:
            process1 = getProcessOutput(["sudo",storcli, arg1,cmd, argLast])
            y = json.loads(process1)
        else:
            y = {"Controllers":[{"Command Status":{"CLI Version":"007.1613.0000.0000 Oct 29, 2020","Operating system":"Linux 4.15.0-143-generic","Controller":0,"Status":"Success","Description":"Show Drive Information Succeeded."},"Response Data":{"Drive Information":[{"EID:Slt":"252:4","DID":0,"State":"Onln","DG":0,"Size":"3.492 TB","Intf":"NVMe","Med":"SSD","SED":"Y","PI":"N","SeSz":"512B","Model":"SAMSUNG MZWLJ3T8HBLS-00007              ","Sp":"U","Type":"-"},{"EID:Slt":"252:6","DID":1,"State":"Onln","DG":0,"Size":"3.492 TB","Intf":"NVMe","Med":"SSD","SED":"Y","PI":"N","SeSz":"512B","Model":"SAMSUNG MZWLJ3T8HBLS-00007              ","Sp":"U","Type":"-"},{"EID:Slt":"252:8","DID":2,"State":"Onln","DG":0,"Size":"3.492 TB","Intf":"NVMe","Med":"SSD","SED":"Y","PI":"N","SeSz":"512B","Model":"SAMSUNG MZWLJ3T8HBLS-00007              ","Sp":"U","Type":"-"},{"EID:Slt":"252:10","DID":3,"State":"Onln","DG":0,"Size":"3.492 TB","Intf":"NVMe","Med":"SSD","SED":"Y","PI":"N","SeSz":"512B","Model":"SAMSUNG MZWLJ3T8HBLS-00007              ","Sp":"U","Type":"-"}]}}]}
        
        x=y['Controllers'][0]['Command Status']
        #print x['Status']
        if str(x['Status'])=="Success":
            i=0
            j=0
            x=y['Controllers'][0]['Response Data']['Drive Information']
            NbSlots=len(x)
            while (i<NbSlots):
                if str(x[i]['State'])=='Onln':
                    driveDetails = {}
                    for key in x[i].keys():
                        if key in attributes:
                            driveDetails[key] = x[i][key]
                    #slotList.append(str(x[j]['EID:Slt']))
                    slotList.append(driveDetails)
                    j=j+1
                i=i+1
    except Exception as err:
        #print(("getMegaRAIDslotList ",err))
        return str(err),slotList,[]

    return "success",slotList,attributes

def getMegaRAIDdrivesInfo(slot):
    DriveData=[]
    drivedata= []
    slot = slot.split(":")[-1]
    attributes = ['Attribute', 'Value']
    headerData = {}
    #sudo /opt/MegaRAID/storcli/storcli64 /c0/e252/sall show J
    #sudo /opt/MegaRAID/storcli/storcli64 /c0 show J
    try:
        storcli="/opt/MegaRAID/storcli/storcli64"
        #sudo /opt/MegaRAID/storcli/storcli64 /c0/e252/s4 show all J
        storCLIlog="R600"
        argLog="logfile="+storCLIlog
        cmd="show"
        cx="/c0"
        arg1='/c0/e252/s'
        arg2='all'
        argLast='J'
        
        if not useFake:
            arg3=arg1+str(slot)
            process1 = getProcessOutput(["sudo",storcli, arg3,cmd, arg2, argLast])
            y = json.loads(process1)
        else:
            arg3=arg1+'4'
            y = {"Controllers":[{"Command Status":{"CLI Version":"007.1613.0000.0000 Oct 29, 2020","Operating system":"Linux 4.15.0-143-generic","Controller":0,"Status":"Success","Description":"Show Drive Information Succeeded."},"Response Data":{"Drive /c0/e252/s4":[{"EID:Slt":"252:4","DID":0,"State":"Onln","DG":0,"Size":"3.492 TB","Intf":"NVMe","Med":"SSD","SED":"Y","PI":"N","SeSz":"512B","Model":"SAMSUNG MZWLJ3T8HBLS-00007              ","Sp":"U","Type":"-"}],"Drive /c0/e252/s4 - Detailed Information":{"Drive /c0/e252/s4 State":{"Shield Counter":0,"Media Error Count":0,"Other Error Count":0,"Drive Temperature":" 33C (91.40 F)","Predictive Failure Count":0,"S.M.A.R.T alert flagged by drive":"No"},"Drive /c0/e252/s4 Device attributes":{"SN":"S4YPNC0R200577      ","Manufacturer Id":"NVMe    ","Model":"SAMSUNG MZWLJ3T8HBLS-00007              ","NAND Vendor":"NA","WWN":"3B5C80DED8DAB9DD","Firmware Revision":"EPK9AB5Q","Raw size":"3.492 TB [0x1bf1f72b0 Sectors]","Coerced size":"3.492 TB [0x1bf0f0000 Sectors]","Non Coerced size":"3.492 TB [0x1bf0f72b0 Sectors]","Device Speed":"16.0GT/s","Link Speed":"16.0GT/s","Write Cache":"Disabled","Logical Sector Size":"512B","Physical Sector Size":"512B","Connector Name":"C0.0 x4","Max lane width":"4"},"Drive /c0/e252/s4 Policies/Settings":{"Drive position":"DriveGroup:0, Span:0, Row:0","Enclosure position":"1","Connected Port Number":"0(path0) ","Sequence Number":54,"Commissioned Spare":"No","Emergency Spare":"No","Last Predictive Failure Event Sequence Number":0,"Successful diagnostics completion on":"N/A","FDE Type":"TCG Opal","SED Capable":"Yes","SED Enabled":"No","Secured":"No","Cryptographic Erase Capable":"Yes","Sanitize Support":"CryptoErase","Locked":"No","Needs EKM Attention":"No","PI Eligible":"No","Certified":"No","Wide Port Capable":"No","Unmap capable":"Yes","Unmap capable for LDs":"No","Multipath":"No","Port Information":[{"Port":0,"Status":"Active","Linkspeed":"16.0GT/s","WWID":"0xddb9dad8de805c3b"},{"Port":1,"Status":"Active","Linkspeed":"16.0GT/s","WWID":"0x0"}]},"Inquiry Data":"00 00 07 12 45 00 10 02 4e 56 4d 65 20 20 20 20 53 41 4d 53 55 4e 47 20 4d 5a 57 4c 4a 33 54 38 41 42 35 51 53 34 59 50 4e 43 30 52 32 30 30 35 37 37 20 20 20 20 20 20 00 00 00 c0 05 c0 06 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "}}}]}
        x=y['Controllers'][0]['Response Data']
        Rarg1='Drive '+arg3 #eg /c0/e252/s4, /c0/e252/s6 etc
        deviceInfo = x[Rarg1][0]

        drivedata.append({'Attribute':'EID:Slt','Value':deviceInfo['EID:Slt']})
        drivedata.append({'Attribute':'State','Value':deviceInfo['State']})
        drivedata.append({'Attribute':'Disk Size','Value':deviceInfo['Size']})
        drivedata.append({'Attribute':'Model','Value':deviceInfo['Model']})
        drivedata.append({'Attribute':'Sector Size','Value':deviceInfo['SeSz']})
        
        Rarg2=Rarg1+' - Detailed Information'

        Rarg4=Rarg1+' State'
        detailedInformation = x[Rarg2][Rarg4]
        # for key, value in detailedInformation.items():
        #     if type(value) != list:
        #         drivedata.append({'Attribute':key,'Value':value})
        drivedata.append({'Attribute':'Media Error Count','Value':detailedInformation['Media Error Count']})
        drivedata.append({'Attribute':'Other Error Count','Value':detailedInformation['Other Error Count']})
        drivedata.append({'Attribute':'Drive Temperature','Value':detailedInformation['Drive Temperature']})
        drivedata.append({'Attribute':'Predictive Failure Count','Value':detailedInformation['Predictive Failure Count']})
        drivedata.append({'Attribute':'S.M.A.R.T alert flagged by drive','Value':detailedInformation['S.M.A.R.T alert flagged by drive']})

        #print "step 3"
        Rarg3= Rarg1+' Device attributes'
        deviceAttributes = x[Rarg2][Rarg3]
        # for key, value in deviceAttributes.items():
        #     if type(value) == str:
        #         drivedata.append({'Attribute':key,'Value':value})
        drivedata.append({'Attribute':'Manufacturer Id','Value':deviceAttributes['Manufacturer Id']})
        drivedata.append({'Attribute':'WWN','Value':deviceAttributes['WWN']})
        drivedata.append({'Attribute':'Firmware Revision','Value':deviceAttributes['Firmware Revision']})
        drivedata.append({'Attribute':'Device Speed','Value':deviceAttributes['Device Speed']})
        drivedata.append({'Attribute':'Link Speed','Value':deviceAttributes['Link Speed']})
        drivedata.append({'Attribute':'Write Cache','Value':deviceAttributes['Write Cache']})
        drivedata.append({'Attribute':'Connector Name','Value':deviceAttributes['Connector Name']})
        drivedata.append({'Attribute':'Max lane width','Value':deviceAttributes['Max lane width']})

        Rarg4= Rarg1+' Policies/Settings'
        policies = x[Rarg2][Rarg4]
        # for key, value in policies.items():
        #     if type(value) == str:
        #         drivedata.append({'Attribute':key,'Value':value})
        drivedata.append({'Attribute':'SED Capable','Value':policies['SED Capable']})
        drivedata.append({'Attribute':'SED Enabled','Value':policies['SED Enabled']})
        drivedata.append({'Attribute':'Last Predictive Failure Event Sequence Number','Value':policies['Last Predictive Failure Event Sequence Number']})
        drivedata.append({'Attribute':'Successful diagnostics completion on','Value':policies['Successful diagnostics completion on']})
        drivedata.append({'Attribute':'Secured','Value':policies['Secured']})
        drivedata.append({'Attribute':'Cryptographic Erase Capable','Value':policies['Cryptographic Erase Capable']})
        drivedata.append({'Attribute':'Locked','Value':policies['Locked']})

        temp = detailedInformation['Drive Temperature']
        error_count_total = int(detailedInformation['Media Error Count']) + int(detailedInformation['Other Error Count']) + int(detailedInformation['Predictive Failure Count'])
        headerData = {"HealthStatus":"n/a","Temperature":temp,"TestResult":'n/a',"SectorErrorCount":error_count_total}
        return {"status":'success',"message":'success',"drivedata":drivedata,"attributes":attributes,"headerdata":headerData}
        
    except Exception as err:
        #print(("getMegaRAIDdrivesInfo Except ",err))
        return {"status":'fail',"message":str(err),"drivedata":drivedata,"attributes":[],"headerdata":{}}

def getSmartData(disk):
    debug=False
    devdisk = '/dev/' + str(disk)
    #process1 = subprocess.check_output(["smartctl","-a","--json=o",devdisk])
    #sudo smartctl -a --json=o /dev/sdd
    cmd = ["sudo","smartctl","-a","--json=o",devdisk]
    if not useFake:
        try:
            y = json.loads(getProcessOutput(cmd))
        except Exception as err:
            if debug==True:
                print ("smartCtl fail",err)
            return {"status":'fail',"message":str(err)}

    else:
        y = {'trim': {'supported': False}, 'power_on_time': {'hours': 9379}, 'ata_version': {'minor_value': 41, 'string': 'ATA8-ACS T13/1699-D revision 4', 'major_value': 496}, 'firmware_version': 'SN12', 'wwn': {'oui': 3152, 'naa': 5, 'id': 767507359}, 'smart_status': {'passed': True}, 'smartctl': {'build_info': '(local build)', 'exit_status': 0, 'argv': ['smartctl', '-a', '--json=o', '/dev/sdb'], 'version': [7, 2], 'svn_revision': '5155', 'output': ['smartctl 7.2 2020-12-30 r5155 [x86_64-linux-4.15.0-141-generic] (local build)', 'Copyright (C) 2002-20, Bruce Allen, Christian Franke, www.smartmontools.org', '', '=== START OF INFORMATION SECTION ===', 'Model Family:     Seagate Constellation ES (SATA)', 'Device Model:     ST31000524NS', 'Serial Number:    9WK3C1JF', 'LU WWN Device Id: 5 000c50 02dbf3b9f', 'Firmware Version: SN12', 'User Capacity:    1,000,204,886,016 bytes [1.00 TB]', 'Sector Size:      512 bytes logical/physical', 'Rotation Rate:    7200 rpm', 'Device is:        In smartctl database [for details use: -P show]', 'ATA Version is:   ATA8-ACS T13/1699-D revision 4', 'SATA Version is:  SATA 2.6, 3.0 Gb/s (current: 3.0 Gb/s)', 'Local Time is:    Thu May 27 20:43:55 2021 IST', 'SMART support is: Available - device has SMART capability.', 'SMART support is: Enabled', '', '=== START OF READ SMART DATA SECTION ===', 'SMART overall-health self-assessment test result: PASSED', '', 'General SMART Values:', 'Offline data collection status:  (0x82)\tOffline data collection activity', '\t\t\t\t\twas completed without error.', '\t\t\t\t\tAuto Offline Data Collection: Enabled.', 'Self-test execution status:      (   0)\tThe previous self-test routine completed', '\t\t\t\t\twithout error or no self-test has ever ', '\t\t\t\t\tbeen run.', 'Total time to complete Offline ', 'data collection: \t\t(  617) seconds.', 'Offline data collection', 'capabilities: \t\t\t (0x7b) SMART execute Offline immediate.', '\t\t\t\t\tAuto Offline data collection on/off support.', '\t\t\t\t\tSuspend Offline collection upon new', '\t\t\t\t\tcommand.', '\t\t\t\t\tOffline surface scan supported.', '\t\t\t\t\tSelf-test supported.', '\t\t\t\t\tConveyance Self-test supported.', '\t\t\t\t\tSelective Self-test supported.', 'SMART capabilities:            (0x0003)\tSaves SMART data before entering', '\t\t\t\t\tpower-saving mode.', '\t\t\t\t\tSupports SMART auto save timer.', 'Error logging capability:        (0x01)\tError logging supported.', '\t\t\t\t\tGeneral Purpose Logging supported.', 'Short self-test routine ', 'recommended polling time: \t (   1) minutes.', 'Extended self-test routine', 'recommended polling time: \t ( 165) minutes.', 'Conveyance self-test routine', 'recommended polling time: \t (   2) minutes.', 'SCT capabilities: \t       (0x10bd)\tSCT Status supported.', '\t\t\t\t\tSCT Error Recovery Control supported.', '\t\t\t\t\tSCT Feature Control supported.', '\t\t\t\t\tSCT Data Table supported.', '', 'SMART Attributes Data Structure revision number: 10', 'Vendor Specific SMART Attributes with Thresholds:', 'ID# ATTRIBUTE_NAME          FLAG     VALUE WORST THRESH TYPE      UPDATED  WHEN_FAILED RAW_VALUE', '  1 Raw_Read_Error_Rate     0x000f   081   063   044    Pre-fail  Always       -       141674428', '  3 Spin_Up_Time            0x0003   098   090   000    Pre-fail  Always       -       0', '  4 Start_Stop_Count        0x0032   100   100   020    Old_age   Always       -       498', '  5 Reallocated_Sector_Ct   0x0033   100   100   036    Pre-fail  Always       -       1 (1 0)', '  7 Seek_Error_Rate         0x000f   070   060   030    Pre-fail  Always       -       12914945158', '  9 Power_On_Hours          0x0032   090   090   000    Old_age   Always       -       9379', ' 10 Spin_Retry_Count        0x0013   100   100   097    Pre-fail  Always       -       0', ' 12 Power_Cycle_Count       0x0032   100   100   020    Old_age   Always       -       551', '184 End-to-End_Error        0x0032   100   100   099    Old_age   Always       -       0', '187 Reported_Uncorrect      0x0032   100   100   000    Old_age   Always       -       0', '188 Command_Timeout         0x0032   100   100   000    Old_age   Always       -       1', '189 High_Fly_Writes         0x003a   100   100   000    Old_age   Always       -       0', '190 Airflow_Temperature_Cel 0x0022   061   056   045    Old_age   Always       -       39 (Min/Max 33/43)', '191 G-Sense_Error_Rate      0x0032   100   100   000    Old_age   Always       -       0', '192 Power-Off_Retract_Count 0x0032   100   100   000    Old_age   Always       -       494', '193 Load_Cycle_Count        0x0032   100   100   000    Old_age   Always       -       549', '194 Temperature_Celsius     0x0022   039   044   000    Old_age   Always       -       39 (0 14 0 0 0)', '195 Hardware_ECC_Recovered  0x001a   021   021   000    Old_age   Always       -       141674428', '197 Current_Pending_Sector  0x0012   100   100   000    Old_age   Always       -       2', '198 Offline_Uncorrectable   0x0010   100   100   000    Old_age   Offline      -       2', '199 UDMA_CRC_Error_Count    0x003e   200   200   000    Old_age   Always       -       0', '', 'SMART Error Log Version: 1', 'No Errors Logged', '', 'SMART Self-test log structure revision number 1', 'No self-tests have been logged.  [To run self-tests, use: smartctl -t]', '', 'SMART Selective self-test log data structure revision number 1', ' SPAN  MIN_LBA  MAX_LBA  CURRENT_TEST_STATUS', '    1        0        0  Not_testing', '    2        0        0  Not_testing', '    3        0        0  Not_testing', '    4        0        0  Not_testing', '    5        0        0  Not_testing', 'Selective self-test flags (0x0):', '  After scanning selected spans, do NOT read-scan remainder of disk.', 'If Selective self-test is pending on power-up, resume after 0 minute delay.', ''], 'platform_info': 'x86_64-linux-4.15.0-141-generic'}, 'temperature': {'current': 39}, 'rotation_rate': 7200, 'interface_speed': {'current': {'sata_value': 2, 'units_per_second': 30, 'string': '3.0 Gb/s', 'bits_per_unit': 100000000}, 'max': {'sata_value': 6, 'units_per_second': 30, 'string': '3.0 Gb/s', 'bits_per_unit': 100000000}}, 'user_capacity': {'bytes': 1000204886016, 'blocks': 1953525168}, 'ata_smart_attributes': {'table': [{'raw': {'string': '141674428', 'value': 141674428}, 'worst': 63, 'name': 'Raw_Read_Error_Rate', 'when_failed': '', 'thresh': 44, 'id': 1, 'value': 81, 'flags': {'error_rate': True, 'string': 'POSR-- ', 'event_count': False, 'performance': True, 'auto_keep': False, 'updated_online': True, 'value': 15, 'prefailure': True}}, {'raw': {'string': '0', 'value': 0}, 'worst': 90, 'name': 'Spin_Up_Time', 'when_failed': '', 'thresh': 0, 'id': 3, 'value': 98, 'flags': {'error_rate': False, 'string': 'PO---- ', 'event_count': False, 'performance': False, 'auto_keep': False, 'updated_online': True, 'value': 3, 'prefailure': True}}, {'raw': {'string': '498', 'value': 498}, 'worst': 100, 'name': 'Start_Stop_Count', 'when_failed': '', 'thresh': 20, 'id': 4, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '1 (1 0)', 'value': 4294967297}, 'worst': 100, 'name': 'Reallocated_Sector_Ct', 'when_failed': '', 'thresh': 36, 'id': 5, 'value': 100, 'flags': {'error_rate': False, 'string': 'PO--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 51, 'prefailure': True}}, {'raw': {'string': '12914945158', 'value': 12914945158}, 'worst': 60, 'name': 'Seek_Error_Rate', 'when_failed': '', 'thresh': 30, 'id': 7, 'value': 70, 'flags': {'error_rate': True, 'string': 'POSR-- ', 'event_count': False, 'performance': True, 'auto_keep': False, 'updated_online': True, 'value': 15, 'prefailure': True}}, {'raw': {'string': '9379', 'value': 9379}, 'worst': 90, 'name': 'Power_On_Hours', 'when_failed': '', 'thresh': 0, 'id': 9, 'value': 90, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '0', 'value': 0}, 'worst': 100, 'name': 'Spin_Retry_Count', 'when_failed': '', 'thresh': 97, 'id': 10, 'value': 100, 'flags': {'error_rate': False, 'string': 'PO--C- ', 'event_count': True, 'performance': False, 'auto_keep': False, 'updated_online': True, 'value': 19, 'prefailure': True}}, {'raw': {'string': '551', 'value': 551}, 'worst': 100, 'name': 'Power_Cycle_Count', 'when_failed': '', 'thresh': 20, 'id': 12, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '0', 'value': 0}, 'worst': 100, 'name': 'End-to-End_Error', 'when_failed': '', 'thresh': 99, 'id': 184, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '0', 'value': 0}, 'worst': 100, 'name': 'Reported_Uncorrect', 'when_failed': '', 'thresh': 0, 'id': 187, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '1', 'value': 1}, 'worst': 100, 'name': 'Command_Timeout', 'when_failed': '', 'thresh': 0, 'id': 188, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '0', 'value': 0}, 'worst': 100, 'name': 'High_Fly_Writes', 'when_failed': '', 'thresh': 0, 'id': 189, 'value': 100, 'flags': {'error_rate': True, 'string': '-O-RCK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 58, 'prefailure': False}}, {'raw': {'string': '39 (Min/Max 33/43)', 'value': 723583015}, 'worst': 56, 'name': 'Airflow_Temperature_Cel', 'when_failed': '', 'thresh': 45, 'id': 190, 'value': 61, 'flags': {'error_rate': False, 'string': '-O---K ', 'event_count': False, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 34, 'prefailure': False}}, {'raw': {'string': '0', 'value': 0}, 'worst': 100, 'name': 'G-Sense_Error_Rate', 'when_failed': '', 'thresh': 0, 'id': 191, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '494', 'value': 494}, 'worst': 100, 'name': 'Power-Off_Retract_Count', 'when_failed': '', 'thresh': 0, 'id': 192, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '549', 'value': 549}, 'worst': 100, 'name': 'Load_Cycle_Count', 'when_failed': '', 'thresh': 0, 'id': 193, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--CK ', 'event_count': True, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 50, 'prefailure': False}}, {'raw': {'string': '39 (0 14 0 0 0)', 'value': 60129542183}, 'worst': 44, 'name': 'Temperature_Celsius', 'when_failed': '', 'thresh': 0, 'id': 194, 'value': 39, 'flags': {'error_rate': False, 'string': '-O---K ', 'event_count': False, 'performance': False, 'auto_keep': True, 'updated_online': True, 'value': 34, 'prefailure': False}}, {'raw': {'string': '141674428', 'value': 141674428}, 'worst': 21, 'name': 'Hardware_ECC_Recovered', 'when_failed': '', 'thresh': 0, 'id': 195, 'value': 21, 'flags': {'error_rate': True, 'string': '-O-RC- ', 'event_count': True, 'performance': False, 'auto_keep': False, 'updated_online': True, 'value': 26, 'prefailure': False}}, {'raw': {'string': '2', 'value': 2}, 'worst': 100, 'name': 'Current_Pending_Sector', 'when_failed': '', 'thresh': 0, 'id': 197, 'value': 100, 'flags': {'error_rate': False, 'string': '-O--C- ', 'event_count': True, 'performance': False, 'auto_keep': False, 'updated_online': True, 'value': 18, 'prefailure': False}}, {'raw': {'string': '2', 'value': 2}, 'worst': 100, 'name': 'Offline_Uncorrectable', 'when_failed': '', 'thresh': 0, 'id': 198, 'value': 100, 'flags': {'error_rate': False, 'string': '----C- ', 'event_count': True, 'performance': False, 'auto_keep': False, 'updated_online': False, 'value': 16, 'prefailure': False}}, {'raw': {'string': '0', 'value': 0}, 'worst': 200, 'name': 'UDMA_CRC_Error_Count', 'when_failed': '', 'thresh': 0, 'id': 199, 'value': 200, 'flags': {'error_rate': True, 'string': '-OSRCK ', 'event_count': True, 'performance': True, 'auto_keep': True, 'updated_online': True, 'value': 62, 'prefailure': False}}], 'revision': 10}, 'ata_sct_capabilities': {'data_table_supported': True, 'error_recovery_control_supported': True, 'value': 4285, 'feature_control_supported': True}, 'json_format_version': [1, 0], 'logical_block_size': 512, 'sata_version': {'string': 'SATA 2.6', 'value': 16}, 'serial_number': '9WK3C1JF', 'power_cycle_count': 551, 'ata_smart_self_test_log': {'standard': {'count': 0, 'revision': 1}}, 'ata_smart_selective_self_test_log': {'table': [{'status': {'string': 'Not_testing', 'value': 0}, 'lba_max': 0, 'lba_min': 0}, {'status': {'string': 'Not_testing', 'value': 0}, 'lba_max': 0, 'lba_min': 0}, {'status': {'string': 'Not_testing', 'value': 0}, 'lba_max': 0, 'lba_min': 0}, {'status': {'string': 'Not_testing', 'value': 0}, 'lba_max': 0, 'lba_min': 0}, {'status': {'string': 'Not_testing', 'value': 0}, 'lba_max': 0, 'lba_min': 0}], 'flags': {'remainder_scan_enabled': False, 'value': 0}, 'power_up_scan_resume_minutes': 0, 'revision': 1}, 'physical_block_size': 512, 'device': {'protocol': 'ATA', 'type': 'sat', 'name': '/dev/sdb', 'info_name': '/dev/sdb [SAT]'}, 'model_family': 'Seagate Constellation ES (SATA)', 'in_smartctl_database': True, 'ata_smart_data': {'self_test': {'status': {'passed': True, 'string': 'completed without error', 'value': 0}, 'polling_minutes': {'short': 1, 'extended': 165, 'conveyance': 2}}, 'offline_data_collection': {'status': {'passed': True, 'string': 'was completed without error', 'value': 130}, 'completion_seconds': 617}, 'capabilities': {'error_logging_supported': True, 'exec_offline_immediate_supported': True, 'values': [123, 3], 'attribute_autosave_enabled': True, 'self_tests_supported': True, 'selective_self_test_supported': True, 'conveyance_self_test_supported': True, 'gp_logging_supported': True, 'offline_is_aborted_upon_new_cmd': False, 'offline_surface_scan_supported': True}}, 'local_time': {'time_t': 1622144635, 'asctime': 'Thu May 27 20:43:55 2021 IST'}, 'ata_smart_error_log': {'summary': {'count': 0, 'revision': 1}}, 'model_name': 'ST31000524NS'}
    #y = json.loads(s)

    exit_status = y["smartctl"]["exit_status"]
    if debug==True:
        print ("exit status", exit_status)
        print ("smart data",y)
    
    if exit_status in [0,64]:
        type = y["device"]["type"]
        temp = y["temperature"]["current"]
        output = y["smartctl"]["output"]
        error_count_total = 'n/a'
        if "ata_smart_self_test_log" in y.keys():
            if "error_count_total" in y["ata_smart_self_test_log"]["standard"]:
                error_count_total = y["ata_smart_self_test_log"]["standard"]["error_count_total"]
        #print("error_count_total : ", error_count_total)
        
        status = 'n/a'
        if "ata_smart_data" in y.keys():
            status = y["ata_smart_data"]["self_test"]["status"]["string"]

        test_result = "n/a"
        sub = "SMART overall-health self-assessment test result"
        s = [s for s in output if sub in s]
        if s:
            test_result = s[0].split(':')[-1].strip()

        headerData = {"HealthStatus":"Normal","Temperature":str(temp) + "deg C","TestResult":test_result,"SectorErrorCount":error_count_total}

        Attributes = [] #header for smart table
        diskdata = []
        if type=="nvme":
            if "nvme_smart_health_information_log" in y.keys():
                for attrs,values in y["nvme_smart_health_information_log"].items():
                    attrDict = {"Name":attrs,"Value":values}
                    Attributes= ['Name', 'Value']
                    diskdata.append(attrDict)

        elif "ata_smart_attributes" in y.keys():
            try:
                idx = output.index("Vendor Specific SMART Attributes with Thresholds:") + 2
                for attrs in y["ata_smart_attributes"]["table"]:
                    name = attrs["name"]
                    value = attrs["value"]
                    Normalized = attrs["raw"]["value"]
                    Threshold = attrs["thresh"]
                    worst = attrs["worst"]
                    Type = 'n/a'
                    if output[idx].split()[0] == str(attrs["id"]):
                        Type =  output[idx].split()[6]
                    
                    idx+=1
                    Assessment = 'OK'
                    attrDict = {"Name":name,"Value":value,"Raw":Normalized,"Threshold":Threshold,"Worst":worst,"Type":Type,"Assessment":Assessment}
                    Attributes= ['Name', 'Value','Raw','Threshold','Worst','Type','Assessment']
                    diskdata.append(attrDict)
            except:
                data = [{'id':disk,"headerData":{},"data":[],"attributes":[],"status":"fail","message":"Error while reading smart data"}]
                return data

        data = [{'id':disk,"headerData":headerData,"data":diskdata,"attributes":Attributes,"status":"success","message":"success"}]

    elif exit_status == 2:
        message = y["smartctl"]["messages"][0]["string"]
        data = [{'id':disk,"headerData":{},"data":[],"attributes":[],"status":"fail","message":message}]

    elif exit_status == 4:
        data = [{'id':disk,"headerData":{},"data":[],"attributes":[],"status":"fail","message":"Unavailable - device lacks SMART capability."}]
    else:
        data = [{'id':disk,"headerData":{},"data":[],"attributes":[],"status":"fail","message":"Unknown error"}]

    return data

getSmartData('sdd')
