import cgi,cgitb
import sqlite3
import ftplib
import os
import json
import zipfile
import sys
import docker
import subprocess
import time
import string
import random
from globalSettings import *

#print "Content-type:text/html\r\n\r\n"

client = docker.from_env()

#Called from cgi_downloadImage.py
#def download_buildImage(FtpServer, ServerUser, ServerPwd, destination,DowloadedFileName, SourceFilename, source, extension,image_name,group_name):
def download_buildImage(FtpServer, ServerUser, ServerPwd, destination,DowloadedFileName, SourceFilename, source, extension,image_name,image_type):
    ftp =ftplib.FTP(FtpServer)
    ftp.login(ServerUser,ServerPwd)
    isPathExists=source.replace(source[:1], '') in ftp.nlst()
    if isPathExists:
        ftp.cwd(source)
        isFileExists = SourceFilename in ftp.nlst()
        if isFileExists:
            filedata = open(os.path.join(destination,DowloadedFileName),'wb')
            ftp.retrbinary('RETR '+SourceFilename,filedata.write)

        filedata.close()
        ftp.quit()

        if str(extension)=="zip":
            path_to_zip_file = str(os.path.join(destination,DowloadedFileName))
            #print("zipfile : " + path_to_zip_file)
            directory_to_extract_to = str(destination)
            with zipfile.ZipFile(os.path.join(destination,DowloadedFileName), 'r') as zip_ref:
                zip_ref.extractall(directory_to_extract_to)
            os.remove(path_to_zip_file)

    #if(group_name=='Docker'):
    if(image_type=='docker'):
        filenames = SourceFilename.split('.')
        path = str(destination) + "/" + str(filenames[0]) + "/"
        tag = str(image_name)
        client.images.build(path=path, tag=tag,rm=True)

#called from cgi_myserver_save_config.py
def save_docker_vm(port,image_name,server_name,group_name):
    containerID=''
    if(image_name=='simple-web' or image_name=='opensis' or image_name=='sanuyi-dvr' or image_name=='yetiforce' or image_name=='open-xchange'):
        port = str(port)
        container = client.containers.create(image=image_name, ports={80:port}, name=server_name)
        containerID = str(container.id)

    elif(image_name=='minio'):
        port = str(port)
        container = client.containers.create(command="server /data",image=image_name, ports={9000:port}, name=server_name, environment=["MINIO_ACCESS_KEY=TESTKEY","MINIO_SECRET_KEY=SECRETKEY"])
        containerID = str(container.id)

    elif(image_name=='odoo'):
        port = str(port)
        try:
            container = client.containers.get("db")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, environment=["POSTGRES_USER=odoo","POSTGRES_PASSWORD=odoo","POSTGRES_DB=postgres"],name="db",image="postgres:10")
        container = client.containers.create(image=image_name, ports={8069:port}, name=server_name, links={'db': 'db'},tty=True)
        containerID = str(container.id)
    
    elif(image_name=='redmine'):
        port = str(port)
        try:
            network = client.networks.get("redmineDefault")
        except docker.errors.NotFound:
            network = client.networks.create("redmineDefault")
        try:
            volumes = client.volumes.get("redmineMariadb_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="redmineMariadb_data")
        try:
            container = client.containers.get("redminedb")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, name="redminedb",network="redmineDefault", volumes={'redmineMariadb_data': {'bind': '/bitnami', 'mode': 'rw'}}, image="bitnami/mariadb:latest", environment=["ALLOW_EMPTY_PASSWORD=yes","MARIADB_USER=bn_redmine","MARIADB_DATABASE=bitnami_redmine"])
        try:
            volumes = client.volumes.get("redmine_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="redmine_data")
        container = client.containers.create(name=server_name, image=image_name, ports={3000:port}, volumes={'redmine_data': {'bind': '/bitnami', 'mode': 'rw'}}, environment=["REDMINE_DB_USERNAME=bn_redmine","REDMINE_DB_NAME=bitnami_redmine"])
        network.connect(container,links={"redminedb":"mariadb"})
        containerID = str(container.id)

    
    elif(image_name=='cassandra'):
        container = client.containers.run(detach=True,image=image_name)        
        cassandraName = container.name
        container = client.containers.get(cassandraName)
        ip_add = container.attrs['NetworkSettings']['IPAddress']

        while True:
            logsStr = container.logs()
            if logsStr.find("Created default superuser role 'cassandra'") > -1:
                break

        try: 
            image = client.images.get("delermando/docker-cassandra-web:v0.4.0")
        except docker.errors.ImageNotFound:
            client.images.pull("delermando/docker-cassandra-web:v0.4.0")

        container = client.containers.create(image="delermando/docker-cassandra-web:v0.4.0",
            name=server_name,
            ports={3000:port},
            environment=["CASSANDRA_HOST_IP="+str(ip_add),"CASSANDRA_PORT=9042"]
        )
        containerID = str(container.id)

    elif(image_name=='suitecrm'):
        port = str(port)
        try:
            network = client.networks.get("suitecrmDefault")
        except docker.errors.NotFound:
            network = client.networks.create("suitecrmDefault")
        try:
            volumes = client.volumes.get("suitecrmMariadb_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="suitecrmMariadb_data")
        try:
            container = client.containers.get("suirtecrmdb")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, name="suirtecrmdb", network="suitecrmDefault",volumes={'suitecrmMariadb_data': {'bind': '/bitnami', 'mode': 'rw'}}, image="bitnami/mariadb:10.3-debian-10", environment=["ALLOW_EMPTY_PASSWORD=yes","MARIADB_USER=bn_suitecrm","MARIADB_DATABASE=bitnami_suitecrm"])
        try:
            volumes = client.volumes.get("suitecrm_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="suitecrm_data")
            
        container = client.containers.create(name=server_name, image=image_name, ports={80:port}, volumes={'suitecrm_data': {'bind': '/bitnami', 'mode': 'rw'}}, environment=["ALLOW_EMPTY_PASSWORD=yes","SUITECRM_DATABASE_USER=bn_suitecrm","SUITECRM_DATABASE_NAME=bitnami_suitecrm"])
        network.connect(container,links={"suirtecrmdb":"mariadb"})
        containerID = str(container.id)

    elif(image_name=='datadoghq-agent'):
        port = str(port)
        container = client.containers.create(image=image_name, ports={80:port}, name=server_name, volumes={"/var/run/docker.sock":{'bind': '/var/run/docker.sock', 'mode': 'ro'},"/proc/":{'bind':'/host/proc/', 'mode': 'ro'},"/sys/fs/cgroup/":{'bind': '/host/sys/fs/cgroup', 'mode': 'ro'}},environment=["DD_API_KEY=90cb4f8eeaee2ff7dcbcb739b25b3cc5","SD_BACKEND=docker","NON_LOCAL_TRAFFIC=false"])
        containerID = str(container.id)

    elif(image_name=='fedena'):
        port = str(port)
        container = client.containers.create(name=server_name,image=image_name,ports={3000:port}, command="/start-fedena.sh")
        containerID = str(container.id)
    
    elif(image_name=='moodle'):
        port = str(port)
        try:
            network = client.networks.get("moodle-network")
        except docker.errors.NotFound:
            network = client.networks.create("moodle-network")
        try:
            volumes = client.volumes.get("moodleMariadb_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="moodleMariadb_data")
        try:
            container = client.containers.get("moodledb")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, name="moodledb",network="moodle-network",volumes={'moodleMariadb_data': {'bind': '/bitnami/mariadb', 'mode': 'rw'}}, image="bitnami/mariadb:10.3-debian-10", environment=["ALLOW_EMPTY_PASSWORD=yes","MARIADB_USER=bn_moodle","MARIADB_DATABASE=bitnami_moodle"])

        try:
            volumes = client.volumes.get("moodle_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="moodle_data")
        try:
            volumes = client.volumes.get("moodledata_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="moodledata_data")
            
        container = client.containers.create(name=server_name, image=image_name,ports={8080:port}, volumes={'moodle_data': {'bind': '/bitnami/moodle', 'mode': 'rw'},'moodledata_data':{'bind': '/bitnami/moodledata', 'mode': 'rw'}},\
            environment=["MOODLE_DATABASE_USER=bn_moodle", \
                "MOODLE_DATABASE_HOST=moodledb", \
                "MARIADB_HOST=moodledb", \
                "MOODLE_DATABASE_NAME=bitnami_moodle", \
                "ALLOW_EMPTY_PASSWORD=yes" ])

        network.connect(container,links={"moodledb":"mariadb"})
        containerID = str(container.id)

    elif(image_name=='onlyoffice'):
        try:
            network = client.networks.get("onlyofficeNet")
        except docker.errors.NotFound:
            network = client.networks.create("onlyofficeNet", driver="bridge")

        try:
            volumes = client.volumes.get("mail_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="mail_data")
        
        try:
            volumes = client.volumes.get("mail_certs")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="mail_certs")

        try:
            volumes = client.volumes.get("mail_log")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="mail_log")

        try:
            volumes = client.volumes.get("document_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="document_data")

        try:
            volumes = client.volumes.get("document_log")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="document_log")

        try:
            volumes = client.volumes.get("document_forgotten")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="document_forgotten")

        try:
            volumes = client.volumes.get("community_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="community_data")

        try:
            volumes = client.volumes.get("community_log")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="community_log")

        try:
            volumes = client.volumes.get("mysql_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="mysql_data")

        try:
            container = client.containers.get("onlyoffice-mysql-server")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="mysql:5.7.21",
                name="onlyoffice-mysql-server",
                stdin_open=True,
                network="onlyofficeNet",
                tty=True,
                restart_policy={"Name": "always"},
                volumes={
                    AppServersPath+group_name+'/'+server_name+''+'/config/mysql/conf.d':{'bind':'/etc/mysql/conf.d'},
                    AppServersPath+group_name+'/'+server_name+''+'/config/mysql/docker-entrypoint-initdb.d':{'bind':'/docker-entrypoint-initdb.d'},
                    'mysql_data' :{'bind': '/var/lib/mysql'}
                }, 
                environment=["MYSQL_ROOT_PASSWORD=my-secret-pw"]
            )

        try:
            container = client.containers.get("onlyoffice-document-server")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="onlyoffice/documentserver:latest",
                name="onlyoffice-document-server",
                stdin_open=True,
                network="onlyofficeNet",
                tty=True,
                restart_policy={"Name": "always"}, \
                volumes={
                    'document_data': {'bind': '/var/www/onlyoffice/Data'},
                    'document_log': {'bind': '/var/log/onlyoffice'},
                    AppServersPath+group_name+'/'+server_name+''+'/document_fonts': {'bind': '/usr/share/fonts/truetype/custom'},
                    'document_forgotten' :{'bind': '/var/lib/onlyoffice/documentserver/App_Data/cache/files/forgotten'}
                }
            )

        try:
            container = client.containers.get("onlyoffice-mail-server")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="onlyoffice/mailserver:latest",
                privileged=True,
                name="onlyoffice-mail-server",
                stdin_open=True,
                network="onlyofficeNet",
                tty=True,
                restart_policy={"Name": "always"},
                hostname="yourdomain.com",
                volumes={
                    'mail_data':{'bind': '/var/vmail'} ,
                    'mail_certs':{'bind': '/etc/pki/tls/mailserver'} ,
                    'mail_log':{'bind': '/var/log'}
                },
                environment=[
                    "MYSQL_SERVER=onlyoffice-mysql-server",
                    "MYSQL_SERVER_PORT=3306",
                    "MYSQL_ROOT_USER=onlyoffice_mailserver_user",
                    "MYSQL_ROOT_PASSWD=onlyoffice_mailserver_user_pass",
                    "MYSQL_SERVER_DB_NAME=onlyoffice_mailserver"
                ]
            )

        subprocessBool=0
        if subprocessBool:
            container = client.containers.create(name=server_name, 
                image=image_name, 
                ports={80:port}, 
                stdin_open=True,
                tty=True,
                restart_policy={"Name": "always"},
                environment=[
                    "ONLYOFFICE_CORE_MACHINEKEY=core_secret",
                    "DOCUMENT_SERVER_PORT_80_TCP_ADDR=onlyoffice-document-server",
                    "MYSQL_SERVER_ROOT_PASSWORD=my-secret-pw",
                    "MYSQL_SERVER_DB_NAME=onlyoffice ",
                    "MYSQL_SERVER_HOST=onlyoffice-mysql-server", 
                    "MYSQL_SERVER_USER=onlyoffice_user",
                    "MYSQL_SERVER_PASS=onlyoffice_pass", 
                    "MAIL_SERVER_API_PORT=8081",
                    "MAIL_SERVER_API_HOST=onlyoffice-mail-server",
                    "MAIL_SERVER_DB_HOST=onlyoffice-mysql-server",
                    "MAIL_SERVER_DB_PORT=3306",
                    "MAIL_SERVER_DB_NAME=onlyoffice_mailserver",
                    "MAIL_SERVER_DB_USER=onlyoffice_mailserver_user",
                    "MAIL_SERVER_DB_PASS=onlyoffice_mailserver_user_pass"
                ],
                volumes={
                    'community_data': {'bind': '/var/www/onlyoffice/Data'},
                    'community_log':{'bind': '/var/log/onlyoffice'},
                    'document_data':{'bind': '/var/www/onlyoffice/DocumentServerData'},
                    '/var/www/Sanuyi/appImages/Docker/onlyoffice/certs':{'bind': '/var/www/onlyoffice/Data/certs'}
                }
            )

            network.connect(container,links={
                "onlyoffice-mysql-server":"onlyoffice-mysql-server",
                "onlyoffice-document-server":"onlyoffice-document-server",
                "onlyoffice-mail-server":"onlyoffice-mail-server"
            })
            containerID = str(container.id)


        else:
            RunCommand = '''
                sudo docker run -d --net onlyofficeNet -i -t --restart=always --name '''+str(server_name) +''' -p '''+str(port) +''':80 \
                -e ONLYOFFICE_CORE_MACHINEKEY=core_secret \
                -e DOCUMENT_SERVER_PORT_80_TCP_ADDR=onlyoffice-document-server \
                -e MYSQL_SERVER_ROOT_PASSWORD=my-secret-pw \
                -e MYSQL_SERVER_DB_NAME=onlyoffice \
                -e MYSQL_SERVER_USER=onlyoffice_user \
                -e MYSQL_SERVER_HOST=onlyoffice-mysql-server \
                -e MYSQL_SERVER_PASS=onlyoffice_pass \
            -e MAIL_SERVER_API_PORT=8081 \
            -e MAIL_SERVER_API_HOST=onlyoffice-mail-server \
            -e MAIL_SERVER_DB_HOST=onlyoffice-mysql-server \
            -e MAIL_SERVER_DB_PORT=3306 \
            -e MAIL_SERVER_DB_NAME=onlyoffice_mailserver \
            -e MAIL_SERVER_DB_USER=onlyoffice_mailserver_user \
            -e MAIL_SERVER_DB_PASS=onlyoffice_mailserver_user_pass \
            -v community_data:/var/www/onlyoffice/Data \
            -v community_log:/var/log/onlyoffice \
            -v document_data:/var/www/onlyoffice/DocumentServerData \
            -v /var/www/Sanuyi/appImages/Docker/onlyoffice/certs:/var/www/onlyoffice/Data/certs \
            --link onlyoffice-mysql-server:onlyoffice-mysql-server \
            --link onlyoffice-document-server:onlyoffice-document-server \
            --link onlyoffice-mail-server:onlyoffice-mail-server \
                ''' + str(image_name)

            txtFilePath = os.path.join("ContainerID.txt")
            with open(txtFilePath,'w') as f2:
                subprocess.call([RunCommand],shell=True, stdout =f2)

            with open(txtFilePath, 'r') as f3:
                containerID = f3.readline().strip()

            os.remove('ContainerID.txt')

    elif(image_name=='lets-chat'):
        container = client.containers.run(detach=True, image = "mongo:latest")
        mongoName = container.name

        container = client.containers.create(image=image_name, ports={8080:port}, name=server_name, links={mongoName: 'mongo'})
        containerID = str(container.id)

    elif(image_name=='wordpress'):
        try:
            network = client.networks.get("wordpress-network")
        except docker.errors.NotFound:
            network = client.networks.create("wordpress-network")

        try:
            volumes = client.volumes.get("wordpress_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="wordpress_data")
        
        try:
            volumes = client.volumes.get("mariadb_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="mariadb_data")   

        try:
            container = client.containers.get("wordpressMariadb")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True,
            network="wordpress-network",
            environment=[
                "ALLOW_EMPTY_PASSWORD=yes",
                "MARIADB_USER=bn_wordpress",
                "MARIADB_DATABASE=bitnami_wordpress"
            ],
            volumes={
                    'mariadb_data': {'bind': '/bitnami/mariadb'}
            }, 
            name="wordpressMariadb",
            image="bitnami/mariadb:10.5.5")

        container = client.containers.create(image=image_name, ports={8080:port}, name=server_name,
                environment=[
                    "ALLOW_EMPTY_PASSWORD=yes",
                    "WORDPRESS_DATABASE_USER=bn_wordpress",
                    "WORDPRESS_DATABASE_NAME=bitnami_wordpress"
                ],
                volumes={
                    'wordpress_data': {'bind': '/bitnami/wordpress'}
                }
            )

        network.connect(container, links={"wordpressMariadb":"mariadb"})

        containerID = str(container.id) 

    elif(image_name=='orangehrm'):
        try:
            network = client.networks.get("orangehrmNet")
        except docker.errors.NotFound:
            network = client.networks.create("orangehrmNet", driver="bridge")

        try:
            volumes = client.volumes.get("orangehrmMariadb_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="orangehrmMariadb_data")
        
        try:
            volumes = client.volumes.get("orangehrm_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="orangehrm_data")   

        try:
            container = client.containers.get("orangehrmMariadb")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True,
            network="orangehrmNet",
            environment=[
                "MARIADB_USER=bn_orangehrm",
                "MARIADB_DATABASE=bitnami_orangehrm",
                "ALLOW_EMPTY_PASSWORD=yes"
            ],
            volumes={
                    'orangehrmMariadb_data': {'bind': '/bitnami'}
            }, 
            name="orangehrmMariadb",
            image="bitnami/mariadb:10.3-debian-10")

        container = client.containers.create(image=image_name, ports={80:port}, name=server_name,
                environment=[
                    "MARIADB_HOST=mariadb",
                    "MARIADB_PORT_NUMBER=3306",
                    "ORANGEHRM_DATABASE_USER=bn_orangehrm",
                    "ORANGEHRM_DATABASE_NAME=bitnami_orangehrm",
                    "ALLOW_EMPTY_PASSWORD=yes"
                ],
                volumes={
                    'orangehrm_data': {'bind': '/bitnami'}
                }
            )
        network.connect(container,links={"orangehrmMariadb":"mariadb"})
        containerID = str(container.id) 
    
    elif(image_name=='grafana' or image_name=='canvas'):
        container = client.containers.create(image=image_name, ports={3000:port}, name=server_name)
        containerID = str(container.id) 

    elif(image_name=='kibana'):
        try:
            network = client.networks.get("kibana-network")
        except docker.errors.NotFound:
            network = client.networks.create("kibana-network")

        try:
            container = client.containers.get("elasticsearch")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True,
            network="kibana-network",
            environment=[
                "discovery.type=single-node"
            ],
            name="elasticsearch",
            image="elasticsearch:7.9.1")

        container = client.containers.create(name=server_name, image=image_name, ports={5601:port})
        network.connect(container, links={'elasticsearch':'elasticsearch'})
        containerID = str(container.id) 

    elif(image_name=='xibo'):
        try:
            volumes = client.volumes.get("xiboDB")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="xiboDB")
        
        try:
            volumes = client.volumes.get("xiboCmsCustom")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="xiboCmsCustom")

        try:
            volumes = client.volumes.get("xiboBackup")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="xiboBackup")

        try:
            volumes = client.volumes.get("xiboThemeCustom")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="xiboThemeCustom")

        try:
            volumes = client.volumes.get("xiboCmsLibrary")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="xiboCmsLibrary")

        try:
            volumes = client.volumes.get("xiboUserscripts")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="xiboUserscripts")

        try:
            volumes = client.volumes.get("xiboCerts")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="xiboCerts")

        try:
            container = client.containers.get("cms-db")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True,
            restart_policy={"Name": "always"},
            environment=[
                            "MYSQL_DATABASE=cms",
                            "MYSQL_USER=cms", 
                            "MYSQL_RANDOM_ROOT_PASSWORD=yes",
                            "MYSQL_PASSWORD=admin"
                ],
            volumes={
                    "xiboDB":{'bind':'/var/lib/mysql', 'mode':'Z'}
            }, 
            name="cms-db",
            image="mysql:5.6")

        try:
            container = client.containers.get("cms-xmr")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True,
            restart_policy={"Name": "always"},
            environment=[
                            "MYSQL_DATABASE=cms",
                            "MYSQL_USER=cms", 
                            "MYSQL_RANDOM_ROOT_PASSWORD=yes",
                            "MYSQL_PASSWORD=admin",
                            "CMS_SMTP_SERVER=smtp.gmail.com:587",
                            "CMS_SMTP_PASSWORD=yourpassword",
                            "CMS_SMTP_USE_TLS=YES",
                            "CMS_SMTP_USE_STARTTLS=YES",
                            "CMS_SMTP_REWRITE_DOMAIN=gmail.com",
                            "CMS_SMTP_HOSTNAME=gmail.com",
                            "CMS_SMTP_FROM_LINE_OVERRIDE=YES",
                            "CMS_SMTP_USERNAME=youraccount@gmail.com"
                ],
            name="cms-xmr",
            image="xibosignage/xibo-xmr:release-0.8")


        container = client.containers.create(image=image_name, ports={80:port}, name=server_name,
                restart_policy={"Name": "always"},
                environment=[
                            "MYSQL_DATABASE=cms",
                            "MYSQL_USER=cms", 
                            "MYSQL_RANDOM_ROOT_PASSWORD=yes",
                            "MYSQL_PASSWORD=admin",
                            "CMS_SMTP_SERVER=smtp.gmail.com:587",
                            "CMS_SMTP_PASSWORD=yourpassword",
                            "CMS_SMTP_USE_TLS=YES",
                            "CMS_SMTP_USE_STARTTLS=YES",
                            "CMS_SMTP_REWRITE_DOMAIN=gmail.com",
                            "CMS_SMTP_HOSTNAME=gmail.com",
                            "CMS_SMTP_FROM_LINE_OVERRIDE=YES",
                            "CMS_SMTP_USERNAME=youraccount@gmail.com"
                ],
                volumes={
                        "xiboCmsCustom":{'bind': '/var/www/cms/custom', 'mode' : 'Z'},
                        "xiboBackup":{'bind': '/var/www/backup', 'mode' : 'Z'},
                        "xiboThemeCustom":{'bind': '/var/www/cms/web/theme/custom', 'mode' : 'Z'},
                        "xiboCmsLibrary":{'bind': '/var/www/cms/library', 'mode' : 'Z'},
                        "xiboUserscripts":{'bind': '/var/www/cms/web/userscripts', 'mode' : 'Z'},
                        "xiboCerts":{'bind': '/var/www/cms/ca-certs', 'mode' : 'Z'}
                },
                links = {
                    "cms-db":"mysql",
                    "cms-xmr":"50001"
                }
            )
        containerID = str(container.id)

    elif(image_name=='erpnext'):
        volume1 = client.volumes.create()

        volume2 = client.volumes.create()

        container = client.containers.create(volumes={
            volume1.name:{'bind':"/home/frappe/frappe-bench/sites/site1.local/"},
            volume2.name:{'bind':"/var/lib/mysql"}},
            image=image_name,
        )
        container = client.containers.create(image=image_name, ports={80:port}, name=server_name,
        volumes_from = [container.name]
        )
        containerID = str(container.id)

    elif(image_name=='mahara'):
        try:
            network = client.networks.get("maharaNet")
        except docker.errors.NotFound:
            network = client.networks.create("maharaNet", driver="bridge")

        #Generating Random 5 letter server name
        generateFlag = 1
        while generateFlag:
            length = 5  #length of random string we want to create
            letters = string.ascii_lowercase
            result_str = ''.join(random.choice(letters) for i in range(length))
            try:
                container = client.containers.get(result_str)
                generateFlag = 1
            except:
                generateFlag = 0
                break

        container = client.containers.run(detach=True,
                image="postgres:9",
                name = result_str,
                network="maharaNet", 
                environment=[
                    "POSTGRES_USER=mahara",
                    "POSTGRES_PASSWORD=graffl3",
                    "POSTGRES_DB=mahara" 
                ]
            )
        
        container = client.containers.create(name=server_name, 
                image=image_name, 
                ports={80:port}
        )

        network.connect(container,links={
            result_str:"db"
        })
        containerID = str(container.id)

    elif(image_name=='openproject'):
        try:
            volumes = client.volumes.get("openproject_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="openproject_data")
        
        try:
            volumes = client.volumes.get("openproject_assets")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="openproject_assets")

        container = client.containers.create(name=server_name, 
                image=image_name, 
                ports={80:port}, 
                environment=[
                    "SECRET_KEY_BASE=secret"
                ],
                volumes={
                    'openproject_data': {'bind': '/var/openproject/pgdata'},
                    'openproject_assets':{'bind': '/var/openproject/assets'}
                }
        )
        containerID = str(container.id)

    elif(image_name=='logicaldoc'):
        try:
            container = client.containers.get("logicaldoc-mysql-server")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="mysql:5.7",
                name="logicaldoc-mysql-server",
                environment=[
                    "MYSQL_ROOT_PASSWORD=mypassword",
                    "MYSQL_DATABASE=logicaldoc",
                    "MYSQL_USER=ldoc",
                    "MYSQL_PASSWORD=changeme"
                ]
            )

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={8080:port}, 
            environment=[
                "LDOC_USERNO=7137DC20-6FA9-4652-BF4E-1AFBE28C2391"
            ],
            links={'logicaldoc-mysql-server':'mysql-ld'}
        )
        containerID = str(container.id)

    elif(image_name=='openemis'):
        try:
            volumes = client.volumes.get("oe-data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="oe-data")

        try:
            container = client.containers.get("oe-database")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="mysql:5.7",
                name="oe-database",
                restart_policy={"Name": "always"},
                environment=[
                    "MYSQL_ROOT_PASSWORD=mypassword",
                    "MYSQL_DATABASE=openemis_core",
                    "MYSQL_USER=admin",
                    "MYSQL_PASSWORD=demo"
                ],
                volumes={
                    'oe-data':{'bind': '/var/lib/mysql'},
                    '/var/www/Sanuyi/appImages/Docker/openemis/config/sql/prd_cor_dmo.sql':{'bind': '/docker-entrypoint-initdb.d/prd_cor_dmo.sql'}
                },
                command = 'mysqld --sql_mode="STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION"'
            )

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={80:port},
            restart_policy={"Name": "always"}, 
            environment=[
                "OE_DATABASE_HOST=oe-database",
                "OE_DATABASE_PORT=3306",
                "OE_DATABASE_USERNAME=admin",
                "OE_DATABASE_PASSWORD=demo",
                "OE_DATABASE_SCHEMA=openemis_core",
                "OE_EMAIL_HOST=localhost",
                "OE_EMAIL_PORT=25",
                "OE_EMAIL_USERNAME=admin",
                "OE_EMAIL_PASSWORD=demo",
                "OE_EMAIL_ADDRESS=noreply@openemis.org"
            ],
            links={'oe-database':'oe-database'}
        )
        containerID = str(container.id)

        
    elif(image_name=='tastyigniter'):
        try:
            volumes = client.volumes.get("tasty_db_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="tasty_db_data")

        try:
            container = client.containers.get("tasty_db")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="mariadb:10.5",
                name="tasty_db",
                restart_policy={"Name": "always"},
                environment=[
                    "MYSQL_ROOT_PASSWORD=yes",
                    "MYSQL_DATABASE=tastyigniter",
                    "MYSQL_USER=tastyigniter",
                    "MYSQL_PASSWORD=somepassword"
                ],
                volumes={
                    'db_data':{'bind': '/var/lib/mysql'},
                },
                command = 'mysqld --sql_mode="STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,TRADITIONAL,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION"'
            )

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={80:port},
            restart_policy={"Name": "always"}, 
            environment=[
                "MYSQL_HOSTNAME=db",
                "MYSQL_DATABASE=tastyigniter",
                "MYSQL_USER=tastyigniter",
                "MYSQL_PASSWORD=somepassword"
            ],
            links={'tasty_db':'db'}
        )
        containerID = str(container.id)

    elif(image_name=='openemr'):
        try:
            volumes = client.volumes.get("OElogvolume")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="OElogvolume")

        try:
            volumes = client.volumes.get("OEsitevolume")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="OEsitevolume")

        try:
            volumes = client.volumes.get("OEdatabasevolume")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="OEdatabasevolume")

        try:
            container = client.containers.get("openemr-mysql")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="mariadb:10.5",
                name="openemr-mysql",
                restart_policy={"Name": "always"},
                environment=[
                    "MYSQL_ROOT_PASSWORD=root",
                ],
                volumes={
                    'OEdatabasevolume':{'bind': '/var/lib/mysql'},
                },
                command = 'mysqld --character-set-server=utf8mb4'
            )

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={80:port},
            restart_policy={"Name": "always"}, 
            environment=[
                "MYSQL_HOST=mysql",
                "MYSQL_ROOT_PASS=root",
                "MYSQL_USER=openemr",
                "MYSQL_PASS=openemr",
                "OE_USER=admin",
                "OE_PASS=pass"
            ],
            volumes={
                    'OElogvolume':{'bind': '/var/log'},
                    'OEsitevolume':{'bind': '/var/www/localhost/htdocs/openemr/sites'}
            },
            links={'openemr-mysql':'mysql'}
        )
        containerID = str(container.id)

    elif(image_name=='frontaccounting'):
        try:
            container = client.containers.get("fa-db")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="mysql:5.6",
                name="fa-db",
                environment=[
                    "MYSQL_ROOT_PASSWORD=12345",
                    "MYSQL_DATABASE=fa-db"
                ]
            )

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={80:port},
            links={'fa-db':'fa_db'},
            command = '--http'
        )
        containerID = str(container.id)

    elif(image_name=='akaunting'):
        try:
            volumes = client.volumes.get("akaunting_db_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="akaunting_db_data")

        try:
            volumes = client.volumes.get("akaunting_app_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="akaunting_app_data")

        try:
            container = client.containers.get("akaunting_db")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="sameersbn/mysql:5.7.24",
                name="akaunting_db",
                restart_policy={"Name": "always"},
                environment=[
                    "DB_USER=akaunting",
                    "DB_PASS=password",
                    "DB_NAME=akaunting_db"
                ],
                volumes={
                    'akaunting_db_data':{'bind': '/var/lib/mysql'}
                }
            )
        

        AppContainer = client.containers.run(detach=True, 
            image=image_name,
            restart_policy={"Name": "always"},
            stdin_open=True,
            tty=True,
            environment=[
                "DEBUG=false",
                "TZ=Asia/Kolkata",
                "DB_HOST=mysql",
                "DB_USER=akaunting",
                "DB_PASS=password",
                "DB_NAME=akaunting_db",
                "AKAUNTING_URL=http://localhost:"+str(port),
                "AKAUNTING_BACKUPS_EXPIRY=0"
            ],
            volumes={
                'akaunting_app_data':{'bind': '/var/lib/akaunting'}
            },
            command = 'app:akaunting',
            links={'akaunting_db':'mysql'}
        )

        container = client.containers.create(name=server_name, 
            image=image_name,
            stdin_open=True,
            tty=True, 
            ports={80:port},
            restart_policy={"Name": "always"}, 
            environment=[
                "AKAUNTING_PHP_FPM_HOST="+AppContainer.name,
                "AKAUNTING_PHP_FPM_PORT=9000"
            ],
            command = 'app:nginx',
            links={AppContainer.name:'php-fpm'}
        )
        containerID = str(container.id)

    elif(image_name=='cliniccases'):
        try:
            volumes = client.volumes.get("cliniccases_data")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="cliniccases_data")

        try:
            volumes = client.volumes.get("cliniccases_mysql")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="cliniccases_mysql")

        try:
            container = client.containers.get("cliniccases_db")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="mysql:5.7",
                name="cliniccases_db",
                restart_policy={"Name": "always"},
                environment=[
                    "MYSQL_ROOT_PASSWORD=terriblepassword",
                    "MYSQL_DATABASE=cliniccases",
                    "MYSQL_USER=cliniccases",
                    "MYSQL_PASSWORD=terriblepassword"
                ],
                volumes={
                    'cliniccases_mysql':{'bind': '/var/lib/mysql'}
                }
            )

        container = client.containers.create(name=server_name, 
            image=image_name,
            ports={80:port},
            restart_policy={"Name": "always"},
            links={"cliniccases_db":"mysql"},
            volumes={
                    'cliniccases_data':{'bind': '/var/cc_docs'}
                }
        )

        containerID = str(container.id)

    elif(image_name=='screenly'):
        try:
            volumes = client.volumes.get("screenly-volume")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="screenly-volume")

        try:
            volumes = client.volumes.get("screenly-assets-volume")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="screenly-assets-volume")

        container = client.containers.create(name=server_name, 
            image=image_name,
            ports={8080:port},
            environment=[
                    "PYTHONUNBUFFERED=1",
                    "LISTEN=0.0.0.0",
                    "CELERY_BROKER_URL=redis://redis:6379/0",
                    "CELERY_RESULT_BACKEND=redis://redis:6379/0"
                ],
            volumes={
                    '/var/www/Sanuyi/appImages/Docker/screenly':{'bind': '/home/pi/screenly'},
                    'screenly-volume':{'bind': '/home/pi/.screenly'},
                    'screenly-assets-volume':{'bind': '/home/pi/screenly_assets'}
                }
        )

        containerID = str(container.id)

    elif(image_name=='alluxio'):
        try:
            network = client.networks.get("alluxio_nw")
        except docker.errors.NotFound:
            network = client.networks.create("alluxio_nw")

        try:
            volumes = client.volumes.get("alluxio_ufs")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="alluxio_ufs")

        
        container = client.containers.create(
            image=image_name,
            name=server_name,
            ports={19999:port},
            network="alluxio_nw",
            volumes={
                'alluxio_ufs' :{'bind': '/opt/alluxio/underFSStorage'}
            }, 
            command='master'
        )
        
        containerID = str(container.id)

    elif(image_name=='syncthing'):

        volume = client.volumes.create()
    
        container = client.containers.create(
            image=image_name,
            name=server_name,
            ports={8384:port},
            volumes={
                volume.name:{'bind': '/var/syncthing'}
            }
        )
        
        containerID = str(container.id)

    elif(image_name=='jupyter'):
        container = client.containers.create(
            image=image_name,
            name=server_name,
            ports={8888:port},
            command = 'start.sh jupyter notebook --NotebookApp.token=""'
        )
        containerID = str(container.id)

    elif(image_name=='ospos'):
        sqlContainer = client.containers.run(detach=True, 
            image="mariadb:10.1.21",
            restart_policy={"Name": "always"},
            volumes={
                AppServersPath+group_name+'/'+server_name+'/database/database.sql' :{'bind': '/docker-entrypoint-initdb.d/database.sql'}
            }, 
            environment=[
            "MYSQL_ROOT_PASSWORD=pointofsale",
            "MYSQL_DATABASE=ospos",
            "MYSQL_USER=admin",
            "MYSQL_PASSWORD=pointofsale"
            ]
        )

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={80:port},
            restart_policy={"Name": "always"},
            environment=[
            "PHP_TIMEZONE=UTC",
            "MYSQL_USERNAME=admin",
            "MYSQL_PASSWORD=pointofsale",
            "MYSQL_DB_NAME=ospos",
            "MYSQL_HOST_NAME=mysql",
            "XDEBUG_CONFIG=remote_host=172.17.0.1"
            ],
            links = {
            sqlContainer.name : 'mysql'
            }
        )
        containerID = str(container.id)

    elif(image_name=='nextcloud'):

        DBvolumes = client.volumes.create()

        DataVolumes = client.volumes.create()
        
        DBcontainer = client.containers.run(detach=True, 
                image="mariadb",
                
                volumes={
                    DBvolumes.name:{'bind': '/var/lib/mysql'}
                }, 
                environment=[
                    "MYSQL_ROOT_PASSWORD=supersecretpassword",
                    "MYSQL_DATABASE=nextcloud",
                    "MYSQL_USER=nextcloud",
                    "MYSQL_PASSWORD=supersecretpassword"
                ]
        )

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={8000:port},
            environment=[
                "TZ=Etc/UTC",
                "PUID=1000",
                "PGID=1000",
                #"DB_TYPE=mysql",
                "DB_NAME=nextcloud",
                "DB_USER=nextcloud",
                "DB_PASSWORD=supersecretpassword",
                "DB_HOST=db_nextcloud"
            ],
            volumes={
                DataVolumes.name:{'bind':'/data'},
            },
            links ={DBcontainer.name:'db_nextcloud'}
        )
        containerID = str(container.id)

    elif(image_name=='ofbiz'):
        #DBvolumes = client.volumes.create()
        
        '''DBcontainer = client.containers.run(detach=True, 
                image="postgres",
                volumes={
                    DBvolumes.name:{'bind': '/var/lib/postgresql/data'}
                }, 
                environment=[
                    "POSTGRES_HOST_AUTH_METHOD=trust"
                ]
        )'''

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={8443:port}
            #links ={DBcontainer.name:'postgres'}
        )
        containerID = str(container.id)
    elif(image_name=='isard'):
        try:
            network = client.networks.get("isard_network")
        except docker.errors.NotFound:
            network = client.networks.create("isard_network")

        try:
            volumes = client.volumes.get("isard_sshkeys")
        except docker.errors.NotFound:
            volumes = client.volumes.create(name="isard_sshkeys")
        

        try:
            container = client.containers.get("isard-database")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="rethinkdb",
                name="isard-database",
                network="isard_network",
                restart_policy={"Name": "unless-stopped"},
                volumes={
                    '/opt/isard/database' :{'bind': '/data'},
                    '/etc/localtime' :{'bind': '/etc/localtime','mode': 'ro'}
                }
            )

        try:
            container = client.containers.get("isard-hypervisor")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="isard/hypervisor:latest",
                name="isard-hypervisor",
                network="isard_network",
                restart_policy={"Name": "unless-stopped"},
                privileged=True,
                volumes={
                    'isard_sshkeys' :{'bind': '/root/.ssh'},
                    '/opt/isard' :{'bind': '/isard'},
                    '/opt/isard/certs/default' :{'bind': '/etc/pki/libvirt-spice'},
                    '/etc/localtime' :{'bind': '/etc/localtime','mode': 'ro'}
                }
            )

        try:
            appContainer = client.containers.get("isard-app")
        except docker.errors.NotFound:
            appContainer = client.containers.run(detach=True, 
                    image="isard/app:latest",
                    restart_policy={"Name": "unless-stopped"},
                    name="isard-app",
                    extra_hosts={'isard-engine':'127.0.0.1'},
                    volumes={
                        'isard_sshkeys' :{'bind': '/root/.ssh'},
                        '/opt/isard/certs' :{'bind': '/certs'},
                        '/opt/isard/logs' :{'bind': '/isard/logs'},
                        '/opt/isard/database/wizard' :{'bind': '/isard/install/wizard'},
                        '/opt/isard/backups' :{'bind': '/isard/backups'},
                        '/opt/isard/uploads' :{'bind': '/isard/uploads'},
                        '/etc/localtime' :{'bind': '/etc/localtime','mode': 'ro'}
                    }
                )

            network.connect(appContainer,links={
                "isard-database":"isard-database",
                "isard-hypervisor":"isard-hypervisor"
            })

        container = client.containers.create(name=server_name, 
            image=image_name, 
            ports={443:port}, 
            restart_policy={"Name": "unless-stopped"},
            volumes={
                '/opt/isard/certs/default' :{'bind': '/etc/nginx/external'},
                '/opt/isard/logs/nginx' :{'bind': '/var/log/nginx'},
                '/etc/localtime' :{'bind': '/etc/localtime','mode': 'ro'}
            }
        )
        network.connect(container,links={
            appContainer.name:"isard-app"
        })
        containerID = str(container.id)

    elif(image_name=='jitsi'):

        try:
            network = client.networks.get("meet.jitsi")
        except docker.errors.NotFound:
            network = client.networks.create("meet.jitsi")

        try:
            container = client.containers.get("jitsi-prosody")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="jitsi/prosody:stable-5142",
                name="jitsi-prosody",
                restart_policy={"Name": "unless-stopped"},
                volumes={
                    '/opt/jitsi/prosody/config' :{'bind': '/config'},
                    '/opt/jitsi/prosody-plugins-custom' :{'bind': '/prosody-plugins-custom'}                
                },
                environment=[
                        "XMPP_DOMAIN=meet.jitsi",
                        "XMPP_AUTH_DOMAIN=auth.meet.jitsi",
                        "XMPP_GUEST_DOMAIN=guest.meet.jitsi",
                        "XMPP_MUC_DOMAIN=muc.meet.jitsi",
                        "XMPP_INTERNAL_MUC_DOMAIN=internal-emuc.meet.jitsi",
                        "XMPP_RECORDER_DOMAIN=recorder.meet.jitsi",
                        "JICOFO_COMPONENT_SECRET=ce58a1d8002771b824cc5fbd200ecc5b",
                        "JICOFO_AUTH_USER=focus",
                        "JICOFO_AUTH_PASSWORD=d6e7aebbed4e2577964aca3b820a6da1",
                        "JVB_AUTH_USER=jvb",
                        "JVB_AUTH_PASSWORD=a0f7c74c7824efeb5b077b70e4e57de1",
                        "JIGASI_XMPP_USER=jigasi",
                        "JIGASI_XMPP_PASSWORD=ae9ae9c0c7db111b17b795cda3862cd4",
                        "JIBRI_XMPP_USER=jibri",
                        "JIBRI_XMPP_PASSWORD=ae519630f303fbddd14f57da3ac84a08",
                        "JIBRI_RECORDER_USER=recorder",
                        "JIBRI_RECORDER_PASSWORD=35ac22e574184dc45fdc7197d0c9cdcb",
                        "TZ=UTC"
                    ]
            )

            network.connect(container,aliases=[
                    "xmpp.meet.jitsi"
                ]
            )
        
        container = client.containers.create(
            image=image_name,
            name=server_name,
            ports={80:port},
            restart_policy={"Name": "unless-stopped"},
            volumes={
                    '/opt/jitsi/web' :{'bind': '/config'},
                    '/opt/jitsi/web/letsencrypt' :{'bind': '/etc/letsencrypt'},                
                    '/opt/jitsi/transcripts' :{'bind': '/usr/share/jitsi-meet/transcripts'}                
            },
            environment=[
                "TZ=UTC",
                "JICOFO_AUTH_USER=focus",
                "XMPP_AUTH_DOMAIN=auth.meet.jitsi",
                "XMPP_BOSH_URL_BASE=http://xmpp.meet.jitsi:5280",
                "XMPP_DOMAIN=meet.jitsi",
                "XMPP_GUEST_DOMAIN=guest.meet.jitsi",
                "XMPP_MUC_DOMAIN=muc.meet.jitsi",
                "XMPP_RECORDER_DOMAIN=recorder.meet.jitsi"
    
            ]
        )
        containerID = str(container.id)

        network.connect(container,aliases=[
                "meet.jitsi"
            ]
        )

        try:
            container = client.containers.get("jitsi-jicofo")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="jitsi/jicofo:stable-5142",
                name="jicofo",
                restart_policy={"Name": "unless-stopped"},
                volumes={
                    '/opt/jitsi/jicofo' :{'bind': '/config'}
                }, 
                environment=[
                    "XMPP_DOMAIN=meet.jitsi",
                    "XMPP_AUTH_DOMAIN=auth.meet.jitsi",
                    "XMPP_INTERNAL_MUC_DOMAIN=internal-muc.meet.jitsi",
                    "XMPP_MUC_DOMAIN=muc.meet.jitsi",
                    "XMPP_SERVER=xmpp.meet.jitsi",
                    "JICOFO_COMPONENT_SECRET=ce58a1d8002771b824cc5fbd200ecc5b",
                    "JICOFO_AUTH_USER=focus",
                    "JICOFO_AUTH_PASSWORD=d6e7aebbed4e2577964aca3b820a6da1",
                    "JVB_BREWERY_MUC=jvbbrewery",
                    "JIGASI_BREWERY_MUC=jigasibrewery",
                    "JIBRI_BREWERY_MUC=jibribrewery",
                    "JIBRI_PENDING_TIMEOUT=90",
                    "TZ=UTC"
                ]
            )

            network.connect(container,
                links={"jitsi-prosody":"prosody"}
            )

        try:
            container = client.containers.get("jitsi-jvb")
        except docker.errors.NotFound:
            container = client.containers.run(detach=True, 
                image="jitsi/jvb:stable-5142",
                name="jitsi-jvb",
                restart_policy={"Name": "unless-stopped"},
                volumes={
                    '/opt/jitsi/jvb' :{'bind': '/config'}
                },
                
                environment=[
                    "XMPP_AUTH_DOMAIN=auth.meet.jitsi",
                    "XMPP_INTERNAL_MUC_DOMAIN=internal-muc.meet.jitsi",
                    "XMPP_SERVER=xmpp.meet.jitsi",
                    "JVB_AUTH_USER=jvb",
                    "JVB_AUTH_PASSWORD=a0f7c74c7824efeb5b077b70e4e57de1",
                    "JVB_BREWERY_MUC=jvbbrewery",
                    "JVB_PORT=10000",
                    "JVB_TCP_HARVESTER_DISABLED=true",
                    "JVB_TCP_PORT=4443",
                    "JVB_TCP_MAPPED_PORT=4443",
                    "JVB_STUN_SERVERS=meet-jit-si-turnrelay.jitsi.net:443",
                    "TZ=UTC"
                ]
            )

            network.connect(container,
                links={"jitsi-prosody":"prosody"}
            )

    elif(image_name==''):
        pass
    elif(image_name==''):
        pass
    elif(image_name==''):
        pass
    elif(image_name==''):
        pass
    

    return containerID
#called from cgi_myserver_launch.py        
def launch_docker_vm(server_name):      
    container = client.containers.get(str(server_name))
    container.start()
        
#called from cgi_myServerEdit_setVM_OFF.py        
def stop_docker_vm(server_name):
    try:
        container = client.containers.get(str(server_name))
        container.stop()
    except:
        pass

#called from cgi_myServerEdit_pauseVM.py
def pause_docker_vm(server_name):
    container = client.containers.get(str(server_name))
    container.pause()

#called from cgi_myServerEdit_pauseVM
def reset_docker_vm(server_name):
    container = client.containers.get(str(server_name))
    container.unpause()

#called from cgi_myServerEdit_deleteVM.py
def delete_docker_vm(server_name):
    try:
        container = client.containers.get(str(server_name))
        container.remove()
    except:
        pass

