#!/usr/bin/env python3
import cgi, cgitb
import json
import uuid
from clientConfiguration import *
from globalSettings import *
from db import *
cgitb.enable()
import sqlite3
import unpackage

#print "Content-type:text/html\r\n\r\n"

#import required modules for unpacking

import subprocess
import os
import hashlib
import zipfile
import gnupg
import ConfigParser
import shutil

message = ''
status = 'fail'

fileId = 0 
FolderUploadPath = '/var/www/uploaded/'
dest_Directory = "/var/www/uploaded/"  #intermediary folder to store files

gpg = gnupg.GPG(gnupghome='/home/ubuntu/gpguser/') #Stores the encryption keys. change according to the home directory

def recursiveFilePermissions(paths):
    for _dir in paths:
        for root, dirs, files in os.walk(_dir):
            for d in dirs:
                os.chmod(os.path.join(root, d), 0o777)
            for f in files:
                os.chmod(os.path.join(root, f), 0o777)

def compare_md5CheckSum(destinationPath,zipFilename,shaFile):
    md5_hash = hashlib.md5()
    with open(destinationPath+"/"+zipFilename,"rb") as f:
        # Read and update hash in chunks of 4K
        for byte_block in iter(lambda: f.read(4096),b""):
            md5_hash.update(byte_block)

        checkSum_zip = md5_hash.hexdigest()

        shaFile = open(destinationPath+"/"+shaFile,"r").read()
        #shaFile = shaFile.split()[0]
        if checkSum_zip == shaFile:
            return "sha's are same we can upload the file"
        else:
            return "they are different"

def unzipFile1(ZipFilePath):
    zipFileName = ZipFilePath.split("/")[-1]
    uploadCode = {}
    destFileName = zipFileName.split(".zip")[0]
    directory_to_extract_to = str(dest_Directory+destFileName)
    with zipfile.ZipFile(os.path.join(ZipFilePath), 'r') as zip_ref:
        zip_ref.extractall(directory_to_extract_to)
    fileList = os.listdir(directory_to_extract_to)

    return fileList,directory_to_extract_to

def verifymasterGPG(masterZipFile):
    try:
        uploadCode = {}
        filesList = unzipFile1(masterZipFile)
        for file in filesList[0]:
            checkExt = os.path.splitext(file)[-1]
            if checkExt==".sig":
                uploadCode["sign"]=file
            elif checkExt==".zip":
                uploadCode["zipFile"] = file

        with open(os.path.join(filesList[1],uploadCode["sign"]),"rb")as f:
            verified = gpg.verify_file(f)
            return ["Verified",filesList[1]+"/"+uploadCode["zipFile"]] if verified else ["Unverified",filesList[1]+"/"+uploadCode["zipFile"]]
    except Exception as e:
        global message
        #message += '<br> Invalid File format ' 
        message += '<br> ' + str(e)
    return ["Unverified",' ']

def verifySHA(zipFile):
    uploadCode = {"zipFile":"","sha":""}
    md5=unzipFile1(zipFile)
    md5FileList = md5[0]
    directory_to_extract_to = md5[1]

    for file in md5FileList:
            checkExt = os.path.splitext(file)[-1]
            if checkExt==".md5":
                uploadCode["sha"]=file
            elif checkExt==".zip":
                uploadCode["zipFile"] = file
    if uploadCode["sha"]!="":
        return [compare_md5CheckSum(directory_to_extract_to,uploadCode["zipFile"],uploadCode["sha"]),os.path.join(directory_to_extract_to,uploadCode["zipFile"])]
    else:
        return ['sha file not available',os.path.joi(directory_to_extract_to,uploadCode["zipFile"])]

def removeFiles(fileList):
    for file in fileList:
        if os.path.isdir(file):
            shutil.rmtree(file)
        else:
            os.remove(file)

pubkeys = gpg.list_keys()

if not pubkeys:
    input_data = gpg.gen_key_input(name_email='divya.testnasya@gmail.com',
    passphrase='pleasehideme',
    key_type="RSA",
    key_length=1024)
    key = gpg.gen_key(input_data)
    pubkeys = gpg.list_keys()

def unpack(fileName):
    residualFiles = []

    global message
    global status
    
    fileName = os.path.join(FolderUploadPath,fileName)
    verifySign = verifymasterGPG(fileName)
    residualFiles.append(fileName)
    extractedMasterFilePath = verifySign[1]
    residualFiles.append(os.path.dirname(extractedMasterFilePath))
    if verifySign[0] == "Verified":
        #Digital Signature Verified - unzip and verify SHA of sanuyi.zip
        verifySign = verifySHA(extractedMasterFilePath)
        if verifySign[0]=="sha's are same we can upload the file":
            masterExtracted = os.path.dirname(verifySign[1])
            residualFiles.append(masterExtracted)
            masterFileList = os.listdir(masterExtracted)
            cnfFile=''
            for file in masterFileList:
                    checkExt = os.path.splitext(file)[-1]
                    if checkExt==".cnf":
                        cnfFile=os.path.join(masterExtracted,file)

            #master.zip verified - unzip and verify SHA of files.zip
            verifySign = verifySHA(verifySign[1])
            if verifySign[0]=="sha's are same we can upload the file":
                codeFilesZip = verifySign[1]	
                residualFiles.append(os.path.dirname(codeFilesZip))

                fileFolder=unzipFile1(verifySign[1])[1]
                residualFiles.append(fileFolder)

                configParser = ConfigParser.RawConfigParser()   
                configFilePath = cnfFile
                configParser.read(configFilePath)

                version = configParser.get('Software Update','version')
                type = configParser.get('Software Update','type')
                gui_dir = configParser.get('Software Update','gui_dir')
                code_dir = configParser.get('Software Update','code_dir')

                versionSource = os.path.join(fileFolder,'version')
                guiSource = os.path.join(fileFolder,'gui')
                
                code_dir = os.path.join(code_dir,version)
                gui_dir = os.path.join(gui_dir,version)

                if not os.path.exists(code_dir):
                    os.makedirs(code_dir)
                if not os.path.exists(gui_dir):
                    os.makedirs(gui_dir)
                
                versionDest = os.path.join(code_dir,os.path.basename(versionSource))
                if os.path.exists(versionDest):
                    shutil.rmtree(versionDest)
                destination = shutil.copytree(versionSource, versionDest)

                guiDest = os.path.join(gui_dir,os.path.basename(guiSource))
                if os.path.exists(guiDest):
                    shutil.rmtree(guiDest)
                destination = shutil.copytree(guiSource, guiDest)
                
                recursiveFilePermissions([guiDest])

                message += " <br> File uploaded successfully"
                status = 'success'
                
                removeFiles(residualFiles)

                #install.checkType(type)
            else:
                message += " <br> FAILED: COULDN'T VERIFY SHA OF FILES.ZIP "
        else:
            message += " <br> FAILED: COULDN'T VERIFY SHA OF SANUYI.ZIP "
    else:
        message +=  " <br> FAILED: COULDN'T VERIFY SIGNATURE  "

    return status,message


