#!/usr/bin/python
#date -d @1234567890
#sudo nano /etc/collectd/collectd.conf
#!/usr/bin/python3
# date -d @1234567890
# sudo nano /etc/collectd/collectd.conf
import cgi
import cgitb

cgitb.enable()
import sqlite3
import json
import os
import time
import sys
import rrdtool
import subprocess
from db import *
from logRoutine import *
initLogging()

true = 1
false = 0
GUI = true
CCM = false
ALL_METRICS = 'all'
now = int(time.time())

print("Content-type:text/html\r\n\r\n")

net_port_mappings = {
"enp46s0f1":"Lan3",
"enp46s0f0":"Lan4",
"enp36s0f0":"Lan1",
"enp36s0f1":"Lan2",
#"enp42s0f3u5u3c2":"Mgt",
}

RRA_cf = 'AVERAGE'

def netstatdata():
    netstat = {}
    try:
        process1 = subprocess.check_output(["cat",'/proc/net/dev'])
        lines= process1.splitlines()
        columnLine = lines[1]
        _, receiveCols , transmitCols = columnLine.split("|")
        receiveCols = map(lambda a:"rx_"+a, receiveCols.split())
        transmitCols = map(lambda a:"tx_"+a, transmitCols.split())
        cols = receiveCols+transmitCols
        for line in lines[2:]:
            if line.find(":") < 0: continue
            net, data = line.split(":")
            if net=="lo" or net=="enp42s0f3u5u3c2":
                continue
            netData = dict(zip(cols, data.split()))
            netstat[net.strip()] = netData
        return netstat
    except Exception as err:
        #print ("cat /proc/net/dev Except ",err)
        dArgs=loggerArgs("netsetdata/" + "collectDManager","netsetdata",criticalLevel,"get")
        ccmLogger(critical, str(err), dArgs)
        # assert False, ccmLogger(critical, str(err), dArgs)
        return netstat

def Metrics(Mtype, arg):
    deviceMetrics = []
    if Mtype == 'M':
        deviceMetrics.append(ALL_METRICS + '.rrd')
        if arg == "GUI":
            metrics = ['total', 'available', 'percent', 'used', 'free', 'active', 'inactive', 'buffers', 'cached', 'shared']
            for metric in metrics:
                deviceMetrics.append('memory_'+metric+'.rrd')
            
        else:
            metrics = ['total', 'available', 'percent', 'used', 'free', 'active', 'inactive', 'buffers', 'cached', 'shared']
            for metric in metrics:
                deviceMetrics.append('memory_'+metric+'.rrd')

    elif Mtype == 'L':
        if arg == "GUI":
            deviceMetrics = ['load.rrd']
        else:
            deviceMetrics = ['load.rrd']

    elif Mtype == 'C':
        deviceMetrics = []
        deviceMetrics.append(ALL_METRICS + '.rrd')
        if arg == "GUI":
            metrics = ['gnice', 'iowait', 'sys', 'guest', 'irq', 'idle', 'usr', 'steal', 'soft', 'nice']
            for metric in metrics:
                deviceMetrics.append(metric+'.rrd')
        else:
            metrics = ['gnice', 'iowait', 'sys', 'guest', 'irq', 'idle', 'usr', 'steal', 'soft', 'nice']
            for metric in metrics:
                deviceMetrics.append(metric+'.rrd')

    elif Mtype == 'P':
        if arg == "GUI":
            metrics = netstatdata().keys()
            for metric in metrics:
                if metric=="lo" or metric=="enp42s0f3u5u3c2":
                    continue
                if metric in net_port_mappings.keys():
                    metric = net_port_mappings[metric]
                deviceMetrics.append(metric+'.rrd')

        else:
            metrics = netstatdata().keys()
            for metric in metrics:
                deviceMetrics.append(metric+'.rrd')

    elif Mtype == "F":
        if arg == "GUI":
            deviceMetrics = ["fan.rrd"]
        else:
            deviceMetrics = ["fan.rrd"]

    elif Mtype == "T":
        if arg == "GUI":
            deviceMetrics = [ALL_METRICS + '.rrd', "temp_probes.rrd","disks_temp.rrd",'cpu.rrd']
        else:
            deviceMetrics = [ALL_METRICS + '.rrd', "temp_probes.rrd","disks_temp.rrd",'cpu.rrd']

    elif Mtype == "PS":
        if arg == "GUI":
            deviceMetrics = ["psu.rrd"]
        else:
            deviceMetrics = ["psu.rrd"]

    elif Mtype == "docker":
        if arg == "GUI":
            deviceMetrics = ["cpu_percentage.rrd", "network_I.rrd", "network_O.rrd",
                             "memory_percentage.rrd", "block_I.rrd", "block_O.rrd", "memory_usage.rrd", "memory_limit.rrd"]
        else:
            deviceMetrics = ["cpu_percentage.rrd", "network_I.rrd", "network_O.rrd",
                             "memory_percentage.rrd", "block_I.rrd", "block_O.rrd", "memory_usage.rrd", "memory_limit.rrd"]

    elif Mtype == "V":  # Volume
        if arg == "GUI":
            deviceMetrics = ["MBw_sec.rrd","IOr_sec.rrd","MBr_sec.rrd","IOw_sec.rrd"]
        else:
            deviceMetrics = ["MBw_sec.rrd","IOr_sec.rrd","MBr_sec.rrd","IOw_sec.rrd"]

    elif Mtype == "D":
        if arg == "GUI":
            deviceMetrics = ["tps.rrd","MBw_sec.rrd","MBw.rrd","MBr_sec.rrd","MBr.rrd","MRD_tps.rrd","MRD_MB_sec.rrd"]
        else:
            deviceMetrics = ["tps.rrd","MBw_sec.rrd","MBw.rrd","MBr_sec.rrd","MBr.rrd","MRD_tps.rrd","MRD_MB_sec.rrd"]

    elif Mtype == "PO_1":
        if arg == "GUI":
            deviceMetrics = ['capacity_allocated.rrd','capacity_free.rrd', 'read_operations.rrd','write_operations.rrd','read_bandwidth.rrd', 'write_bandwidth.rrd']
        else:
            deviceMetrics = ['capacity_allocated.rrd','capacity_free.rrd', 'read_operations.rrd','write_operations.rrd','read_bandwidth.rrd', 'write_bandwidth.rrd']
    elif Mtype == "PO":
        if arg == "GUI":
            deviceMetrics = ["tps.rrd","MBw_sec.rrd","MBw.rrd","MBr_sec.rrd","MBr.rrd"]
        else:
            deviceMetrics = ["tps.rrd","MBw_sec.rrd","MBw.rrd","MBr_sec.rrd","MBr.rrd"]
    else:
        deviceMetrics = ['None defined']

    return deviceMetrics


if GUI == true:
    import cgi
    import cgitb
    cgitb.enable()

if GUI == true:
    form = cgi.FieldStorage()
    request_Type = form.getvalue('requestType')
    deviceList = form.getvalue('deviceList')
    scale = form.getvalue('scale')
    NumHorizontal_points_in_graph = form.getvalue(
        'NumHorizontal_points_in_graph')
    metrics = form.getvalue('metrics')
else:
    MetricChoices = []
    print('1. minutes')
    print('2. hours')
    print('3. days')
    print('4. weeks')
    print('5. months')
    choice = int(eval(input("select TimeBase==>")))
    if (choice == 1):
        scale = "mins"
        NumHorizontal_points_in_graph = 10
    if (choice == 2):
        scale = "hours"
        NumHorizontal_points_in_graph = 60
    if (choice == 3):
        scale = "days"
        NumHorizontal_points_in_graph = 60
    if (choice == 4):
        scale = "weeks"
        NumHorizontal_points_in_graph = 60
    if (choice == 5):
        NumHorizontal_points_in_graph = 60
        scale = "months"
    print('1. Disk Stats')
    print('2. Volume Stats')
    print('3. Pool Stats')
    print('4. Ethernet Stats')
    print('5. Virtual Disk Stats')
    print('6. CPU stats')
    print('7. CPU stats')
    print('8 CPU stats')
    print('9. Fan Stats')
    print('10. Temp_Probe Stats')
    print('11. PSU Stats')
    print('12.Memory Stats')
    print('13.CPURRD stats')
    print('14. DockerApp Stats')
    choice = int(eval(input("select cgi function==>")))
    if (choice == 1):
        request_Type = 'D'
        deviceList = 'D'
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
        choice = int(eval(input("select Metric==>")))
        metrics = MetricChoices[choice]

    elif (choice == 2):
        request_Type = 'V'
        deviceList = 'V'
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
        choice = int(eval(input("select Metric==>")))
        metrics = MetricChoices[choice]

    elif (choice == 3):
        request_Type = 'PO'
        deviceList = 'PO'
    elif (choice == 4):
        request_Type = 'P'
        deviceList = 'P'
    if (choice == 5):
        request_Type = 'VD'
        deviceList = 'VD'

    elif (choice == 6):
        request_Type = 'read_CPU'
        deviceList = 'C'
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
        choice = int(eval(input("select Metric==>")))
        metrics = MetricChoices[choice]
    elif (choice == 7):
        request_Type = 'read_CPU'
        deviceList = 'C'
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
        choice = int(eval(input("select Metric==>")))
        metrics = MetricChoices[choice]
    elif (choice == 8):
        request_Type = 'read_CPU'
        deviceList = 'C'
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
        choice = int(eval(input("select Metric==>")))
        metrics = MetricChoices[choice]

    elif (choice == 9):
        request_Type = "F"
        deviceList = "F"
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
    elif (choice == 10):
        request_Type = "T"
        deviceList = "T"
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
    elif (choice == 11):
        request_Type = "PS"
        deviceList = "PS"
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
    elif (choice == 12):
        request_Type = 'M'
        deviceList = 'M'
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
    elif (choice == 13):
        request_Type = 'CP'
        deviceList = 'CP'
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
    elif (choice == 14):
        request_Type = "docker"
        deviceList = "docker"
        MetricChoices = Metrics(deviceList, 'GUI')
        print(MetricChoices)
        choice = int(eval(input("select Metric==>")))
        metrics = MetricChoices[choice]

    print(("Request_Type="+str(request_Type)))

retentionMins = 60
minutesPerPoint = 6

if scale == "mins":
    retentionMins = 60
    minutesPerPoint = 6
elif scale == "hours":
    retentionMins = 24 * 60
    minutesPerPoint = 30
elif scale == "days":
    retentionMins = int(7 * 24 * 60)
    minutesPerPoint = int(6*60)
elif scale == "weeks":
    retentionMins = int(4*7*24*60)
    minutesPerPoint = int(7*6*60)
elif scale == "month":
    retentionMins = int(3*4*7*24*60)
    minutesPerPoint = int(15*6*60)

def guiDeviceResult(rrdPath, rrdFile, deviceList, GUIdeviceList):
    result_all = dict()
    #minutesPerPoint = retentionMins / int(NumHorizontal_points_in_graph)
    retentionSecs = retentionMins * 60
    #rrdPath = "/var/lib/collectd/rrd/ubuntu"
    i = 0
    for device in deviceList:
        rrdDevice = device
        if rrdFile == " ":
            #DataFile = rrdPath + "/" + rrdDevice
            DataFile = os.path.join(rrdPath,rrdDevice)
        else:
            #DataFile = rrdPath + rrdDevice + "/" + rrdFile
            DataFile = os.path.join(rrdPath + rrdDevice,rrdDevice)

        #DataFile= "/var/lib/collectd/rrd/ubuntu/interface-lo/if_packets.rrd"
        #print "DataFile", DataFile 
        now = int(time.time())
        now = now-60
        startTime = now - retentionSecs
        endTime = now
        secondsPerPoint = minutesPerPoint * 60
        startTime = int(startTime/minutesPerPoint)
        startTime = int(startTime*minutesPerPoint)
        endTime = int(endTime/minutesPerPoint)
        endTime = int(endTime*minutesPerPoint)
        (timeInfo, columns, rows) = rrdtool.fetch(DataFile, RRA_cf, '-r', str(secondsPerPoint), '-s',
                                                  str(startTime), '-e', str(endTime))
        rows.pop()  # remove the last datapoint because RRD sometimes gives funky values
        colWidth = len(columns)
        lenRows = len(rows)
        result = []
        epoch_range = dict()
        epoch_range['epoch_range'] = list(timeInfo)
        result.append(epoch_range)
        cols = dict()
        if GUIdeviceList[i] == 'network':
            columns = [s + '/Sec' for s in columns]
        cols['columns'] = columns
        result.append(cols)
        for row in rows:
            temp = dict()
            if row[0] == None:
                continue
            if (colWidth == 1):
                temp['val1'] = round(float(row[0]), 2)
            if (colWidth == 2):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
            if (colWidth == 3):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
            if (colWidth == 4):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
                temp['val4'] = round(float(row[3]), 2)
            if (colWidth > 4):
                temp['row'] = [round(r,2) for r in row]
            result.append(temp)
        GUIdevice = GUIdeviceList[i]
        i = i+1
        result_all[GUIdevice] = result
    return result_all


def guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList):
    result_all = dict()
    #minutesPerPoint = retentionMins / int(NumHorizontal_points_in_graph)
    retentionSecs = retentionMins * 60
    i = 0
    DataFile = os.path.join(rrdPath,rrdFile)
    tnow = now-60
    startTime = tnow - retentionSecs
    endTime = tnow
    secondsPerPoint = minutesPerPoint * 60
    startTime = int(startTime/minutesPerPoint)
    startTime = int(startTime*minutesPerPoint)
    endTime = int(endTime/minutesPerPoint)
    endTime = int(endTime*minutesPerPoint)
    if not os.path.isfile(DataFile):
        GUIdevice = GUIdeviceList[i]
        result_all[GUIdevice] = [{"epoch_range":[]}, {"columns":[]}]
        return result_all
    (timeInfo, columns, rows) = rrdtool.fetch(DataFile, RRA_cf, '-r', str(secondsPerPoint), '-s',
                                              str(startTime),'-e', str(endTime))
    rows.pop()
    colWidth = len(columns)

    lenRows = len(rows)

    result = []
    epoch_range = dict()
    epoch_range['epoch_range'] = list(timeInfo)
    result.append(epoch_range)
    cols = dict()
    if GUIdeviceList[i] == 'network':
        columns = [s + '/Sec' for s in columns]
    cols['columns'] = columns
    result.append(cols)
    # print len(rows)
    for row in rows:
        # print row
        # print row[0]
        temp = dict()
        # if row[0] == None:
        #     continue
        temp['row'] = []
        for r in row:
            if r:
                temp['row'].append(float(round(r,2)))
            else:
                temp['row'].append(0)
        # temp['row'] = [float(round(r,2)) for r in row if r!=None] 
        result.append(temp)
    GUIdevice = GUIdeviceList[i]
    i = i+1
    result_all[GUIdevice] = result
    return result_all
    # return result

def Get_rrdFilesPath():
    #rrdPath = "/mnt/data/log/log/sanuyi_rrdFiles"
    rrdPath = "/var/www/sanuyi_rrdFiles"
    return rrdPath


def Get_rrdPath():
    process1 = subprocess.check_output(["hostname"])
    process1 = process1.replace("\r", "")
    process1 = process1.replace("\n", "")
    path = "/var/lib/collectd/rrd/"+process1+"/"
    return path


def EpochToTime(epoch):
    mytime = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(epoch))
    # print mytime


def GetSlot(device):

    if device == "sda":
        return "slot1"
    elif device == "sdb":
        return "slot2"
    elif device == "sdc":
        return "slot3"
    elif device == "sdd":
        return "slot4"
    elif device == "sde":
        return "slot5"
    elif device == "sdf":
        return "slot6"
    elif device == "sdg":
        return "slot7"
    elif device == "sdh":
        return "slot8"
    elif device == "sdi":
        return "slot9"
    elif device == "sdj":
        return "slot10"
    return "slotx"


def get_Metrics(Mtype):
    deviceMetrics = []
    arg = "GUI"
    deviceMetrics = Metrics(Mtype, arg)
    result = {"metrics": deviceMetrics}
    print((json.JSONEncoder().encode(result)))


def read_rrd_cpu():
    minutesPerPoint = retentionMins / int(NumHorizontal_points_in_graph)
    retentionSecs = retentionMins * 60
    rrdPath = "/var/lib/collectd/rrd/ubuntu/"
    #metrics = form.getvalue('metrics')
    metrics_Str = str(metrics)
    result_all = dict()
    ls = subprocess.Popen(
        ["ls", "-p", "/var/lib/collectd/rrd/ubuntu/"], stdout=subprocess.PIPE, )
    grep = subprocess.Popen(
        ["grep", "cpu-"], stdin=ls.stdout, stdout=subprocess.PIPE, )
    endOfPipe = grep.stdout
    for line in endOfPipe:
        #     print (line)
        # for i in range(0,5):
        cpu = str(line)[:-1]
        abs_Path = rrdPath + cpu + metrics_Str + ".rrd"
        now = int(time.time())
        now = now - 60
        startTime = str(now - retentionSecs)
        endTime = str(now)
        secondsPerPoint = minutesPerPoint * 60
        NumPoints = retentionSecs / secondsPerPoint
        (timeInfo, columns, rows) = rrdtool.fetch(abs_Path, RRA_cf, '-r', str(secondsPerPoint), '-s',
                                                  startTime, '-e', endTime)
        rows.pop()  # remove the last datapoint because RRD sometimes gives funky values
        colWidth = len(columns)
        rows.pop
        rows.pop
        lenRows = len(rows)
        result = []
        epoch_range = dict()
        epoch_range['epoch_range'] = list(timeInfo)
        result.append(epoch_range)

        cols = dict()
        cols["columns"] = columns
        result.append(cols)
        # print len(rows)

        for row in rows:
            #print row
            # print row[0]
            temp = dict()
            if row[0] == None:
                continue
            if (colWidth == 1):
                temp['val1'] = round(float(row[0]), 2)
            if (colWidth == 2):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
            if (colWidth == 3):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
            if (colWidth == 4):
                temp['val1'] = round(float(row[0]), 2)
                temp['val2'] = round(float(row[1]), 2)
                temp['val3'] = round(float(row[2]), 2)
                temp['val4'] = round(float(row[3]), 2)

            if (colWidth > 4):
                temp['row'] = [round(r,2) for r in row]

            result.append(temp)
        result_all[cpu[:-1]] = result

        # result =  json.dumps(result)

    print((json.JSONEncoder().encode(result_all)))
    # print result

def get_result_for_all_metrics(GUIdeviceList):
    result_all = {'ALL': [{"epoch_range":[]}, {"columns":[]}]}
    arg = "GUI"
    deviceList = form.getvalue('deviceList')
    metrics = form.getvalue('metrics')
    all_metrics = Metrics(deviceList, arg)
    all_metrics.remove(ALL_METRICS+'.rrd')
    all_columns = []
    all_rows = []
    for metric in all_metrics:
        rrdFile = str(metric)
        if GUIdeviceList[0] == 'Temperature':
            if "temp_probes" in str(metric):
                rrdFile = "temp_probes.rrd"
            elif "disks_temp" in str(metric):
                rrdFile = "disks_temp.rrd"
            elif "cpu" in str(metric):
                rrdFile = "cpu_temp.rrd"
        elif GUIdeviceList[0] == 'CPU':
            elementName = "cpu"
            rrdFile = elementName + '_' + str(metric)
        rrdPath = Get_rrdFilesPath()
        result = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
        epoch_range = result[result.keys()[0]][0]
        columns = result[result.keys()[0]][1]
        if not epoch_range or not columns['columns']:
            print epoch_range, columns['columns']
            continue
        try:
            if columns["columns"][0] == "virtual_memory":
                updated_columns = [str(metric).replace('.rrd','')]
            else:
                updated_columns = [str(metric).replace('.rrd','_')  + cols for cols in columns['columns']]
        except:
            updated_columns = [str(metric).replace('.rrd','_')  + cols for cols in columns['columns']]
            
        
        all_columns.extend(updated_columns)
        rows = result[result.keys()[0]][2:]
        for i, row in enumerate(rows):
            if len(all_rows)-1 < i:
                all_rows.append(row)
            else:
                all_rows[i]['row'].extend(row['row'])

    result_all = {"ALL": [epoch_range, {'columns' : all_columns}]}
    result_all["ALL"].extend(all_rows)
    return result_all

def DB_Interfaces():
    EthList = []
    GuiList = []
    conn = sqlite3.connect(db_filename, check_same_thread=False)
    conn.text_factory = str
    c = conn.cursor()
    query = c.execute("select system_name,name from eth_ports")
    interfaces = c.fetchall()
    for eth in interfaces:
        #if str(eth[0]) != "null" and eth[0] is not None:
        if str(eth[0]) != "null":
            device = "interface-"+eth[0]
            EthList.append(device)
            #device = eth[0]
            device = eth[1]
            GuiList.append(device)
    c.close()
    return EthList, GuiList


def read_rrd_eth():
    rrdPath = Get_rrdPath()
    rrdFile = "if_octets.rrd"
    if "bytes" in str(metrics):
        rrdFile = "if_octets.rrd"
    if "packets" in str(metrics):
        rrdFile = "if_packets.rrd"
    if "errors" in str(metrics):
        rrdFile = "if_errors.rrd"
    result_all = dict()
    deviceList = DB_Interfaces()[0]
    GUIdeviceList = DB_Interfaces()[1]
    result_all = guiDeviceResult(rrdPath, rrdFile, deviceList, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))

def read_rrd_network():
    rrdPath = Get_rrdFilesPath()
    GUIdeviceList = []
    GUIdeviceList.append("network")
    elementName = "network"
    metrics = form.getvalue('metrics')
    if str(metrics) in net_port_mappings.values():
        for key, value in net_port_mappings.items():
            if value == str(metrics):
                metrics = key
    rrdFile = elementName+"_"+str(metrics)+".rrd"
    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))

def read_rrd_logical_port():
    rrdPath = Get_rrdPath()
    GUIdeviceList = []
    GUIdeviceList.append("logical")
    rrdFile = "load/load.rrd"
    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))

def read_rrd_pools():
    rrdPath = Get_rrdPath()
    # etrics = form.getvalue('metrics')
    # Check what user has selected
    rrdFile = "df_complex-used.rrd"   # default value
    if "free" in str(metrics):
        rrdFile = "df_complex-free.rrd"
    if "reserved" in str(metrics):
        rrdFile = "df_complex-reserved.rrd"
    if "used" in str(metrics):
        rrdFile = "df_complex-used.rrd"
    result_all = dict()
    GUIdeviceList = []
    deviceList = []
    ls = subprocess.Popen(
        ["ls", "-p", "/var/lib/collectd/rrd/ubuntu/"], stdout=subprocess.PIPE, )
    grep = subprocess.Popen(
        ["grep", "df-p2-"], stdin=ls.stdout, stdout=subprocess.PIPE, )
    endOfPipe = grep.stdout
    for line in endOfPipe:
        device = str(line)[:-2]
        deviceList.append(device)
        GUIdeviceList.append(device)
    result_all = guiDeviceResult(rrdPath, rrdFile, deviceList, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_rrd_disks():
    rrdPath = Get_rrdPath()
    # metrics = form.getvalue('metrics')
    rrdFile = "disk_io_time.rrd"   # default value

    if "IO" in str(metrics):
        rrdFile = "disk_io_time.rrd"
    elif "Merged" in str(metrics):
        rrdFile = "disk_merged.rrd"
    elif "Rd-Wr" in str(metrics):
        rrdFile = "disk_octets.rrd"
    elif "Operations" in str(metrics):
        rrdFile = "disk_ops.rrd"
    elif "Time" in str(metrics):
        rrdFile = "disk_time.rrd"
    elif "Pending" in str(metrics):
        rrdFile = "pending_operations.rrd"

    result_all = dict()
    GUIdeviceList = []
    deviceList = []
    ls = subprocess.Popen(
        ["ls", "-p", "/var/lib/collectd/rrd/ubuntu/"], stdout=subprocess.PIPE, )
    # ls -p /var/lib/collectd/rrd/ubuntu/
    grep = subprocess.Popen(
        ["grep", "disk-"], stdin=ls.stdout, stdout=subprocess.PIPE, )
    endOfPipe = grep.stdout
    for line in endOfPipe:
        device = str(line)[:-2]  # remove \ and lf
        if device[5:].isalpha():
            # print "device=",device[5:]
            deviceList.append(device)
            slot = GetSlot(device[5:])
            GUIdeviceList.append(slot)
    result_all = guiDeviceResult(rrdPath, rrdFile, deviceList, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_rrd_volume():
    rrdPath = Get_rrdFilesPath()
    GUIdeviceList = []
    GUIdeviceList.append("Volume")
    elementName = "volume"
    if "MBw_sec" in str(metrics):
        rrdFile = elementName+"_"+"MBw_sec.rrd"
    elif "IOr_sec" in str(metrics):
        rrdFile = elementName+"_"+"IOr_sec.rrd"
    elif "MBr_sec" in str(metrics):
        rrdFile = elementName+"_"+"MBr_sec.rrd"
    elif "IOw_sec" in str(metrics):
        rrdFile = elementName+"_"+"IOw_sec.rrd"

    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_psu():
    rrdPath = Get_rrdFilesPath()
    GUIdeviceList = []
    GUIdeviceList.append("PSU")
    rrdFile = "psu.rrd"
    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_temp():
    GUIdeviceList = []
    GUIdeviceList.append("Temperature")
    if str(metrics) == 'all':
        result_all = get_result_for_all_metrics(GUIdeviceList)
    else:
        if "temp_probes" in str(metrics):
            rrdFile = "temp_probes.rrd"
        elif "disks_temp" in str(metrics):
            rrdFile = "disks_temp.rrd"
        elif "cpu" in str(metrics):
            rrdFile = "cpu_temp.rrd"
        # rrdFile = str(metrics) + '.rrd'
        rrdPath = Get_rrdFilesPath()
        result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_fan():
    rrdFile = "fan.rrd"
    GUIdeviceList = []
    GUIdeviceList.append("Fan")
    rrdPath = Get_rrdFilesPath()
    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_disks():
    rrdPath = Get_rrdFilesPath()
    GUIdeviceList = []
    GUIdeviceList.append("Disks")
    elementName = "disks"
    rrdFile = elementName+"_"+str(metrics)+".rrd"

    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_pools():
    # rrdPath=Get_rrdPath()
    rrdPath = Get_rrdFilesPath()
    GUIdeviceList = []
    GUIdeviceList.append("Pools")
    #element = "storage"
    metrics = form.getvalue('metrics')
    elementName = "pools"
    rrdFile = elementName+"_"+str(metrics)+".rrd"
    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_memory():
    elementName = "memory"
    metrics = form.getvalue('metrics')
    GUIdeviceList = []
    GUIdeviceList.append("Memory")
    if str(metrics) == ALL_METRICS:
        result_all = get_result_for_all_metrics(GUIdeviceList)

    else:
        rrdFile = str(metrics) + '.rrd'
        rrdPath = Get_rrdFilesPath()
        result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    
    print((json.JSONEncoder().encode(result_all)))


def read_cpu():
    GUIdeviceList = []
    GUIdeviceList.append("CPU")
    elementName = "cpu"
    metrics = form.getvalue('metrics')
    if str(metrics) == ALL_METRICS:
        result_all = get_result_for_all_metrics(GUIdeviceList)
    else:
        if metrics is None:
            metrics = 'temp'
        rrdFile = elementName + '_' + str(metrics) + '.rrd'
        rrdPath = Get_rrdFilesPath()
        result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))


def read_docker():
    rrdPath = Get_rrdFilesPath()
    GUIdeviceList = []
    GUIdeviceList.append("Docker")
    elementName = "dockerApps"
    if "cpu_percentage" in str(metrics):
        rrdFile = elementName+"_cpu_percentage.rrd"
    elif "network_I" in str(metrics):
        rrdFile = elementName+"_network_I.rrd"
    elif "network_O" in str(metrics):
        rrdFile = elementName+"_network_O.rrd"
    elif "memory_percentage" in str(metrics):
        rrdFile = elementName+"_memory_percentage.rrd"
    elif "block_O" in str(metrics):
        rrdFile = elementName+"_block_O.rrd"
    elif "block_I" in str(metrics):
        rrdFile = elementName+"_block_I.rrd"
    elif "memory_limit" in str(metrics):
        rrdFile = elementName+"_memory_limit.rrd"
    elif "memory_usage" in str(metrics):
        rrdFile = elementName+"_memory_usage.rrd"
    # deviceMetrics = ["cpu_percentage.rrd","network_I.rrd","network_O.rrd","memory_percentage.rrd","memory_usage.rrd","block_I.rrd","block_O.rrd"]

    result_all = guiDeviceResult_RRDTool(rrdPath, rrdFile, GUIdeviceList)
    print((json.JSONEncoder().encode(result_all)))

if request_Type == 'get_Metrics':
    get_Metrics(deviceList)
elif request_Type == 'P':
    # read_rrd_eth()
    read_rrd_network()
elif request_Type == 'L':
    # read_rrd_eth()
    read_rrd_logical_port()
elif request_Type == 'PO':
    # read_rrd_pools()
    read_pools()
elif request_Type == 'PS':
    read_psu()
elif request_Type == 'T':
    read_temp()
elif request_Type == "F":
    read_fan()
elif request_Type == "M":
    read_memory()
elif request_Type == "C":
    read_cpu()
elif request_Type == "docker":
    read_docker()
elif request_Type == "V":
    read_rrd_volume()
elif request_Type == 'D':
    read_disks()
# elif request_Type == 'D':  # Divya for each stat type put in the correct type and call a function.
#    read_rrd_disks()
