#!/usr/bin/python

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *
import logging
from logRoutineV2 import init_logger, loggerArgs
#initLogging()
from clearTextPwd import *


#handler_log = "Setup-Services"
serviceLogger = init_logger("Setup-Services")

useDocker = False
if useDocker:
    import docker
    client = docker.from_env()

#for email testing
import smtplib
from email.MIMEMultipart import MIMEMultipart
from email.MIMEText import MIMEText
import traceback
import ssl, sys

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()


CCM = False

def ccmLogger(logger,level_num,data,arguments):
    gll = 30
    # print "in ccmLogger", "handlers : ", logger[0].handlers[0].baseFilename, " , ", logger[1].handlers[0].baseFilename
    if int(arguments['LogLevel']) <= gll:
        if level_num ==0:
            logger[0].info(data,extra=arguments)
        elif level_num == 1:
            logger[0].warning(data,extra=arguments)
        elif level_num == 2:
            logger[0].error(data,extra=arguments)
            logger[1].error(data, extra=arguments)
            # print "logged error"
        elif level_num == 3:
            logger[0].critical(data,extra=arguments)
            logger[1].critical(data, extra=arguments)
            # print "logged critical"
        elif level_num == 4:
            logger[0].debug(data,extra=arguments)
    else:
        pass

def create_EmailServices():
    handler_log = "SETUP-EMAIL"

    sender = form.getvalue('sender')
    emailRecipient = form.getvalue('emailRecipient')
    password = form.getvalue('password')
    smtpServer = form.getvalue('smtpServer')
    portNumber = form.getvalue('portNumber')
    alertType = form.getvalue('alertType')
    emailValidation = form.getvalue('emailValidation')

    if smtpServer != "":
        flag = False
        status = 'fail'
        description =  ""
        try:
            mailserver = smtplib.SMTP_SSL(smtpServer, portNumber,timeout=1)
            mailserver.ehlo()
            mailserver.login(sender,password)
            mailserver.quit()
            flag = True
        except smtplib.SMTPAuthenticationError as e:
            msg = e[-1]
            status = 'fail'
            description =  e[-1]
        except ssl.SSLError as e:
            try:
                mailserver = smtplib.SMTP(smtpServer, portNumber,timeout=1)
                mailserver.ehlo()
                mailserver.starttls()
                mailserver.login(sender,password)
                mailserver.quit()
                flag = True
            except smtplib.SMTPAuthenticationError as e:
                msg = e[-1]
                status = 'fail'
                description =  e[-1]
            except socket.timeout as e:
                status = 'fail'
                description =  e[-1]
            except Exception as e:
                desc = sys.exc_info()
                status = 'fail'
                description =  e[-1]
        except socket.timeout as e:
            status = 'fail'
            description =  e[-1]
        except Exception as e:
            desc = sys.exc_info()
            status = 'fail'
            description =  e[-1]

        if not flag and emailValidation=='yes':
            query_lan = c.execute("update email_logs set state=2")
            conn.commit()
            print json.JSONEncoder().encode({"status": status, "description": description})
            dArgs=loggerArgs(handler_log, "email_logs",10,"create")
            ccmLogger(serviceLogger,3,"Email Validation Failed",dArgs)
            
            return

        if CCM:
            cmd = "SaveEmail"
            message = "set,element=services,element_name={0},args=7,Action={1},recipient_email={2}," \
                    "password={3},smtp_server={4},port={5},alert_type={6},uuid={7}" \
                .format(sender, cmd, emailRecipient, password, smtpServer, portNumber, alertType, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            dArgs=loggerArgs("email_logs/" + "services_Manager","sender",infoLevel,"create")
            ccmLogger(serviceLogger,info,response["description"],dArgs)
            print response
            delete_ccm_response(cmd_Id)
        else:
            query_lan = c.execute("delete from email_logs")
            conn.commit()
            state = 1 # no validation
            if emailValidation=='yes':
                state = 0 # validated
            
            Encryptpassword=dbSavePwd(password)
            password = Encryptpassword
            
            query_lan = c.execute(
                "insert into email_logs (sender_email,recipient_email,password,smtp_server,port,alert_type, state) values(?,?,?,?,?,?,?)",
                [sender, emailRecipient, password, smtpServer, portNumber, alertType, state])
            conn.commit()
            #loggerArgs(element,elementName,loglevel,action)

            dArgs=loggerArgs(handler_log, "email_logs",30,"create")
            ccmLogger(serviceLogger,0,"Saved successfully",dArgs)
            print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"})
            
    else:
        dArgs=loggerArgs(handler_log, "email_logs",20,"create")
        ccmLogger(serviceLogger,2,"Fill All mandatory fields",dArgs)
        print json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})

    c.close()
    conn.close()


def create_BackupServices():
    backupDest = form.getvalue('backupDest')
    iPAddress = form.getvalue('iPAddress')
    port = form.getvalue('port')
    accountName = form.getvalue('accountName')
    bckPassword = form.getvalue('bckPassword')
    certificate = form.getvalue('certificate')

    if backupDest != "":
        if CCM:
            cmd = "SaveService"
            message = "set,element=services,element_name={0},args=6,Action={1},ip_address={2}," \
                    "account_name={3},password={4},certificate_path={5},port={6},uuid={7}" \
                .format(backupDest, cmd, iPAddress, accountName, bckPassword, certificate,port, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            dArgs=loggerArgs("backup/" + "services_Manager",accountName,infoLevel,"update")
            ccmLogger(info,response["description"],dArgs)
            print response
            delete_ccm_response(cmd_Id)
        else:
            container_id = ''
            try:
                query_lan=c.execute("select container_id from backup where destination_name='" + str(backupDest) + "'")
                container_id = c.fetchone()[0]
                dArgs=loggerArgs("backup/services_Manager",accountName,debugLevel,"getContainer")
                ccmLogger(debug,"success", dArgs)
            except Exception as e:
                dArgs=loggerArgs("backup/services_Manager",accountName,criticalLevel,"getContainer")
                ccmLogger(critical,str(e), dArgs)
                # assert False, ccmLogger(critical, str(e), dArgs)
                pass
            conn.commit()
            query_lan = c.execute("delete from backup where destination_name='" + str(backupDest) + "'")
            conn.commit()
            query_lan = c.execute(
                "insert into backup (ip_address,account_name,password,certificate_path,destination_name,port) values(?,?,?,?,?,?)",
                [iPAddress, accountName, bckPassword, certificate, backupDest, port])
            conn.commit()
            if str(backupDest) == 'Minio Object Storage' and useDocker:
                try:
                    container = client.containers.get(container_id)
                    container.remove(force=True)
                    dArgs=loggerArgs("container/services_Manager",accountName,debugLevel,"getContainer")
                    ccmLogger(debug, "success", dArgs)
                except Exception as e:
                    dArgs=loggerArgs("container/services_Manager",accountName,criticalLevel,"getContainer")
                    ccmLogger(critical, str(e), dArgs)
                    # assert False, ccmLogger(critical, str(e), dArgs)
                    pass
                try: 
                    image = client.images.get("minio/minio")
                    dArgs=loggerArgs("minio_image/services_Manager",accountName,debugLevel,"getImage")
                    ccmLogger(debug, "Success", dArgs)
                except docker.errors.ImageNotFound as e:
                    dArgs=loggerArgs("minio_image/services_Manager",accountName,criticalLevel,"getImage")
                    ccmLogger(critical, str(e), dArgs)
                    client.images.pull("minio/minio")
                    # assert False, ccmLogger(critical, str(e), dArgs)
                port = str(port)
                container = client.containers.create(
                    command="server /data",image="minio/minio", ports={9000:port}, 
                    environment=["MINIO_ACCESS_KEY={}".format(accountName),"MINIO_SECRET_KEY={}".format(bckPassword)])
                container.start()
                containerID = str(container.id)
                query = c.execute("update backup set container_id=? where destination_name=?",[containerID, backupDest])
            dArgs=loggerArgs("backup/" + "services_Manager",accountName,infoLevel,"update")
            ccmLogger(info,"updated successfully",dArgs)
            print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"})
    else:
        dArgs=loggerArgs("backup/" + "services_Manager",accountName,errorLevel,"update")
        ccmLogger(error,"Fill All mandatory fields",dArgs)
        print json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})

    c.close()
    conn.close()

def read_EmailServices():
    query=c.execute("select count(*) from email_logs")
    count=c.fetchone()[0]
    if count!=0:
        query1 = c.execute("select password from email_logs")
        pwd = c.fetchone()[0]
        if pwd!=None:
            if pwd.startswith("hello"):
                checkDePwd = pwd
            else:
                checkDePwd = readDBPwd(pwd)
    
    dbquery = "SELECT id,recipient_email,sender_email,password,smtp_server,port,alert_type,state from email_logs"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id": col[0], "recipient_email": col[1], "sender_email": col[2], "password": checkDePwd,
                      "smtp_server": col[4], "port": col[5], "alert_type": col[6], "state":col[7]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_BackupServices():
    destType = form.getvalue('destType')
    dbquery = "SELECT id,destination_name,ip_address,account_name,password,certificate_path,port from backup where destination_name='" + str(
        destType) + "'"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id": col[0], "destination_name": col[1], "ip_address": col[2], "account_name": col[3],
                      "password": col[4], "certificate_path": col[5], 'port':col[6]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)


print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_EmailServices':
    create_EmailServices()
elif request_Type == 'create_BackupServices':
    create_BackupServices()
elif request_Type == 'read_BackupServices':
    read_BackupServices()
elif request_Type == 'read_EmailServices':
    read_EmailServices()
else:
    print json.JSONEncoder().encode({"test"})
