var hostGrayedOutRules = [{ 'protocol': 1, 'user': 1, 'password': 1, 'iqn': 0, 'wwn': 0 },
{ 'protocol': 2, 'user': 1, 'password': 1, 'iqn': 0, 'wwn': 0 },
{ 'protocol': 3, 'user': 0, 'password': 0, 'iqn': 1, 'wwn': 0 },
{ 'protocol': 4, 'user': 1, 'password': 1, 'iqn': 1, 'wwn': 0 },
{ 'protocol': 5, 'user': 1, 'password': 1, 'iqn': 0, 'wwn': 0 },
{ 'protocol': 6, 'user': 0, 'password': 0, 'iqn': 0, 'wwn': 1 }
];
var oemConfig = JSON.parse( sessionStorage.getItem("OEMType"));
var selectedProtocol = 0;
var hostActionPage = '';
function Request() {
	var request = {
		url: "",
		parameters: {},
		statusType: "",
		typeNumber: "",
		isSingleStatus: false
	};
	return request;
}
var isCanisterView = false;
$(window).bind("load", function () {
	BindAllStatus();
	BindMetricsData("C");
	InitializeChart('C', 'mins', 'CPU' , 'idle');
});
function BindAllStatus() {
	var request = new Request();
	request.url = "cgi/cgi_statusView.py";
	request.parameters = { "requestType": 'read_StatusAll' };
	request.statusType = "All";
	CallPythonService(request);
}
function GetRequestType(statusType) {
	if (statusType === 'fans') {
		return "read_Fans";
	}
	else if (statusType === 'temp_probes') {
		return "read_Temp_probes";
	}
	else if (statusType === 'network') {
		return "read_Network";
	}
	else if (statusType === 'cpu') {
		return "read_CPU";
	}
	else if (statusType === 'psu') {
		return "read_PSU";
	}
	else if (statusType === 'psu1') {
		return "read_PSU1";
	}
	else if (statusType === 'psu2') {
		return "read_PSU2";
	}
	else if (statusType === 'disks') {
		isCanisterView = false;
		return "read_Disks";
	}
	else if (statusType === 'HDD') {
		return "read_HDD";
	}
	else if (statusType === 'SSD') {
		return "read_SSD";
	}
	else if (statusType === 'StoragePools') {
		return "read_StoragePools";
	}
	else if (statusType === 'Canister') {
		isCanisterView = true;
		return "read_Canister_Details";
	}
}
function ShowStatus(statusType,type="") {
	var request = new Request();
	if (statusType != 'StoragePools1') {
		request.url = "cgi/cgi_statusView.py";
		request.parameters = { "requestType": GetRequestType(statusType),type : type };
	}
	else {
		request.url = "cgi/cgi_setup_SectionData_Get.py?SectionName=StoragePools";
		request.parameters = { "requestType": GetRequestType(statusType) };
	}


	if (request.url != "") {
		request.statusType = statusType;
		CallPythonService(request);
	}
}
function closeModel(){
	// window.location.reload();
}
function CallPythonService(request) {
	request.parameters.uuid = uuid;
	$.ajax({
		type: "Get",
		url: request.url,
		contentType: 'application/json',
		dataType: 'json',
		headers: { 'Access-Control-Allow-Origin': '*' },
		data: request.parameters,
		success: function (response) {
			// console.log("response", response, request,request.statusType)
			if (request.isSingleStatus)
				BindSingleStatus(request.statusType, request.typeNumber, response);
			else if (request.statusType === "DiskSMART")
				BindDiskSMARTData(response, request.parameters.disk)
			else if (request.statusType === "CanisterSMART")
				BindDiskSMARTData(response, request.parameters.slot)
			else if (request.statusType == "SSDFullData")
				BindSSDFullData(response, request.parameters.SSDId)
			else if (request.statusType == "StoragePoolsFullData")
				BindPoolsFullData(response, request.parameters.poolId)

			else if (request.statusType == "ReadComponent")
				BindComponentStatus(request.parameters.title, response)

			/*else if(request.statusType == "getApps")
				BindApps(request.statusType,response);*/
			else
				BindResponseData(request.statusType, response,request?.parameters?.type);
		},
		error: function (ex) {
			swal("Error", ex.description, "error");
			if (request.statusType === "DiskSMART")
				$("#divSMARTinfo").html("")
			if (!isProduction) {
				console.log(ex);
			}
		}
	});
}
function BindResponseData(statusType, response,type) {
	var showPopUp = true;
	var result = SetIconPath(response);
	$('#divSMARTinfo').html('');
	$('#btRefresh').attr('onclick', '');
	if (statusType === 'fans') {
		$('#displayHeader').html('Fan Status View');
		$('#btRefresh').attr('onclick', 'RefreshData("fans")');

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();

		var tableHeader = '<table border="1" class="table table-striped table-bordered" id="tblResult"><thead><tr class="tbheader"><th>Fan</th><th>State</th><th>Name</th><th>Speed</th><th>Location</th><th>Low Threshold</th><th>High Threshold</th></tr></thead><tbody id="tblbody"></tbody></table>'
		$('#displayData').html(tableHeader);
		$.each(result, function (i, item) {
			var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.location + '</td><td>' + item.low_threshold + '</td><td>' + item.hi_threshold + '</td></tr>'
			$('#tblbody').append(records);
		});
		$('#tblResult').DataTable(GetTableConfig(statusType));
	}
	else if (statusType == 'temp_probes') {
		$('#displayHeader').html('Temperature Status View');
		$('#btRefresh').attr('onclick', 'RefreshData("temp_probes")');

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();

		var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>Temp</th><th>State</th><th>Name</th><th>Temp</th><th>Low Threshold</th><th>High Threshold</th></tr></thead><tbody id="tblbody"></tbody></table>'
		$('#displayData').html(tableHeader);
		$.each(response, function (i, item) {
			var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.temp + '</td><td>' + item.low_threshold + '</td><td>' + item.hi_threshold + '</td></tr>'
			$('#tblbody').append(records);
		});

		$('#tblResult').DataTable(GetTableConfig(statusType));
	}
	else if (statusType == 'network') {
		$('#displayHeader').html('Network Status View');
		$('#btRefresh').attr('onclick', 'RefreshData("network")');

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		var tableHeader = '<table border="1" class="table table-striped table-bordered" id="tblResult"><thead><tr class="tbheader"><th>Port</th><th>State</th><th>Name</th><th>Speed</th><th>IP</th><th>Netmask</th><th>Monitor</th><th>Link</th></tr></thead><tbody id="tblBody"></tbody></table>'
		$('#displayData').html(tableHeader);
		$.each(response, function (i, item) {
			console.log(item);
            if (item.Monitor == 1){
            //item.monitor = (item.monitor == 1) ? "Yes" : "yes";
            item.Monitor ="Yes" }
            else if (item.Monitor == 0) {
            item.Monitor ="No"}
			var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.speed + '</td><td>' + item.ip + '</td><td>' + item.netmask + '</td><td>' + item.Monitor + '</td><td>' + item.port_id + '</td></tr>'
			$('#tblBody').append(records);
		});

		$('#tblResult').DataTable(GetTableConfig(statusType));
	}
	else if (statusType == 'psu') {
		$('#displayHeader').html('PSU Status View');
		$('#btRefresh').attr('onclick', 'RefreshData("psu")');

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();

		var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>PSU</th><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody id="tblbody"></tbody></table>'
		$('#displayData').html(tableHeader);
		$.each(response, function (i, item) {
			var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
			$('#tblbody').append(records);
		});

		$('#tblResult').DataTable(GetTableConfig(statusType));
	}
	else if (statusType == 'cpu') {
		$('#displayHeader').html('CPU Status View');
		$('#btRefresh').attr('onclick', 'RefreshData("cpu")');

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();

		var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>CPU</th><th>State</th><th>Name</th><th>Controller</th><th>Location</th><th>Cores</th><th>Cache Size</th><th>Temperature</th><th>Vendor</th><th>Model Number</th><th>Cpu(mhz)</th></tr></thead><tbody id="tblbody"></tbody></table>'
		$('#displayData').html(tableHeader);
		$('#displayData').append(`<div style="width: 100%;height: 100%; text-align:center" id="loader"> <img src="images/loader.gif" ></div>`);
		$("#tblResult").hide()
		$.each(response, function (i, item) {
			var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.controllerName + '</td><td>' + item.location + '</td><td>' + item.cores + '</td><td>' + item.cacheSize + '</td><td>' + item.temperature + '</td><td>' + item.vendorId + '</td><td>' + item.modelNum + '</td><td>' + item.cpuMhz + '</td></tr>'
			$('#tblbody').append(records);
		});
		setTimeout(()=> {
			$("#tblResult").show()
			$("#loader").hide()
			$('#tblResult').DataTable(GetTableConfig(statusType));
		},200)
	}
	else if (statusType == 'psu2') {
		$('#displayHeader').html('PSU2 Status View');
		$('#btRefresh').attr('onclick', 'RefreshData("psu2")');

		var dataTable = $('#tblResult').DataTable();

		dataTable.destroy();

		var tableHeader = '<table border="1" class="table table-curved tbdata" id="tblResult"><thead><tr class="tbheader"><th>PSU</th><th>State</th><th>Name</th><th>AC Status</th><th>DC Status</th></tr></thead><tbody id="tblbody"></tbody></table>'
		$('#displayData').html(tableHeader);
		$.each(response, function (i, item) {
			var records = '<tr><td>' + item.Slot + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.name + '</td><td>' + item.ac_status + '</td><td>' + item.dc_status + '</td></tr>'
			$('#tblbody').append(records);
		});

		$('#tblResult').DataTable(GetTableConfig(statusType));
	}
	else if (statusType == 'disks' || statusType == 'Canister') 
	{
		if(isCanisterView) {
			var actionColumn = "Action"
			$('#displayHeader').html('Canister Status View');
			if(type){
				$('#btRefresh').attr('onclick', 'RefreshData("Canister","'+type+'")');
			}
			else{

				$('#btRefresh').attr('onclick', 'RefreshData("Canister")');
			}
		}
		else {
			var actionColumn = "Action"
			$('#displayHeader').html('Disk Status View');
			$('#btRefresh').attr('onclick', 'RefreshData("disks")');
		}

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();
		var headers = ['Disk', 'State', 'Name', 'Type', 'Size', "Pool", 'Status', actionColumn]
		var headerString = '';
		headers.forEach(element => {
			headerString += '<th>' + element + '</th>'
		});
		var tableHeader = `<table border="1" class="table table-curved tbdata hoverTable" id="tblResult"><thead><tr class="tbheader">
		` + headerString + `
		</tr></thead><tbody id="tblbody"></tbody></table>`;

		$('#displayData').html(tableHeader);
		$('#displayData').css('height', '250px');
		$.each(response, function (i, item) {//item.id
			var wwn = GetString(item.wwn); //item.wwn
			var clss = '';
			if(isCanisterView)
				clss = "disabled"
			if(isCanisterView && !item.isCan)
				return
			var records = `<tr  title="Click here for more info" class="diskrownum_` + i + `">
			<!--<td><input type="radio" name="diskUpload" id="disk_`+ wwn + `" value=\`` + wwn + `\` /></td>-->
			<td onclick="ShowDiskSMARTData(\`` + item.name + `\`,'` + item.location + `')"><span title="` + GetString(item.location) + `">` + trimString(GetString(item.location), 10) + `</span></td>
			<td onclick="ShowDiskSMARTData(\`` + item.name + `\`,'` + item.location + `')"><img src="` + item.IconPath + `" alt="` + item.state + `" id="state" class="dvstate"></td>
			<td onclick="ShowDiskSMARTData(\`` + item.name + `\`,'` + item.location + `')"><span title="` + wwn + `">` + trimString(wwn, 15) + `</span></td>
			<td onclick="ShowDiskSMARTData(\`` + item.name + `\`,'` + item.location + `')">` + item.rotation + `</td>
			<td onclick="ShowDiskSMARTData(\`` + item.name + `\`,'` + item.location + `')">` + item.size + `</td>
			<td onclick="ShowDiskSMARTData(\`` + item.name + `\`,'` + item.location + `')">` + item.pool + `</td>
			<!--<td>` + item.vid + `</td>
			<td><span title="` + GetString(item.pid) + `">` + trimString(GetString(item.pid), 12) + `</span></td>
			<td><span title="` + GetString(item.prl) + `">` + trimString(GetString(item.prl), 12) + `</span></td>
			
			<td><span title="` + GetString(item.serial) + `">` + trimString(GetString(item.serial), 10) + `</span></td>-->
			<td onclick="ShowDiskSMARTData(\`` + item.name + `\`,'` + item.location + `')">` + item.status + `</td>`;
			//if(!isCanisterView) {
			if(true) {
				records+=`<td width="18%" class="`+clss+`" align="center">
				<span class="linksBlkPop"> 
				
				<a href="javascript:void(0);" onclick="showDiskInfo(\`` + item.id + `\`)" id="info-btn" class="yellowBGPop" style="float: left;">
				<img src="images/infoIcon.png" alt="Disk Info" title="Disk Info"></a> 
				
				<label class="radio-switch" title="Click to Turn On Volume">
					<input type="checkbox" onclick="OnOffDisks(\`` + wwn + `\`,'off')" name="VolumeToggele">
					<span class="slider"></span>
				</label>
				
				<label class="radio-switch hide" title="Click to Turn Off Volume">
					<input type="checkbox" onclick="OnOffDisks(\`` + wwn + `\`,'on')" name="VolumeToggele" checked>
					<span class="slider"></span>
                </label>

                <a href="javascript:void(0);" onclick="openConfigfileUpload(\`` + wwn + `\`)" id="upload-btn" class="yellowBGPop">
				<img src="images/upload-icon.png" alt="Upload" title="Upload"></a> 
                
                <a href="javascript:void(0);" class="yellowBGPop" onclick="ejectDisk(\`` + wwn + `\`)">
				<img src="images/eject-icon.png" alt="Eject" title="Eject"></a> 

				</span>
			</td>`
			}
			records+=`</tr>`
			//var records = '<tr onclick="ShowDiskSMARTData(\''+item.id%5+'\')" title="Click here for more info" class="diskrownum_'+i+'"><td>' + item.location + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.wwn + '</td><td>' + 'HDD' + '</td><td>' + item.size + '</td><td>' + item.vid + '</td><td>' + item.pid + '</td><td>' + item.prl + '</td><td>' + item.serial + '</td><td>' + 'OK' + '</td></tr>'

			$('#tblbody').append(records);
		});
		$(document).ready(function() {
			var table = $('#tblResult').DataTable(GetTableConfig(statusType));
			var activeRowIndex = -1;
		  
			// Event listener for row click event
			$('#tblResult tbody').on('click', 'tr', function() {
			  // Remove active class from all rows
			  $('#tblResult tbody tr').removeClass('active-row');
		  
			  // Add active class to the clicked row
			  $(this).addClass('active-row');
		  
			  // Store the index of the active row
			  activeRowIndex = table.row(this).index();
			});
		  
			// Event listener for page change event
			table.on('page.dt', function() {
			  // Remove active class from all rows
			  $('#tblResult tbody tr').removeClass('active-row');
		  
			  // Reapply active class to the previously active row
			  if (activeRowIndex >= 0) {
				var activeRow = table.row(activeRowIndex).node();
				$(activeRow).addClass('active-row');
			  }
			});
		});
		  

		
		var footer = `
		<div class="col-xs-9 btnsBox" style="padding-bottom: 0px;">
                        <div class="row pull-right">
                            <a href="javascript:void(0)" onclick="openConfigfileUpload()" class="red-button mr-Rt20"
							id="upload-btn" data-dismiss="modal">Upload</a>
                        </div>
                    </div>
		`;
		var footer = `
		<div class="col-xs-9 btnsBox" style="padding-bottom: 0px;">
						<span class="linksBlk pull-right"> 
						<a href="javascript:void(0);" class=" yellowBG">
						<img src="images/screen-shot-icon.png" alt="Snap" title="Snap"></a>
							<a href="javascript:void(0);" class=" yellowBG">
						<img src="images/infoIcon.png" alt="infoIcon" title="Info"></a>  
						 
						 <label class="radio-switch hide" title="Click to Turn On Volume">
							  <input type="checkbox" name="VolumeToggele">
							  <span class="slider"></span>
						  </label>
						  
						  <label class="radio-switch" title="Click to Turn Off Volume">
							  <input type="checkbox" name="VolumeToggele" checked>
							  <span class="slider"></span>
						  </label>

						</span>
                    </div>
		`;
		//$('#displayData').append(footer);
		//$("#upload-btn").css("background", "grey");
		//$("#upload-btn").css("pointerEvents", "none");
	}
	else if (statusType == 'SSD') {
		$('#displayHeader').html('SSD Status View');
		$('#btRefresh').attr('onclick', 'RefreshData("SSD")');

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();

		var tableHeader = '<table border="1" class="table table-curved tbdata hoverTable" id="tblResult"><thead><tr class="tbheader"><th>Name</th><th>Write Cache</th><th>Read Cache</th><th>Data</th><th>Type</th></tr></thead><tbody id="tblbody"></tbody></table>'
		$('#displayData').html(tableHeader);
		$('#displayData').css('height', '250px');
		$.each(response, function (i, item) {
			var records = '<tr onclick="ShowSSDData(' + i + ')" class="diskrownum_' + i + '"><td>' + item.location + '</td><td>' + item.writeCache + '</td><td>' + item.readCache + '</td><td>' + item.dataSize + '</td><td>' + item.type + '</td></tr>'
			$('#tblbody').append(records);
		});
		$('#tblResult').DataTable(GetTableConfig(statusType));
	}
	else if (statusType == 'StoragePools') {
		let data = SetIconPath(response.data);
		$('#displayHeader').html('Storage Pool View');
		$('#btRefresh').attr('onclick', 'RefreshData("StoragePools")');

		var dataTable = $('#tblResult').DataTable();
		dataTable.destroy();

		var tableHeader = `<table border="1" class="table table-striped table-bordered hoverTable" id="tblResult" style="width : 100% !important">
			<thead>
				<tr class="tbheader">
					<th>Pool</th>
					<th>State</th>
					<th>Redundancy</th>
					<th>#Disks</th>
					<th>Raid Level</th>
					<th>Disk missing</th>
					<th>Storage Capacity</th>
					<th>Used Storage</th>
					<th>Remaining Capacity</th>
					<th>Cache Read</th>
					<th>Cache Write</th>
					<th>Type</th>
					${ oemConfig.device == 'Raptor' ? "<th>Action</th>" : ""}
				</tr>
			</thead>
			<tbody id="tblBody"></tbody>
		</table>`;

		$('#displayData').html(tableHeader);
		$('#displayData').append(`<div style="width: 100%;height: 100%; text-align:center" id="loader"> <img src="images/loader.gif" ></div>`);
		$("#tblResult").hide()
		const item = {}
		$.each(data, function (i, item) {
			//var records = '<tr onclick="ShowStoragePoolsData(\''+item.pool+'\')"  class="diskrownum_'+item.id+'"><td>' +item.pool + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' +item.redundancy + '</td><td>' +item.diskMissing + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + 0 + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + item.compression + '</td><td>' + item.dedup + '</td><td>' + item.cache_RD + '</td><td>' + item.cache_WRITE + '</td><td>' + item.type + '</td></tr>'
			//var records = '<tr onclick="ShowStoragePoolsData(\''+item.system_name+'\')"  class="diskrownum_'+item.id+'"><td>' +item.system_name + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' +item.redundancy + '</td><td>' +item.diskMissing + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + 0 + '</td><td>' + (ConvertToFloat(item.capacity)-ConvertToFloat(item.protection)) + '</td><td>' + item.compression + '</td><td>' + item.dedup + '</td><td>' + item.cache_RD + '</td><td>' + item.cache_WRITE + '</td><td>' + item.type + '</td></tr>'
			var records = '<tr <!--onclick="ShowStoragePoolsData(\'' +item.system_name+ '\')"  class="diskrownum_' + item.id + '"-->><td title="'+item.system_name+'">' + trimString(item.system_name,15) + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td><td>' + item.redundancy + '</td><td>' + item.disks + '</td><td>' + item.raidlvl + '</td><td>' + item.diskMissing + '</td><td>' + item.capacity + '</td><td>' + item.used + '</td><td>' + item.remaining + '</td><td>' +  item.cache_RD + '</td><td>' + item.cache_WRITE + '</td><td>' + item.type + '</td>'
			if (oemConfig.device == 'Raptor') {
				// Add action buttons to the row
				records += '<td align="center">' +
						   '<div class="flex" style="justify-content: space-between">' +
						   '<a href="javascript:void(0);" class="yellowBG" onclick="getStorageInfo(' + item.id + ');">' +
						   '<img src="images/infoIcon.png" alt="infoIcon" title="Info"/>' +
						   '</a>' +
						   '<a href="javascript:void(0);" class="yellowBG" onclick="rebootStorage(' + item.id + ');">' +
						   '<img src="images/build.png" alt="infoIcon" title="ReBuild"/>' +
						   '</a>' +
						   '</div>' +
						   '</td>';
			}
		
			// Close the table row
			records += '</tr>';
			$('#tblBody').append(records);
		});
		let tableConf = GetTableConfig(statusType);
		let columnDefs = [
			{ width: 40, targets: 0 },
			{ width: 40, targets: 1 },
			{ width: 40	, targets: 2 },
			{ width: 40, targets: 3 },
			{ width: 50, targets: 4 },
			{ width: 50, targets: 5 },
			{ width: 80, targets: 6 },
			{ width: 70, targets: 7 },
			{ width: 90, targets: 8 },
			{ width: 65, targets: 9 },
			{ width: 65, targets: 10 },
			{ width: 100, targets: 11 },
			// { width: 60, targets: 12 }
		]
		if(oemConfig.device == "Raptor"){
			columnDefs.push({ width: 70, targets: 12 })
		}
		setTimeout(function() {
			$("#tblResult").show()
			$("#loader").hide()
			$('#tblResult').DataTable({
				...tableConf,
				columnDefs: columnDefs
			}).columns.adjust().draw();
		}, 170);
	}
	else if (statusType == 'Canister2') {
		$('#displayHeader').html('4 Bay Canister');
		$('#btRefresh').attr('onclick', 'RefreshData("Canister")');

		try {
			var dataTable = $('#tblResult').DataTable();
			dataTable.destroy();
		} catch (error) {
			var i = 0;
		}

		var headerData = ''
		response.attributes.forEach(element => {
			headerData += "<th>" + element + "</th>";
		});
		headerData = headerData == '' ? '<th>Name</th><th>Size</th>' : headerData;
		var tableHeader = `<table border="1" class="table table-striped table-bordered hoverTable" id="tblResult">
		<thead>
			<tr class="tbheader">
			`+ headerData + `
			</tr>
		</thead><tbody id="tblBody"></tbody></table>`;

		$('#displayData').html(tableHeader);

		$.each(response.data, function (i, item) {
			var rowdata = '';
			response.attributes.forEach(element => {
				rowdata += `<td>` + item[element] + "</td>"
			});
			var records = `<tr onclick="ShowCanisterSMARTData(\`` + item['EID:Slt'] + `\`)" title="Click here for more info" class="canisterrownum_` + i + `">` + rowdata + '</tr>'
			$('#tblBody').append(records);
		});

		$('#tblResult').DataTable(GetTableConfig(statusType));
	}
	else if (statusType === 'All') {
		showPopUp = false;
		DisplayAllStatus(response);
	}
	else if (statusType == 'SaveHost') {
		if (response.status != 'fail')
			HostPageNavigate();
		alert(response.description);
		BindAllHosts();
		return;
	}
	else if (statusType == 'getProtocol') {
		$("#ddlHostType option").remove();
		$('#ddlHostType').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
			$('#ddlHostType').append(new Option(item.protocolName, item.id));
		});
		//SetUpGrayedOutRules(1);
		return;
	}
	else if (statusType == 'getHosts') {
		$("#ddlHostNames option").remove();
		$('#ddlHostNames').append(new Option('-- Select --', ''));
		$('#tbodyHostData').html('');
		$.each(response, function (i, item) {

			var host = `<tr class="text-left">
                                       <td class="col-xs-2 class-span-trim text-left">
                                          `+ item.name + `
                                       </td>
									   <td class="col-xs-2 text-left">`+ item.protocol_name + `</td>
                                       <td class="col-xs-2 text-left">`+ GetString(item.user_name) + `</td>
                                       <td class="col-xs-2 text-left">
                                          `+ GetString(item.pw) + `
                                       </td>
                                       <td class="col-xs-2 text-left">
                                          `+ GetString(item.iqn) + `
                                       </td>
                                       <td class="col-xs-2 text-left">
                                          `+ GetString(item.wwn) + `
                                       </td>
                                    </tr>`
			$('#tbodyHostData').append(host);

			$('#ddlHostNames').append(new Option(item.name, item.id));
		});
		return;
	}
	else if (statusType == 'getHostsForVolume') {
		$("#ddlVolumeHost option").remove();
		$('#ddlVolumeHost').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
			$('#ddlVolumeHost').append(new Option(item.name, item.id));
		});
		//$('#ddlVolumeHost').multiselect();
		return;
	}
	else if (statusType == 'getProtocolForVolume') {
		$("#ddlVolumeProtocol option").remove();
		$('#ddlVolumeProtocol').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
			$('#ddlVolumeProtocol').append(new Option(item.protocolName, item.id));
		});
		return;
	}
	else if (statusType == 'getStoragePools') {
		$("#ddlVolumePool option").remove();
		$('#ddlVolumePool').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
			$('#ddlVolumePool').append(new Option(item.name, item.id));
		});
		return;
	}
	else if (statusType == 'getEthernetPorts') {
		$("#ddlvolumePorts option").remove();
		$('#ddlvolumePorts').append(new Option('-- Select --', ''));
		$.each(response, function (i, item) {
			$('#ddlvolumePorts').append(new Option(item.name, item.id));
		});
		return;
	}
	else if (statusType == 'getHostById') {
		var host = response[0];
		$('#txtHostName').val(host.name);
		$('#ddlHostType').val(host.protocol_id);
		$('#txtHostUser').val(host.user_name);
		$('#txtHostPwd').val(host.pw);
		$('#txtHostIQN').val(host.iqn);
		$('#txtHostWWN').val(host.wwn);

		SetUpGrayedOutRules(host.protocol_id);
		return;
	}
	else if (statusType == 'SaveVolume') {
		BindVolumeSavedData();
		alert(response.description);
		if (response.status != 'fail')
			VolumeMgrPageNavigate('cancel');
		return;
	}
	else if (statusType == 'changeVolumeState') {
		BindVolumeSavedData();
		alert(response.description);
		return;
	}
	else if (statusType == 'SaveSnapVolume') {
		if (response.status == 'fail') {
			swal("Error", response.description, "error");
		}
		else {
			BindVolumeSavedData();
			swal("success", response.description, "success");
		}
		return;
	}
	else if (statusType == 'getVolumeSavedData') {
		$("#ddlVolumeNames option").remove();
		$('#ddlVolumeNames').append(new Option('-- Select --', ''));

		//$('#ddlVolumeNames').trigger('change');

		$('#tbodyVolumeData').html('');
		$.each(response, function (i, item) {
			var dedup = item.dedup == 'true' ? 'Yes' : 'No';
			var compression = item.compression == 'true' ? 'Yes' : 'No';
			var onClass = item.state == 6 ? 'blinkled' : '';
			var offClass = item.state == 4 ? 'blinkled' : '';
			var len = $(this).text().trim().length;
			item.nametext = item.name
			if (item.name.length > 10) {
				item.name = item.name.substr(0, 12) + '...';
			}
			var strVolume = `<tr class="text-left">
                                       <td class="col-xs-1 class-span-trim text-left" title="`+ item.nametext + `">
                                          `+ item.name + `
                                       </td>
									   <td class="col-xs-1 text-left">`+ item.type + `</td>
                                       <td class="col-xs-1 text-left">`+ item.size + `</td>
                                       <td class="col-xs-1 text-left">
                                          `+ item.poolName + `
                                       </td>
                                       <td class="col-xs-1 text-left">
                                          `+ item.lun + ` 
                                       </td>
                                       <td class="col-xs-1 text-left">
                                          `+ dedup + `
                                       </td>
									   <td class="col-xs-1 text-left">
                                          `+ compression + `
                                       </td>
									   <td class="col-xs-1">
                                          `+ item.protocolName + `
                                       </td>
                                       <td class="col-xs-1 ">
                                          `+ item.hostName + `
                                       </td>
                                       <td class="col-xs-1 text-left"> 
                                          `+ item.portName + `
                                       </td>
                                       <td class="col-xs-2" align="center">
                                          <span class="linksBlk"> 
                                          <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/screen-shot-icon.png" alt="Snap" title="Snap" onclick="SnapShotVolume(`+ item.id + `,'` + item.name + `')"></a>
											  <a href="javascript:void(0);" class=" yellowBG">
                                          <img src="images/infoIcon.png" alt="infoIcon" title="Info" onclick="VolumeInfo(`+ item.size + `)"></a>  
										  <a href="javascript:void(0);" class="`+ onClass + `">
											<img src="images/power-On.png" alt="Start" title="Start" onclick="OnOffVolume(`+ item.id + `,` + 6 + `)">
										  </a>
                                          <a href="javascript:void(0);" class="`+ offClass + `">
											<img src="images/power-Off.png" alt="Stop" title="Stop" onclick="OnOffVolume(`+ item.id + `,` + 4 + `)">
										  </a>
                                        
                                          </span>
                                       </td>
                                    </tr>`;
			$('#tbodyVolumeData').append(strVolume);
			if (item.type == 'Native')
				$('#ddlVolumeNames').append(new Option(item.name, item.id));
		});

		return;
	}
	else if (statusType == 'getVolumeById') {
		var volume = response[0];

		$('#txtVolumeSize').val(volume.size);
		$('#ddlVolumeProtocol').val(volume.protocolId);
		$('#ddlVolumePool').val(volume.poolId);
		$('#ddlVolumeHost').val(volume.hostId);
		$('#txtVolumeLUN').val(volume.lun);
		$('#ddlvolumePorts').val(volume.portId);
		$('#chkDedup').prop('checked', volume.dedup == "true" ? true : false);// volume.dedup
		$('#chkCompression').prop('checked', volume.compression == "true" ? true : false);
		//"size":$('#txtVolumeSize').val(),"protocolId":$('#ddlVolumeProtocol').val(),"poolId":$('#ddlVolumePool').val(),"hostId":$('#ddlVolumeHost').val(),"lun":$('#txtVolumeLUN').val(),"portId":$('#ddlvolumePorts').val()
		return;
	}
	else if (statusType == 'getMetricsByDevice') {

		$("#ddlDeviceMetric option").remove();
		//$('#ddlDeviceMetric').append(new Option('Select',''));
		$('#ddlDeviceMetric').append(new Option("Select Metric"), "select");
		$.each(response.metrics, function (i, item) {
			$('#ddlDeviceMetric').append(new Option(item.replace('.rrd', '')), item);
		});
		$('#aMetricInfo').attr('data-original-title', $("#ddlDeviceMetric").val() + ' info content here');
		return;
	}
	else if (statusType == 'getMetricsByDevice') {

	}
	else if (statusType == 'eject_Disk') {
		if(response.status !='fail')
			swal("Success", response.description , "success");
		else
			swal("Error", response.description , "error");

	}
	else if (statusType == 'onOff_Disk') {
		if(response.status !='fail')
			swal("Success", response.description , "success");
		else
			swal("Error", response.description , "error");
	}
	else if (statusType == 'HotSwapButton' || statusType=="onOffReset") {
		showPopUp=false;
		if(response.status !='fail')
			swal("Success", response.description , "success");
		else
			swal("Error", response.description , "error");
	}
	else if (statusType == "diskInfo") {
		let records = '', record = '';
		$('#divDiskInfo').html('');
		$("#diskInfoPop .modal-title label").html("Disk info");
		for (let [key, value] of Object.entries(response.data)) {
		  //console.log(`${key}: ${value}`);
		  var infoData=`<div class="form-group">
						<div class="col-lg-12 padding-0">
							<div class="col-xs-4 padding-0">
								<h4><b>`+key+`:</b></h4>
							</div>
							<div class="col-xs-4 padding-0">
								<h4>`+value+`</h4>
							</div>
						</div>
                       </div>`;
			$('#divDiskInfo').append(infoData);
		}
		$('#diskInfoPop').modal('show');
	
	}
	else if (statusType == "read_StoragePoolsById"){
		$('#divDiskInfo').html('');
		$("#diskInfoPop .modal-title label").html("Storage Information");
		for (let [key, value] of Object.entries(response[0])) {
			if(key != "IconPath" && key != "Slot"){
				var infoData=`<div class="form-group">
							  <div class="col-lg-12 padding-0">
								  <div class="col-xs-4 padding-0">
									  <h4><b>`+key+`</b></h4>
								  </div>
								  <div class="col-xs-2 mt-2">:</div>
								  <div class="col-xs-4 padding-0">
									  <h4>`+value+`</h4>
								  </div>
							  </div>
							 </div>`;
				  $('#divDiskInfo').append(infoData);
			}
		}
		$('#diskInfoPop').modal('show');
	}
	else if (statusType == "reboot_StoragePool") {
		swal("Error", response.description , "error");
	}
	$('#tblhead').on("click", function () {
		$('#tblhead tr').removeClass('highlighted');
		$(this).addClass('highlighted');
	});
	$('#tblhead thead').css('background', 'red');
	$('#tblhead thead').css('color', 'white');
	$("#tblhead").tableHeadFixer();
	if (showPopUp)
		$('#displayPopUp').modal('show');
}
/*function BindApps(statusType,response)
{
	if(statusType == 'getApps')
	{
		$("#ddlApplication option").remove();	
		//$('#ddlDeviceMetric').append(new Option('Select',''));
		$.each(response, function (i, item) {
			$('#ddlApplication').append(new Option(item, item));            
		});
		$('#ddlApplication').click();
	}
}*/
function ConvertToFloat(str) {
	return str.replace(' TB', '');
}
$(document).on('click', 'input[name="diskUpload"]', function () {
	$("#upload-btn").css("background", "#ed1c24");
	$("#upload-btn").css("pointerEvents", "auto");
});
function SetIconPath(response) {
	var result = [];
	$.each(response, function (i, item) {
		switch (item.state) {
			case 0:
				item.IconPath = "./images/green-switch.png";
				item.Slot = i + 1;
				break;
			case 1:
				item.IconPath = "./images/orange-switch.png";
				item.Slot = i + 1;
				break;
			case 2:
				item.IconPath = "./images/red-switch.png";
				item.Slot = i + 1;
				break;
			case 3:
				item.IconPath = "./images/yellow-switch.png";
				item.Slot = i + 1;
				break;
		}
		result.push(item);
	});
	return result;
}
function RefreshData(type,type1="") {
	ShowStatus(type,type1);
}
function DisplayAllStatus(response) {
	var htmlData = GetFinalStatus(response.fans);
	$('#divFan').html(htmlData);
	htmlData = GetFinalStatus(response.temp_probes);
	$('#divTemp_probes').html(htmlData);
	htmlData = GetFinalStatus(response.network);
	$('#divNetwork').html(htmlData);
	htmlData = GetFinalStatus(response.psu);
	$('#divPsu').html(htmlData);
	htmlData = GetFinalStatus(response.disks);
	$('#divDisks').html(htmlData);
	htmlData = GetFinalStatus(response.cpu);
	$('#divCpu').html(htmlData);

	$('#divBackup').html('<div class="greenFlash">Ok</div>');
	$('#divAlerts').html('<div class="greenFlash">Ok</div>');
	$('#divVmStatus').html('<div class="greenFlash">Ok</div>');
	$('#divFastier').html('<div class="greenFlash">Ok</div>');
	htmlData = GetFinalStatus(response.pools);
	$('#divStoragePoll').html(htmlData);
	//$('#divStoragePoll').html('<div class="greenFlash">Ok</div>');

}
function GetFinalStatus(states) {
	var redcheck = states.indexOf(2);
	var orangecheck = states.indexOf(1);
	var greencheck = states.indexOf(0);
	var htmlData = '';
	if (redcheck != -1)
		htmlData = '<div class="redFlash">Alert</div>';
	else if (orangecheck != -1)
		htmlData = '<div class="orangeFlash">Warning</div>';
	else if (greencheck != -1)
		htmlData = '<div class="greenFlash">Ok</div>';
	else
		htmlData = '<div class="orangeFlash">N/A</div>';
	return htmlData;
}
function GetStatusbyType(type, typeNumber) {
	var request = new Request();
	request.parameters = { "requestType": GetRequestType(type) };
	request.url = 'cgi/cgi_statusView.py';
	request.statusType = type;
	request.typeNumber = typeNumber;
	request.isSingleStatus = true;
	CallPythonService(request);
}
function BindSingleStatus(statusType, typeNumber, response) {
	$('#tblheadsingle thead').css('background', 'red');
	$('#tblheadsingle thead').css('color', 'white');
	$("#tblheadsingle").tableHeadFixer();
	$('#displayPopUpsingle').modal('show');
}

function BindComponentStatus(component, response) {
	$('#displayHeadersingle').html(component);
	var dataTable = $('#tblResult').DataTable();
	dataTable.destroy();
	var headerData = ''
	
	response.attributes.forEach(element => {
		headerData += "<th>" + element + "</th>";
	});
	var tableHeader = `<table border="1" class="table table-curved tbdata" id="tblheadsingle">
						<thead><tr class="tbheader">
						`+ headerData + `
						</tr></thead><tbody></tbody></table>`;
	$('#displayDatasingle').html(tableHeader);
	var records = '';
	$.each(response.data, function (i, item) {
		response.data=SetIconPath(response.data);
		var rowdata = '';
		if ((component=="LAN LED1") || (component=="LAN LED2") || (component=="LAN LED3") || (component=="LAN LED4") || (component=="Warning LED") ){
			response.attributes.forEach(element => {
				rowdata='<td>' + item.name + '</td><td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td> <td>' + item.speed + '</td>'
			});
		}
		else{
			response.attributes.forEach(element => {
				rowdata += "<td>" + item[element] + "</td>"
			});
		}

		records += '<tr>' + rowdata + '</tr>'
	});
	$('#tblheadsingle > tbody').append(records);

	$('#tblheadsingle thead').css('background', 'red');
	$('#tblheadsingle thead').css('color', 'white');
	$("#tblheadsingle").tableHeadFixer();
	$('#displayPopUpsingle').modal('show');
}

function ShowDiskSMARTData(disk, slot) {
	var request = new Request();
	request.url = "cgi/cgi_statusView.py"
	request.statusType = "DiskSMART";
	request.parameters = { "disk": disk, "requestType": 'read_DisksSMART_Data', "slot": slot };
	CallPythonService(request);
}
function ShowCanisterSMARTData(slot) {
	var request = new Request();
	request.url = "cgi/cgi_statusView.py"
	request.statusType = "CanisterSMART";
	request.parameters = { "slot": slot, "requestType": 'read_CanisterSMART_Data' };
	CallPythonService(request);
}
function ShowSSDData(ssdId) {
	var request = new Request();
	request.url = "cgi/cgi_statusView.py"
	request.statusType = "SSDFullData";
	request.parameters = { "SSDId": ssdId, "requestType": 'read_SSDFull_Data' };
	CallPythonService(request);
}
function ShowStoragePoolsData(poolId) {
	var request = new Request();
	request.url = "cgi/cgi_statusView.py"
	request.statusType = "StoragePoolsFullData";
	request.parameters = { "poolId": poolId, "requestType": 'read_PoolsFull_Data' };
	CallPythonService(request);
}

function BindDiskSMARTData(response, diskId) {
	var data = response[0];
	if (data.status == 'success' && data.attributes.length > 0) {
		var cls = '.diskrownum_' + diskId;
		$(cls).addClass('highlighted');
		$('#tblResult tr').removeClass('highlighted');
		$('#displayData').css('height', '170px');
		var headerdata = '';
		data.attributes.forEach(element => {
			headerdata += '<th>' + element + '</th>';
		});
		console.log(data.headerData)
		var htmlData = `<div class="table2 cardContainer"><div class="row">  <div class="col-lg-3">  <div class="card">  <h3>Health Status</h3>  <div class="cardBody">  <h4>` + data.headerData.HealthStatus + `</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Temperature</h3>  <div class="cardBody">  <h4>` + data.headerData.Temperature + `</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Self Test Result</h3>  <div class="cardBody">  <h4>` + data.headerData.TestResult + `</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Sector Error count</h3>  <div class="cardBody">  <h4>` + data.headerData.SectorErrorCount + `</h4>  </div>  </div>  </div></div>    <div class="clearfix"></div><div id="displayData" style="display: block; width: 568px; overflow: scroll; height: 200px;">  
						<table width="100%" border="0" class="table-bordered" id="tblDisksSmart">  
							<thead>
								<tr>
									`+ headerdata + `
								</tr>
							</thead>
							<tbody id="divDisksRows">   
							</tbody>
						</table>
					</div></div>`;
		$('#divSMARTinfo').html(htmlData);
		var rows = '';
		$.each(data.data, function (i, item) {
			var rowdata = '';
			data.attributes.forEach(element => {
				rowdata += "<td>" + item[element] + "</td>"
			});
			rows = '<tr>' + rowdata + '</tr> ';
			$('#tblDisksSmart tbody').append(rows);
		});
		$("#tblDisksSmart").tableHeadFixer();
	}
	else if (data.status == 'fail') {
		var htmlData = `<div class="table2 cardContainer"><div class="row">  <div class="col-lg-3">  <div class="card">  <h3>Health Status</h3>  <div class="cardBody">  <h4>${data.headerData.HealthStatus}</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Temperature</h3>  <div class="cardBody">  <h4>${data.headerData.Temperature}</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Self Test Result</h3>  <div class="cardBody">  <h4>${data.headerData.TestResult}</h4>  </div>  </div>  </div>  <div class="col-lg-3">  <div class="card">  <h3>Sector Error count</h3>  <div class="cardBody">  <h4>${data.headerData.SectorErrorCount}</h4>  </div>  </div>  </div></div>    <div class="clearfix"></div><div id="displayData" class="Blink" style="text-align: center; color: red;"><h2> ${data.message} </h2></div></div>`;
		$('#divSMARTinfo').html(htmlData);
	}
}
function GetValueByKey(dataObject, key) {
	let obj = dataObject.find(o => o.key === key);
	if (obj == undefined)
		return "N/A";
	return obj.value;
}

function BindSSDFullData(response, ssdID) {
	var cls = '.diskrownum_' + ssdID;
	$('#tblResult tr').removeClass('highlighted');
	$(cls).addClass('highlighted');

	$('#displayData').css('height', '170px');
	var htmlData = '<div class="table2 cardContainer"><div class="clearfix"></div><div id="displayData" style="display: block; width: 568px; overflow: scroll; height: 200px;">  <table width="100%" border="0" class="table-bordered" id="tblDisksSmart">  <thead><tr>    <th>Attribute</th>    <th>Value</th>    <th>Normalized</th>    <th>Threshold</th>    <th>Worst</th> <th>Type</th> <th>Assesment</th></tr></thead><tbody id="divDisksRows">   </tbody></table></div></div>';
	$('#divSMARTinfo').html(htmlData);
	$.each(response, function (i, item) {
		var rows = '<tr>    <td>' + item.Name + '</td>    <td>' + item.value + '</td> <td>' + item.Normalized + '</td>   <td>' + item.Threshold + '</td>    <td>' + item.worst + '</td>    <td>' + item.Type + '</td> <td>' + item.Assessment + '</td>      </tr> ';
		$('#tblDisksSmart tbody').append(rows);
	});
	$("#tblDisksSmart").tableHeadFixer();
}
function BindPoolsFullData(response, poolId) {
	var cls = '.diskrownum_' + poolId;
	$('#tblResult tr').removeClass('highlighted');
	$(cls).addClass('highlighted');

	$('#displayData').css('height', '170px');
	var htmlData = '<div class="table2 cardContainer"><div class="clearfix"></div><div id="displayData" style="display: block; width: 568px; overflow: scroll; height: 200px;">  <table width="100%" border="0" class="table-bordered" id="tblDisksSmart">  <thead><tr>    <th>Disk</th>    <th>State</th>    <th>Size (GB)</th>    <th>WWN</th>    <th>Status</th></tr></thead><tbody id="divDisksRows">   </tbody></table></div></div>';
	$('#divSMARTinfo').html(htmlData);
	var result = SetIconPath(response);
	$.each(response, function (i, item) {
		var rows = '<tr>    <td>' + item.name + '</td>    <td><img src="' + item.IconPath + '" alt="' + item.state + '" id="state" class="dvstate"></td> <td>' + item.size + '</td>   <td>' + item.wwn + '</td>    <td>' + item.status + '</td></tr> ';
		$('#tblDisksSmart tbody').append(rows);
	});
	$("#tblDisksSmart").tableHeadFixer();
}
// $('#tblhead tr').click(function(e) {
// $('#tblhead tr').removeClass('highlighted');
// $(.diskrownum_).addClass('highlighted');
// });

function SaveHost() {
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if (!isFormValid)
		return;
	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "SaveHost";
	request.parameters = { "requestType": 'create_Host', "hostName": $('#txtHostName').val(), "protocol": $('#ddlHostType').val(), "user": $('#txtHostUser').val(), "password": $('#txtHostPwd').val(), "iqn": $('#txtHostIQN').val(), "wwn": $('#txtHostWWN').val() };
	CallPythonService(request);
}
function UpdateHost() {
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if (!isFormValid)
		return;
	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "SaveHost";
	request.parameters = { "requestType": 'update_Host', "hostId": $('#ddlHostNames').val(), "hostName": $('#txtHostName').val(), "protocol": $('#ddlHostType').val(), "user": $('#txtHostUser').val(), "password": $('#txtHostPwd').val(), "iqn": $('#txtHostIQN').val(), "wwn": $('#txtHostWWN').val() };
	CallPythonService(request);
}
function DeleteHost() {
	var isFormValid = $("#formHostServer").validationEngine('validate');
	if (!isFormValid)
		return;
	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "SaveHost";
	request.parameters = { "requestType": 'delete_Host', "hostId": $('#ddlHostNames').val() };
	CallPythonService(request);
}
function GetAllProtocol() {
	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "getProtocol";
	request.parameters = { "requestType": 'read_Protocol' };
	CallPythonService(request);
}
$('#ddlHostNames').change(function () {
	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "getHostById";
	request.parameters = { "requestType": 'read_Host', "hostId": $(this).val() };
	CallPythonService(request);
});
$('#ddlHostType').change(function () {
	//$('#txtHostName').val('');

	SetUpGrayedOutRules(1);
});
function SetUpGrayedOutRules(protocolId) {
	if (hostActionPage == 'Delete')
		return;
	var protocol = $('#ddlHostType').val();
	var rule = hostGrayedOutRules[protocol - 1];

	if (rule.user == 0) {
		$('#txtHostUser').attr('disabled', true);
		$('#txtHostUser').val('');
	}
	else
		$('#txtHostUser').attr('disabled', false);

	if (rule.password == 0) {
		$('#txtHostPwd').attr('disabled', true);
		$('#txtHostPwd').val('');
	}
	else
		$('#txtHostPwd').attr('disabled', false);

	if (rule.iqn == 0) {
		$('#txtHostIQN').attr('disabled', true);
		$('#txtHostIQN').val('');
	}
	else
		$('#txtHostIQN').attr('disabled', false);


	if (rule.wwn == 0) {
		$('#txtHostWWN').attr('disabled', true);
		$('#txtHostWWN').val('');
	}
	else
		$('#txtHostWWN').attr('disabled', false);
}

$('.clsHostPage').click(function () {
	$('.clsHostPage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
	BindAllHosts();
});

function BindAllHosts() {
	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "getHosts";
	request.parameters = { "requestType": 'read_Host', "hostId": 0 };
	CallPythonService(request);
}
function openHostPopup() {
	//$('#btnHostAdd').trigger('click');
}
function HostPageNavigate(page) {
	$('#txtHostName').val('')
	$('#txtHostUser').val('');
	$('#txtHostPwd').val('');
	$('#txtHostIQN').val('');
	$('#txtHostWWN').val('');

	$('.hostFieldCls').attr('disabled', false);
	GetAllProtocol();
	$('#divHostNew').css('display', 'none');
	hostActionPage = page;

	if (page == 'Add') {
		$('.clsHostNames').css('display', 'none');
		$('#btnHostAction').attr('onclick', 'SaveHost()').html('Confirm');
		$('#divHostNew').css('display', 'block');
		BindAllHosts();

	}
	else if (page == 'Edit') {
		$('.clsHostNames').css('display', 'block');
		$('#btnHostAction').attr('onclick', 'UpdateHost()').html('Confirm');
		$('#divHostNew').css('display', 'block');
	}
	else if (page == 'Delete') {
		$('.clsHostNames').css('display', 'block');
		$('#btnHostAction').attr('onclick', 'DeleteHost()').html('Confirm');
		$('#divHostNew').css('display', 'block');
		$('.hostFieldCls').attr('disabled', true);
	}
	else {
		$('.clsHostPage').removeClass('alert-danger');
	}
}
// Host Manager code End

// Volume Manager code Start
$('.clsVolumePage').click(function () {
	$('.clsVolumePage').removeClass('alert-danger');
	$(this).addClass('alert-danger');
});

function VolumeMgrPageNavigate(page) {
	$('#txtVolumeSize').val('');
	$('#txtVolumeLUN').val('');
	$('#txtVolumeName').val('');


	$('#ddlVolumeProtocol').attr('disabled', false);
	$('#ddlVolumeHost').attr('disabled', false);
	$('#ddlvolumePorts').attr('disabled', false);
	$('#chkCompression').attr('disabled', false);
	$('#chkDedup').attr('disabled', false);
	$('#txtVolumeLUN').attr('disabled', false);
	$('#ddlVolumePool').attr('disabled', false);
	$('#txtVolumeSize').attr('disabled', false);

	$('#divNewVolumeMgr').hide();
	if (page == 'Add') {
		BindVolumeDefaultData();
		$('#txtVolumeName').show();
		$('#ddlVolumeNames').hide();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick', 'SaveVoume()');
	}
	else if (page == 'Edit') {
		BindVolumeDefaultData();
		$('#txtVolumeName').hide();
		$('#ddlVolumeNames').show();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick', 'UpdateVoume()');
		$('#ddlVolumeProtocol').attr('disabled', true);
		$('#ddlVolumeHost').attr('disabled', true);
	}
	else if (page == 'Delete') {
		BindVolumeDefaultData();
		$('#txtVolumeName').hide();
		$('#ddlVolumeNames').show();
		$('#divNewVolumeMgr').show();
		$('#btnVolumeAction').attr('onclick', 'DeleteVoume()');

		$('#ddlVolumeProtocol').attr('disabled', true);
		$('#ddlVolumeHost').attr('disabled', true);
		$('#ddlvolumePorts').attr('disabled', true);
		$('#chkCompression').attr('disabled', true);
		$('#chkDedup').attr('disabled', true);
		$('#txtVolumeLUN').attr('disabled', true);
		$('#ddlVolumePool').attr('disabled', true);
		$('#txtVolumeSize').attr('disabled', true);
	}
	else if (page == 'cancel') {
		$('#divNewVolumeMgr').hide();
		$('.clsVolumePage').removeClass('alert-danger');
	}
	BindVolumeSavedData();
}
function BindVolumeDefaultData() {
	selectedProtocol = 0;
	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "getHostsForVolume";
	request.parameters = { "requestType": 'read_Host', "hostId": 0 };
	CallPythonService(request);

	var request = new Request();
	request.url = "cgi/cgi_Pool_Get.py"
	request.statusType = "getStoragePools";
	request.parameters = { "requestType": 'read_pool' };
	CallPythonService(request);

	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "getEthernetPorts";
	request.parameters = { "requestType": 'read_Ethernet_ports' };
	CallPythonService(request);

	var request = new Request();
	request.url = "cgi/cgi_HostManager.py"
	request.statusType = "getProtocolForVolume";
	request.parameters = { "requestType": 'read_Protocol' };
	CallPythonService(request);

}
function SaveVoume() {
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if (!isFormValid)
		return;
	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");
	//var selectedhosts = $('#ddlVolumeHost').val() != null ? $('#ddlVolumeHost').val().toString():'0';

	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "SaveVolume";
	request.parameters = { "requestType": 'create_Volume', "volumeName": $('#txtVolumeName').val(), "size": $('#txtVolumeSize').val(), "dedup": dedup, "compression": compression, "protocolId": $('#ddlVolumeProtocol').val(), "poolId": $('#ddlVolumePool').val(), "hostId": $('#ddlVolumeHost').val(), "lun": $('#txtVolumeLUN').val(), "portId": $('#ddlvolumePorts').val() };
	CallPythonService(request);
}
function UpdateVoume() {
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if (!isFormValid)
		return;

	var dedup = $('#chkDedup').is(":checked");
	var compression = $('#chkCompression').is(":checked");

	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "SaveVolume";
	request.parameters = { "requestType": 'update_Volume', "volumeId": $('#ddlVolumeNames').val(), "size": $('#txtVolumeSize').val(), "dedup": dedup, "compression": compression, "protocolId": $('#ddlVolumeProtocol').val(), "poolId": $('#ddlVolumePool').val(), "hostId": $('#ddlVolumeHost').val(), "lun": $('#txtVolumeLUN').val(), "portId": $('#ddlvolumePorts').val() };
	CallPythonService(request);
}
function DeleteVoume() {
	var isFormValid = $("#formVolumeMgr").validationEngine('validate');
	if (!isFormValid)
		return;
	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "SaveVolume";
	request.parameters = { "requestType": 'delete_Volume', "volumeId": $('#ddlVolumeNames').val() };
	CallPythonService(request);
}
function BindVolumeSavedData() {
	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "getVolumeSavedData";
	request.parameters = { "requestType": 'read_Volume', 'volumeId': 0 };
	CallPythonService(request);
}
$('#ddlVolumeNames').change(function () {
	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "getVolumeById";
	request.parameters = { "requestType": 'read_Volume', 'volumeId': $(this).val() };
	CallPythonService(request);
});

function OnOffVolume(volumeId, state) {
	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "changeVolumeState";
	request.parameters = { "requestType": 'onOff_Volume', 'volumeId': volumeId, "state": state };
	CallPythonService(request);
}
function SnapShotVolume(volumeId, volumeName) {
	$('#volumeSnapshotPop').modal('show');
	$('#txtSnapshotName').val(volumeName + "-ss1");
	$('#btnVolumeSnap').attr('onclick', "SaveSnapshotVolume(" + volumeId + ")");
}
$('#txtSnapshotName').on('input', function () {
	if ($(this).val().length > 0)
		$('#btnVolumeSnap').show();
	else
		$('#btnVolumeSnap').hide();
})
function VolumeInfo(size) {
	$('#lblSize').text(size + ' GB');
	$('#volumeInfoPop').modal('show');
}
function SaveSnapshotVolume(volumeId) {
	var snapShotName = $('#txtSnapshotName').val();
	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = 'SaveSnapVolume';
	request.parameters = { "requestType": 'snapShot_volume', "volumeId": volumeId, "snapShotName": snapShotName };
	CallPythonService(request);
}

$('#ddlVolumeProtocol').change(function () {
	selectedProtocol = $(this).val();
	var request = new Request();
	request.url = "cgi/cgi_VolumeManager.py"
	request.statusType = "getHostsForVolume";
	request.parameters = { "requestType": 'read_HostByProtocol', "protocolId": selectedProtocol };
	CallPythonService(request);
});

function OpenChartGroupSelection(showclass) {
	$('.clsDevice').hide();
	$('.' + showclass).show();
	for(label of $('.' + showclass)[0].children) {
		let checked = $(label).find(":input").prop("checked");
		if(checked == true){
			$('#divMetrics').show();
			return;
		}
	}
	$('#divMetrics').hide();
}
function ShowChart() {
	var deviceList = $("input[name='chartGroup']:checked").val();
	var scale = $("input[name='chartSclae']:checked").val();
	var grpName = $("input[name='chartGroup']:checked").attr('group');
	var metric = $('#ddlDeviceMetric').val();
	//console.log("deviceList, scale, grpName, metric: ", deviceList, scale, grpName, metric);
	metric = metric == null ? '' : metric;
	if(metric == "Select Metric" || metric == ""){
		metric = "idle";
		//swal("Warning", "Select a Metric", "warning");
		//return;
	}
	InitializeChart(deviceList, scale, grpName, metric);
}

/*function ShowApplicationChart()
{
	$('#divMetrics').hide();
	$('#divApplications').hide();
	
	var deviceList=$("input[name='chartAppGroup']:checked").val();
	var scale =$("input[name='chartSclae']:checked").val();
	var grpName = $("input[name='chartAppGroup']:checked").attr('group');
	var appName = $('#ddlApplication').val();
	var metric=$('#ddlDeviceMetric').val();
	$("input[name='chartAppGroup']:checked").prop('checked', false);
	InitializeApplicationChart(deviceList,scale,grpName,metric,appName);
}*/

$('input[type=radio][name=chartGroup]').change(function () {
	$("#showGraph").attr("onclick", "ShowChart()");
	var device = $("input[name='chartGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});
$('input[type=radio][name=chartGroup]').click(function () {
	$("#showGraph").attr("onclick", "ShowChart()");
	var device = $("input[name='chartGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});

/*$('input[type=radio][name=chartAppGroup]').change(function() {
	$("#showGraph").attr("onclick","ShowApplicationChart()");
	var device=$("input[name='chartAppGroup']:checked").val();
	BindApplicationDevices(device);
	//$('#divApplications').show();
});
$('input[type=radio][name=chartAppGroup]').click(function() {
	$("#showGraph").attr("onclick","ShowApplicationChart()");
	var device=$("input[name='chartAppGroup']:checked").val();
	BindApplicationDevices(device);
	//$('#divApplications').show();
});

$('#ddlApplication').change(function(){
	var device=$("input[name='chartAppGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});
$('#ddlApplication').click(function(){
	var device=$("input[name='chartAppGroup']:checked").val();
	BindMetricsData(device);
	$('#divMetrics').show();
});*/

$('#ddlDeviceMetric').change(function () {
	$('#aMetricInfo').attr('data-original-title', $("#ddlDeviceMetric").val() + ' info content here');
});
function BindMetricsData(device) {
	var request = new Request();
	request.url = "cgi/cgi_CollectD_Manager.py"
	request.statusType = "getMetricsByDevice";
	request.parameters = { "requestType": 'get_Metrics', "deviceList": device };
	CallPythonService(request);
}
/*function BindApplicationDevices(device)
{
	var request = new Request();
	request.url ="cgi/cgi_CollectD_Manager.py"
	request.statusType="getApps";
	request.parameters={"requestType":'get_Apps',"deviceList":device};
	CallPythonService(request);
}*/
$('.clsChartScale').change(function () {
	ShowChart();
});
$('#btnResizeGraph').click(function () {
	if ($(this).attr('currentView') == 'small') {
		$(this).attr('ht', $('.serverMiddle').height());
		$(this).attr('wd', $('.serverMiddle').width());
		$(this).attr('ContainerHt', $('#container').height());
		$(this).attr('currentView', 'full');
		$(this).val('Zoom Out');
		$('.serverContainer').hide();
		$('.serverMiddle').width($(window).width() - 54);
		$('.serverMiddle').height($(window).height());
		$('#container').height($(window).height() - 200);

		$('html, body').animate({
			scrollTop: ($('.serverMiddle').first().offset().top)
		}, 500);
	}
	else {
		$(this).attr('currentView', 'small');
		$(this).val('Zoom In');
		$('.serverContainer').show();
		$('.serverMiddle').width($(this).attr('wd'));
		$('.serverMiddle').height($(this).attr('ht'));
		$('#container').height($(this).attr('ContainerHt'));

	}
	ShowChart();

});
function GetString(str) {
	if (str == null)
		return 'n/a';
	else
		return str;
}

function trimString(valueString, lengthValue) {
	var len = String(valueString).trim().length;
	var newValueString = valueString;
	if (len > lengthValue) {
		newValueString = String(valueString).substr(0, lengthValue) + '...';
	}
	return newValueString;
}
function BindDiskImage() {
	var request = new Request();
	request.url = 'cgi/cgi_statusView.py';
	request.parameters = { requestType: 'read_Disks' };
	InvokePythonService(request).then(function (response) {
		var hddCount = 1;
		var ssdCount = 1
		$.each(response, function (i, item) {
			if (item.rotation == 'HDD') {
				$("[poolType=" + item.rotation + "][Number=" + hddCount + "]").attr("onclick", "GetStatusbyType('disks','" + item.wwn + "')").attr('title', item.name);
				hddCount += 1;
			}
			else {
				$("[poolType=" + item.rotation + "][Number=" + ssdCount + "]").attr("onclick", "GetStatusbyType('disks','" + item.wwn + "')").attr('title', item.name);
				ssdCount += 1;
			}
		});
		$('[data-toggle="tooltip"]').tooltip()
	}).catch(function (ex) {
		console.log(ex);
	});
}
BindDiskImage()



function ShowSSDChart() {
	$('#popUpSSDChart').modal('show');
	var request = new Request();
	request.url = 'cgi/cgi_statusView.py';
	request.parameters = { requestType: 'read_SSDChartData' };
	InvokePythonService(request).then(function (response) {
		SSDChartOthers(response.ssdOtherUsage);
		SSDChartDataUsage(response.ssdDataUsage);
	}).catch(function (ex) {
		console.log(ex);
	});


}
function SSDChartDataUsage(response) {
	var chartData = [];
	var drillDownData = [];
	$.each(response, function (i, item) {
		chartData.push({ name: item.name, y: item.used, drilldown: item.name });

		var listDataDrillDown = [];
		$.each(item.List, function (j, record) {
			listDataDrillDown.push([record.name, record.size]);
		});
		if (listDataDrillDown.length > 0) {
			drillDownData.push({
				name: item.name,
				id: item.name,
				data: listDataDrillDown
			});
		}
	});


	Highcharts.chart('divSSDChartData', {
		chart: {
			type: 'pie',
			options3d: {
				enabled: true,
				alpha: 60,
				beta: 0
			}
		},
		title: {
			text: 'SSD Pool usage',
			style: { "color": "black", "fontSize": "20px", fontWeight: 'bold' },
		},
		subtitle: {
			text: 'Click on storage type to see in details.'
		},
		exporting: {
			enabled: false
		},
		plotOptions: {
			series: {
				dataLabels: {
					enabled: true,
					format: '{point.name}: {point.y:.1f}%'
				}
			},
			pie: {
				allowPointSelect: true,
				cursor: 'pointer',
				depth: 35,
				dataLabels: {
					enabled: true,
					format: '{point.name}'
				}
			}
		},

		tooltip: {
			headerFormat: '<span style="font-size:11px">{series.name}</span><br>',
			pointFormat: '<span style="color:{point.color}">{point.name}</span>: <b>{point.y:.2f}%</b> of total<br/>'
		},
		series: [{
			name: 'Storage',
			colorByPoint: true,
			data: chartData
		}],
		drilldown: {
			series: drillDownData
		}

	});
}


function SSDChartOthers(response) {

	var ssdOtherUsageData = [];
	var drillDownData = [];

	$.each(response, function (i, item) {
		ssdOtherUsageData.push({ name: item.name, y: item.used, drilldown: '' });


		var listDataDrillDown = [];
		$.each(item.List, function (j, record) {
			listDataDrillDown.push([record.name, record.size]);
		});
		if (listDataDrillDown.length > 0) {
			drillDownData.push({
				name: item.name,
				id: item.name,
				data: listDataDrillDown
			});
		}
	});


	Highcharts.chart('divSSDChartOther', {
		chart: {
			type: 'pie',
			options3d: {
				enabled: true,
				alpha: 60,
				beta: 0
			}
		},
		title: {
			text: 'SSD Pool used for acceleration/cache',
			style: { "color": "black", "fontSize": "20px", fontWeight: 'bold' },
		},
		subtitle: {
			text: 'Click on storage type to see in details.'
		},
		exporting: {
			enabled: false
		},
		plotOptions: {
			series: {
				dataLabels: {
					enabled: true,
					format: '{point.name}: {point.y:.1f}%'
				}
			},
			pie: {
				allowPointSelect: true,
				cursor: 'pointer',
				depth: 35,
				dataLabels: {
					enabled: true,
					format: '{point.name}'
				}
			}
		},

		tooltip: {
			headerFormat: '<span style="font-size:11px">{series.name}</span><br>',
			pointFormat: '<span style="color:{point.color}">{point.name}</span>: <b>{point.y:.2f}%</b> of total<br/>'
		},
		series: [{
			name: 'Storage',
			colorByPoint: true,
			data: ssdOtherUsageData
		}],
		drilldown: {
			series: drillDownData
		}
	});
}

function InvokePythonService(request) {
	return new Promise(function (resolve, reject) {
		request.parameters.uuid = uuid;
		$.ajax({
			type: "Get",
			url: request.url,
			contentType: 'application/json',
			dataType: 'json',
			headers: { 'Access-Control-Allow-Origin': '*' },
			data: request.parameters,
			success: function (response) {
				resolve(response);
			},
			error: function (ex) {
				reject(ex); // Reject the promise and go to catch()
				if (!isProduction) {
					console.log(ex);
				}
			}
		});
	});
}
var diskUploadId = '';
function openConfigfileUpload(diskid) {
	diskUploadId = diskid;
	$('#fileUploadIfSrc').attr('src', 'configfileUpload.html');
	$('#divFileUpload').modal('show');
}
function OnOffDisks(disk, status) {
	//console.log("Disk : ", disk, " Status : ", status);
	var request = new Request();
	request.url = "cgi/cgi_DiskStatusViewActionManager.py"
	request.statusType = "onOff_Disk";
	request.parameters = { "requestType": 'onOff_Disk', 'diskid': disk, "status": status };
	CallPythonService(request);
}
function ejectDisk(disk) {
	//console.log("ejected disk : ", disk);
	swal({
		title: "Are you sure?",
		text: "You want to eject the DISK!",
		type: "warning",
		showCancelButton: true,
		confirmButtonClass: "btn-danger",
		confirmButtonText: "Yes, eject it!",
		cancelButtonText: "No, cancel please!",
		closeOnConfirm: false,
		closeOnCancel: false
	  },
	  function(isConfirm) {
		if (isConfirm) {
			var request = new Request();
			request.url = "cgi/cgi_DiskStatusViewActionManager.py"
			request.statusType = "eject_Disk";
			request.parameters = { "requestType": 'eject_Disk', 'disk': disk };
			CallPythonService(request);
		} else {
		  swal("Cancelled", "Your Disk is safe :)", "error");
		}
	  });
	
}

$('input[name="serverComponents"]').on('click', function () {
	var component = $(this).attr('component');
	var request_url = 'cgi/cgi_statusView.py';
	var request_type= "read_component";
	var request_statusType = "ReadComponent";
	if(component=="hotswap") {
		request_url = "cgi/cgi_DiskStatusViewActionManager.py";
		var request_type= "hotswap";
		var request_statusType = "HotSwapButton";
		var title = $(this).attr('data-original-title');
		var request = new Request();
		request.parameters = { "requestType": request_type, "component": component, "title": title };
		request.url = request_url;
		request.statusType = request_statusType;
		request.isSingleStatus = false;
		CallPythonService(request);
	}
	else if(component=="reset" || component=="onoff"){
		request_type = "onOffReset";
		request_statusType = "onOffReset"; 
		swal({
			title: "Please enter the password",
			html: true,
			text: "<input type='password' class='form-control' id='confirm-password' placeholder='Password'>",
			showCancelButton: true,
			closeOnConfirm: false,
		  	closeOnCancel: false,
			width: 100,
			animation: "slide-from-top"
		},
			function(isConfirm) {
				if (isConfirm) {
					var password = btoa(parent.$('#confirm-password').val());
					var sessionData =JSON.parse(sessionStorage.getItem("sessionData"));	
					var user_id = sessionData['Userid'];
					var title = $(this).attr('data-original-title');

					var request = new Request();
					request.parameters = {  "requestType": request_type, "component": component, "title": title,  "userId":user_id, "password":password};
					request.url = request_url;
					request.isSingleStatus = false;
					request.statusType = request_statusType;
					CallPythonService(request);
				} else {
				  	parent.swal("Cancelled", "", "error");
				}
		});
	}
	else {
		var title = $(this).attr('data-original-title');
		var request = new Request();
		request.parameters = { "requestType": request_type, "component": component, "title": title };
		request.url = request_url;
		request.statusType = request_statusType;
		request.isSingleStatus = false;
		CallPythonService(request);
	}
});

function showDiskInfo(disk)
{
	var request = new Request();
	request.url = "cgi/cgi_DiskStatusViewActionManager.py"
	request.statusType = "diskInfo";
	request.parameters = { "requestType": 'diskInfo', 'diskid': disk };
	CallPythonService(request);
}

function getStorageInfo(id){
	var request = new Request();
	request.url = "cgi/cgi_statusView.py"
	request.statusType = "read_StoragePoolsById";
	request.parameters = { "requestType": 'read_StoragePoolsById', id};
	CallPythonService(request);
}	
function rebootStorage(id){
	swal({
		title: "Are you sure?",
		text: "You want to Rebuild the Pool!",
		type: "warning",
		showCancelButton: true,
		confirmButtonClass: "btn-danger",
		confirmButtonText: "Yes, reboot it!",
		cancelButtonText: "No, cancel please!",
		closeOnConfirm: false,
		closeOnCancel: false
	},
	function(isConfirm) {
		if (isConfirm) {
			var request = new Request();
			request.url = "cgi/cgi_statusView.py"
			request.statusType = "reboot_StoragePool";
			request.parameters = { "requestType": 'reboot_StoragePool', id};
			CallPythonService(request);
		}
		else {
			parent.swal("Cancelled", "", "error");
	  }
	})
}	
