#!/usr/bin/python

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
import subprocess
from db import *
from clearTextPwd import *
from logRoutine import *
initLogging()

form = cgi.FieldStorage()
request_Type = form.getvalue('RequestType')
cmd_Id = get_ccm_command_id()

CCM = False

def updateSystemName(system_name):
    FileName = "/etc/hosts"
    old_system_name = getSystemName()

    process = subprocess.check_output(['sudo','chmod','777',FileName])

    process = subprocess.check_output(['sudo','hostnamectl','set-hostname',system_name])

    with open(FileName) as f:
        newText=f.read().replace(old_system_name, system_name)

    with open(FileName, "w") as f:
        f.write(newText)

def getCanisterSerialNumber(CanDBFileName):
    canisterSerial=""
    CheckFile = CanDBFileName
    isfile=os.path.isfile(CheckFile)
    if isfile==True:
        f_size=os.path.getsize(CheckFile)
        if f_size==0:
            process = subprocess.check_output(["rm",CheckFile])
            isfile=os.path.isfile(CheckFile)
            canisterSerial = None
            #return "NoDB"
        else:
            try:
                Fconn = sqlite3.connect(CanDBFileName)
                Fconn.text_factory = str
                Fconn.execute('pragma foreign_keys=ON')
                Fc = Fconn.cursor()
                query = Fc.execute("select serial_number from system")
                canisterSerial = Fc.fetchone()[0]
                Fc.close()
                Fconn.close()
            except Exception as e:
                Fc.close()
                Fconn.close()
    else:
        canisterSerial = None
    
    
    return canisterSerial


def getSystemName():
    system_name = "n/a"
    process1 = subprocess.check_output(["hostnamectl"])
    output = process1.splitlines()
    for line in output:
        if "Static hostname" in line.split(':')[0].strip():
            system_name = line.split(':')[-1].strip()
    return system_name


def create_MachineSetupServices():
    system_name = form.getvalue('system_name')
    controller_name = form.getvalue('controller_name')
    #canister_serial = form.getvalue("canister_sl")

    if system_name != "" and controller_name!='' and system_name and controller_name:
        try:
            updateSystemName(system_name)
        except Exception as e:
            print json.JSONEncoder().encode({"status": "fail", "description": "Error while updating the system name: {}".format(e)})
            return
        query_lan = c.execute("update system set name='" + str(system_name) + "'")
        conn.commit()
        query_lan = c.execute("update controller set name='" + str(controller_name) + "'")
        conn.commit()
        print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully"})
    else:
        print json.JSONEncoder().encode({"status": "fail", "description": "Fill All mandatory fields"})

    c.close()
    conn.close()


def read_MachineSetupServices():
    canDbFilename = "/mnt/system/quantumDB.db"    

    dbquery = "SELECT c.name, s.serial_number from system s, controller c"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        system_name = getSystemName()
        canisterSerial= getCanisterSerialNumber(canDbFilename)
        jsonschema = {"system_name": system_name, "controller_name": col[0], "serial_number":col[1],"canister_serial":canisterSerial}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def updateCanister():
    userId = form.getvalue('userId')
    password = form.getvalue('password')
    #print"Password",password
    decoded_password = password.decode('base64')
    password = decoded_password

    query_pwd = c.execute("select password from person where id=?",[userId])
    db_Pwd = c.fetchone()[0]
    conn.commit()
    isEnPwd = is_EncodedString_base64(db_Pwd)
    
    if isEnPwd :
        EncryptGUIpwd = pwd_encoding(password)
        password = EncryptGUIpwd

    query=c.execute("SELECT * from person where id=? and password=?",[userId,password])
    isValidCredentials=c.fetchall()

    if isValidCredentials:
        sys_serial = c.execute("select serial_number from system")
        for col in c:
            serial_number=col[0] 
        canDbFilename = "/mnt/system/quantumDB.db"
        try:
            Fconn = sqlite3.connect(canDbFilename)
            Fconn.text_factory = str
            Fconn.execute('pragma foreign_keys=ON')
            Fc = Fconn.cursor()
            dbquery=Fc.execute("update system set serial_number='"+serial_number+"'")
            Fconn.commit()
            Fc.close()
            Fconn.close()
            print json.JSONEncoder().encode({"status": "success", "description": "Saved successfully","serial_number":serial_number})
        except Exception as e:
            Fc.close()
            Fconn.close()
            print json.JSONEncoder().encode({"status": "fail", "description": e})
    else:
        print json.JSONEncoder().encode({"status": "fail", "description": "Invalid Credentials"})
    conn.close()

print ("Content-type:text/html\r\n\r\n")
if request_Type == 'create_MachineSetupServices':
    create_MachineSetupServices()
elif request_Type == 'read_MachineSetupServices':
    read_MachineSetupServices()
elif request_Type=="updateCanister":
    updateCanister()
else:
    print json.JSONEncoder().encode({"status": "fail", "description": "test"})
