#!/usr/bin/python

import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from db import *
from globalSettings import *
from logRoutine import *
initLogging()

###########################
#Libraries added for rclone
###########################
import subprocess
import os
import datetime
###########################

form = cgi.FieldStorage()
request_Type=form.getvalue('requestType')
#startDir = "/mnt/lo_lv1/nfsvolume"
startDir = "/mnt/lv2"

def backupToMinio(scheduleName,sourceDirectories,minio_host):
    now = datetime.now()
    dt_string = now.strftime("%d-%m-%Y %H:%M:%S")
    FNULL = open(os.devnull, 'w')
    FNULL = open("rclone.txt", 'w')
    sourceDirs = ''
    for x in sourceDirectories:
        sourceDirs += '--include "' + x + '/**" ' 
    command='sudo rclone --config "{}" mkdir "{}":backup'.format(rclone_config_path,minio_host)
    proc = subprocess.Popen([command],shell=True,stdout=FNULL,stderr=subprocess.STDOUT)
    
    command= 'sudo rclone --config "'+rclone_config_path+'" "'+startDir+'" "'+minio_host+'":backup/"bkp ' + dt_string+'/" '+sourceDirs
    proc = subprocess.Popen([command],shell=True,stdout=FNULL,stderr=subprocess.STDOUT)

def pathto_dict(path):
    for root, dirs, files in os.walk(path, topdown=True):
        tree = {"root": root,"name": root.split('/')[-1], "type":"folder", "children":[]}
        tree["children"].extend([pathto_dict(os.path.join(root, d)) for d in sorted(dirs)])
        return tree
        
def GetEmailState():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    try:
        c.execute("select state from email_logs")
        state = c.fetchone()[0]
        if state == 0:
            return state
    except Exception as e:
        return 2
    c.close()
    conn.close()

    #return 2

def save_schedule():
    scheduleName=form.getvalue('scheduleName')
    frequency = form.getvalue('frequency')
    startTime = str(form.getvalue('startTime'))
    startDate=form.getvalue('startDate')
    action = form.getvalue('action')
    endDate = form.getvalue('endDate')  
    backup = form.getvalue('backup')
    VMIds = form.getvalue('VMIds')
    volId = form.getvalue('volId')
    volDestId = form.getvalue('volDestId')
    scheduleId = form.getvalue('scheduleId')
    sourceDirectories = form.getvalue('sourceDirectories')

    if frequency=="At Canister Insert":
        endDate=T_next=None
        startDateFormat = "%Y-%m-%d"
        startTimeFormat = "%H:%M"
        startDate = str(datetime.datetime.utcnow().strftime(startDateFormat))
        startTime = str(datetime.datetime.utcnow().strftime(startTimeFormat))
        # T_next=startDate+" "+startTime
        # endDate = startDate
        
    else:
        t_now_date = datetime.datetime.utcnow().date()
        t_now = datetime.datetime.utcnow()
        
        start_time_object = datetime.datetime.strptime('{} {}'.format(startTime, startDate), '%H:%M %Y-%m-%d') + datetime.timedelta(minutes=2)
        end_date_object = datetime.datetime.strptime('{}'.format(endDate), '%Y-%m-%d').date()

        
        if start_time_object < t_now:
            print json.JSONEncoder().encode({"status":"fail","description":"Failed, start date&time is before current date&time."})
            return 0
        
        if end_date_object < t_now_date or end_date_object < start_time_object.date():
            print json.JSONEncoder().encode({"status":"fail","description":"Failed,end date is before current date&time (or) end date is before start date."})
            return 0
        T_next=startDate+" "+startTime
    
    status="stopped"
    done_percentage=0


    if action == "Email Logs":
        EmailState=GetEmailState()
        if EmailState !=0:
            print json.JSONEncoder().encode({"status":"fail","description":"Failed, no valid Email configuration"})
            return 0
            
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()

    if frequency=="At Canister Insert" and action in['Local Backup',"File Server Backup","Backup System"]:
        c.execute("select count(*) from schedule where frequency='At Canister Insert' and action='"+action+"' and isdeleted!=1")
        count = c.fetchone()[0]
        if count!=0:
            print(json.JSONEncoder().encode({"status":"fail","description":"At Canister Insert {} is already scheduled".format(action)}))
            c.close()
            conn.close()
            return

    if action == "Local Backup":
        validStates = [6,8,10,12]
        c.execute("select state from volume where id='"+volDestId+"'")
        volDestState = int(c.fetchone()[0])
        if volDestState not in validStates:
            print json.JSONEncoder().encode({"status":"fail","description":"Failed,Destination volume not in running state."})
            c.close()
            conn.close()
            return
        if frequency!="At Canister Insert":
            c.execute("select state from volume where id='"+volId+"'")
            volSrcId = int(c.fetchone()[0])
            if volSrcId not in validStates:
                print(json.JSONEncoder().encode({"status":"fail","description":"Failed,Source volume not in running state."}))
                c.close()
                conn.close()
                return

    query_lan=c.execute("select count(*) from schedule where name='"+ scheduleName+"' and isdeleted!=1")
    nameCount = c.fetchone()[0]
    conn.commit()
    
    if nameCount == 0:
        if scheduleName!="":
            query_lan=c.execute("insert into schedule (name,frequency,start_time,start_date,end_date,action,action_element,status,vm_id,t_next,done_percentage,isdeleted,vol_id,vol_dest_id,dirs) values(?,?,?,?,?,?,?,?,?,?,?,0,?,?,?)",[scheduleName,frequency,startTime,startDate,endDate,action,backup,status,VMIds,T_next,done_percentage,volId,volDestId,sourceDirectories])
            conn.commit()
            dArgs=loggerArgs("schedule/" + "schedulerManager",scheduleName,infoLevel,"create")
            ccmLogger(info,"successfully saved " + scheduleName,dArgs)
            print json.JSONEncoder().encode({"status":"success","description":"Saved successfully"})
        else:
            dArgs=loggerArgs("schedule/" + "schedulerManager","scheduleName",errorLevel,"create")
            ccmLogger(error,"Fill All mandatory fields",dArgs)
            print json.JSONEncoder().encode({"status":"fail","description":"Fill All mandatory fields"})
    else:
        dArgs=loggerArgs("schedule/" + "schedulerManager","scheduleName",errorLevel,"create")
        ccmLogger(error,"Schedule Name Already Exists",dArgs)
        print json.JSONEncoder().encode({"status":"fail","description":"Schedule Name Already Exists"})
    c.close()
    conn.close()
    
def update_schedule():

    scheduleName=form.getvalue('scheduleName')
    frequency = form.getvalue('frequency')
    startTime = str(form.getvalue('startTime'))
    startDate=form.getvalue('startDate')
    action = form.getvalue('action')
    endDate = form.getvalue('endDate')  
    backup = form.getvalue('backup')
    VMIds = form.getvalue('VMIds')
    volId = form.getvalue('volId')
    volDestId = form.getvalue('volDestId')
    scheduleId = form.getvalue('scheduleId')
    sourceDirectories = form.getvalue('sourceDirectories')

    if frequency=="At Canister Insert":
        endDate=T_next=None
        startDateFormat = "%Y-%m-%d"
        startTimeFormat = "%H:%M"
        startDate = str(datetime.datetime.utcnow().strftime(startDateFormat))
        startTime = str(datetime.datetime.utcnow().strftime(startTimeFormat))
        

    else:
        t_now_date = datetime.datetime.utcnow().date()
        t_now = datetime.datetime.utcnow()
        
        start_time_object = datetime.datetime.strptime('{} {}'.format(startTime, startDate), '%H:%M %Y-%m-%d') + datetime.timedelta(minutes=2)
        end_date_object = datetime.datetime.strptime('{}'.format(endDate), '%Y-%m-%d').date()

        
        if start_time_object < t_now:
            print json.JSONEncoder().encode({"status":"fail","description":"Failed, start date&time is before current date&time."})
            return 0
        
        if end_date_object < t_now_date or end_date_object < start_time_object.date():
            print json.JSONEncoder().encode({"status":"fail","description":"Failed, end date is before current date&time (or) end date is before start date."})
            return 0

        T_next=startDate+" "+startTime
    

    status="stopped"
    done_percentage=0
    
    if action == "Email Logs":
        EmailState=GetEmailState()
        if EmailState !=0:
            #dArgs=loggerArgs(handler_log, "Schedule-EmailLogs",10,"update")
            #ccmLogger(schLogger,3,"No valid Email configuration",dArgs)
            print json.JSONEncoder().encode({"status":"fail","description":"Failed, no valid Email configuration"})
            #c.close()
            #conn.close()
            return
    
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    
    if frequency=="At Canister Insert" and action in['Local Backup',"File Server Backup","Backup System"]:
        c.execute("select count(*) from schedule where frequency='At Canister Insert' and action='"+action+"' and isdeleted!=1 and id!="+scheduleId+"")
        count = c.fetchone()[0]
        if count!=0:
            print(json.JSONEncoder().encode({"status":"fail","description":"At Canister Insert {} is already scheduled".format(action)}))
            c.close()
            conn.close()
            return
    
    if action == "Local Backup":
        validStates = [6,8,10,12]
        c.execute("select state from volume where id='"+volDestId+"'")
        volDestState = int(c.fetchone()[0])
        if volDestState not in validStates:
            print json.JSONEncoder().encode({"status":"fail","description":"Failed,Destination volume not in running state."})
            c.close()
            conn.close()
            return
        if frequency!="At Canister Insert":
            c.execute("select state from volume where id='"+volId+"'")
            volSrcId = c.fetchone()[0]
            if volSrcId not in validStates:
                print(json.JSONEncoder().encode({"status":"fail","description":"Failed,Source volume not in running state."}))
                c.close()
                conn.close()
                return

    query = c.execute("select count(*) from schedule where name='"+(scheduleName)+"' and isdeleted!=1 and id!="+scheduleId+"")

    counter = c.fetchone()[0]

    if counter == 0:
    
        query_lan=c.execute("Update schedule set name=?,frequency=?,start_time=?,start_date=?,end_date=?,action=?,action_element=?,vm_id=?,vol_id=?,vol_dest_id=?,dirs=?,status=?,done_percentage=0,t_next=? where id=?",(scheduleName,frequency,startTime,startDate,endDate,action,backup,VMIds,volId,volDestId,sourceDirectories,status,T_next,scheduleId))
        conn.commit()
        dArgs=loggerArgs("schedule/" + "schedulerManager",scheduleName,infoLevel,"update")
        ccmLogger(info,"updated successfully " + scheduleName,dArgs)
        print json.JSONEncoder().encode({"status":"success","description":"Updated successfully"})
    else:
        print json.JSONEncoder().encode({"status":"fail","description":"Schedule Name Already Exist"})
    c.close()
    conn.close()
    
def read_schedule():
    scheduleId=form.getvalue('scheduleId')
    ''' 
    #Before Changing the query
    if scheduleId != str(0) :
        dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name from schedule s INNER JOIN volume v on s.vol_id=v.id INNER JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  and s.id="+str(scheduleId)
    else:
        dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name from schedule s INNER JOIN volume v on s.vol_id=v.id INNER JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  --where action !='Email Logs'"
    '''
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()

    if scheduleId != str(0) :
        dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name,s.dirs from schedule s LEFT JOIN volume v on s.vol_id=v.id LEFT JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  and s.id="+str(scheduleId)
    else:
        dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name,s.dirs from schedule s LEFT JOIN volume v on s.vol_id=v.id LEFT JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  --where action !='Email Logs'"
    
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        if col[15] is None:
            dirs=''
        else:
            dirs=col[15]
        jsonschema = {"id":col[0],"name" : col[1],"frequency" :col[2],"start_time" : col[3],"start_date" : col[4],"end_date" : col[5],"action" :col[6],"status":col[7],"action_element":col[8],"vm_ID":col[9],"PerDone":col[10],"source_vol_id":col[11],"dest_vol_id":col[12],"source_vol":col[13],"dest_vol":col[14],"dirs":dirs.split(',,')[:-1]}
        dbdata.append(jsonschema)
    c.close()
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_scheduleInfo():
    scheduleId=form.getvalue('scheduleId')

    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    
    dbquery="""
            select A.id,A.schedule_id,A.vol_dest_id,A.complete_date,A.complete_time,A.result,ifnull(v.name,'n/a') from (
            select sh.id,sh.schedule_id,sh.complete_date,sh.complete_time,sh.result,s.vol_dest_id  from schedule_history sh
            inner join schedule s on s.id=sh.schedule_id
            where sh.schedule_id="""+scheduleId+""")A
            LEFT JOIN volume v on v.id=A.vol_dest_id
            """ 
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"date" : col[3],"time" :col[4],"result" : col[5],"dest_vol":col[6]}
        dbdata.append(jsonschema)
    c.close()
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def delete_schedule():
    conn=sqlite3.connect(DBPath)
    conn.text_factory=str
    c=conn.cursor()
    scheduleId = form.getvalue('scheduleId')
    
    query_lan=c.execute("select count(*) from schedule where status='running' and id="+str(scheduleId)+"")
    nameCount = c.fetchone()[0]
    conn.commit()
    if nameCount == 0:
        #query_lan=c.execute("Update schedule set isDeleted=1 where id="+str(scheduleId))
        query_lan = c.execute("delete from schedule where id="+str(scheduleId))
        conn.commit()
        query_info = c.execute("delete from schedule_history where schedule_id="+str(scheduleId))
        conn.commit()
        dArgs=loggerArgs("schedule/" + "schedulerManager","delete schedule",infoLevel,"delete")
        ccmLogger(info,"Deleted successfully",dArgs)
        print json.JSONEncoder().encode({"status":"success","description":"Deleted successfully"})
    else:
        query_lan=c.execute("Update schedule set status='finished' where id="+str(scheduleId))
        conn.commit()
        print json.JSONEncoder().encode({"status":"fail","description":"Cannot delete a running Schedule, setting status to finished."})
    c.close()
    conn.close()
        
def scheduleRestore():
    #scheduleId = form.getvalue('scheduleId')
    #schRestorPoint = form.getvalue('sch_result')
    #schSourceVol = form.getvalue('sch_SrcVol')
    #schDestinationVol = form.getvalue('sch_DestVol')
    restore=False
    if restore==True:
        print json.JSONEncoder().encode({"status":"success","description":"Success"})
    else:
        print json.JSONEncoder().encode({"status":"fail","description":"No restore point found"})

def readDirectories():
    volId = form.getvalue('volId')
    if volId==None:
        pathDir=None
        desc = "Success"
        print json.JSONEncoder().encode({"status":'success',"description":desc,"Directory":pathDir})    
        return
    query_lan=c.execute("select name from volume where id="+str(volId)+"")
    vol_name = c.fetchone()[0]
    conn.commit()
    global startDir
    startDir = os.path.join('/mnt',vol_name)
    if not os.path.exists(startDir):
        status,desc = 'fail', "Directory doesn't exist" 
        print json.JSONEncoder().encode({"status":status,"description":desc,"Directory":desc})
        return 0
    if not os.listdir(startDir):
        status,desc = 'fail', "Directory doesn't contain any files"
        print json.JSONEncoder().encode({"status":status,"description":desc,"Directory":desc})
        return 0
    #Using hardcoded path now - otherwise extract from the volume ID
    # startDir = "/home/ubuntu/nfsvolume"
    pathDir = pathto_dict(startDir)
    desc = "Success"
    print json.JSONEncoder().encode({"status":'success',"description":desc,"Directory":pathDir})

print ("Content-type:text/html\r\n\r\n")

if request_Type == 'save_schedule':
    save_schedule()
elif request_Type == 'update_schedule':
    update_schedule()
elif request_Type == 'read_schedule':
    read_schedule()
elif request_Type == 'delete_schedule':
    delete_schedule()
elif request_Type == 'read_scheduleInfo':
    read_scheduleInfo()
elif request_Type == 'restore_schedule':
    scheduleRestore()
elif request_Type == 'read_Directories':
    readDirectories()

