#!/usr/bin/python   

import cgi, cgitb
from global_gui_data import *
from globalSettings import *
from global_func import *
import json
from db import *

cgitb.enable()
import sqlite3


form = cgi.FieldStorage()
SectionName=form.getvalue('SectionName')

def getPoolStatus(state):
    state = int(state)
    if state==0:
        return "Good"
    elif state==1:
        return "Degraded"
    elif state==2:
        return "Critical"
    else:
        return "Rebuilding"

def getPoolLevel(lvl):
    if lvl == '0':
        return '0'
    elif lvl == '1':
        return '5'
    elif lvl == '2':
        return '6'
    else:
        return 'n/a'
    
def getStorageDetails(raw, pool_storage, lvl):
    protectedStorage = pool_storage
    rawStorage = raw
    if lvl > 0:
        rawStorage = '0 GB'
        protectedStorage = str(pool_storage) + ' GB'
    else:
        rawStorage = str(raw) + ' GB'
        protectedStorage = '0 GB'
    return rawStorage, protectedStorage

def getNbDisks(systemName):
    return "4"
    
def getCanisterSerialNumber(CanDBFileName):
    canisterSerial=""
    CheckFile = CanDBFileName
    isfile=os.path.isfile(CheckFile)
    if isfile==True:
        f_size=os.path.getsize(CheckFile)
        if f_size==0:
            process = subprocess.check_output(["rm",CheckFile])
            isfile=os.path.isfile(CheckFile)
            canisterSerial = None
            #return "NoDB"
        else:
            try:
                Fconn = sqlite3.connect(CanDBFileName)
                Fconn.text_factory = str
                Fconn.execute('pragma foreign_keys=ON')
                Fc = Fconn.cursor()
                query = Fc.execute("select serial_number from system")
                canisterSerial = Fc.fetchone()[0]
                Fc.close()
                Fconn.close()
            except Exception as e:
                Fc.close()
                Fconn.close()
    else:
        canisterSerial = None
    
    
    return canisterSerial

def get_dbdata():
    if SectionName == 'Network':
        dbquery="select id,name,cidr,enable_dhcp from network"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            name = col[1]
            if name == "Management":
                name = "IPMI Port"
            jsonschema = {"col0":col[0],"col1" :name,"col2" :col[2],"col3":col[3]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Network","Section":SectionName,"header":["Name","CIDR","Enable DHCP"],"colWidth":[4,4,4],"data":dbdata})

    
    elif SectionName == 'OrgGroup':
        dbquery="select id,Name,Description from OrgGroup"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3":"ViewRoles("+str(col[0])+")"}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Organization Groups","Section":SectionName,"header":["Name","Description","Action"],"colWidth":[4,4,4],"data":dbdata})
        
    elif SectionName == 'OrgRole':
        dbquery="select id,Name,Description from OrgRole"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3":"ViewUsers("+str(col[0])+")"}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Organization Roles","Section":SectionName,"header":["Name","Description","Action"],"colWidth":[4,4,4],"data":dbdata})
        
    elif SectionName == 'OrgUsers':
        dbquery="select id,userName,FirstName,LastName,contactEmail from person"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[3],"col4" :col[4]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Organization Peoples","Section":SectionName,"header":["User Name","First Name","Last Name","Email"],"colWidth":[3,3,3,3],"data":dbdata})
        
    elif SectionName == 'StoragePools':
        dbquery = "select id,name,level,0 available,deduplication,compression,(case when acceleration_storage > 0 then ROUND(acceleration_storage,2)|| ' GB' WHEN acceleration_storage <= 0 AND name='HDD POOL' then 'No' else 'N/A' end),system_name,ifnull(calculatedraw,0),state,pool_storage,ifnull(encryption,'n/a') from multi_device where name!='system'"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            rawStorage, protectedStorage = getStorageDetails(int(col[8]),int(col[10]), int(col[2]))
            jsonschema = {"col0": col[0], "col1": str(col[7]), "col2": col[1], "col3": rawStorage, "col4": protectedStorage, "col5": getPoolStatus(str(col[9])), "col6": getPoolLevel(str(col[2])), "col7": getNbDisks(str(col[7])), "col8": col[4], "col9": col[11], "col10": col[5], "col11": str(col[6])}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title": "Storage Pools", "Section": SectionName, "header": ["Pool", "Type", "Raw Storage", "Protected Storage", "Status", "Raid Level", "#Disks", "Dedup","Encryp","Compr","Acc"], "colWidth": [1, 2, 1, 1, 1, 1, 1, 1,1,1,1], "data": dbdata})
    
    elif SectionName == 'MachineSetupService':
        canisterSerial= getCanisterSerialNumber("/mnt/system/quantumDB.db")
        dbquery="select 0,s.name,c.name,s.serial_number from controller c, system s"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3":col[3],"col4":canisterSerial}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["System Name","Controller Name","Serial Number","Canister Searial Number"],"colWidth":[4,4,4,4],"data":dbdata})

    elif SectionName == 'BackupServices':
        dbquery="select id,destination_name,ip_address,account_name from backup"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[3]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["Destination","IP Address","Account Name"],"colWidth":[4,4,4],"data":dbdata})

    elif SectionName == 'EmailServices':
        dbquery="select id,recipient_email,sender_email,smtp_server,port,alert_type from email_logs"	
        #dbquery="select id,sender_email,smtp_server,port,alert_type from email_logs"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2],"col3":col[3],"col4":col[4],"col5":col[5].replace(';',', ')}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["Recipient Email","Sender Email","SMTP Server","Port","Alert Type"],"colWidth":[3,3,2,2,2],"data":dbdata})

    elif SectionName == 'CBAServices':
        dbquery = "SELECT id,upper(enableCBA),upper(enableSSH) from cbaServer"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["Enable CBA", "Enable SSH"],"colWidth":[6,6],"data":dbdata})
        
    elif SectionName == 'NTPServices':
        #dbquery = "SELECT time_zone_val,time_zone,ntp_time_zone,ntp_server from ntpServer"
        dbquery = "SELECT 0,time_zone,ntp_server from ntpServer"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            #jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2],"col3":col[3]}
            jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["Time Zone","NTP Server"],"colWidth":[6,6],"data":dbdata})

    elif SectionName == 'KMIPServices':
        dbquery = "SELECT id,userName,host,port from kmipServer"
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1":col[1],"col2":col[2],"col3":col[3]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Services","Section":SectionName,"header":["User name","Host","Port"],"colWidth":[4,4,4],"data":dbdata})
    
    elif SectionName == 'Hardware':
        dbquery="select 0,'Fan1','0','0'"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[3]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Att1","Att2"],"colWidth":[4,4,4],"data":dbdata})
    
    elif SectionName == 'HardwareTemperature':
        dbquery='''Select id,name,ifnull(location,'System'),ifnull(temperature,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(min,0),ifnull(max,0),ifnull([default],0) from cpu where name='CPU'
                    union all
                Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull([temp_default],0) from disks where name not like 'sd%'
                    union all
                Select id,name,ifnull(location,'System'),ifnull(temp,0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull([default],0) from temp_probes
        '''	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            #jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : NameConversions('Temperature',col[3]),"col4" : col[8],"col5" :col[4],"col6" : col[5]}
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : getTemperatureValue(NameConversions('Temperature',col[8]),col[3]),"col4" : NameConversions('Temperature',col[8]),"col5" :col[4],"col6" : col[5]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Temperature","Type","Low Threshold","High Threshold"],"colWidth":[2,2,2,2,2,2],"data":dbdata})
        
    elif SectionName == 'HardwareFans':
        dbquery='''Select id,name,location,ifnull([default],0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull(speed,0) from fan
        '''	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0":col[0],"col1" : col[1],"col2" :col[2],"col3" : col[8],"col4" : col[3],"col5" :col[4],"col6" : col[5]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Speed","Default","Low Threshold","High Threshold"],"colWidth":[2,2,2,2,2,2],"data":dbdata})
        
    elif SectionName == 'HardwareNetwork':
        dbquery='''Select id,name,location,ifnull(tx_rx_monitor,0),ifnull(err_threshold,50),ifnull(err_max,0),ifnull(tx_rx_default,10) from eth_ports where name!='IPMI'
        '''	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            name = col[1]
            if name == "Management":
                name = "IPMI Port"
            jsonschema = {"col0":col[0],"col1" :name,"col2" :col[2],"col3" : NameConversions('Monitor',col[3]),"col4" : col[6],"col5" :col[4]}
            dbdata.append(jsonschema)
        conn.close()
        #return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Monitor","Max Error Rate / min","Warning Error Rate / min"],"colWidth":[2,2,2,3,3],"data":dbdata})
        return json.JSONEncoder().encode({"Title":"Hardware","Section":SectionName,"header":["Name","Location","Monitor","Warning Error Rate / min","Max Error Rate / min"],"colWidth":[2,2,2,3,3],"data":dbdata})
        
    
    elif SectionName == 'HardwareStroage':
        dbquery = '''Select id,system_name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,50),ifnull(err_max,0),ifnull(tx_rx_default,10) from multi_device where name!='system'
        union all
        Select id,name,ifnull(location,'System'),ifnull(tx_rx_monitor,0),ifnull(err_threshold,50),ifnull(err_max,0),ifnull([tx_rx_default],10) from disks where name not like 'sd%'
        '''
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            jsonschema = {"col0": col[0], "col1": col[1], "col2": col[2], "col3": NameConversions(
                'Monitor', col[3]), "col4": col[6], "col5": col[4]}
            dbdata.append(jsonschema)
        conn.close()
        #return json.JSONEncoder().encode({"Title": "Hardware", "Section": SectionName, "header": ["Name", "Location", "Monitor", "Max Error Rate / min", "Warning Error Rate / min"], "colWidth": [2, 2, 2, 3, 3], "data": dbdata})
        return json.JSONEncoder().encode({"Title": "Hardware", "Section": SectionName, "header": ["Name", "Location", "Monitor", "Warning Error Rate / min","Max Error Rate / min"], "colWidth": [2, 2, 2, 3, 3], "data": dbdata})

    elif SectionName == 'PortGroups':
        dbquery="Select id,name,ip,netmask,ifnull(mtu_size,0),enable_port,dhcp_enabled from eth_ports order by name"	
        query = c.execute(dbquery)
        dbdata = []
        conn.commit()
        for col in c:
            name = col[1]
            if name == "Management":
                name = "IPMI Port"
            jsonschema = {"col0":col[0],"col1" :name,"col2" :col[2],"col3" : col[3],"col4" :col[4],"col5" : col[5],"col6" : col[6]}
            dbdata.append(jsonschema)
        conn.close()
        return json.JSONEncoder().encode({"Title":"Ethernet Status","Section":SectionName,"header":["Name","IP Address","Net Mask","MTU Size","Enabled","DHCP"],"colWidth":[2,2,2,2,2,2],"data":dbdata})
    
        
def NameConversions(Title,type):
    if Title == 'Temperature':
        #if type == 'F':
        if type == 'f':
            return 'Fahrenheit'
        #elif type == 'Celcius':
        elif type == 'c':
            return 'Celcius'
        else:
            return TemperatureType  #read default type from globalSettings
    elif Title == 'Monitor':
        if type == 0:
            return 'OFF'
        elif type == 1:
            return 'ON'
        else:
            return ''
            

def convertTemperature(fromTemp, to, value):
    if fromTemp=='Celcius' and to=='Fahrenheit':
        value = (value * 9/5) + 32
    elif fromTemp=='Fahrenheit' and to=='Celcius':
        value = (value - 32) * 5/9
    
    return value

def getTemperatureValue(Temptype, value):
    if Temptype=="Celcius": #read default type from globalSettings
        return str(value)+"&#176; C"  #&#176; is html code for deg symbol 
    else:
        value = convertTemperature("Celcius","Fahrenheit",value)
        return str(value)+"&#176; F"

def fakedata():
    mockdata	= []
    return json.JSONEncoder().encode(mockdata)

print("Content-type:text/html\r\n\r\n")

if (gui_data=='DB'):
    print(get_dbdata())	

elif(gui_data=='FAKE'):
    print(fakedata())

else:
    print("Invalid INPUT")
