#!/usr/bin/python   

import cgi, cgitb
from global_gui_data import *
from globalSettings import *
from global_func import *
from smartData import *
import json
from db import *
CCM=True
cgitb.enable()
import sqlite3
from clearTextPwd import *
form=cgi.FieldStorage()

request_Type=form.getvalue('requestType')
NORMAL_STATE = 0
def getPoolStatus(state):
    state = int(state)
    if state==0:
        return "Good"
    elif state==1:
        return "Degraded"
    elif state==2:
        return "Critical"
    else:
        return "Rebuilding"
    
def getStorageDetails(raw, pool_storage, lvl):
    protectedStorage = pool_storage
    rawStorage = raw
    if lvl > 0:
        rawStorage = '0 GB'
        protectedStorage = str(pool_storage) + ' GB'
    else:
        rawStorage = str(raw) + ' GB'
        protectedStorage = '0 GB'
    return rawStorage, protectedStorage

def getNbDisks(systemName):
    return "10"

def getRedundancy(PoolLevel):
    redundancy=0
    if int(PoolLevel)==1:
        redundancy=1
    if int(PoolLevel)==2:
        redundancy=2
    if int(PoolLevel)==3:
        redundancy=3
    return redundancy

def getTemperatureValue(Temptype, value):
    if Temptype=="Celcius": #read default type from globalSettings
        return str(value)+"&#176; C"  #&#176; is html code for deg symbol 
    else:
        value = convertTemperature("Celcius","Fahrenheit",value)
        return str(value)+"&#176; F"

def read_StatusAll():
    query = c.execute("SELECT name,state,speed,low_threshold,hi_threshold from fan")
    fandata = []
    conn.commit()
    for col in c:
        fandata.append(col[1])

    query = c.execute("SELECT name,state from cpu")
    cpudata=[]
    conn.commit()
    for col in c:
        jsonschema = {"name" : "cpu","state" :col[1]}
        cpudata.append(col[1])
    
    query = c.execute("SELECT name,state,temp,low_threshold,hi_threshold from temp_probes")
    temp_probesdata=[]
    conn.commit()
    for col in c:
        jsonschema = {"name" : "temp_probes","state" :col[1]}
        temp_probesdata.append(col[1])

    query = c.execute("SELECT name,state,speed,ip,netmask,port_id,tx_rx_monitor from eth_ports")	
    networkdata=[]	
    conn.commit()	
    for col in c:	
        state = col[1]	
        if str(col[6]) == "0":	
            state = NORMAL_STATE 	
        jsonschema = {"name" : "network","state" :state}	
        networkdata.append(state)	
    query = c.execute("SELECT name,state,ac_status,dc_status from psu")	
    psudata=[]	
    conn.commit()
    for col in c:
        jsonschema = {"name" : "psu","state" :col[1]}
        psudata.append(col[1])

    query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_1'")
    psudata1=[]
    conn.commit()
    for col in c:
        jsonschema = {"name" : "psu","state" :col[1]}
        psudata1.append(col[1])

    query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_2'")
    psudata2=[]
    conn.commit()
    for col in c:
        jsonschema = {"name" : "psu","state" :col[1]}
        psudata2.append(col[1])

    query = c.execute("SELECT name,state,vid,pid,prl,serial,size from disks")
    disksdata=[]
    conn.commit()
    for col in c:
        jsonschema = {"name" : "disks","state" :col[1]}
        disksdata.append(col[1])
        
    query=c.execute("select state from multi_device")
    poolData=[]
    conn.commit()
    for col in c:	
        state = col[0]		
        jsonschema = {"name" : "pool","state" :state}	
        poolData.append(state)
    conn.close()
    print json.JSONEncoder().encode({"fans":fandata,"cpu":cpudata,"network":networkdata,"psu":psudata,"psu1":psudata1,"psu2":psudata2,"disks":disksdata,"temp_probes":temp_probesdata,"pools":poolData})

def read_StatusFan():
    query = c.execute("SELECT name,state,speed,low_threshold,hi_threshold,location from fan")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"speed" : col[2],"low_threshold" : col[3],"hi_threshold" :col[4],"location":col[5]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_StatusTemp_probes():
    query = c.execute("SELECT name,state,temp,low_threshold,hi_threshold from temp_probes")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"temp" : getTemperatureValue(TemperatureType,col[2]),"low_threshold" : col[3],"hi_threshold" :col[4]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)
    
def read_StatusCPU():
    '''query = c.execute("SELECT name,state,temp,low_threshold,hi_threshold from temp_probes")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"temp" : col[2],"low_threshold" : col[3],"hi_threshold" :col[4]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)'''

    query = c.execute("SELECT cpu.name,cpu.state,cpu.controller_id,(case when cpu.location is NULL then 'N/A' else cpu.location end)location,\
        (case when cpu.cores is NULL then 'N/A' else cpu.cores end)cores,(case when cpu.cache_Size is NULL then 'N/A' else cpu.cache_Size end),\
            (case when cpu.temperature is NULL then 'N/A' else cpu.temperature end),(case when cpu.vendorId is NULL then 'N/A' else cpu.vendorId end),\
                (case when cpu.modelNum is NULL then 'N/A' else cpu.modelNum end),(case when cpu.cpu_Mhz is NULL then 'N/A' else cpu.cpu_Mhz end),controller.name from cpu inner join controller on controller.id=cpu.controller_id")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"controllerName" : col[10],"location" : col[3],"cores" :col[4],"cacheSize":col[5],"temperature":col[6],"vendorId":col[7],"modelNum":col[8],"cpuMhz":col[9]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def PortValue(cmd,port,param):
    if cmd=="get":
        _path = os.path.join("/sys/class/net/",port)
        path = os.path.join(_path,param)
        try:
            with open(path,"r") as f:
                val = f.read().strip()
            return val
        except Exception as err:
            #print "/sys/class/net/ except",port
            return 0
            
def read_portsStatus(portName):    
    _path = os.path.join("/sys/class/net/", portName)
    path = os.path.join(_path, 'operstate') #was carrier
    #/sys/class/net/enp46s0f0/operstate
    #state = 2
    state=""
    try:
        with open(path,"r") as f:
            state = str(f.read().strip())
            return state

    except Exception as e:
        return state

def read_StatusNetwork2():
    query = c.execute("SELECT name,state,speed,ip,netmask,port_id,tx_rx_monitor,system_name from eth_ports")
    dbdata = []
    conn.commit()
    for col in c:
        Mon= str(col[6])
        system_name=str(col[7])
        speed=PortValue("get",system_name,"speed")
        name = col[0]
        if name == "Management":
            name = "IPMI Port"
        state = col[1]
        if state==0:
            portState="Up"
        else:
            portState="Down"
        Monitor=str(Mon)
        Monitor=int(col[6])
        if str(Mon) == "0":  #1=ON, 0=OFF
            state = NORMAL_STATE

        jsonschema = {"name" : name,"state" :state,"speed" : speed,"ip" : col[3],"netmask" :col[4],"Monitor":Monitor,"port_id" :portState}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)


def read_StatusNetwork():
    query = c.execute("SELECT name,state,speed,ip,netmask,port_id,tx_rx_monitor,system_name, enable_port from eth_ports")
    dbdata = []
    conn.commit()
    for col in c:
        Mon= str(col[6])
        system_name=str(col[7])
        enable_port=str(col[8])
        #print "system name",system_name
        speed=PortValue("get",system_name,"speed")
        #speed="999"
        name = col[0]
        if name == "Management":
            name = "IPMI Port"
        state = col[1]
        #portState="Up"
        portState=PortValue("get",system_name,"operstate")
        Monitor=str(Mon)
        Monitor=int(col[6])
        if (str(Mon) == "0" or str(enable_port)=='No'):  #1=ON, 0=OFF
            state = NORMAL_STATE

        jsonschema = {"name" : name,"state" :state,"speed" : speed,"ip" : col[3],"netmask" :col[4],"Monitor":Monitor,"port_id" :portState}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def getDCstatus(dc):
    if dc == "0x00":
        return "OK"
    else:
        return "error"

def read_StatusPSU():
    query = c.execute("SELECT name,state,ac_status,dc_status from psu")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"ac_status" : col[2],"dc_status" : getDCstatus(str(col[3]))}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_StatusPSU1():
    query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_1'")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"ac_status" : col[2],"dc_status" : col[3]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_StatusPSU2():
    query = c.execute("SELECT name,state,ac_status,dc_status from psu where name='PSU_2'")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"ac_status" : col[2],"dc_status" : col[3]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_StatusDisks():	
    query = c.execute("SELECT d.name,d.state,d.vid,d.pid,d.prl,d.serial,d.size,d.id,d.location,d.wwn,(case when rotation=0 then 'NVMe' else 'HDD' end) rotation,ifnull(m.system_name,'n/a') from disks d left join multi_device m on  d.multi_device_id=m.id")
    dbdata = []
    conn.commit()
    for col in c:
        isCan = False #is canister
        if "can" in str(col[8]).lower():
            isCan = True
        
        jsonschema = {"name" : col[0],"state" :col[1],"vid" : col[2],"pid" : col[3],"prl" :col[4],"serial" :col[5],"size" :col[6],"id":col[7],"location":col[8],"wwn":col[9],"rotation":col[10],"pool":col[11],"isCan":isCan,"status":"OK"}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_DisksSMART_Data():
    mockdata    = [{"id":0,"headerData":{"HealthStatus":"Normal","Temprature":"53deg C","TestResult":"Success","SectorErrorCount":89},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"45","Threshold":"9","worst":"87","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"44","Normalized":"37","Threshold":"99","worst":"7","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"32","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"34","Normalized":"66","Threshold":"9","worst":"80","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"1","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"Fail"}]},
                   {"id":1,"headerData":{"HealthStatus":"Good","Temprature":"4deg C","TestResult":"Success","SectorErrorCount":50},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"8","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
                   {"id":2,"headerData":{"HealthStatus":"Weak","Temprature":"53deg C","TestResult":"Success","SectorErrorCount":8},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"76","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
                   {"id":3,"headerData":{"HealthStatus":"Good","Temprature":"3deg C","TestResult":"Success","SectorErrorCount":45},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
                   {"id":4,"headerData":{"HealthStatus":"Normal","Temprature":"33deg C","TestResult":"Success","SectorErrorCount":40},"Attributes":[{"Name":"Start/Stop Count","value":"3","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
                   {"id":5,"headerData":{"HealthStatus":"Fail","Temprature":"100deg C","TestResult":"Fail","SectorErrorCount":9},"Attributes":[{"Name":"Start/Stop Count","value":"3000","Normalized":"26","Threshold":"1","worst":"99","Type":"Old Age","Assessment":"OK"},{"Name":"Spin Retry Count","value":"35","Normalized":"66","Threshold":"6","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On Time","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Read error Rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Seek error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power On errors","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"SSD Erase fail count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Power loss protection failure","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Head stablility","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"High fly writes","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"Load cycle count","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"},{"Name":"G sense error rate","value":"3","Normalized":"66","Threshold":"9","worst":"99","Type":"Pre Fail","Assessment":"OK"}]},
                   ]
    disk = form.getvalue('disk')
    slot = str(form.getvalue('slot'))
    if "can" in slot.lower():
        slotnum = slot.split(':')[-1]
        slotnum = 4 + (int(slotnum)-1)*2 #1 is 4, 2 is 6, 3 is 8 and so on
        data = getMegaRAIDdrivesInfo(str(slotnum))
        data = [{'id':slot,"headerData":data["headerdata"],"data":data["drivedata"],"attributes":data["attributes"],"status":data["status"],"message":data["message"]}]
    else:
        data = getSmartData(disk)
    print json.JSONEncoder().encode(data)

def read_CanisterSMART_Data():
    slot = form.getvalue('slot')
    data = getMegaRAIDdrivesInfo(slot)
    data = [{'id':slot,"headerData":data["headerdata"],"data":data["drivedata"],"attributes":data["attributes"],"status":data["status"],"message":data["message"]}]

    #print json.JSONEncoder().encode({'description':data["message"],'data':data["drivedata"],'Attributes':data["attributes"]})
    print json.JSONEncoder().encode(data)

def read_Canister_Details():
    query = c.execute("SELECT name,state,vid,pid,prl,serial,size,id,location,wwn,(case when rotation=0 then 'SSD' else 'HDD' end) rotation from disks")
    dbdata = []
    conn.commit()
    for col in c:
        isCan = False #is canister
        if "can" in str(col[8]).lower():
            isCan = True
        jsonschema = {"name" : col[0],"state" :col[1],"vid" : col[2],"pid" : col[3],"prl" :col[4],"serial" :col[5],"size" :col[6],"id":col[7],"location":col[8],"wwn":col[9],"rotation":col[10],"isCan":isCan,"status":"OK"}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)

def read_Canister_Details2():
    list = getMegaRAIDslotList()
    data = []
    attributes = list[2]
    description = list[0]
    #print list[1]
    if description == 'success' and list[1]:
        for slot in list[1]:
            data.append(slot)

    #attributes, data, description = [], [], ''
    print json.JSONEncoder().encode({"attributes":attributes, "data" : data, "description" :description})

def read_SSDFull_Data():
    mockdata = [{"id":1,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
                {"id":2,"Name":"HDD2","field1":"val1","field2":"val2","field3":"val3"},
                {"id":3,"Name":"HDD3","field1":"val1","field2":"val2","field3":"val3"}]
    print json.JSONEncoder().encode(mockdata)
def read_SSD():
    '''mockdata = [{"id":1,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
                {"id":2,"Name":"HDD2","field1":"val1","field2":"val2","field3":"val3"},
                {"id":3,"Name":"HDD3","field1":"val1","field2":"val2","field3":"val3"}]
    print json.JSONEncoder().encode(mockdata)'''
    query = c.execute("SELECT name,state,vid,pid,prl,serial,size,id,wwn,location from disks")
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"name" : col[0],"state" :col[1],"vid" : col[2],"pid" : col[3],"prl" :col[4],"serial" :col[5],"size" :col[6],"id":col[7],"wwn":col[8],"location":col[9]}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode(dbdata)
    
def read_HDD():
    mockdata = [{"id":1,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
                {"id":2,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"},
                {"id":3,"Name":"HDD1","field1":"val1","field2":"val2","field3":"val3"}]
    print json.JSONEncoder().encode(mockdata)

def getRemaining(poolSize,poolID):
    
    c=conn.cursor()
    used = 0
    remaining =0   
    dbquery=c.execute("select sum(size) from volume where multi_device_id=?",[poolID])
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        used=int(resp)
    c.close
    remaining=poolSize-used
    return used,remaining

def getPoolDiskInfo(poolID):

    c=conn.cursor()
    NbPoolDisks = 0
    NbMissingPoolDisks =0
    query = c.execute("select count(*) from disks where name like 'mr%'")
    NbPoolDisks=int(c.fetchone()[0])
    dbquery=c.execute("select state from disks where name like'mr%'")#multi_device_id=?",[poolID])
    resp=c.fetchall()
    for disk in resp:
        #NbPoolDisks=NbPoolDisks+1
        state=str(disk[0])
        #if state !='0':
        if state == '2':
            NbMissingPoolDisks=NbMissingPoolDisks+1
    c.close()

    return NbPoolDisks,NbMissingPoolDisks

def read_StoragePools2():
    dbquery="select id,name,(case when name='HDD POOL' then '16 ' else '4 TB' end) capacity,pool_storage,0 available,deduplication,compression,(case when acceleration_storage > 0 then cast(acceleration_storage as text)|| ' TB' else 'No' end) from multi_device"	
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        jsonschema = {"id":col[0],"pool" : col[1],"capacity" :col[2],"protection" : str(col[3]),"available" : str(computeAvailableStorage(col[1]))+' TB',"dedup" :col[5],"compression" : col[6],"acceleration" : str(col[7]),"cache_RD":0,"cache_WRITE":0}
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode({"data":dbdata})

def read_StoragePools():
    dbquery = "select id,name,level,0 available,deduplication,compression,(case when acceleration_storage > 0 then ROUND(acceleration_storage,2)|| ' GB' WHEN acceleration_storage <= 0 AND name='HDD POOL' then 'No' else 'N/A' end),system_name,ifnull(calculatedraw,0),state,ifnull(pool_storage,0) from multi_device where name!='system'"
    query = c.execute(dbquery)
    dbdata = []
    conn.commit()
    for col in c:
        rawStorage, protectedStorage = getStorageDetails(int(col[8]),int(col[10]), int(col[2]))
        poolID=col[0]
        vals= getRemaining(int(col[10]),poolID)
        used=str(vals[0])
        remaining= str(vals[1])
        vals=getPoolDiskInfo(poolID)
        diskUsed=vals[0]
        diskMissing=vals[1]
        raid_level = col[2]
        if int(raid_level)==1:
            raid_level=5

        #Pool State Redundancy Raid Level Disk missing Storage Capacity Used Storage Remaining Capacity Compression Dedup Cache Read Cache Write Type
        jsonschema = {
            "id": col[0], "system_name": str(col[7]), "type": col[1], "raw_storage": rawStorage, "protected_storage": protectedStorage, 
            "state": col[9], "level": str(col[2]), "disks": diskUsed, "dedup": col[4], 
            "compression": col[5], "cache_RD": str(col[6]),"cache_WRITE": str(col[6]), "diskMissing":str(diskMissing), "redundancy": getRedundancy(int(col[2])),
            "remaining": remaining + ' GB', 'used' : used +' GB', 'capacity' : str(col[10]) + ' GB', "raidlvl" : raid_level
        }
        dbdata.append(jsonschema)
    conn.close()
    print json.JSONEncoder().encode({"data":dbdata})
    
def read_PoolsFull_Data():
    mockdata = [{"id":1,"ProtocolName":"CIFS","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
                {"id":2,"ProtocolName":"NFS","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
                {"id":3,"ProtocolName":"iSCSI-Chap","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
                {"id":4,"ProtocolName":"iSCSI-NoChap","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
                {"id":5,"ProtocolName":"FTP","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5},
                {"id":6,"ProtocolName":"FC","Total":16,"StorageCapacity":8,"UsedCapacity":3,"RemainingCapacity":5}
                ]
    print json.JSONEncoder().encode(mockdata)

def read_component():
    nework_component_mapping = {
        "lanport1" : "LAN2",
        "lanport2" : "LAN1",
        "lanport3" : "IPMI",
        "networkcard1" : "LAN3",
        "networkcard2" : "LAN4",
    }
    fan_component_mapping = [
        "Fan#F1",
        "Fan#F2",
        "Fan#R1"
    ]
    led_component_mapping = {"lanled1":"LAN1","lanled2":"LAN2"}
    attributes, mockdata = [], []
    component = form.getvalue('component')
    if component in nework_component_mapping.keys():
        component = nework_component_mapping[component]
        c.execute("Select ip,netmask,dhcp_enabled,enable_port,name from eth_ports where name = ?",[component])
        for col in c:
            name = component
            if component == "Management":
                name = "IPMI Port"
            jsonschema = {"IP Address": col[0], "Subnet": col[1], "DHCP Enabled": col[2], "Port Enabled": col[3], "Name":name}
            attributes = ["Name", "IP Address" , "Subnet", "DHCP Enabled" , "Port Enabled"]
            mockdata = [jsonschema]
    elif component in fan_component_mapping:
        dbquery='''Select id,name,location,ifnull([default],0),ifnull(low_threshold,0),ifnull(hi_threshold,0),ifnull(t_min,0),ifnull(t_max,0),ifnull(speed,0) from fan where name = '{}'
        '''.format(component)
        query = c.execute(dbquery)
        conn.commit()
        for col in c:
            jsonschema = {"ID":col[0],"Name" : col[1],"Location" :col[2],"Speed" : col[8],"Default" : col[3],"Low Threshold(%)" :col[4],"High Threshold(%)" : col[5]}
            attributes = ["ID","Name","Location","Speed","Default","Low Threshold(%)","High Threshold(%)"]
            mockdata = [jsonschema]
            
            
    elif component in led_component_mapping.keys():
        component = led_component_mapping[component]
        dbLedData=[]
        dbquery=c.execute("select name,state,speed,system_name,tx_rx_monitor,enable_port from eth_ports where name = ?",[component])
        for col in c:
            Mon= str(col[4])
            system_name = col[3]
            portState = read_portsStatus(system_name)
            enable_port = col[5]
            speed = str(PortValue("get",system_name,"speed"))
            if portState=="down":
                state=2                
            elif (portState=="up" and(speed=="" or speed==None)):
                state=1
            elif portState=="up" and speed!="0":
                state=0
            else:
                state= 1
            attributes = ['Name','State','Speed']
            jsonschema = {"name":col[0],"state":state,"speed":speed}
            dbLedData.append(jsonschema)
        mockdata=dbLedData
    
    elif component == "warningled":
        db_WarningLed = []
        attributes = ['Name','State','Error']
        eth_Name = ['LAN1','LAN2']
        eth_sysName = {}
        
        for name in eth_Name:            
            query = c.execute("select system_name from eth_ports where name=?",[name])
            for col in c:
                eth_sysName[name]=col[0]
        
        for name,sysname in eth_sysName.items():
            portState = read_portsStatus(sysname)
            speed = str(PortValue("get",sysname,"speed"))
            
            if portState=="down":
                state=2
            elif (portState=="up" and(speed=="" or speed==None)):
                state=1
            elif portState=="up" and speed!="0":
                state=0

            else:
                state=1
            
            if state!= NORMAL_STATE:
                jsonschema = {"name":name,"state":state,"speed":speed}
                db_WarningLed.append(jsonschema)
                
        if db_WarningLed!=[]:
            mockdata=db_WarningLed
        else:
            jsonschema = {"name":"None","state":0,"speed":"None"}
            mockdata = [jsonschema]
            
    elif component == "vgaport":
        attributes=["Name","Enabled","Monitor"]
        mockdata = [{"Name":"VGA Port","Enabled":"Yes","Monitor":"Unknown"}]
    
    elif component == "vdc12":
        attributes = ["Name","AC","DC"]
        mockdata = [{"Name":"12VDC-IN","AC":"OK","DC":"OK"}]
    
    else:
        attributes = ['id','Name','field1','field2','field3']
        mockdata = [{"id":1,"Name":component,"field1":"val1","field2":"val2","field3":"val3"}]
        cmd="poff_controller"
        SystemName="R6000"
        cmd_Id = get_ccm_command_id()
        message="set,element=controller,element_name={0},args=2,action={1},uuid={2}".\
        format(SystemName,cmd,cmd_Id)
        #send_ccm_msg(message)
    
    c.close()
    print json.JSONEncoder().encode({"attributes":attributes,"data":mockdata, "component" : component})

def onOffReset():
    userId = form.getvalue('userId')
    password = form.getvalue('password')
    decoded_password = password.decode('base64')
    password = decoded_password
    component = form.getvalue('component')
    
    query_pwd = c.execute("select password from person where id=?",[userId])
    db_Pwd = c.fetchone()[0]
    conn.commit()
    isEnPwd = is_EncodedString_base64(db_Pwd)
    if isEnPwd :
        EncryptGUIpwd = pwd_encoding(password)
        password = EncryptGUIpwd

    query=c.execute("SELECT * from person where id=? and password=?",[userId,password])
    isValidCredentials=c.fetchall()
    if isValidCredentials:
        if component == "reset":
            if (CCM==True):
                cmd="reset_controller"
                SystemName="R6000"
                cmd_Id = get_ccm_command_id()
                message="set,element=controller,element_name={0},args=2,action={1},uuid={2}".\
                format(SystemName,cmd,cmd_Id)
                send_ccm_msg(message) 
                #response = get_ccm_response(cmd_Id)
                #print (response)
                print json.JSONEncoder().encode({"status": "success", "description": "Scheduled for system reset!"})
            else:
                print json.JSONEncoder().encode({"status": "success", "description": "CCM False,Scheduled for system reset!"})
            
        elif component == "onoff":
            if (CCM==True):
                cmd="poff_controller"
                SystemName="R6000"
                cmd_Id = get_ccm_command_id()
                message="set,element=controller,element_name={0},args=2,action={1},uuid={2}".\
                format(SystemName,cmd,cmd_Id)
                send_ccm_msg(message) 
                #response = get_ccm_response(cmd_Id)
                #print (response)
                print json.JSONEncoder().encode({"status": "success", "description": "Scheduled for power Off!"})
            else:
                print json.JSONEncoder().encode({"status": "success", "description": "CCM False,Scheduled for power Off!"})
    else:
        print json.JSONEncoder().encode({"status": "fail", "description": "Invalid Credentials"})

    
print "Content-type:text/html\r\n\r\n"

if request_Type == 'read_StatusAll':
    read_StatusAll()
elif request_Type == 'read_Fans':
    read_StatusFan()
elif request_Type == 'read_Temp_probes':
    read_StatusTemp_probes()
elif request_Type == 'read_CPU':
    read_StatusCPU()
elif request_Type == 'read_Network':
    read_StatusNetwork()
elif request_Type == 'read_PSU':
    read_StatusPSU()
elif request_Type == 'read_PSU1':
    read_StatusPSU1()
elif request_Type == 'read_PSU2':
    read_StatusPSU2()
elif request_Type == 'read_Disks':
    read_StatusDisks()
elif request_Type == 'read_DisksSMART_Data':
    read_DisksSMART_Data()
elif request_Type == 'read_StoragePools':
    read_StoragePools()
elif request_Type == 'read_PoolsFull_Data':
    read_PoolsFull_Data()
elif request_Type == 'read_SSD':
    read_SSD()
elif request_Type == 'read_SSDFull_Data':
    read_SSDFull_Data()
elif request_Type == 'read_HDD':
    read_HDD()
elif request_Type == 'read_component':
    read_component()
elif request_Type == 'read_Canister_Details':
    read_Canister_Details()
elif request_Type == 'read_CanisterSMART_Data':
    read_CanisterSMART_Data()
elif request_Type == 'onOffReset':
    onOffReset()



