import sqlite3
conn=sqlite3.connect('sanuyiDB.db')
conn.execute('pragma foreign_keys=ON')
c=conn.cursor()

#DATA_SYSTEM

d_sys=[('System1',0,'12-05-2010','12-03-2011','12-03-2020','RIGHT',12,32,16384,0,0,0)
       ]
c.executemany(''' INSERT INTO system
             (name,state,cr_date,edit_date,del_date,location,total_vcpu,total_memoryGB,total_storageGB,used_vcpu,used_memoryGb,used_storageGB)
             VALUES(?,?,?,?,?,?,?,?,?,?,?,?)''',d_sys)

#DATA_CONTROLLER
       
d_contr=[('Controller1',0,1,'12-12-2010','15-08-2011','15-05-2020','TOP'),
       ('Controller2',0,1,'13-04-2010','18-07-2011','18-06-2020','BOTTOM'),
       ('Controller3',0,1,'10-04-2010','04-08-2011','06-12-2020','RIGHT')]
c.executemany('''INSERT INTO controller
             (name,state,system_id,cr_date,edit_date,del_date,location)
             VALUES(?,?,?,?,?,?,?)''',d_contr)

#DATA_PSU
d_psu=[('PSU_1','snum_64_Status',0,'2017-12-19','2017-12-19'),
       ('PSU_2','snum_65_Status',1,'2017-12-19','2017-12-19'),
       ('PSU_3','snum_74_PS_Redundancy',2,'2017-12-19','2017-12-19'),
              ]
c.executemany('''INSERT INTO psu
              (name,system_name,state,cr_date,edit_date)
              VALUES(?,?,?,?,?)''',d_psu)
#DATA_PROBES
d_temp_probes=[('Probe_1','snum_64_Status',0,'2017-12-19','2017-12-19','TOP','30','20','40'),
       ('Probe_2','snum_65_Status',0,'2017-12-19','2017-12-19','BOTTOM','30','20','40'),
       ('Probe_3','snum_74_PS_Redundancy',0,'2017-12-19','2017-12-19','LEFT','30','20','40'),
              ]
c.executemany('''INSERT INTO temp_probes
              (name,system_name,state,cr_date,edit_date,location,[default],t_min,t_max)
              VALUES(?,?,?,?,?,?,?,?,?)''',d_temp_probes)
			  
#DATA_FAN
d_fan=[('CPU1','snum_35_FAN_MOD_3B_RPM',0,'2017-12-19','2017/12/19','TOP','RPM','1000','800','1200'),
	   ('CPU2','snum_35_FAN_MOD_3B_RPM',0,'2017-12-19','2017/12/19','TOP','RPM','1000','800','1200'),
	   ('REAR FAN1','snum_36_FAN_MOD_4A_RPM',0,'2017-12-19','2017/12/19','RPM','TOP','1000','800','1200'),
	   ('REAR FAN2','snum_37_FAN_MOD_4B_RPM',0,'2017-12-19','2017/12/19','RPM','TOP','1000','800','1200'),
	   ('PSU1 FAN','snum_38_FAN_MOD_5A_RPM',0,'2017-12-19','2017/12/19','RPM','TOP','1000','800','1200'),
	   ('PSU2 FAN','snum_39_FAN_MOD_5B_RPM',0,'2017-12-19','2017/12/19','RPM','TOP','1000','800','1200')]

c.executemany('''INSERT INTO FAN
         (name,system_name,state,cr_date,edit_date,speed,location,[default],t_min,t_max)
          VALUES(?,?,?,?,?,?,?,?,?,?)''',d_fan)

#DATA_CPU
d_cpu=[('CPU1',0,'18-01-10','19-02-2011','20-03-2020',1,'TOP',6,480,15000,'L1',700,5,80,20,120),
       ('CPU2',0,'15-04-10','16-05-2011','17-06-2020',2,'LEFT',8,700,25000,'L2',900,8,80,20,120)]

c.executemany(""" INSERT INTO cpu
              (name,state,cr_date,edit_date,del_date,controller_id,location,cores,freq,watts,cache,bandwidth,socket_type,[default],min,max)
              VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)""",d_cpu)

#Data_DIMM
d_dimm=[('Dimm1',0,'20-07-10','21-08-2011','22-09-2020',1,'BOTTOM',80,1200),
        ('Dimm2',0,'05-10-10','06-11-2011','25-12-2020',1,'TOP',100,2000),
        ('Dimm3',0,'19-04-10','20-05-2011','22-06-2020',2,'LEFT',70,1000),
        ]

#c.executemany("""INSERT INTO dimm
 #            (name,state,cr_date,edit_date,del_date,controller_id,location,size,watts)
  #           VALUES(?,?,?,?,?,?,?,?,?)""",d_dimm)


#DATA_ETH_PORTS
d_eth_ports=[('Management','enp4s0f0',0,'18-06-10','07-07-2011','15-08-2020',1,'LEFT','192.168.12.1','255.255.0.0','No',1,'No',1000,10,20,'YES',10),
             ('LAN1','enp4s0f1',0,'07-09-10','05-10-2011','30-11-2020',1,'RIGHT','192.168.12.100','255.255.0.0','Yes',2,'No',1000,10,20,'YES',10),
             ('WAN','eno1',1,'18-12-10','19-01-2011','20-03-2020',1,'TOP','192.168.12.121','255.255.255.0','No',3,'No',1000,10,20,'YES',10),
             ('Admin','eno2',0,'05-02-10','18-03-2011','20-04-2020',1,'RIGHT','192.168.12.12','255.255.0.0','Yes',4,'Yes',1000,10,20,'YES',10),
             ('LAN2','enp4s0f1',0,'05-02-10','18-03-2011','20-04-2020',1,'RIGHT','192.168.12.111','255.255.0.0','Yes',5,'No',10000,10,20,'YES',10),
             ('LAN3','enp4s0f1',0,'05-02-10','18-03-2011','20-04-2020',1,'RIGHT','192.168.12.100','255.255.0.0','No',6,'Yes',100,10,20,'YES',10)]

c.executemany(""" INSERT INTO eth_ports
             (name,system_name,state,cr_date,edit_date,del_date,controller_id,location,ip,netmask,dhcp_enabled,port_id,enable_port,speed,err_threshold,err_max,tx_rx_monitor,tx_rx_default)
             VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)""",d_eth_ports)

#DATA_GATEWAY
d_gateway=[('Management',0,'07-09-10','05-10-2011','30-11-2020',1,'RIGHT','10.0.15.2','103.12.15.11'),
           ('LAN',0,'18-12-10','19-01-2011','20-03-2020',1,'LEFT','10.0.15.2','103.12.15.12'),
           ('WAN',0,'07-09-10','05-10-2011','30-11-2020',1,'RIGHT','10.0.15.2','103.12.15.13'),
           ('Admin',0,'18-12-10','19-01-2011','20-03-2020',1,'LEFT','10.0.15.2','103.12.15.14')]


c.executemany("""INSERT INTO gateway
         (name,state,cr_date,edit_date,del_date,controller_id,location,default_gateway_ip,dns_server)
         VALUES(?,?,?,?,?,?,?,?,?)""",d_gateway )


#DATA_DISKS
d_disks=[('HDD1',0,'2017-12-19','2017-12-19','sda','FUJITSU','MBB2147RC','5701','BS10P990057V',10,60,70,20),
         ('HDD2',0,'2017-12-19','2017-12-19','sdb','FUJITSU','MBB2147RC','5701','BS10P990058S',10,60,70,20),
         ('HDD3',0,'2017-12-19','2017-12-19','sdc','FUJITSU','MBB2147RC','5701','BS10P99005JY',10,60,70,20),
         ('HDD4',0,'2017-12-19','2017-12-19','sde','Dell','Virtual Disk','1028','null',10,60,70,20),
		 ('HDD5',0,'2017-12-19','2017-12-19','sda','FUJITSU','MBB2147RC','5701','BS10P990057V',10,60,70,20),
         ('HDD6',0,'2017-12-19','2017-12-19','sdb','FUJITSU','MBB2147RC','5701','BS10P990058S',10,60,70,20),
         ('HDD7',0,'2017-12-19','2017-12-19','sdc','FUJITSU','MBB2147RC','5701','BS10P99005JY',10,60,70,20),         
		 ('SSD1',0,'2017-12-19','2017-12-19','sdc','FUJITSU','MBB2147RC','5701','BS10P99005JY',10,60,70,20),
         ('SSD2',0,'2017-12-19','2017-12-19','sde','Dell','Virtual Disk','1028','null',10,60,70,20),
		 ('SSD3',0,'2017-12-19','2017-12-19','sdc','FUJITSU','MBB2147RC','5701','BS10P99005JY',10,60,70,20),
         ('SSD4',0,'2017-12-19','2017-12-19','sde','Dell','Virtual Disk','1028','null',10,60,70,20)
         ]

c.executemany("""INSERT INTO disks
             (name,state,cr_date,edit_date,d_id,vid,pid,prl,serial,[default],temp_default,t_max,err_max)
             VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?)""",d_disks)



##DATA_NETWORK

d_network=[('network1',0,'07-09-10','05-10-2011','30-11-2020','192.168.12.1/24','no'),
          ('network2',0,'18-12-10','19-01-2011','20-03-2020','192.168.12.2/24','no')]

c.executemany("""INSERT INTO network
            (name,state,cr_date,edit_date,del_date,cidr,enable_dhcp)
           VALUES(?,?,?,?,?,?,?) """,d_network)




#DATA_STORAGEPATH
d_storagepath=[('Storage1',0,'15-05-10','16-08-11','20-03-13','LEFT','Storage_A1','Storage_B1'),
              ('Storage2',0,'19-05-10','17-07-11','21-04-14','RIGHT','Storage_A2','Storage_B2')]

c.executemany("""INSERT INTO storagepath
              (name,state,cr_date,edit_date,del_date,location,STORAGE_A,STORAGE_B)
              VALUES(?,?,?,?,?,?,?,?) """,d_storagepath)
#d_vm_profile

d_vm_profile=[('Standard',1,0.5,10),
              ('Professional',2,1,100),
              ('Business',4,2,500),
              ('Ultimate',8,4,1000)]
c.executemany("""INSERT INTO vm_profile
		(name,vcpu,memory,storage)
		VALUES(?,?,?,?)""",d_vm_profile)
#DATA_vm_group
d_vm_group=[('Finance',0,'05-04-2017','15-12-2018','06-12-2020','/images/finance.png'),
            ('Collaborative',0,'05-04-2017','15-12-2018','06-12-2020','/images/banking.png'),
            ('Dental',0,'05-04-2017','15-12-2018','06-12-2020','/images/dental.png'),
            ('Digital Signage',0,'05-04-2017','15-12-2018','06-12-2020','/images/DigitalSignage.png'),
            ('Education',0,'05-04-2017','15-12-2018','06-12-2020','/images/education.png'),
            ('Health',0,'05-04-2017','15-12-2018','06-12-2020','/images/health.png'),
            ('Legal',0,'05-04-2017','15-12-2018','06-12-2020','/images/legal.png'),
            ('Point of Sale',0,'05-04-2017','15-12-2018','06-12-2020','/images/point-of-sale.png'),
            ('Microsoft',0,'05-04-2017','15-12-2018','06-12-2020','/images/Operating-System.png'),
            ('Operating System',0,'05-04-2017','15-12-2018','06-12-2020','/images/Operating-System-2.png'),
            ('NAS',0,'05-04-2017','15-12-2018','06-12-2020','/images/nas.png'),
            ('Restaurant',0,'05-04-2017','15-12-2018','06-12-2020','/images/Restaurant.png'),
            ('Surveillance',0,'05-04-2017','15-12-2018','06-12-2020','/images/Surveillance.png'),
            ('VDI',0,'05-04-2017','15-12-2018','06-12-2020','/images/VDI.png'),
            ('VOIP',0,'05-04-2017','15-12-2018','06-12-2020','/images/VOIP.png'),
            ('My Backups',0,'05-04-2017','05-04-2017','05-04-2017','/images/VOIP.png'),
			('Storage Related',0,'05-04-2017','05-04-2017','05-04-2017','/images/VOIP.png')]
c.executemany("""INSERT INTO vm_group
             (group_name,state,cr_date,edit_date,del_date,path_group_icon)
             VALUES(?,?,?,?,?,?)""",d_vm_group)

#vm_image
d_image=[('ubuntu1',0,'05-03-2017','12-04-2017',23720160,1,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Finance','exe','ubuntu1'),
         ('ubuntu2',0,'05-03-2017','12-04-2017',13267968,1,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Education','img','Edu12MB'),
         ('ubuntu3',0,'05-03-2017','12-04-2017',23720160,1,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Finance','exe','ubuntu3'),
         ('Group Office',0,'05-03-2017','12-04-2017',0,2,'no','free',20,'Group-Office is an enterprise CRM and groupware tool. Share projects, calendars, files and e-mail online with co-workers and clients. Easy to use and fully customizable.','/images/GroupOffice.png','/Collaborative','iso','col1'),
         ('Kune',0,'05-03-2017','12-04-2017',0,2,'no','free',10,'Kune provides, to each person or collective, a collection of web tools which allows them to boost their potential social actions.','/images/Kune.png','/Collaborative','iso','col2'),
         ('Open Project',0,'05-03-2017','12-04-2017',10060722,2,'no','free',10,"OpenProject is the leading open source project management software to support your project management process (PMI)",'/images/OpenProject.png','/Digital','cab','digitalDocs'),
         ('Retro Share',0,'05-03-2017','12-04-2017',13267968,2,'no','free',10,'Retroshare creates encrypted connections to your friends. Nobody can spy on you. Retroshare is completely decentralized. This means there are no central servers. It is entirely Open-Source and free. There are no costs, no ads and no Terms of Service.','/images/RetroShare.jpg','/Education','img','Edu12MB'),
         ('Project.net',0,'05-03-2017','12-04-2017',0,2,'no','free',10,'Project.net is a complete, open source cloud based enterprise project management application that helps companies plan, execute and deliver on their entire portfolio of projects.','/images/Project_net.jpg','/Collaborative','iso','col5'),
         ('Zentyal',0,'05-03-2017','12-04-2017',10060722,2,'no','free',10,'Zentyal is an open source email and groupware solution based on Ubuntu Linux.','/images/Zentyal.png','/Digital','cab','digitalDocs'),
         ('ubuntu4',0,'05-03-2017','12-04-2017',0,3,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Dental','iso','ubuntu1'),
         ('ubuntu5',0,'05-03-2017','12-04-2017',13267968,3,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu5.jpg','/Education','img','Edu12MB'),
         ('ubuntu6',0,'05-03-2017','12-04-2017',0,3,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Dental','iso','ubuntu2'),
         ('ubuntu7',0,'05-03-2017','12-04-2017',497424,4,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Microsoft','sys','e1k62x64'),
         ('ubuntu8',0,'05-03-2017','12-04-2017',0,4,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Digital','iso','ubuntu2'),
         ('ubuntu9',0,'05-03-2017','12-04-2017',10060722,4,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Digital','cab','digitalDocs',),
         ('ubuntu10',0,'05-03-2017','12-04-2017',0,5,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu5.jpg','/Education','iso','ubuntu1'),
         ('ubuntu11',0,'05-03-2017','12-04-2017',10060722,5,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Digital','cab','digitalDocs'),
         ('ubuntu12',0,'05-03-2017','12-04-2017',0,5,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Education','iso','ubuntu2'),
         ('ubuntu13',0,'05-03-2017','12-04-2017',0,6,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Dental','iso','ubuntu2'),
         ('ubuntu14',0,'05-03-2017','12-04-2017',23720160,6,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Finance','exe','ubuntu2'),
         ('ubuntu15',0,'05-03-2017','12-04-2017',13267968,6,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu5.jpg','/Education','img','Edu12MB'),
         ('ubuntu16',0,'05-03-2017','12-04-2017',0,7,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Dental','iso','ubuntu2'),
         ('ubuntu17',0,'05-03-2017','12-04-2017',23720160,7,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Finance','exe','ubuntu2'),
         ('ubuntu18',0,'05-03-2017','12-04-2017',0,7,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Dental','iso','ubuntu2'),
         ('ubuntu19',0,'05-03-2017','12-04-2017',10060722,8,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Digital','cab','digitalDocs'),
         ('ubuntu20',0,'05-03-2017','12-04-2017',23720160,8,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu5.jpg','/Finance','exe','ubuntu2'),
         ('ubuntu21',0,'05-03-2017','12-04-2017',497424,8,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Microsoft','sys','e1k62x64'),
         ('ubuntu22',0,'05-03-2017','12-04-2017',23720160,9,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Microsoft','doc','ubuntu29'),
         ('ubuntu23',0,'05-03-2017','12-04-2017',23720160,9,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Microsoft','doc','ubuntu28'),
         ('powerPoint',0,'05-03-2017','12-04-2017',10060722,9,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Digital','cab','digitalDocs'),
         ('ubuntu25',0,'05-03-2017','12-04-2017',10060722,10,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu5.jpg','/Digital','cab','digitalDocs'),
         ('ubuntu26',0,'05-03-2017','12-04-2017',0,10,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Dental','iso','ubuntu2'),
         ('ubuntu27',0,'05-03-2017','12-04-2017',497424,10,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Microsoft','sys','e1k62x64'),
         ('ubuntu28',0,'05-03-2017','12-04-2017',23720160,11,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Finance','exe','ubuntu2'),
         ('ubuntu29',0,'05-03-2017','12-04-2017',10060722,11,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Digital','cab','digitalDocs'),
         ('ubuntu30',0,'05-03-2017','12-04-2017',0,11,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu5.jpg','/Dental','iso','ubuntu2'),
         ('ubuntu31',0,'05-03-2017','12-04-2017',23720160,12,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Finance','exe','ubuntu2'),
         ('ubuntu32',0,'05-03-2017','12-04-2017',497424,12,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Microsoft','sys','e1k62x64'),
         ('ubuntu33',0,'05-03-2017','12-04-2017',497424,12,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Microsoft','sys','e1k62x64'),
         ('ubuntu34',0,'05-03-2017','12-04-2017',23720160,13,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Finance','exe','ubuntu2'),
         ('ubuntu35',0,'05-03-2017','12-04-2017',497424,13,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu5.jpg','/Microsoft','sys','e1k62x64'),
         ('ubuntu36',0,'05-03-2017','12-04-2017',0,13,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/Dental','iso','ubuntu2'),
         ('ubuntu37',0,'05-03-2017','12-04-2017',10060722,14,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Digital','cab','digitalDocs'),
         ('ubuntu38',0,'05-03-2017','12-04-2017',497424,14,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/Microsoft','sys','e1k62x64'),
         ('ubuntu39',0,'05-03-2017','12-04-2017',23720160,14,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu4.jpg','/Finance','exe','ubuntu2'),
         ('ubuntu40',0,'05-03-2017','12-04-2017',23720160,15,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu1.jpg','/VOIP','exe','ubuntu40'),
         ('ubuntu41',0,'05-03-2017','12-04-2017',13267968,15,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu2.jpg','/Education','iso','Edu12MB'),
         ('ubuntu42',0,'05-03-2017','12-04-2017',23720160,15,'no',100,20,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/ubuntu3.jpg','/VOIP','exe','ubuntu42'),
		 ('Moodle',0,'05-03-2017','12-04-2017',13267968,5,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/moodle.jpg','/Education','iso','moodle'),		 
         ('Canvas',0,'05-03-2017','12-04-2017',13267968,5,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/Canvas.jpg','/Education','iso','Canvas'),		 
         ('OpenSiS',0,'05-03-2017','12-04-2017',13267968,5,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/OpenSiS.jpg','/Education','iso','OpenSiS'),		 
         ('Gibbon',0,'05-03-2017','12-04-2017',13267968,5,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/Gibbon.jpg','/Education','iso','Gibbon'),		
		 ('Fedena',0,'05-03-2017','12-04-2017',13267968,5,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/Fedena.jpg','/Education','iso','Fedena'),
		 ('OFBiz',0,'05-03-2017','12-04-2017',13267968,1,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/OFBiz.jpg','/Finance','iso','OFBiz'),
		 ('FrontAccounting',0,'05-03-2017','12-04-2017',13267968,1,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/FrontAccounting.jpg','/Finance','iso','FrontAccounting'),
		 ('Multiview',0,'05-03-2017','12-04-2017',13267968,1,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/Multiview.jpg','/Finance','iso','Multiview'),
		 ('Budget Maestro',0,'05-03-2017','12-04-2017',13267968,1,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/Budget-Maestro.jpg','/Finance','iso','Budget-Maestro'),
		 ('FlexVDI',0,'05-03-2017','12-04-2017',13267968,14,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/FlexVDI.jpg','/VDI','iso','FlexVDI'),
		 ('Xibo',0,'05-03-2017','12-04-2017',13267968,4,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/Xibo.jpg','/Digital','iso','Xibo'),
		 ('iSPY',0,'05-03-2017','12-04-2017',13267968,13,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/iSPY.jpg','/Surveillance','iso','iSPY'),
		 ('Cassandra',0,'05-03-2017','12-04-2017',13267968,17,'no','free',10,'DESCRIPTION SHOULD BE DISPLAYED HERE','/images/Cassandra.jpg','/StorageRelated','iso','Cassandra')
         ]
c.executemany("""INSERT INTO vm_image
                (image_name,state,cr_date,edit_date,vm_image_size,vm_group_id,downloded,image_cost,support_cost,image_description,path_image_icon,
               app_download_server,image_type,file_name)
               VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?) """,d_image)


#protocol
d_PROTOCOL=['CIFS','NFS','iSCSI-Chap','iSCSI-NoChap','FTP','FC']
for i in d_PROTOCOL:
  c.execute("INSERT INTO protocol(name) VALUES('"+i+"') ")
  conn.commit()

#org_Group7

c.execute("INSERT INTO OrgGroup(Name,Description) VALUES('nasyaIT','MGMT')")
#user

c.execute("INSERT INTO Person(userName,FirstName,LastName,password) VALUES('admin','admin','A','pleasehideme')")

#EMAIL services
c.execute(""" INSERT INTO email_logs(recipient_email,sender_email,password,smtp_server,port,alert_type) 
VALUES('divyavani.ram@gmail.com,divya.vani12@gmail.com','divyavani.nasya@gmail.com','hello123hello123','smtp.gmail.com',587,'Logs')""")
#BACKUP SREVICE
c.execute(""" INSERT INTO backup(destination_name,ip_address,account_name,password)
VALUES('Sanuyi Cloud','oppermanns.com','testaccount@oppermanns.com','uTwzZHwvU)?H') """)

conn.commit()
c.close()
conn.close()

