import gnupg
import os
import traceback
import subprocess
from uuid import getnode as get_mac

message = ' '
status = 'fail'

def get_mac_hash():
    mac = get_mac()
    return hash(mac)

def getBaseBoardSerialNumber():
    #sudo dmidecode -s baseboard-serial-number
    process1 = subprocess.check_output(["sudo",'dmidecode','-s','baseboard-serial-number'])
    dmiSerial =  process1.strip()
    if len(dmiSerial)==0:
        #print "No Serial"
        process1 = subprocess.check_output(["sudo",'dmidecode','-s','system-uuid'])
        UUID = process1.strip()
        #print "UUID=",UUID
        dmiSerial=UUID.replace("-","")
        #print "dmidecode serial (baseboard)=",dmiSerial
    #else:
        #print "dmidecode serial(uuid)=",dmiSerial
    return (dmiSerial)

def recursiveFilePermissions(paths):
    os.system('sudo chmod -R 777 ' + paths)

recursiveFilePermissions('/home/sanuyi/gpguser/')
gpg = gnupg.GPG(gnupghome='/home/sanuyi/gpguser/') #Stores the encryption keys. change according to the home directory
pubkeys = gpg.list_keys()

if not pubkeys:
    input_data = gpg.gen_key_input(name_email='divya.testnasya@gmail.com',
    passphrase='pleasehideme',
    key_length=1024)
    key = gpg.gen_key(input_data)

def unpack(fileName):
    global message
    global status
    try:
        with open(fileName,'r') as f:
            encrypted_ascii_data = f.read()
        
        encrypted_string = str(encrypted_ascii_data)
    
        decrypted_data_obj = gpg.decrypt(encrypted_string, passphrase="pleasehideme")
        decrypted_data = str(decrypted_data_obj)
        if decrypted_data.strip() == '' or decrypted_data is None:
            message += "<br><strong> Couldn't decrypt file! </strong>"
            return status, message
        system_id, license = decrypted_data.split('\n')

        if system_id == str(getBaseBoardSerialNumber()) and decrypted_data_obj.ok:
            message += " <br><strong> File Uploaded Successfully. </strong><br><strong>License: </strong>" + license
            status = 'success'
        else:
            if system_id != str(getBaseBoardSerialNumber()):
                message += "<br><strong> System ID's did not match! </strong>"
            else:
                message += "<br><strong> File failed to be verified </strong>"
    except Exception as e:
        message += "<br> FAILED <br>" 
        message += str(traceback.format_exc()).replace('\n','<br>')

    return status, message
            
