
import logging
from logging.handlers import RotatingFileHandler
import random
from globalSettings import LogsFilePath,AlertsFilePath
import os


#levelName=State
'''A global Logging level (GLL) is defined as part of the setup
If logging_level <= GLL:
Log
Else:
    pass
If I set GLL to 90 everything is logged, if I set to 10 only logging messages 0&10 are logged.
Logging_level=0 (for all critical issues (Asserts, CRITICAL)
Logging_level=10 (for all normal INFO & WARNING)
Logging_level=20 onwards (for code debug tracing, this will depend on the programmer decision)'''

gll = 100


INFO = 0
WARNING = 1
ERROR = 2
CRITICAL = 3
DEBUG = 4

infoLevel = random.randint(20,50)
warningLevel = random.randint(10,20)
debugLevel = random.randint(50,90)
criticalLevel = 0
errorLevel = random.randint(1,10) 


def CGI_log(logger,LogType,LogLevel,msg):
        log_elt="cgi"
        log_eltName="cgi_test"
        args=loggerArgs(log_elt,log_eltName,LogLevel,str(msg))
        ccmLogger(logger,LogType,"CGI_test ",args)
        
def ccmLogger(logger,level_num,data,arguments):
    gll = 90
    # print "in ccmLogger1", "handlers : ", logger[0].handlers[0].baseFilename, " , ", logger[1].handlers[0].baseFilename
    if int(arguments['LogLevel']) <= gll:
        if level_num ==INFO:
            logger[0].info(data,extra=arguments)
        elif level_num == WARNING:
            logger[0].warning(data,extra=arguments)
        elif level_num == ERROR:
            logger[0].error(data,extra=arguments)
            logger[1].error(data, extra=arguments)
        elif level_num == CRITICAL:
            logger[0].critical(data,extra=arguments)
            logger[1].critical(data, extra=arguments)
        elif level_num == DEBUG:
            logger[0].debug(data,extra=arguments)
        #else:
        #   logger.notset(data,extra=arguments)
    else:
        pass

def loggerArgs(element,elementName,loglevel,action):
    #print "in loggerArgs"
    loggerArgs={}
    loggerArgs['element']=element
    loggerArgs['elementname']=elementName
    loggerArgs['LogLevel']=loglevel
    loggerArgs['action']=action
    return loggerArgs


def initLogging():
        return 0

def init_logger(name):
    return_values = []
    logger = logging.getLogger(name+"C")
    log_format = '@%(asctime)s@ %(element)s @%(elementname)s @%(LogLevel)s @%(levelname)s @%(action)s @%(message)s'
    handler = RotatingFileHandler('/mnt/data/testlogger.log',maxBytes=1000000,backupCount=4)
    logger_format=logging.Formatter(fmt=log_format,datefmt="%d/%m/%Y-%H:%M:%S")
    handler.setFormatter(logger_format)
    logger.addHandler(handler)
    logger.setLevel(logging.DEBUG)
    return_values.append(logger)
    
    alerts_file = logging.FileHandler("alerts.log")
    logger_formatter = logging.Formatter(fmt=log_format,datefmt="%d/%m/%Y-%H:%M:%S")
    alerts_file.setFormatter(logger_formatter)
    logger = logging.getLogger(name+"A")
    logger.addHandler(alerts_file)
    logger.setLevel(logging.ERROR)
    return_values.append(logger)
    return return_values


def DelHandler(logger):
    for h in logger.handlers:
       logger.removeHandler(h)



# def assertLog(args, message, level):
#   ccmLogger(level, message, args)
#   pass
# a = 1



