var chartSeries = [];
var chartColors = ["red", "green", "blue", "black", "orange", "#808080", "#06230b"]
var chartTitle='';
var titleTooltip= "";
var yAxisTitle = ""
function Request() {
    var request = {
        url: "",
        parameters: {},
        Type: ""
    };
}
Highcharts.setOptions({
    global: {
        useUTC: true
    }
});
$(function() {
    var chart;
    var chartData = [];


    var response = [{
        "component": 'CPU',
        "componentPath": 'CPU'
    }, {
        "component": 'Memory',
        "componentPath": 'Memory'
    }, {
        "component": 'Disk',
        "componentPath": 'Disk'
    }, {
        "component": 'DF',
        "componentPath": 'DF'
    }]
    $('#ddlComponent').append(new Option('-- Select --', 0));
    $.each(response, function(i, item) {
        $('#ddlComponent').append(new Option(item.component, item.componentPath));
    });

});



function Renderchart(series) {
    chart = Highcharts.chart('container', {
        chart: {
            type: 'spline',
            zoomType: 'xy',
            //backgroundColor: "#9e9e9e",
            animation: Highcharts.svg, // don't animate in old IE
            marginRight: 10,
        },
        title: {
            text: '<span title="'+titleTooltip+'">' + chartTitle + ' Analytics'+'</span>',
            style: {
                "color": "black",
                "fontSize": "20px",
                fontWeight: 'bold'
            },
			useHTML:true
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
                day: "%e. %b",
                month: "%b '%y",
                year: "%Y"
            },
            tickInterval: 1,
            title: {
                text: 'Time',
                style: {
                    "color": "black",
                    "fontSize": "15px",
                    fontWeight: 'bold'
                },
            },

        },
        yAxis: {
            // max: 100,
            // min: 0,
            title: {
                text: yAxisTitle,
                style: {
                    "color": "black",
                    "fontSize": "15px",
                    fontWeight: 'bold'
                },
            },
            gridLineWidth: 0,
            plotLines: [{
                value: 0,
                width: 1,
                color: '#808080'
            }]
        },
        legend: {
            enabled: true,

        },
        //colors: ["red", "green", "blue", "black", "orange", "#808080", "#06230b"],
        exporting: {
            enabled: true
        },
        plotOptions: {
            series: {
                showCheckbox: false,
                marker: {
                    enabled: false
                },
                events: {
                    checkboxClick: function(event) {
                        if (event.checked) {
                            this.show();
                            this.legendSymbol.hide();
                        } else {
                            this.hide();
                            this.legendSymbol.hide();
                        }
                    }
                }
            }
        },

        series: series,

        responsive: {
            rules: [{
                condition: {
                    maxWidth: 500
                },
                chartOptions: {
                    legend: {
                        layout: 'horizontal',
                        align: 'center',
                        verticalAlign: 'bottom'
                    }
                }
            }]
        }

    });
	
	 $('#plain').click(function() {
     chart.update({
			 chart: {
				 inverted: false,
				 polar: false
			 },
		 subtitle: {
			text: 'Plain'
			}
		});
     });


}

function PrepareDefaultData(data) {
    chartData = data;
	chartSeries=[];
	for(var prop in data) {
		var device = ConvertDefaultToSeriesData(data[prop],prop);
		for(var i in device)
		{
			if(device[i].data.length>0)
				chartSeries.push(device[i]);
		}
	}
	
	//chartSeries = ConvertToSeriesData(chartData);
    chartSeries = UpdateColors(chartSeries)
    //StartChart(chartSeries);
	console.log(chartSeries);
    Renderchart(chartSeries);

}

function ConvertDefaultToSeriesData(Data,Name) {
	var seriresNames = Data[1].columns;
    var seriesData = [{
        name: Name +' '+seriresNames[0],
        selected: false,
        data: []
    },{
        name: Name+' '+seriresNames[1],
        selected: false,
        data: []
    },{
        name: Name+' '+seriresNames[2],
        selected: false,
        data: []
    },];

    var config = Data[0];
    var startTime = config.epoch_range[0];
    var endTime = config.epoch_range[1];
    var numInterval = config.epoch_range[2];
    var timeDiff = numInterval;// / 60;
    Data.shift();
	Data.shift();

    var epochValue = startTime;
    $.each(Data, function(index, item) {
        var d = new Date(0);
        d.setUTCSeconds(epochValue);
		if(item.val1 != undefined)
			seriesData[0].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds()), item.val1]);
		if(item.val2 != undefined)
			seriesData[1].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds()), item.val2]);
		if(item.val3 != undefined)
			seriesData[2].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds()), item.val3]);
        epochValue = epochValue + timeDiff;
    });
    seriesData[0].data = seriesData[0].data.slice(0, 1000);
	seriesData[1].data = seriesData[1].data.slice(0, 1000);
	seriesData[2].data = seriesData[2].data.slice(0, 1000);

    return (seriesData);
}

function PrepareData(data) {
    chartData = data;
	chartSeries=[];
	for(var prop in data) {
        //console.log("prop: ", prop, "data :", data, "data[prop] :", data[prop]);
        var device = ConvertToSeriesData(data[prop],prop);
		for(var i in device)
		{
			if(device[i].data.length>0)
				chartSeries.push(device[i]);
		}
	}
	
	//chartSeries = ConvertToSeriesData(chartData);
    chartSeries = UpdateColors(chartSeries)
    //StartChart(chartSeries);
	//console.log(chartSeries);
    if(chartSeries.length == 0){
        swal("Warning", "No Data Found", "warning");
        try{
            chart.destroy()
        }
        catch{

        }
        return ;
    }
    Renderchart(chartSeries);
}

function ConvertToSeriesData(Data,Name) {
    //console.log("Data[1] :", Data)
    var seriresNames = Data[1].columns;
    var seriesData = []
    $.each(seriresNames, function(index, item) {
        seriesData.push({
            name: item,
            selected: false,
            data: []
        });
    });

    var config = Data[0];
    var startTime = config.epoch_range[0];
    var endTime = config.epoch_range[1];
    var numInterval = config.epoch_range[2];
    var timeDiff = numInterval;// / 60;
    Data.shift();
	Data.shift();

    var epochValue = endTime;
    Data.reverse();
    $.each(Data, function(index, item) {
        //console.log(index, item)
        var d = new Date(0);
        d.setUTCSeconds(epochValue);
        $.each(item.row, function(i, value) {
            if(item.row[i] != undefined)
			    seriesData[i].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds()), item.row[i]]);
        });
        epochValue = epochValue - timeDiff;
    });
    // var epochValue = startTime;
    // $.each(Data, function(index, item) {
    //     console.log(index, item)
    //     var d = new Date(0);
    //     d.setUTCSeconds(epochValue);
    //     $.each(item.row, function(i, value) {
    //         if(item.row[i] != undefined)
	// 		    seriesData[i].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds()), item.row[i]]);
    //     });
    //     epochValue = epochValue + timeDiff;
    // });
    
    //console.log("seriesData : ", seriesData)
    $.each(seriesData, function(index, item) {
        seriesData[index].data = seriesData[index].data.slice(0, 1000);
        seriesData[index].data.reverse()
    });
    return (seriesData);
}

function UpdateColors(data) {
    for (var i = 0; i < data.length; i++) {
        data[i].color = chartColors[i];
    }
    return data;
}

function CallPythonServiceChart(request) {
	request.parameters.uuid=uuid;
    $.ajax({
        type: "Get",
        url: request.url,
        contentType: 'application/json',
        dataType: 'json',
        headers: { 'Access-Control-Allow-Origin': '*' },
        data: request.parameters,
        success: function (response) {
			//response = {"cpu-12": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-13": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-10": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-11": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-14": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-15": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-0": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-1": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-2": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-3": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-4": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-5": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-6": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-7": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-8": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}], "cpu-9": [{"epoch_range": [1532851200, 1532855040, 480]}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}, {"val1": 0.0}]};
			PrepareData(response);
        },
        error: function (ex) {			
			var response = {"cpu-12": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]} ,{"val1": 99.9}, {"val1": 99.96}, {"val1": 99.95}, {"val1": 99.95}, {"val1": 99.91}, {"val1": 99.87}, {"val1": 99.9}, {"val1": 99.91}], "cpu-13": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 92.13}, {"val1": 94.7}, {"val1": 95.87}, {"val1": 99.91}, {"val1": 98.59}, {"val1": 97.51}, {"val1": 97.94}, {"val1": 98.56}], "cpu-10": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.89}, {"val1": 99.93}, {"val1": 99.88}, {"val1": 99.93}, {"val1": 99.88}, {"val1": 99.84}, {"val1": 99.82}, {"val1": 99.87}], "cpu-11": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.98}, {"val1": 99.75}, {"val1": 99.98}, {"val1": 99.98}, {"val1": 99.95}, {"val1": 99.98}, {"val1": 99.96}, {"val1": 99.89}], "cpu-14": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.93}, {"val1": 99.98}, {"val1": 99.93}, {"val1": 99.9}, {"val1": 99.87}, {"val1": 99.79}, {"val1": 99.81}, {"val1": 99.47}], "cpu-15": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.97}, {"val1": 99.55}, {"val1": 99.87}, {"val1": 99.88}, {"val1": 99.92}, {"val1": 99.89}, {"val1": 99.92}, {"val1": 99.99}], "cpu-0": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.91}, {"val1": 99.93}, {"val1": 99.93}, {"val1": 99.94}, {"val1": 99.86}, {"val1": 99.87}, {"val1": 99.93}, {"val1": 99.92}], "cpu-1": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 97.94}, {"val1": 95.48}, {"val1": 97.71}, {"val1": 98.23}, {"val1": 98.96}, {"val1": 94.9}, {"val1": 95.28}, {"val1": 95.21}], "cpu-2": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.83}, {"val1": 99.84}, {"val1": 99.84}, {"val1": 99.83}, {"val1": 99.81}, {"val1": 99.8}, {"val1": 99.8}, {"val1": 99.8}], "cpu-3": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.97}, {"val1": 99.97}, {"val1": 99.96}, {"val1": 99.4}, {"val1": 99.99}, {"val1": 99.98}, {"val1": 99.93}, {"val1": 99.96}], "cpu-4": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.94}, {"val1": 99.93}, {"val1": 99.94}, {"val1": 99.93}, {"val1": 99.35}, {"val1": 99.9}, {"val1": 99.9}, {"val1": 99.94}], "cpu-5": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.84}, {"val1": 98.33}, {"val1": 94.71}, {"val1": 92.48}, {"val1": 97.94}, {"val1": 97.64}, {"val1": 96.67}, {"val1": 94.96}], "cpu-6": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.96}, {"val1": 99.98}, {"val1": 99.96}, {"val1": 99.97}, {"val1": 99.96}, {"val1": 99.42}, {"val1": 99.9}, {"val1": 99.97}], "cpu-7": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.98}, {"val1": 99.85}, {"val1": 99.86}, {"val1": 99.89}, {"val1": 99.98}, {"val1": 99.97}, {"val1": 99.96}, {"val1": 99.51}], "cpu-8": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.9}, {"val1": 99.49}, {"val1": 99.49}, {"val1": 99.95}, {"val1": 99.9}, {"val1": 99.9}, {"val1": 99.88}, {"val1": 99.91}], "cpu-9": [{"epoch_range": [1532847360, 1532851680, 480]}, {"columns": ["rx", "tx"]}, {"val1": 99.37}, {"val1": 99.25}, {"val1": 98.72}, {"val1": 98.41}, {"val1": 92.8}, {"val1": 96.73}, {"val1": 97.4}, {"val1": 98.69}]};	
			swal("Warning", "No Data Found", "warning");
			try{
             		   chart.destroy()
		            }
            		catch{
		            }
			//PrepareDefaultData(response);
            if(!isProduction){
				console.log(ex);
			}
        }
    });
}

function InitializeChart(deviceList,scale,groupName,metrics)
{
	chartTitle = groupName;
	yAxisTitle = metrics;
	titleTooltip = 'Selected Metric: '+metrics;
	var RequestType ="";
	if(deviceList == "C")
		RequestType = "read_CPU";
	else if(deviceList == "E")
		RequestType = "read_Eth";
	else
		RequestType ="read_Old";
	
	var request = new Request();
	request.url ="cgi/cgi_CollectD_Manager.py"
	request.statusType="getChartData";
	request.parameters={"requestType":deviceList,"deviceList":deviceList,"scale":scale,"metrics":metrics,"NumHorizontal_points_in_graph":10};
	CallPythonServiceChart(request);
}

