Highcharts.setOptions({
    global: {
        useUTC: false
    }
});

var progress=true;
var chartData=[];
var series = [];

function CallCSVData(csvPath,legendName)
{
	// $.ajax({
    // url: csvPath,
    // success: function (csv) {
		// CSV2JSON(csv); 
		// }
	// });

$.ajax(csvPath )
  .done(function(csv) {
	series.push({"data":CSV2JSON(csv),"name":legendName});
  })
  .fail(function(csv) {
   return CSV2JSON(csv);
  })
  .always(function(csv) {
    //CSV2JSON(csv);
  });
}


var chartSeries1 = CallCSVData('../Sanuyi/result (1).csv','CPU');
var chartSeries2 = CallCSVData('../Sanuyi/result (2).csv', 'Memory');


// series = [{
        // name: 'CPU',
        // data: chartSeries1
    // },{
        // name: 'Memory',
        // data: chartSeries2
	// },{
        // name: 'Network',
        // data: chartSeries2
    // }];

function StartChart(series){
Highcharts.chart('container', {
    chart: {
        type: 'spline',
        animation: Highcharts.svg, // don't animate in old IE
        marginRight: 10,
        events: {
            load: function () {
                 var series = this.series[0];				
                 setInterval(function () {					
                     var x = (new Date()).getTime(),
                         y = Math.random();
						if(progress)
							 series.addPoint([x, y], true, true);					
                 }, 1000);
            }
        }
    },
    title: {
        text: 'System Analytics'
    },
    xAxis: {
        type: 'datetime',
        tickPixelInterval: 150,
		title: {
            text: 'Time'
        },
    },
    yAxis: {
        title: {
            text: 'Utilization'
        },
        plotLines: [{
            value: 0,
            width: 1,
            color: '#808080'
        }]
    },
    tooltip: {
        formatter: function () {
            return '<b>' + this.series.name + '</b><br/>' +
                Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' +
                Highcharts.numberFormat(this.y, 2);
        }
    },
    legend: {
        enabled: true
    },
    exporting: {
        enabled: true
    },
    series: series
});
}

$('#start').click(function(){	  
		progress = true;
 });
$('#stop').click(function(){	  
		progress = false;
});


function CSVToArray(strData, strDelimiter) {
    // Check to see if the delimiter is defined. If not,
    // then default to comma.
    strDelimiter = (strDelimiter || ",");
    // Create a regular expression to parse the CSV values.
    var objPattern = new RegExp((
    // Delimiters.
    "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
    // Quoted fields.
    "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
    // Standard fields.
    "([^\"\\" + strDelimiter + "\\r\\n]*))"), "gi");
    // Create an array to hold our data. Give the array
    // a default empty first row.
    var arrData = [[]];
    // Create an array to hold our individual pattern
    // matching groups.
    var arrMatches = null;
    // Keep looping over the regular expression matches
    // until we can no longer find a match.
    while (arrMatches = objPattern.exec(strData)) {
        // Get the delimiter that was found.
        var strMatchedDelimiter = arrMatches[1];
        // Check to see if the given delimiter has a length
        // (is not the start of string) and if it matches
        // field delimiter. If id does not, then we know
        // that this delimiter is a row delimiter.
        if (strMatchedDelimiter.length && (strMatchedDelimiter != strDelimiter)) {
            // Since we have reached a new row of data,
            // add an empty row to our data array.
            arrData.push([]);
        }
        // Now that we have our delimiter out of the way,
        // let's check to see which kind of value we
        // captured (quoted or unquoted).
        if (arrMatches[2]) {
            // We found a quoted value. When we capture
            // this value, unescape any double quotes.
            var strMatchedValue = arrMatches[2].replace(
            new RegExp("\"\"", "g"), "\"");
        } else {
            // We found a non-quoted value.
            var strMatchedValue = arrMatches[3];
        }
        // Now that we have our value string, let's add
        // it to the data array.
        arrData[arrData.length - 1].push(strMatchedValue);
    }
    // Return the parsed data.
    return (arrData);
}

function CSV2JSON(csv) {
    var array = CSVToArray(csv);
    var objArray = [];
    for (var i = 1; i < array.length; i++) {
        objArray[i - 1] = {};
        for (var k = 0; k < array[0].length && k < array[i].length; k++) {
            var key = array[0][k];
            objArray[i - 1][key] = array[i][k]
        }
    }

    var json = JSON.stringify(objArray);
    var str = json.replace(/},/g, "},\r\n");	
    return str;
}

$("#convert").click(function() {   
	CallCSVData();
    //var json = CSV2JSON(chartData);    
});
setTimeout(
  function() 
  {
    StartChart(series);
  }, 10000);