#!/usr/bin/python3

import cgi, cgitb
from global_func import *

cgitb.enable()
import sqlite3
import json
from db import *
from globalSettings import CCM

form = cgi.FieldStorage()
request_Type = form.getvalue('requestType')
cmd_Id = get_ccm_command_id()
#print "request_Type: ",request_Type

def update_wan():
    netmask = form.getvalue('netmask')
    ip_address = form.getvalue('ip_address')
    port = form.getvalue('port_enabled')
    dhcp = form.getvalue('dhcp_enabled')
    name = 'WAN'
    cmd = "update_WAN"
    add_validate(ip_address)
    add_validate(netmask)

    if add_validate(ip_address) == True and add_validate(netmask) == True:
        if CCM==true:
            message = "set,element=eth_ports,element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                      "port={4},dhcp={5},uuid={6}" \
                .format(name, cmd, netmask, ip_address, port, dhcp, cmd_Id)
            #message = "set,element=eth_ports,element_name=Management,args=6,Action=update_MGT,netmask=255.255.0.0,ip_address=192.168.12.11,gateway=10.0.15.2,dhcp=No,dns=103.12.15.11,uuid="+str(cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print(response)
            delete_ccm_response(cmd_Id)
        else:
            query_lan=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,enable_port=? where name=?",(ip_address,netmask,dhcp,port,name))
            conn.commit()
            print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
    else:
        print(json.JSONEncoder().encode(
            {"status": "fail", "description": "Enter valid ipv4 address, all values should be in the range 0-255"}))

    c.close()
    conn.close()

#update_wan()
def read_wan():
    result = {}
    query_lan = c.execute("Select ip,netmask,dhcp_enabled,enable_port from eth_ports where name='WAN'")
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['port_enabled'] = col[3]
    conn.commit()
    c.close()
    conn.close()
    print((json.JSONEncoder().encode(result)))


def update_lan():
    netmask = form.getvalue('netmask')
    ip_address = form.getvalue('ip_address')
    name = form.getvalue('name')
    port = form.getvalue('port_enabled')
    dhcp = form.getvalue('dhcp_enabled')

    add_validate(ip_address)
    add_validate(netmask)
    cmd = "update_LAN"
    if add_validate(ip_address) == True and add_validate(netmask) == True:
        if CCM == true:
            message = "set,element=eth_ports, element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                      "port={4},dhcp={5},uuid={6}" \
                .format(name, cmd, netmask, ip_address, port, dhcp, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print(response)
            delete_ccm_response(cmd_Id)
        else:
            query_lan=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,enable_port=? where name=?",(ip_address,netmask,dhcp,port,name))
            conn.commit()
            print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
    else:
        print(json.JSONEncoder().encode(
            {"status": "fail", "description": "Enter valid ipv4 address, all values should be in the range 0-255"}))
    c.close()
    conn.close()


def read_lan():
    lanData = []
    result = {}
    squery_lan = c.execute("Select ip,netmask,dhcp_enabled,enable_port,name from eth_ports where name in ('LAN1','LAN2','LAN3')")
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['port_enabled'] = col[3]
        result['name'] = col[4]
        jsonschema = {"ip_address": col[0], "subnet": col[1], "dhcp_enabled": col[2], "port_enabled": col[3],
                      "name": col[4]}
        lanData.append(jsonschema)
    conn.commit()
    c.close()
    conn.close()
    print((json.JSONEncoder().encode(lanData)))


def update_mgt():
    netmask = form.getvalue('netmask')
    gateway = form.getvalue('gateway')
    dns = form.getvalue('dns')
    dhcp = form.getvalue('dhcp_enabled')
    name = 'Management'
    ip_address = form.getvalue('ip_address')
    cmd = "update_MGT"
    add_validate(ip_address)
    add_validate(netmask)
    add_validate(gateway)

    if add_validate(ip_address) == True and add_validate(netmask) == True and add_validate(gateway) == True:
        if CCM == true:
            message = "set,element=eth_ports, element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                      "gateway={4},dhcp={5},dns={6},uuid={7}" \
                .format(name, cmd, netmask, ip_address, gateway, dhcp, dns, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print(response)
            delete_ccm_response(cmd_Id)
        else:
            query_net_dhcp=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=? where name=?",(ip_address,netmask,dhcp,name))
            conn.commit()
            query_gw_dns=c.execute("update gateway set default_gateway_ip = ?,dns_server=? where name=?",(gateway,dns,name))
            conn.commit()
            print(json.JSONEncoder().encode({'status':'success','description':'Saved successfully'}))
    else:
        print(json.JSONEncoder().encode(
            {"status": "fail", "description": "Enter valid ipv4 address, all values should be in the range 0-255"}))
    c.close()
    conn.close()


def read_mgt():
    result = {};
    query_eth = c.execute(
        "Select ip,netmask,dhcp_enabled,default_gateway_ip,dns_server from eth_ports ep inner join gateway g on ep.name=g.name  where ep.name='Management'")
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['default_gateway_ip'] = col[3]
        result['dns_server'] = col[4]
    conn.commit()
    c.close()
    conn.close()
    print(json.JSONEncoder().encode(result))


def update_adm():
    netmask = form.getvalue('netmask')
    ip_address = form.getvalue('ip_address')
    name = 'Admin'
    port = form.getvalue('port_enabled')
    dhcp = form.getvalue('dhcp_enabled')
    cmd = "update_ADM"
    add_validate(ip_address)
    add_validate(netmask)

    if add_validate(ip_address) == True and add_validate(netmask) == True:
        if CCM == true:
            message = "set,element=eth_ports, element_name={0},args=6,Action={1},netmask={2},ip_address={3}," \
                      "port={4},dhcp={5},uuid={6}" \
                .format(name, cmd, netmask, ip_address, port, dhcp, cmd_Id)
            send_ccm_msg(message)
            response = get_ccm_response(cmd_Id)
            print(response)
    #        print json.JSONEncoder().encode({"status":"success","description":"Saved successfully"})
            delete_ccm_response(cmd_Id)
        else:
            query_lan=c.execute("update eth_ports set ip = ?,netmask=?,dhcp_enabled=?,enable_port=? where name=?",(ip_address,netmask,dhcp,port,name))
            conn.commit()
            print(json.JSONEncoder().encode({"status":"success","description":"Saved successfully"}))
    else:
        print(json.JSONEncoder().encode(
            {"status": "fail", "description": "Enter valid ipv4 address, all values should be in the range 0-255"}))
    c.close()
    conn.close()


def read_adm():
    result = {}
    query_lan = c.execute("Select ip,netmask,dhcp_enabled,enable_port from eth_ports where name='Admin'")
    for col in c:
        result['ip_address'] = col[0]
        result['subnet'] = col[1]
        result['dhcp_enabled'] = col[2]
        result['port_enabled'] = col[3]
    conn.commit()
    c.close()
    conn.close()
    print((json.JSONEncoder().encode(result)))


print ("Content-type:text/html\r\n\r\n")

if request_Type == 'update_wan':
    update_wan()
elif request_Type == 'read_wan':
    read_wan()
elif request_Type == 'update_lan':
    update_lan()
elif request_Type == 'read_lan':
    read_lan()
elif request_Type == 'update_mgt':
    update_mgt()
elif request_Type == 'read_mgt':
    read_mgt()
elif request_Type == 'update_adm':
    update_adm()
elif request_Type == 'read_adm':
    read_adm()
