#!/usr/bin/python3

import cgi,cgitb
cgitb.enable()
from global_func import *
from globalSettings import *
import sqlite3
import json
import csv

from db import *

form = cgi.FieldStorage()
requestType=form.getvalue('requestType')

def read_storage():
    
    HDDpools = 0
    dbquery=c.execute("select count(*) from multi_device where name='HDD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        HDDpools=int(resp)

    SSDpools = 0
    dbquery=c.execute("select count(*) from multi_device where name='SSD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        SSDpools=int(resp)

    AllocatedHDD = 0
    dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='HDD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        AllocatedHDD=int(resp)
    
    AllocatedSSD = 0
    dbquery=c.execute("select sum(calculatedRaw) from multi_device where name='SSD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        AllocatedSSD=int(resp)

    HDDdisks = 0
    dbquery=c.execute("select sum(level) from multi_device where name='HDD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        HDDdisks=int(resp)
    
    SSDdisks = 0
    dbquery=c.execute("select sum(level) from multi_device where name='SSD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        SSDdisks=int(resp)

    HDDvolumes = 0
    dbquery=c.execute("select count(*) from volume join multi_device on volume.multi_device_id=multi_device.id where multi_device.name='HDD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        HDDvolumes=int(resp)
    
    SSDvolumes = 0
    dbquery=c.execute("select count(*) from volume join multi_device on volume.multi_device_id=multi_device.id where multi_device.name='SSD POOL'")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        SSDvolumes=int(resp)

    availableHDD=int(1000*TotalHDDStorage)-int(AllocatedHDD)    #This is in GB
    availableSSD=int(1000*TotalSSDStorage)-int(AllocatedSSD)    #This is in GB
    #availableSSD=int(1000*TotalSSDStorage)-int(AllocatedSSD)-int(AllocatedAcceleration)    
        
    print(json.JSONEncoder().encode({"hddDisks":HDDdisks,"ssdDisks":SSDdisks,\
        "hddvolumes":HDDvolumes,"ssdvolumes":SSDvolumes,\
        "hddpools":HDDpools,"ssdpools":SSDpools,\
            "availableHDDStorage":availableHDD,"availableSSDStorage":availableSSD,\
                "AllocatedHDD":AllocatedHDD,"AllocatedSSD":AllocatedSSD}))    
    conn.close()

def read_status():
    states = {}
    query = c.execute("SELECT state from fan")
    fandata = []
    conn.commit()
    for col in c:
        fandata.append(col[0])
    states["fan"] = fandata

    query = c.execute("SELECT state from temp_probes")
    tempdata=[]
    conn.commit()
    for col in c:
        tempdata.append(col[0])
    states["temp"] = tempdata

    query = c.execute("SELECT state from eth_ports")
    networkdata=[]
    conn.commit()
    for col in c:
        networkdata.append(col[0])
    states["network"] = networkdata

    query = c.execute("SELECT state from psu where name='PSU_1'")
    psudata=[]
    conn.commit()
    for col in c:
        psudata.append(col[0])
    states["psu"] = psudata

    query = c.execute("SELECT state from psu where name='PSU_2'")
    psudata2=[]
    conn.commit()
    for col in c:
        psudata2.append(col[0])
    states["psu2"] = psudata2

    query = c.execute("SELECT name,state,vid,pid,prl,serial,size from disks")
    disksdata=[]
    conn.commit()
    for col in c:
        disksdata.append(col[0])
    states["disks"] = disksdata

    query = c.execute("SELECT state from cpu")
    cpudata=[]
    conn.commit()
    for col in c:
        cpudata.append(col[0])
    states["cpu"] = cpudata

    conn.close()

    flag = -1
    for key,value in list(states.items()):
        try:
            indexValue = value.index(2)
        except ValueError:
            indexValue = -1

        if indexValue != -1:
            flag = 2
            break

    if flag==-1:
        for key,value in list(states.items()):
            try:
                indexValue = value.index(1)
            except ValueError:
                indexValue = -1

            if indexValue != -1:
                flag = 1
                break

    if flag==-1:
        for key,value in list(states.items()):
            try:
                indexValue = value.index(0)
            except ValueError:
                indexValue = -1

            if indexValue != -1:
                flag = 0
                break
    
    print(json.JSONEncoder().encode({"state":flag,"version":SoftwareVersion}))

def read_resources():
    usedVcpu = 0
    usedRam = 0
    usedStorage = 0
    dbquery=c.execute("select used_vcpu,used_memoryGB,used_storageGB from system where name='System1'")
    resp=c.fetchall()[0]
    if (isinstance(resp[0], int))==True:
        usedVcpu=int(resp[0])
    if (isinstance(resp[1], int))==True:
        usedRam=int(resp[1])
    if (isinstance(resp[2], int))==True:
        usedStorage=int(resp[2])

    print(json.JSONEncoder().encode({"usedVcpu":usedVcpu,"usedRAM":usedRam,"usedStorage":usedStorage}))

def read_apps():

    totalApps = 0
    dbquery=c.execute("select count(*) from virtualmachine")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        totalApps=int(resp)

    activeapps = 0
    dbquery=c.execute("select count(*) from virtualmachine where state=6")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        activeapps=int(resp)

    suspendedapps = totalApps - activeapps

    print(json.JSONEncoder().encode({"active":activeapps,"suspended":suspendedapps}))

def read_hostServers():
    hostservers = 0
    dbquery=c.execute("select count(*) from host")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        hostservers=int(resp)
    print(json.JSONEncoder().encode({"hostservers":hostservers}))
    
def read_alerts():
    with open(AlertsFilePath, 'rb') as csvfile:
		filereader = csv.reader(csvfile, delimiter='@')
		i = 0
		for row in filereader:
			i+=1	
    print(json.JSONEncoder().encode({"alerts":i}))

def read_schedules():
    schedules = 0
    dbquery=c.execute("select count(*) from schedule")
    #dbquery=c.execute("SELECT count(*) from schedule s INNER JOIN volume v on s.vol_id=v.id INNER JOIN volume v1 on s.vol_dest_id=v1.id")
    resp=c.fetchone()[0]
    if (isinstance(resp, int))==True:
        schedules=int(resp)
    print(json.JSONEncoder().encode({"schedules":schedules}))


print("Content-type:text/html\r\n\r\n")
if requestType=='getStatus':
    read_status()
elif requestType == 'getResources':
    read_resources()
elif requestType == 'getApps':
    read_apps()
elif requestType == 'getHostServers':
    read_hostServers()
elif requestType == 'getStorage':
    read_storage()
elif requestType == 'getAlerts':
    read_alerts()
elif requestType == 'getSchedules':
    read_schedules()

