#!/usr/bin/python3

import rrdtool
import time
from random import randint
import sqlite3
from rrdtool import update
import sys
import os
from globalSettings import *
import re
import docker

client = docker.from_env()

#DBPath = "/var/www/gitDivya_gui/sanuyiDB.db"

dbFilePath = DBPath
path = DBPath.split("/")[:-1]
rrdDBPath = "/".join(path)+"/"


startTime = int(time.time())-60
step = "10"

rrdElementsList = ["disks","cpu","fan","temp_probes","psu","volume","vm_image","multi_device","memory"]
#deviceMetricFiles = ["rd_io","wr_io"]


def dbRRD_connect(dbFilename):
    conn = sqlite3.connect(dbFilename) #(rrdDBPath+dbFilename)
    conn.text_factory = str 
    return conn

def EpochToTime(epoch):
    mytime = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(epoch))

def Get_rrdPath():
    rrdPath = "/var/www/sanuyi_rrdFiles/"
    return rrdPath


#http://web-tech.ga-usa.com/2011/08/using-rrds-with-many-data-sources-rrdtool/index.html
# see above link onhow to have multiple datasets
# ex 

def DB_GetElementNamesList(dbFile,element):
    conn = dbRRD_connect(dbFile)
    conn.text_factory = str
    c = conn.cursor()

    elmntsNamesList = []
    query = c.execute("select name from '"+element+"'")
    for col in c:
        elemName = col[0]
        elmntsNamesList.append(elemName)
    
    return elmntsNamesList

#def getElemnetValues(element,fieldName4DSval) @DIVYA once the field value from the DB is finalised use fields "name, DSvalue Field" and retrive the DS value based on the name"

def getElemValues(element):
    elemValue = randint(10,100)
    return elemValue

def DB_GetVolumeList(dbFile):
    # see DB_GetIdriveList
    #psuList = ["psu1","psu2"]
    conn = dbRRD_connect(dbFile)
    conn.text_factory = str
    c = conn.cursor()
    volList = []
    c.execute("select name from volume")
    for col in c:
        vol_name = col[0]
        #vol_name = re.sub('[^a-zA-Z0-9 \n\.]', '', my_str)
        vol_name = re.sub("@","_",vol_name)
        volList.append(vol_name)
    print("VolList",volList)
    return volList
    #return ["volume@1","volume2","volume3","volume4"]
    
    c.close()
    conn.close()

def DB_GetDockerAppName(dbFile):
    conn = dbRRD_connect(dbFile)
    conn.text_factory = str
    c = conn.cursor()
    dockerAppList =[]
    
    c.execute("select img.image_name from vm_image img inner join vm_group grp on img.vm_group_id=grp.id where grp.group_name='Docker'")
    for col in c:
        imgName = col[0]
        dockerAppList.append(imgName)
    return dockerAppList

def DB_GetPoolList(dbFile):
    conn = dbRRD_connect(dbFile)
    conn.text_factory = str
    c = conn.cursor()
    poolList = []
    c.execute("select system_name from multi_device")
    for col in c:
        poolName = col[0]
        poolList.append(poolName)
    return poolList

def DB_GetMemoryList():
    #Fake DATA
    memoryList = ["memory1","memory2","memory3"]
    return memoryList


def DB_GetPSUList(dbFile):
    # see DB_GetIdriveList
    #psuList = ["psu1","psu2"]
    conn = dbRRD_connect(dbFile)
    conn.text_factory = str
    c = conn.cursor()
    psuList = []
    c.execute("select name from psu")
    for col in c:
        psu_name = col[0]
        psuList.append(psu_name)
    return psuList
    
    c.close()
    conn.close()

def getPSU(PSU):
    psuValues = randint(10,100)
    return psuValues

def DB_GetfanList(dbFile):
    #fanList = ["fan1","fan2","fan3","fan4"]
    conn = dbRRD_connect(dbFile)
    conn.text_factory = str
    c = conn.cursor()
    fanList = []
    c.execute("select name from fan")
    for col in c:
        fan_name=col[0]
        fanList.append(fan_name)
    return fanList
    c.close()
    conn.close()

def getFAN(FAN):
    fanValues = randint(10,100)
    return fanValues


def checkRRDFile(fileNamePath,dataSourceLst):
    if not os.path.isfile(fileNamePath):        
        #Create DataSource Structure based on no.of DataSources
        print("Creating file ",fileNamePath)
        rra = "RRA:AVERAGE:0.5:60:40" # we can change this after we finalise the no.of datapoints
        string1 = ""
        for i in dataSourceLst:
            string1 = string1+"DS:"+i+":GAUGE:2000:U:U,"
            #print string1

        dsList=string1.split(",")[:-1]

        rrdtool.create(fileNamePath,"--start",str(startTime),"--step",str(step),
        dsList,
        "RRA:AVERAGE:0.5:5m:300h",
        "RRA:AVERAGE:0.5:1h:50d",
        "RRA:AVERAGE:0.5:1d:600d")
    else:
        dsList = rrdtool.fetch(fileNamePath, "AVERAGE")[1]
        #print "dsList : ",dsList

        #Check if any new dataSource is been added
        string1 = ""
        for dataSource in dataSourceLst:
            if dataSource not in dsList:
                string1 = string1+"DS:"+dataSource+":GAUGE:2000:U:U,"

        if string1 !="":
            dsCommand=string1.split(",")[:-1]
            rrdtool.tune(fileNamePath, dsCommand)  #If added, change the rrd file
            print("added ", dsCommand)

        #Check if any previous data source has been deleted
        string1 = ""
        for ds in dsList:
            if ds not in dataSourceLst:
                string1 = string1+"DEL:"+ds+","

        if string1 !="":
            delCommand =string1.split(",")[:-1]
            rrdtool.tune(fileNamePath, delCommand)  #If removed, delete the data souce from the rrd file
            print("removed ", delCommand)

        print("file already exists",fileNamePath)
        pass

def createUpdateDS(dbFile,element):
    
    #for element in elementsList:
    if element == "volume":
        deviceMetrics = ["rd_io.rrd","wr_io.rrd"]
        dataSourceLst =DB_GetVolumeList(dbFile)
    
    elif element == "disks":
        deviceMetrics = ["temp.rrd","rd_io.rrd","wr_io.rrd","media.rrd"]
        dataSourceLst = DB_GetElementNamesList(dbFile,element)
    
    elif element == "vm_image":
        deviceMetrics = ["cpu-usage.rrd","storage-rd.rrd","storage-wr.rrd","network-rd.rrd","network-wr.rrd"]
        element = "dockerApps"
        dataSourceLst =DB_GetDockerAppName(dbFile)
    
    elif element == "multi_device":
        deviceMetrics = ['free-space.rrd', 'reserved-space.rrd', 'used-space.rrd']
        element = "pools"
        dataSourceLst = DB_GetPoolList(dbFile)
    
    elif element == "memory":
        deviceMetrics = [" "]
        dataSourceLst =DB_GetMemoryList()
    
    else:
        deviceMetrics = [" "]
        dataSourceLst = DB_GetElementNamesList(dbFile,element)
    return [deviceMetrics,dataSourceLst]



def createRRD1(dbFile,elementsList):
    filePath = Get_rrdPath()
    for element in elementsList:
        deviceMetrics = createUpdateDS(dbFile,element)[0] 
        dataSourceLst = createUpdateDS(dbFile,element)[1]
        
        if element == "vm_image":
            element = "dockerApps"
        elif element == "multi_device":
            element = "pools"
        else:
            pass

        for metricFile in deviceMetrics:
            if metricFile == " ":
                fileName = element+".rrd"
            else:
                fileName =element+"_"+metricFile #+".rrd"

            #print "Metric File",metricFile
            fileNamePath = filePath+fileName
            #print "FILENAMEPATH",fileNamePath
            #print "element",element
            #print "2.DataSourceList",dataSourceLst
            time.sleep(1)
            checkRRDFile(fileNamePath,dataSourceLst)
            #print "\n"


def updateSanuyiRRD1(dbFile,elementsList):
    updateTime = int(time.time())
    filePath = Get_rrdPath()
 
    for element in elementsList:
        deviceMetrics = createUpdateDS(dbFile,element)[0] 
        dataSourceLst = createUpdateDS(dbFile,element)[1]
        
        if element == "vm_image":
            element = "dockerApps"
        elif element == "multi_device":
            element = "pools"
        else:
            pass
        

        for metricFile in deviceMetrics:
            if metricFile == " ":
                fileName = filePath+element+".rrd"
            
            else:
                fileName =filePath+element+"_"+metricFile
            #elementNamesList = DB_GetVolumeList(dbFile)
            elementValues = []        

            for name in dataSourceLst:
                val = getElemValues(name)
                elementValues.append(str(val))
            dataSrc = ":".join(dataSourceLst)
            dataVal = ":".join(elementValues)
            
            print("Device",dataSrc)
            print("Device Values",dataVal)
            print("Time of Sample",updateTime)

            update(fileName,"-t",dataSrc,str(updateTime)+":"+dataVal)


count=1
# This should loop and sleep every T seconds
t_Sec = 120
t_Sec = int (step)

def rrdManager():
    count=1
    while True:
        createRRD1(dbFilePath,rrdElementsList)
        updateSanuyiRRD1(dbFilePath,rrdElementsList)
        time.sleep(t_Sec)
        count += 1
        print("\n")


rrdManager()
