#!/usr/bin/python3

import cgi,cgitb
from global_func import *
cgitb.enable()
import sqlite3
import json
from db import *

###########################
#Libraries added for rclone
###########################
import subprocess
import os
from datetime import datetime
###########################

form = cgi.FieldStorage()
request_Type=form.getvalue('requestType')

def backupToMinio(scheduleName,sourceDirectories):
	now = datetime.now()
	dt_string = now.strftime("%d-%m-%Y %H:%M:%S")
	FNULL = open(os.devnull, 'w')
	FNULL = open("rclone.txt", 'w')
	sourceDirs = ''
	for x in sourceDirectories:
		sourceDirs += '--include "' + x + '/**" ' 

	command= 'rclone copy /home/ubuntu/nfsvolume/ "minio:nfsvolume/nfsvolume ' + dt_string+'/" '+sourceDirs
	proc = subprocess.Popen([command],shell=True,stdout=FNULL,stderr=subprocess.STDOUT)
	'''for dir in sourceDirectories:
		if dir!='':
			retcode = subprocess.call(['rclone','copy','/home/ubuntu/nfsvolume','minio:nfsvolume/nfsvolume ' + dt_string,sourceDirs],
				shell=True,
				stdout=FNULL, 
				stderr=subprocess.STDOUT)'''

def pathto_dict(path):
    for root, dirs, files in os.walk(path, topdown=True):
        tree = {"root": root,"name": root.split('/')[-1], "type":"folder", "children":[]}
        tree["children"].extend([pathto_dict(os.path.join(root, d)) for d in sorted(dirs)])
        return tree

def save_schedule():
	scheduleName=form.getvalue('scheduleName')
	frequency = form.getvalue('frequency')
	startTime = str(form.getvalue('startTime'))
	startDate=form.getvalue('startDate')
	action = form.getvalue('action')
	endDate = form.getvalue('endDate')	
	backup = form.getvalue('backup')
	VMIds = form.getvalue('VMIds')
	volId = form.getvalue('volId')
	volDestId = form.getvalue('volDestId')
	scheduleId = form.getvalue('scheduleId')
	sourceDirectories = form.getvalue('sourceDirectories')

	T_next=startDate+" "+startTime
	status="stopped"
	done_percentage=0
	
	query_lan=c.execute("select count(*) from schedule where name='"+ scheduleName+"' and isdeleted!=1")
	nameCount = c.fetchone()[0]
	conn.commit()
	
	if nameCount == 0:
		if scheduleName!="":
			query_lan=c.execute("insert into schedule (name,frequency,start_time,start_date,end_date,action,action_element,status,vm_id,t_next,done_percentage,isdeleted,vol_id,vol_dest_id,dirs) values(?,?,?,?,?,?,?,?,?,?,?,0,?,?,?)",[scheduleName,frequency,startTime,startDate,endDate,action,backup,status,VMIds,T_next,done_percentage,volId,volDestId,sourceDirectories])
			conn.commit()
			print(json.JSONEncoder().encode({"status":"success","description":"Saved successfully"}))
			#Experimenting Rclone
			if action=='Start File Backup':
				#print "called"
				#print sourceDirectories
				sourceDirectories = sourceDirectories.split(',,') #Delimiter as used in schedule.js
				backupToMinio(scheduleName,sourceDirectories[:-1])
		else:
			print(json.JSONEncoder().encode({"status":"fail","description":"Fill All mandatory fields"}))
	else:
		print(json.JSONEncoder().encode({"status":"fail","description":"Schedule Name Already Exists"}))
	c.close()
	conn.close()
	
def update_schedule():
	scheduleName=form.getvalue('scheduleName')
	frequency = form.getvalue('frequency')
	startTime = str(form.getvalue('startTime'))
	startDate=form.getvalue('startDate')
	action = form.getvalue('action')
	endDate = form.getvalue('endDate')	
	backup = form.getvalue('backup')
	VMIds = form.getvalue('VMIds')
	volId = form.getvalue('volId')
	volDestId = form.getvalue('volDestId')
	scheduleId = form.getvalue('scheduleId')
	sourceDirectories = form.getvalue('sourceDirectories')

	T_next=startDate+" "+startTime
	status="stopped"
	done_percentage=0
	
	query_lan=c.execute("Update schedule set name=?,frequency=?,start_time=?,start_date=?,end_date=?,action=?,action_element=?,vm_id=?,vol_id=?,vol_dest_id=?,dirs=?,status=?,done_percentage=0 where id=?",(scheduleName,frequency,startTime,startDate,endDate,action,backup,VMIds,volId,volDestId,sourceDirectories,status,scheduleId))
	conn.commit()
	print(json.JSONEncoder().encode({"status":"success","description":"Updated successfully"}))
	
def read_schedule():
	scheduleId=form.getvalue('scheduleId')
	''' 
	#Before Changing the query
	if scheduleId != str(0) :
		dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name from schedule s INNER JOIN volume v on s.vol_id=v.id INNER JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  and s.id="+str(scheduleId)
	else:
		dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name from schedule s INNER JOIN volume v on s.vol_id=v.id INNER JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  --where action !='Email Logs'"
	'''
	if scheduleId != str(0) :
		dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name,s.dirs from schedule s LEFT JOIN volume v on s.vol_id=v.id LEFT JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  and s.id="+str(scheduleId)
	else:
		dbquery="SELECT s.id,s.name,s.frequency,s.start_time,s.start_date,s.end_date,s.action,s.status,s.action_element,s.vm_ID,s.done_percentage,v.id,v1.id,v.name,v1.name,s.dirs from schedule s LEFT JOIN volume v on s.vol_id=v.id LEFT JOIN volume v1 on s.vol_dest_id=v1.id  where s.isDeleted=0  --where action !='Email Logs'"
	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		if col[15] is None:
			dirs=''
		else:
			dirs=col[15]
		jsonschema = {"id":col[0],"name" : col[1],"frequency" :col[2],"start_time" : col[3],"start_date" : col[4],"end_date" : col[5],"action" :col[6],"status":col[7],"action_element":col[8],"vm_ID":col[9],"PerDone":col[10],"source_vol_id":col[11],"dest_vol_id":col[12],"source_vol":col[13],"dest_vol":col[14],"dirs":dirs.split(',,')[:-1]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def read_scheduleInfo():
	scheduleId=form.getvalue('scheduleId')
	
	dbquery="""
			select A.id,A.schedule_id,A.vol_dest_id,A.complete_date,A.complete_time,A.result,v.name from (
			select sh.id,sh.schedule_id,sh.complete_date,sh.complete_time,sh.result,s.vol_dest_id  from schedule_history sh
			inner join schedule s on s.id=sh.schedule_id
			where sh.schedule_id="""+scheduleId+""")A
			INNER JOIN volume v on v.id=A.vol_dest_id
			"""	
	query = c.execute(dbquery)
	dbdata = []
	conn.commit()
	for col in c:
		jsonschema = {"id":col[0],"date" : col[3],"time" :col[4],"result" : col[5],"dest_vol":col[6]}
		dbdata.append(jsonschema)
	conn.close()
	print(json.JSONEncoder().encode(dbdata))

def delete_schedule():
	scheduleId = form.getvalue('scheduleId')
	
	query_lan=c.execute("select count(*) from schedule where status='running' and id="+str(scheduleId)+"")
	nameCount = c.fetchone()[0]
	conn.commit()
	if nameCount == 0:
		query_lan=c.execute("Update schedule set isDeleted=1 where id="+str(scheduleId))
		conn.commit()
		print(json.JSONEncoder().encode({"status":"success","description":"Deleted successfully"}))
	else:
		print(json.JSONEncoder().encode({"status":"fail","description":"Cannot Delete Running Schedule"}))

def scheduleRestore():
	#scheduleId = form.getvalue('scheduleId')
	#schRestorPoint = form.getvalue('sch_result')
    #schSourceVol = form.getvalue('sch_SrcVol')
    #schDestinationVol = form.getvalue('sch_DestVol')
    print(json.JSONEncoder().encode({"status":"success","description":"Success"}))

def readDirectories():
	volId = form.getvalue('volId')

	#Using hardcoded path now - otherwise extract from the volume ID
	startDir = "/home/ubuntu/nfsvolume"
	pathDir = pathto_dict(startDir)
	print(json.JSONEncoder().encode({"status":"success","description":"Success","Directory":pathDir}))

print ("Content-type:text/html\r\n\r\n")

if request_Type == 'save_schedule':
	save_schedule()
elif request_Type == 'update_schedule':
	update_schedule()
elif request_Type == 'read_schedule':
	read_schedule()
elif request_Type == 'delete_schedule':
	delete_schedule()
elif request_Type == 'read_scheduleInfo':
	read_scheduleInfo()
elif request_Type == 'restore_schedule':
    scheduleRestore()
elif request_Type == 'read_Directories':
    readDirectories()

